GNU bug report logs - #43389
28.0.50; Emacs memory leaks

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Michael Heerdegen <michael_heerdegen@HIDDEN>; merged with #43395, #43876, #44666; Done: Stefan Monnier <monnier@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 43389-done <at> debbugs.gnu.org:


Received: (at 43389-done) by debbugs.gnu.org; 20 Jan 2021 15:49:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 10:49:38 2021
Received: from localhost ([127.0.0.1]:55980 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2Fjm-0000Fa-8I
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:49:38 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:36762)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1l2Fjk-0000FN-Ii
 for 43389-done <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:49:37 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id E60F0608B5;
 Wed, 20 Jan 2021 16:49:29 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1611157770;
 bh=njEmat6v1ndBOWEyYEtrSNGLrdcXaBz8GZPQjDMbvIs=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=kOlRv7urZxvU/cZ6rrz1sJTyXV9e1LEo6r4pXkkFi3C0Qy+pY5NR9WwCQ2EdkJfeX
 3Tnr+MKng7SEGjoZNa/6NOYoEfq+suXPq11uldgsRLKRzajXCWOk8PGR7faORDHEqE
 Ty3Z4IIjSk1GZ2ctmy39A4ZTm40dvaxJ9pJltYpc=
From: Trevor Bentley <trevor@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <jwvwnw74o0x.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <87eek0rmqa.fsf@HIDDEN>
 <83zh2l33fv.fsf@HIDDEN> <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
 <87k0s7q0j4.fsf@HIDDEN>
 <jwvturb65pi.fsf-monnier+emacs@HIDDEN> <83im7r7hf3.fsf@HIDDEN>
 <jwvwnw74o0x.fsf-monnier+emacs@HIDDEN>
Date: Wed, 20 Jan 2021 16:49:28 +0100
Message-ID: <87eeifpq0n.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389-done
Cc: fweimer@HIDDEN, , dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, 43389-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Stefan Monnier <monnier@HIDDEN> writes:

> Trevor: I marked this bug as closed under the assumption that 
> this problem is solved, but of course, if it re-occurs feel free 
> to re-open (ideally while running under GDB in a similar setup, 
> so we get a clear backtrace again ;-) 

Agreed.

And thanks to everyone for all of the help!  I very much look 
forward to having long-lived emacs processes again :)

-Trevor





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389-done <at> debbugs.gnu.org:


Received: (at 43389-done) by debbugs.gnu.org; 20 Jan 2021 15:40:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 10:40:42 2021
Received: from localhost ([127.0.0.1]:55960 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2Fb8-0008TR-AW
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:40:42 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:44747)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1l2Fb6-0008TE-8w
 for 43389-done <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:40:40 -0500
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id C3F58440334;
 Wed, 20 Jan 2021 10:40:34 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 5BAD144031D;
 Wed, 20 Jan 2021 10:40:33 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1611157233;
 bh=wMQ+lnhvZGhW7hcHEfzk5FH744jAWSh2JygiskUYevQ=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=V4xaxDOavDaJuwp9OtScJn3wZiMo6ZvZ6PR1UMvb9fW+9h1xOwswBIJTFNVn4mYzQ
 xzN37hut0yegGDuQt0ZkphCR3wE9npmHGjqwvj39BoinWldqlD5uoyH+V8iMRRZ/L9
 GeP2h25QJzLPsVIKY226vJkYopBAEO6uQTU1OC91G7mCj6Fw6nNGXYolbchmWvvhra
 fz1E7JrhpBb6FXN1IBmA625Ybln13OaunqHHTRCj1du74i71vtNCA4cQIlp0/1Iq0u
 xE9qC2CIIDXUu+D7TM4uzfVfBqrTaEXL6JmeoHVJgB8/Y7ydOqeS+U22asSpYX6pXQ
 utab+WRU7+7pA==
Received: from alfajor (unknown [45.72.224.181])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id EEDA71204FE;
 Wed, 20 Jan 2021 10:40:32 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwvwnw74o0x.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
 <87k0s7q0j4.fsf@HIDDEN>
 <jwvturb65pi.fsf-monnier+emacs@HIDDEN> <83im7r7hf3.fsf@HIDDEN>
Date: Wed, 20 Jan 2021 10:40:31 -0500
In-Reply-To: <83im7r7hf3.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 20 Jan
 2021 17:32:32 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.039 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389-done
Cc: fweimer@HIDDEN, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 43389-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> Eli, do you think it should go to `emacs-27`?
> Definitely, thanks.

OK, done.

Trevor: I marked this bug as closed under the assumption that this
problem is solved, but of course, if it re-occurs feel free to re-open
(ideally while running under GDB in a similar setup, so we get a clear
backtrace again ;-)



        Stefan





Notification sent to Jean Louis <bugs@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Stefan Monnier <monnier@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 43389-done <at> debbugs.gnu.org:


Received: (at 43389-done) by debbugs.gnu.org; 20 Jan 2021 15:40:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 10:40:42 2021
Received: from localhost ([127.0.0.1]:55960 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2Fb8-0008TR-AW
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:40:42 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:44747)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1l2Fb6-0008TE-8w
 for 43389-done <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:40:40 -0500
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id C3F58440334;
 Wed, 20 Jan 2021 10:40:34 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 5BAD144031D;
 Wed, 20 Jan 2021 10:40:33 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1611157233;
 bh=wMQ+lnhvZGhW7hcHEfzk5FH744jAWSh2JygiskUYevQ=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=V4xaxDOavDaJuwp9OtScJn3wZiMo6ZvZ6PR1UMvb9fW+9h1xOwswBIJTFNVn4mYzQ
 xzN37hut0yegGDuQt0ZkphCR3wE9npmHGjqwvj39BoinWldqlD5uoyH+V8iMRRZ/L9
 GeP2h25QJzLPsVIKY226vJkYopBAEO6uQTU1OC91G7mCj6Fw6nNGXYolbchmWvvhra
 fz1E7JrhpBb6FXN1IBmA625Ybln13OaunqHHTRCj1du74i71vtNCA4cQIlp0/1Iq0u
 xE9qC2CIIDXUu+D7TM4uzfVfBqrTaEXL6JmeoHVJgB8/Y7ydOqeS+U22asSpYX6pXQ
 utab+WRU7+7pA==
Received: from alfajor (unknown [45.72.224.181])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id EEDA71204FE;
 Wed, 20 Jan 2021 10:40:32 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwvwnw74o0x.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
 <87k0s7q0j4.fsf@HIDDEN>
 <jwvturb65pi.fsf-monnier+emacs@HIDDEN> <83im7r7hf3.fsf@HIDDEN>
Date: Wed, 20 Jan 2021 10:40:31 -0500
In-Reply-To: <83im7r7hf3.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 20 Jan
 2021 17:32:32 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.039 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389-done
Cc: fweimer@HIDDEN, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 43389-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> Eli, do you think it should go to `emacs-27`?
> Definitely, thanks.

OK, done.

Trevor: I marked this bug as closed under the assumption that this
problem is solved, but of course, if it re-occurs feel free to re-open
(ideally while running under GDB in a similar setup, so we get a clear
backtrace again ;-)



        Stefan





Notification sent to Naveed Chehrazi <nchehrazi@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Stefan Monnier <monnier@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 43389-done <at> debbugs.gnu.org:


Received: (at 43389-done) by debbugs.gnu.org; 20 Jan 2021 15:40:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 10:40:42 2021
Received: from localhost ([127.0.0.1]:55960 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2Fb8-0008TR-AW
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:40:42 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:44747)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1l2Fb6-0008TE-8w
 for 43389-done <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:40:40 -0500
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id C3F58440334;
 Wed, 20 Jan 2021 10:40:34 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 5BAD144031D;
 Wed, 20 Jan 2021 10:40:33 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1611157233;
 bh=wMQ+lnhvZGhW7hcHEfzk5FH744jAWSh2JygiskUYevQ=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=V4xaxDOavDaJuwp9OtScJn3wZiMo6ZvZ6PR1UMvb9fW+9h1xOwswBIJTFNVn4mYzQ
 xzN37hut0yegGDuQt0ZkphCR3wE9npmHGjqwvj39BoinWldqlD5uoyH+V8iMRRZ/L9
 GeP2h25QJzLPsVIKY226vJkYopBAEO6uQTU1OC91G7mCj6Fw6nNGXYolbchmWvvhra
 fz1E7JrhpBb6FXN1IBmA625Ybln13OaunqHHTRCj1du74i71vtNCA4cQIlp0/1Iq0u
 xE9qC2CIIDXUu+D7TM4uzfVfBqrTaEXL6JmeoHVJgB8/Y7ydOqeS+U22asSpYX6pXQ
 utab+WRU7+7pA==
Received: from alfajor (unknown [45.72.224.181])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id EEDA71204FE;
 Wed, 20 Jan 2021 10:40:32 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwvwnw74o0x.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
 <87k0s7q0j4.fsf@HIDDEN>
 <jwvturb65pi.fsf-monnier+emacs@HIDDEN> <83im7r7hf3.fsf@HIDDEN>
Date: Wed, 20 Jan 2021 10:40:31 -0500
In-Reply-To: <83im7r7hf3.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 20 Jan
 2021 17:32:32 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.039 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389-done
Cc: fweimer@HIDDEN, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 43389-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> Eli, do you think it should go to `emacs-27`?
> Definitely, thanks.

OK, done.

Trevor: I marked this bug as closed under the assumption that this
problem is solved, but of course, if it re-occurs feel free to re-open
(ideally while running under GDB in a similar setup, so we get a clear
backtrace again ;-)



        Stefan





Notification sent to Madhu <enometh@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Stefan Monnier <monnier@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 43389-done <at> debbugs.gnu.org:


Received: (at 43389-done) by debbugs.gnu.org; 20 Jan 2021 15:40:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 10:40:42 2021
Received: from localhost ([127.0.0.1]:55960 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2Fb8-0008TR-AW
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:40:42 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:44747)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1l2Fb6-0008TE-8w
 for 43389-done <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:40:40 -0500
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id C3F58440334;
 Wed, 20 Jan 2021 10:40:34 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 5BAD144031D;
 Wed, 20 Jan 2021 10:40:33 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1611157233;
 bh=wMQ+lnhvZGhW7hcHEfzk5FH744jAWSh2JygiskUYevQ=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=V4xaxDOavDaJuwp9OtScJn3wZiMo6ZvZ6PR1UMvb9fW+9h1xOwswBIJTFNVn4mYzQ
 xzN37hut0yegGDuQt0ZkphCR3wE9npmHGjqwvj39BoinWldqlD5uoyH+V8iMRRZ/L9
 GeP2h25QJzLPsVIKY226vJkYopBAEO6uQTU1OC91G7mCj6Fw6nNGXYolbchmWvvhra
 fz1E7JrhpBb6FXN1IBmA625Ybln13OaunqHHTRCj1du74i71vtNCA4cQIlp0/1Iq0u
 xE9qC2CIIDXUu+D7TM4uzfVfBqrTaEXL6JmeoHVJgB8/Y7ydOqeS+U22asSpYX6pXQ
 utab+WRU7+7pA==
Received: from alfajor (unknown [45.72.224.181])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id EEDA71204FE;
 Wed, 20 Jan 2021 10:40:32 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwvwnw74o0x.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
 <87k0s7q0j4.fsf@HIDDEN>
 <jwvturb65pi.fsf-monnier+emacs@HIDDEN> <83im7r7hf3.fsf@HIDDEN>
Date: Wed, 20 Jan 2021 10:40:31 -0500
In-Reply-To: <83im7r7hf3.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 20 Jan
 2021 17:32:32 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.039 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389-done
Cc: fweimer@HIDDEN, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 43389-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> Eli, do you think it should go to `emacs-27`?
> Definitely, thanks.

OK, done.

Trevor: I marked this bug as closed under the assumption that this
problem is solved, but of course, if it re-occurs feel free to re-open
(ideally while running under GDB in a similar setup, so we get a clear
backtrace again ;-)



        Stefan





Notification sent to Michael Heerdegen <michael_heerdegen@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Stefan Monnier <monnier@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 20 Jan 2021 15:32:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 10:32:45 2021
Received: from localhost ([127.0.0.1]:55947 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2FTR-0008Hx-FU
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:32:45 -0500
Received: from eggs.gnu.org ([209.51.188.92]:54286)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1l2FTB-0008HT-O9
 for 43389 <at> debbugs.gnu.org; Wed, 20 Jan 2021 10:32:44 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52077)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1l2FT4-0003sn-HS; Wed, 20 Jan 2021 10:32:22 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1848
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1l2FT0-0006tP-Uq; Wed, 20 Jan 2021 10:32:20 -0500
Date: Wed, 20 Jan 2021 17:32:32 +0200
Message-Id: <83im7r7hf3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <jwvturb65pi.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Wed, 20 Jan 2021 09:53:08 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
 <87k0s7q0j4.fsf@HIDDEN>
 <jwvturb65pi.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  michael_heerdegen@HIDDEN,
>   carlos@HIDDEN,  fweimer@HIDDEN,  43389 <at> debbugs.gnu.org,
>   bugs@HIDDEN,  dj@HIDDEN
> Date: Wed, 20 Jan 2021 09:53:08 -0500
> 
> > I don't know emacs internals, so you'll have to figure out if this is
> > X dependent (probably) and/or GTK dependent.  It should be possible to come
> > up with an easier way to reproduce it now.
> 
> The backtrace is clear enough, no need to reproduce it.

Indeed.

> I installed the simple patch below into `master.  It should fix the
> immediate problem of failing to set consing_until_gc back to a sane
> value and it should also fix the other immediate problem of getting to
> `siglongjmp` from `unblock_input` via `window_parameter`.
> 
> Eli, do you think it should go to `emacs-27`?

Definitely, thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 20 Jan 2021 14:53:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 09:53:19 2021
Received: from localhost ([127.0.0.1]:53339 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2ErH-0006cp-A1
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 09:53:19 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:40193)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1l2ErF-0006cd-JM
 for 43389 <at> debbugs.gnu.org; Wed, 20 Jan 2021 09:53:18 -0500
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 251DD101137;
 Wed, 20 Jan 2021 09:53:12 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id AA32A1000DA;
 Wed, 20 Jan 2021 09:53:09 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1611154389;
 bh=XMa10L486h5VjAoBNwAMyaTmaQWxH4AhcbVvQDTk/7w=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=G1kie8/SeRuxo4CKRB7+Yo67/4Uz66UtzbTAtbCJBugJ6dUEpzAfXpiM7TakpDabF
 drNL/xFVkaCIDfpT083gS14tX2/S6/HuJLzqijVPvy4/eKQiDqLKrnjblxsB6seIa1
 0iKZ9DVONwe862N+vpwSmffkxl+20jfrwatmD8z0OVZhnREPxMeLsyzarXDi9DMX4q
 5B7OXMW1PAgpOICiqJpDVdS5mwMxqB6sbnyOkurw/nHbo/CZl/R7rFiBfS95KCWLDI
 bQtZzV4mt3ZN70bPhm0kQEHFegMtapJ7O4ndokyg+5koLRdZ0DM3GntVLAqUzy1wOR
 8pTOxL0/M5z0Q==
Received: from alfajor (unknown [45.72.224.181])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 5029C1204F0;
 Wed, 20 Jan 2021 09:53:09 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwvturb65pi.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
 <87k0s7q0j4.fsf@HIDDEN>
Date: Wed, 20 Jan 2021 09:53:08 -0500
In-Reply-To: <87k0s7q0j4.fsf@HIDDEN> (Trevor Bentley's message
 of "Wed, 20 Jan 2021 13:02:23 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.062 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> If you have a look at this long backtrace, you can see that we are inside
> a garbage_collect call (frame #38).  An X11 focus event comes in, triggering
> a bunch of GTK/GDK/X calls.  Mysteriously, this leads to a maybe_quit() call
> which in turn calls longjmp(). longjmp jumps right out of the garbage
> collect, leaving it unfinished.

Indeed, thanks!

> I don't know emacs internals, so you'll have to figure out if this is
> X dependent (probably) and/or GTK dependent.  It should be possible to come
> up with an easier way to reproduce it now.

The backtrace is clear enough, no need to reproduce it.

The GC properly speaking is actually finished at that point, BTW
(luckily: I think you'd have seen worse outcomes if that weren't the
case ;-).

I installed the simple patch below into `master.  It should fix the
immediate problem of failing to set consing_until_gc back to a sane
value and it should also fix the other immediate problem of getting to
`siglongjmp` from `unblock_input` via `window_parameter`.

Eli, do you think it should go to `emacs-27`?

> Backtrace:
> -----------
> (gdb) bt
> #0  0x00007ffff5571230 in siglongjmp () at /usr/lib/libc.so.6
> #1  0x00005555557bd38d in unwind_to_catch (catch=0x555555dfc320, type=NONLOCAL_EXIT_THROW, value=0x30) at eval.c:1181
> #2  0x00005555557bd427 in Fthrow (tag=0xe75830, value=0x30) at eval.c:1198
> #3  0x00005555557bdea7 in process_quit_flag () at eval.c:1526
> #4  0x00005555557bdeef in maybe_quit () at eval.c:1547
> #5  0x00005555557cbbb1 in Fassq (key=0xd0b0, alist=0x55555901c573) at fns.c:1609
> #6 0x0000555555632b63 in window_parameter (w=0x555555f2d088, parameter=0xd0b0) at window.c:2262
> #7 0x000055555563a075 in window_wants_tab_line (w=0x555555f2d088) at window.c:5410
> #8 0x00005555555c22b1 in get_phys_cursor_geometry (w=0x555555f2d088, row=0x55555d9f3ef0, glyph=0x55555fd20e00, xp=0x7fffffff9c48, yp=0x7fffffff9c4c, heightp=0x7fffffff9c50) at xdisp.c:2650
> #9 0x00005555556c1b12 in x_draw_hollow_cursor (w=0x555555f2d088, row=0x55555d9f3ef0) at xterm.c:9495
> #10 0x00005555556c24f9 in x_draw_window_cursor (w=0x555555f2d088, glyph_row=0x55555d9f3ef0, x=32, y=678, cursor_type=HOLLOW_BOX_CURSOR, cursor_width=1, on_p=true, active_p=false) at xterm.c:9682
> #11 0x000055555561a922 in display_and_set_cursor (w=0x555555f2d088, on=true, hpos=2, vpos=18, x=32, y=678) at xdisp.c:31738
> #12 0x000055555561aa5b in update_window_cursor (w=0x555555f2d088, on=true) at xdisp.c:31773
> #13 0x000055555561aabf in update_cursor_in_window_tree (w=0x555555f2d088, on_p=true) at xdisp.c:31791
> #14 0x000055555561aaab in update_cursor_in_window_tree (w=0x55555907a490, on_p=true) at xdisp.c:31789
> #15 0x000055555561aaab in update_cursor_in_window_tree (w=0x55555a514b68, on_p=true) at xdisp.c:31789
> #16 0x000055555561ab37 in gui_update_cursor (f=0x555556625468, on_p=true) at xdisp.c:31805
> #17 0x00005555556b9829 in x_frame_unhighlight (f=0x555556625468) at xterm.c:4490
> #18 0x00005555556ba22d in x_frame_rehighlight (dpyinfo=0x55555626d6c0) at xterm.c:4852
> #19 0x00005555556b98fc in x_new_focus_frame (dpyinfo=0x55555626d6c0, frame=0x0) at xterm.c:4520
> #20 0x00005555556b9a3d in x_focus_changed (type=10, state=2, dpyinfo=0x55555626d6c0, frame=0x555556625468, bufp=0x7fffffffa0d0) at xterm.c:4554
> #21 0x00005555556ba0a6 in x_detect_focus_change (dpyinfo=0x55555626d6c0, frame=0x555556625468, event=0x7fffffffa840, bufp=0x7fffffffa0d0) at xterm.c:4787
> #22 0x00005555556c0235 in handle_one_xevent (dpyinfo=0x55555626d6c0, event=0x7fffffffa840, finish=0x555555c901d4 <current_finish>, hold_quit=0x7fffffffab50) at xterm.c:8810
> #23 0x00005555556bde28 in event_handler_gdk (gxev=0x7fffffffa840, ev=0x55555cccf0c0, data=0x0) at xterm.c:7768
> #24 0x00007ffff75f780f in  () at /usr/lib/libgdk-3.so.0
> #25 0x00007ffff75fb3cb in  () at /usr/lib/libgdk-3.so.0
> #26 0x00007ffff759f15b in gdk_display_get_event () at /usr/lib/libgdk-3.so.0
> #27 0x00007ffff75fb104 in  () at /usr/lib/libgdk-3.so.0
> #28 0x00007ffff6fcb8f4 in g_main_context_dispatch () at /usr/lib/libglib-2.0.so.0
> #29 0x00007ffff701f821 in  () at /usr/lib/libglib-2.0.so.0
> #30 0x00007ffff6fca121 in g_main_context_iteration () at /usr/lib/libglib-2.0.so.0
> #31 0x00007ffff784e2c7 in gtk_main_iteration () at /usr/lib/libgtk-3.so.0
> #32 0x00005555556c1821 in XTread_socket (terminal=0x5555560b7460, hold_quit=0x7fffffffab50) at xterm.c:9395
> #33 0x000055555570f3a2 in gobble_input () at keyboard.c:6890
> #34 0x000055555570f894 in handle_async_input () at keyboard.c:7121
> #35 0x000055555570f8dd in process_pending_signals () at keyboard.c:7139
> #36 0x000055555570f9cf in unblock_input_to (level=0) at keyboard.c:7162
> #37 0x000055555570fa4c in unblock_input () at keyboard.c:7187
> #38 0x000055555578f49a in garbage_collect () at alloc.c:6121
> #39 0x000055555578efe7 in maybe_garbage_collect () at alloc.c:5964
> #40 0x00005555557bb292 in maybe_gc () at lisp.h:5041
> #41 0x00005555557c12d6 in Ffuncall (nargs=2, args=0x7fffffffad68) at eval.c:2793
> #42 0x000055555580f7d6 in exec_byte_code
> ...  --------------

Of course, there might be other places where we could get to
`maybe_quit` from `XTread_socket`, given the enormous amount of code it
can execute.  :-(


        Stefan


diff --git a/src/alloc.c b/src/alloc.c
index c0a55e61b9..b86ed4ed26 100644
--- a/src/alloc.c
+++ b/src/alloc.c
@@ -6101,11 +6101,13 @@ garbage_collect (void)
 
   gc_in_progress = 0;
 
-  unblock_input ();
-
   consing_until_gc = gc_threshold
     = consing_threshold (gc_cons_threshold, Vgc_cons_percentage, 0);
 
+  /* Unblock *after* re-setting `consing_until_gc` in case `unblock_input`
+     signals an error (see bug#43389).  */
+  unblock_input ();
+
   if (garbage_collection_messages && NILP (Vmemory_full))
     {
       if (message_p || minibuf_level > 0)
diff --git a/src/window.c b/src/window.c
index e025e0b082..eb16e2a433 100644
--- a/src/window.c
+++ b/src/window.c
@@ -2260,7 +2260,7 @@ DEFUN ("window-parameters", Fwindow_parameters, Swindow_parameters,
 Lisp_Object
 window_parameter (struct window *w, Lisp_Object parameter)
 {
-  Lisp_Object result = Fassq (parameter, w->window_parameters);
+  Lisp_Object result = assq_no_quit (parameter, w->window_parameters);
 
   return CDR_SAFE (result);
 }





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 20 Jan 2021 12:08:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 07:08:54 2021
Received: from localhost ([127.0.0.1]:53083 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2CIA-0006nN-02
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 07:08:54 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:35387)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1l2CI7-0006n7-TR
 for 43389 <at> debbugs.gnu.org; Wed, 20 Jan 2021 07:08:52 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id C7A5D60842;
 Wed, 20 Jan 2021 13:08:45 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1611144525;
 bh=FVdXQYrIbgqj26GF+rnrJYRqKi+QoEGEfL0j4kilSb8=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=Es5pZNV2/z4pdFRNNXZyn7LldTS53GfSdqPr78M06JycHPns6jTM/LOo9TWjRJhlk
 7IDq0PqTdFTyJtFqsy6xc7ET/Yjtc+lLUGzXMC8StgRcmW21b46DAUO5d0pwYiry7Y
 nrMqH+6XcwrW9A1Bn359JyOMTEaJKi9XWgKM+mGU=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <87k0s7q0j4.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
 <87k0s7q0j4.fsf@HIDDEN>
Date: Wed, 20 Jan 2021 13:08:44 +0100
Message-ID: <87h7nbq08j.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I'm incompetent at formatting e-mails.  Have a link to the 
backtrace instead:

https://trevorbentley.com/mtrace/backtrace.txt

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 20 Jan 2021 12:02:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 07:02:34 2021
Received: from localhost ([127.0.0.1]:53079 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2CC2-0006et-3x
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 07:02:34 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:35329)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1l2CBz-0006ec-2R
 for 43389 <at> debbugs.gnu.org; Wed, 20 Jan 2021 07:02:32 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 6C5E1606E0;
 Wed, 20 Jan 2021 13:02:24 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1611144144;
 bh=8CleTkDI/WZDTrPKRmLjufqksVJAOtXdEkSa5uQaI/U=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=hlcan/H1OmhyXLZbFv3NRJZgI92kvlWzDL6N8DzRjFJdyYF9CNUkbP2nDZfKApQwi
 5V/VzO+C/g+RlAseM8WO1OUkS43r3bnKmMOgbKbP/qaNK7CDLuwAfry4kXg50MXpG2
 3ogYEEu5j8TnCnhrLJwGh673QscuvdEcIiETjCC8=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <87ft48qdw7.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN>
 <83v9dpn9em.fsf@HIDDEN> <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
 <87ft48qdw7.fsf@HIDDEN>
Date: Wed, 20 Jan 2021 13:02:23 +0100
Message-ID: <87k0s7q0j4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> I tried setting a breakpoint in longjmp, but it's called 3 times 
> for every keypress!  That's inconvenient.  Running one single 
> instance now with a conditional breakpoint on longjmp: it will 
> break if longjmp is called while it's in unblock_input(). 

I disappeared for ages because... the problem disappeared.  I went 
a month without reproducing it, despite putting a hold on 
upgrading both system and emacs packages while debugging.  Very 
odd.

But today it appeared again.  And, for the first time, in a gdb 
session with breakpoints to confirm my theory.  I believe I've 
found the underlying issue.

If you have a look at this long backtrace, you can see that we are 
inside a garbage_collect call (frame #38).  An X11 focus event 
comes in, triggering a bunch of GTK/GDK/X calls.  Mysteriously, 
this leads to a maybe_quit() call which in turn calls longjmp(). 
longjmp jumps right out of the garbage collect, leaving it 
unfinished.

Internally in garbage_collect, consing_until_gc was set to the 
HI_THRESHOLD upper-bound.  It is left that way when longjmp leaps 
out of it, and no automatic garbage collect is ever performed 
again.  This is the start of the ballooning memory.

This also explains why my minimized emacs session never hits it 
and my work sessions hit it very often, and less often on 
weekends.  It's triggered by focus events.  I flitter around 
between windows constantly while working.

I don't know emacs internals, so you'll have to figure out if this 
is X dependent (probably) and/or GTK dependent.  It should be 
possible to come up with an easier way to reproduce it now.

Backtrace:
-----------
(gdb) bt #0  0x00007ffff5571230 in siglongjmp () at 
/usr/lib/libc.so.6 #1  0x00005555557bd38d in unwind_to_catch 
(catch=0x555555dfc320, type=NONLOCAL_EXIT_THROW, value=0x30) at 
eval.c:1181 #2  0x00005555557bd427 in Fthrow (tag=0xe75830, 
value=0x30) at eval.c:1198 #3  0x00005555557bdea7 in 
process_quit_flag () at eval.c:1526 #4  0x00005555557bdeef in 
maybe_quit () at eval.c:1547 #5  0x00005555557cbbb1 in Fassq 
(key=0xd0b0, alist=0x55555901c573) at fns.c:1609 #6 
0x0000555555632b63 in window_parameter (w=0x555555f2d088, 
parameter=0xd0b0) at window.c:2262 #7  0x000055555563a075 in 
window_wants_tab_line (w=0x555555f2d088) at window.c:5410 #8 
0x00005555555c22b1 in get_phys_cursor_geometry (w=0x555555f2d088, 
row=0x55555d9f3ef0, glyph=0x55555fd20e00, xp=0x7fffffff9c48, 
yp=0x7fffffff9c4c, heightp=0x7fffffff9c50) at xdisp.c:2650 #9 
0x00005555556c1b12 in x_draw_hollow_cursor (w=0x555555f2d088, 
row=0x55555d9f3ef0) at xterm.c:9495 #10 0x00005555556c24f9 in 
x_draw_window_cursor (w=0x555555f2d088, glyph_row=0x55555d9f3ef0, 
x=32, y=678, cursor_type=HOLLOW_BOX_CURSOR, cursor_width=1, 
on_p=true, active_p=false) at xterm.c:9682 #11 0x000055555561a922 
in display_and_set_cursor (w=0x555555f2d088, on=true, hpos=2, 
vpos=18, x=32, y=678) at xdisp.c:31738 #12 0x000055555561aa5b in 
update_window_cursor (w=0x555555f2d088, on=true) at xdisp.c:31773 
#13 0x000055555561aabf in update_cursor_in_window_tree 
(w=0x555555f2d088, on_p=true) at xdisp.c:31791 #14 
0x000055555561aaab in update_cursor_in_window_tree 
(w=0x55555907a490, on_p=true) at xdisp.c:31789 #15 
0x000055555561aaab in update_cursor_in_window_tree 
(w=0x55555a514b68, on_p=true) at xdisp.c:31789 #16 
0x000055555561ab37 in gui_update_cursor (f=0x555556625468, 
on_p=true) at xdisp.c:31805 #17 0x00005555556b9829 in 
x_frame_unhighlight (f=0x555556625468) at xterm.c:4490 #18 
0x00005555556ba22d in x_frame_rehighlight (dpyinfo=0x55555626d6c0) 
at xterm.c:4852 #19 0x00005555556b98fc in x_new_focus_frame 
(dpyinfo=0x55555626d6c0, frame=0x0) at xterm.c:4520 #20 
0x00005555556b9a3d in x_focus_changed (type=10, state=2, 
dpyinfo=0x55555626d6c0, frame=0x555556625468, bufp=0x7fffffffa0d0) 
at xterm.c:4554 #21 0x00005555556ba0a6 in x_detect_focus_change 
(dpyinfo=0x55555626d6c0, frame=0x555556625468, 
event=0x7fffffffa840, bufp=0x7fffffffa0d0) at xterm.c:4787 #22 
0x00005555556c0235 in handle_one_xevent (dpyinfo=0x55555626d6c0, 
event=0x7fffffffa840, finish=0x555555c901d4 <current_finish>, 
hold_quit=0x7fffffffab50) at xterm.c:8810 #23 0x00005555556bde28 
in event_handler_gdk (gxev=0x7fffffffa840, ev=0x55555cccf0c0, 
data=0x0) at xterm.c:7768 #24 0x00007ffff75f780f in  () at 
/usr/lib/libgdk-3.so.0 #25 0x00007ffff75fb3cb in  () at 
/usr/lib/libgdk-3.so.0 #26 0x00007ffff759f15b in 
gdk_display_get_event () at /usr/lib/libgdk-3.so.0 #27 
0x00007ffff75fb104 in  () at /usr/lib/libgdk-3.so.0 #28 
0x00007ffff6fcb8f4 in g_main_context_dispatch () at 
/usr/lib/libglib-2.0.so.0 #29 0x00007ffff701f821 in  () at 
/usr/lib/libglib-2.0.so.0 #30 0x00007ffff6fca121 in 
g_main_context_iteration () at /usr/lib/libglib-2.0.so.0 #31 
0x00007ffff784e2c7 in gtk_main_iteration () at 
/usr/lib/libgtk-3.so.0 #32 0x00005555556c1821 in XTread_socket 
(terminal=0x5555560b7460, hold_quit=0x7fffffffab50) at 
xterm.c:9395 #33 0x000055555570f3a2 in gobble_input () at 
keyboard.c:6890 #34 0x000055555570f894 in handle_async_input () at 
keyboard.c:7121 #35 0x000055555570f8dd in process_pending_signals 
() at keyboard.c:7139 #36 0x000055555570f9cf in unblock_input_to 
(level=0) at keyboard.c:7162 #37 0x000055555570fa4c in 
unblock_input () at keyboard.c:7187 #38 0x000055555578f49a in 
garbage_collect () at alloc.c:6121 #39 0x000055555578efe7 in 
maybe_garbage_collect () at alloc.c:5964 #40 0x00005555557bb292 in 
maybe_gc () at lisp.h:5041 #41 0x00005555557c12d6 in Ffuncall 
(nargs=2, args=0x7fffffffad68) at eval.c:2793 #42 
0x000055555580f7d6 in exec_byte_code
...  --------------

For breakpoints, I am doing the following:

1) make a global static variable in alloc.c:
static int enable_gc_trace = 0;

2) in garbage_collect(), 'enable_gc_trace++' when it starts and 
'enable_gc_trace--' when it ends.  I just wrapped the call to 
unblock_input(), but you could widen that window.

3) run in gdb with conditional breakpoints on GC and longjmp 
functions:
b siglongjmp if enable_gc_trace > 0
b internal_catch if enable_gc_trace > 0
b internal_catch_all if enable_gc_trace > 0
b maybe_garbage_collect if enable_gc_trace > 0

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 14 Dec 2020 21:25:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 14 16:25:06 2020
Received: from localhost ([127.0.0.1]:54717 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kovL7-0006Ae-PU
	for submit <at> debbugs.gnu.org; Mon, 14 Dec 2020 16:25:06 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:44289)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kovL6-00069z-1V
 for 43389 <at> debbugs.gnu.org; Mon, 14 Dec 2020 16:25:04 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 628E860694;
 Mon, 14 Dec 2020 22:24:57 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607981097;
 bh=MFMtcsEMjrog7XnbVOuggW7KMuosBxlCxZoGrE+l2iI=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=ZWL9u7fFbcfGBIMjwFeQ0kFD7uOUtCZJBtOjV0b8FFvraiRlxrtdY2Y4yytPyxYN1
 KCLELEidenKIOP/FrG/R9/LynBal442f9uyNnqBlf8di1uhwnWQhYnLg2T098/Dk8I
 Qk4uo3p77fVv3+6aTZ6mKLP+HWwDjJRlXqzwmtoo=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83mtyhcbno.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN> <83mtyhcbno.fsf@HIDDEN>
Date: Mon, 14 Dec 2020 22:24:56 +0100
Message-ID: <87ft48qdw7.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> > Does thread-last-error return something non-nil?  
>>  Nope, nil in all instance, including the one in a weird state. 
> 
> Then it's unlikely that a thread died unnatural death. 
> 

No, sure doesn't seem like it.  Just hit it in an instance with 
more printfs, and it looks like it leaps right out of some 
sub-call of process_pending_signals(), continuing to run elsewhere 
without finishing garbage_collect().  To me, that means exactly 
one thing: longjmp.

If something manages to longjmp out of garbage_collect() at that 
point, it leaves with consing_until_gc set to HI_THRESHOLD.  This 
must explain why automatic GC stops running for hours or days, but 
manual GCs still work.

I tried setting a breakpoint in longjmp, but it's called 3 times 
for every keypress!  That's inconvenient.  Running one single 
instance now with a conditional breakpoint on longjmp: it will 
break if longjmp is called while it's in unblock_input().

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 14 Dec 2020 03:25:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 13 22:25:02 2020
Received: from localhost ([127.0.0.1]:50795 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koeTu-0003D9-L7
	for submit <at> debbugs.gnu.org; Sun, 13 Dec 2020 22:25:02 -0500
Received: from eggs.gnu.org ([209.51.188.92]:36894)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1koeTt-0003Cc-NX
 for 43389 <at> debbugs.gnu.org; Sun, 13 Dec 2020 22:25:02 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46184)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1koeTn-0003H6-Hm; Sun, 13 Dec 2020 22:24:55 -0500
Received: from [176.228.60.248] (port=1212 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1koeTm-0000TF-N7; Sun, 13 Dec 2020 22:24:55 -0500
Date: Mon, 14 Dec 2020 05:24:43 +0200
Message-Id: <83mtyhcbno.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87k0tlqvzv.fsf@HIDDEN> (message from Trevor
 Bentley on Sun, 13 Dec 2020 21:41:40 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
 <87k0tlqvzv.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: michael_heerdegen@HIDDEN, monnier@HIDDEN, carlos@HIDDEN,
>  fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN
> Cc: 
> Date: Sun, 13 Dec 2020 21:41:40 +0100
> 
> > Does thread-last-error return something non-nil? 
> 
> Nope, nil in all instance, including the one in a weird state.

Then it's unlikely that a thread died unnatural death.

> I'm running one instance with printfs in some of the 
> unblock_input() functions, and one in gdb with breakpoints on 
> Fmake_thread, pthread_create, and emacs_abort.  If you have other 
> suggested probe points, I'm happy to test.

A breakpoint in watch_gc_cons_percentage, perhaps, to see if and when
the threshold gets changed?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 13 Dec 2020 20:41:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 13 15:41:50 2020
Received: from localhost ([127.0.0.1]:50519 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koYBh-0004k3-Na
	for submit <at> debbugs.gnu.org; Sun, 13 Dec 2020 15:41:49 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:37336)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1koYBf-0004jL-Mn
 for 43389 <at> debbugs.gnu.org; Sun, 13 Dec 2020 15:41:47 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 48DEA60256;
 Sun, 13 Dec 2020 21:41:41 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607892101;
 bh=b6dv1HupdnzWoUYptGjiGxKowrS3YdEvclr3GRcdfAU=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=XcQTjeK838gNt1AYZRM8DnsTouSYLVrjb+L2f1vuR2UYgPBSeMiAaJIRjLA/63u+I
 P45ndGg7jy6G9gRyhXByfreEnsiDEc9DbSFPuxoqjy8ZM+P3292cSUbRY/ujwoMh9u
 wcaXAfTPtRXYO/rWK63usblG/bALF5L4dLjIKEZ0=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83o8ixcv9v.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN> <83o8ixcv9v.fsf@HIDDEN>
Date: Sun, 13 Dec 2020 21:41:40 +0100
Message-ID: <87k0tlqvzv.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> Does thread-last-error return something non-nil? 

Nope, nil in all instance, including the one in a weird state.

I'm running one instance with printfs in some of the 
unblock_input() functions, and one in gdb with breakpoints on 
Fmake_thread, pthread_create, and emacs_abort.  If you have other 
suggested probe points, I'm happy to test.

Opening 10 emacses at a time seems to be going better for 
reproducing.  Sometimes it triggers in an hour, sometimes in 3 
days, but if I just flood the system with emacs processes I tend 
to hit it within a day.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 13 Dec 2020 20:21:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 13 15:21:30 2020
Received: from localhost ([127.0.0.1]:50437 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koXru-0003Bl-77
	for submit <at> debbugs.gnu.org; Sun, 13 Dec 2020 15:21:30 -0500
Received: from eggs.gnu.org ([209.51.188.92]:47034)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1koXrs-0003Ay-Al
 for 43389 <at> debbugs.gnu.org; Sun, 13 Dec 2020 15:21:21 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41218)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1koXrm-0005Zd-8u; Sun, 13 Dec 2020 15:21:14 -0500
Received: from [176.228.60.248] (port=3217 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1koXrl-00057y-Dm; Sun, 13 Dec 2020 15:21:13 -0500
Date: Sun, 13 Dec 2020 22:21:00 +0200
Message-Id: <83o8ixcv9v.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87mtyhqxy1.fsf@HIDDEN> (message from Trevor
 Bentley on Sun, 13 Dec 2020 20:59:34 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
 <87mtyhqxy1.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: michael_heerdegen@HIDDEN, monnier@HIDDEN, carlos@HIDDEN,
>  fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN
> Cc: 
> Date: Sun, 13 Dec 2020 20:59:34 +0100
> 
> > As long as the main thread runs, you might indeed see nothing 
> > special. 
> 
> This was exactly my thought: a thread I'm not even aware of must 
> be silently crashing and leaving GC in a bad state.
> 
> But there's only a single case of 'make-thread' in my ~/.emacs.d/, 
> and it's extremely unlikely that function ever runs 
> ("lsp-download-install").
> 
> More importantly, I'm comparing (list-threads) in emacs and "info 
> threads" in gdb, and the failed instance looks identical to the 
> non-failed instances: a single emacs thread ("Main"), and three 
> real threads ("emacs", "gmain", "gdbus").  garbage_collect() not 
> present in any backtrace when interrupted.
> 
> I'm at a loss for how it teleported out of that garbage_collect() 
> call.  Back to printf, I guess.  Maybe there was a short-lived 
> thread that isn't normally running...

Does thread-last-error return something non-nil?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 13 Dec 2020 19:59:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 13 14:59:42 2020
Received: from localhost ([127.0.0.1]:50347 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koXWw-0001YV-9t
	for submit <at> debbugs.gnu.org; Sun, 13 Dec 2020 14:59:42 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:37112)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1koXWv-0001Y0-Di
 for 43389 <at> debbugs.gnu.org; Sun, 13 Dec 2020 14:59:41 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 4197960D0F;
 Sun, 13 Dec 2020 20:59:35 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607889575;
 bh=mUzBSF+99CrwNiPEUdrdVih8IL/k4rNE+BW+5H0ECas=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=WM0+OLxUr4Qqv1VGxk97yQiZdI1ZrEjJVL5PDLeNjYuaSHFHYtO5BD5apNw8hL4+n
 PuhgotsKh6EJR/SEuX9TxtSQ7EJdtfdXNvL8POj3czxUcSqpw/rrCXIKBZpLfinzMj
 znRSDyx8zt78vlV02ULjz1BDQXrn/FT/wL/LtVxg=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83pn3dcx89.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN> <83pn3dcx89.fsf@HIDDEN>
Date: Sun, 13 Dec 2020 20:59:34 +0100
Message-ID: <87mtyhqxy1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> Hmm, that makes it trickier.  No clue if my default packages 
>> launch threads, but it's possible. 
> 
> Grep them for make-thread. 
> 
>> I just hit the bug in one of my sessions: the call to 
>> unblock_input() in garbage_collect() never returns. 
> 
> If that ran in a thread, perhaps the thread died. 
> 
>> But the session still completely works, so I'm not really sure 
>> what's going on here. 
> 
> As long as the main thread runs, you might indeed see nothing 
> special. 

This was exactly my thought: a thread I'm not even aware of must 
be silently crashing and leaving GC in a bad state.

But there's only a single case of 'make-thread' in my ~/.emacs.d/, 
and it's extremely unlikely that function ever runs 
("lsp-download-install").

More importantly, I'm comparing (list-threads) in emacs and "info 
threads" in gdb, and the failed instance looks identical to the 
non-failed instances: a single emacs thread ("Main"), and three 
real threads ("emacs", "gmain", "gdbus").  garbage_collect() not 
present in any backtrace when interrupted.

I'm at a loss for how it teleported out of that garbage_collect() 
call.  Back to printf, I guess.  Maybe there was a short-lived 
thread that isn't normally running...

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 13 Dec 2020 19:39:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 13 14:39:08 2020
Received: from localhost ([127.0.0.1]:50308 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koXD1-0008Sq-Ty
	for submit <at> debbugs.gnu.org; Sun, 13 Dec 2020 14:39:08 -0500
Received: from eggs.gnu.org ([209.51.188.92]:37244)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1koXD0-0008S3-83
 for 43389 <at> debbugs.gnu.org; Sun, 13 Dec 2020 14:39:06 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40708)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1koXCu-0007OD-CE; Sun, 13 Dec 2020 14:39:00 -0500
Received: from [176.228.60.248] (port=4613 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1koXCs-0003d6-NM; Sun, 13 Dec 2020 14:39:00 -0500
Date: Sun, 13 Dec 2020 21:38:46 +0200
Message-Id: <83pn3dcx89.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87r1ntqz4c.fsf@HIDDEN> (message from Trevor
 Bentley on Sun, 13 Dec 2020 20:34:11 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
 <87r1ntqz4c.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: michael_heerdegen@HIDDEN, monnier@HIDDEN, carlos@HIDDEN,
>  fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN
> Cc: 
> Date: Sun, 13 Dec 2020 20:34:11 +0100
> 
> >> Garbage collect never runs on other threads/forks, right? 
> > 
> > If you use packages or commands that create Lisp threads, I 
> > think GC can run from any of these Lisp threads. 
> 
> Hmm, that makes it trickier.  No clue if my default packages 
> launch threads, but it's possible.

Grep them for make-thread.

> I just hit the bug in one of my sessions: the call to 
> unblock_input() in garbage_collect() never returns.

If that ran in a thread, perhaps the thread died.

> But the session still completely works, so I'm not really sure
> what's going on here.

As long as the main thread runs, you might indeed see nothing special.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 13 Dec 2020 19:34:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 13 14:34:19 2020
Received: from localhost ([127.0.0.1]:50298 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koX8N-00086L-3p
	for submit <at> debbugs.gnu.org; Sun, 13 Dec 2020 14:34:19 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:36968)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1koX8M-00085m-2x
 for 43389 <at> debbugs.gnu.org; Sun, 13 Dec 2020 14:34:18 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id BF83960F0A;
 Sun, 13 Dec 2020 20:34:11 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607888051;
 bh=cJjskamOjTtdQ9lBuj/bR+ySZUECdyuv48qxyqsZcG8=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=UBJj9nmnneIKYS16ZTc3By1VajLGDV0NI8TwswUcwmdksgCqz3+if+3k9iuDr1XN9
 pzVy+REtBdf4FQ2y7u8JZEoaxXzBX9EeVQ8G1aGv3sYzvpZuy3ZKfzFKlhNZnarQY+
 qOIPRQ1XG9UiyUpkG0+d96C3jhOkdIoqzfBHsX/0=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <833609ena5.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN> <833609ena5.fsf@HIDDEN>
Date: Sun, 13 Dec 2020 20:34:11 +0100
Message-ID: <87r1ntqz4c.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Garbage collect never runs on other threads/forks, right? 
> 
> If you use packages or commands that create Lisp threads, I 
> think GC can run from any of these Lisp threads. 

Hmm, that makes it trickier.  No clue if my default packages 
launch threads, but it's possible.

I just hit the bug in one of my sessions: the call to 
unblock_input() in garbage_collect() never returns.  But the 
session still completely works, so I'm not really sure what's 
going on here.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 13 Dec 2020 15:31:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 13 10:31:06 2020
Received: from localhost ([127.0.0.1]:49933 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koTKz-0006hd-Px
	for submit <at> debbugs.gnu.org; Sun, 13 Dec 2020 10:31:06 -0500
Received: from eggs.gnu.org ([209.51.188.92]:43820)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1koTKw-0006h7-Gr
 for 43389 <at> debbugs.gnu.org; Sun, 13 Dec 2020 10:31:04 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:36514)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1koTKq-0005K8-2L; Sun, 13 Dec 2020 10:30:56 -0500
Received: from [176.228.60.248] (port=4336 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1koTKp-0002rU-8r; Sun, 13 Dec 2020 10:30:55 -0500
Date: Sun, 13 Dec 2020 17:30:42 +0200
Message-Id: <833609ena5.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87tusqqa6n.fsf@HIDDEN> (message from Trevor
 Bentley on Sun, 13 Dec 2020 11:20:32 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
 <87tusqqa6n.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: monnier@HIDDEN, carlos@HIDDEN, fweimer@HIDDEN,
>  43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN
> Cc: 
> Date: Sun, 13 Dec 2020 11:20:32 +0100
> 
> I have one instance running that has clearly hit the problem. 
> garbage_collect() never printed its "end" message, and there have 
> been no further garbage collects in nearly 20 hours:
> 
> ----
> 1607783297: garbage_collect start 1607783297: gc_sweep start 
> 1607783297: gc_sweep end (0 s) ----
> 
> Right now, I'm leaning towards this being the root cause. 
> Something is causing a garbage collect to crash or hang or 
> otherwise exit in some unknown way, and automatic garbage 
> collection gets disabled until I manually retrigger it.
> 
> Garbage collect never runs on other threads/forks, right?

If you use packages or commands that create Lisp threads, I think GC
can run from any of these Lisp threads.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 13 Dec 2020 10:20:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 13 05:20:41 2020
Received: from localhost ([127.0.0.1]:47461 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koOUb-0006so-DG
	for submit <at> debbugs.gnu.org; Sun, 13 Dec 2020 05:20:41 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:34379)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1koOUZ-0006s9-0m
 for 43389 <at> debbugs.gnu.org; Sun, 13 Dec 2020 05:20:39 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 1734D602DE;
 Sun, 13 Dec 2020 11:20:33 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607854833;
 bh=kzlKwGgGCn351D6OitbVWGniRvAxnTO6an4jUAI8/YA=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=NZe3b42TVBSKfUi0ytC/zCWgjo4nOHtEnSwVFxe+U6YB4aletUD067bC0FPNbQqoj
 qmnrKlvdTZ8nrQTJWVW0u444p4CJ3OfC0X98qz6phoo0wyxq9DIOIQgQIaynXoQmI4
 SlvYIB1xKorzCu12+VCHKfXe0KbN7dyfVgsLanmE=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83eejue5v8.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN> <83eejue5v8.fsf@HIDDEN>
Date: Sun, 13 Dec 2020 11:20:32 +0100
Message-ID: <87tusqqa6n.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, monnier@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> Dunno if it matters, but `gnus-registry-save' binds it 
>> temporarily to a high value 
> 
> I'd prefer very much that our core code never did that. 

I'm not sure what that is, but I'm not calling it directly, and 
probably not indirectly either.  Not doing any mail reading in the 
instances that are inflating.

I print the gc variables in each of my log analyses, and they have 
always been the same: the default.

I have one instance running that has clearly hit the problem. 
garbage_collect() never printed its "end" message, and there have 
been no further garbage collects in nearly 20 hours:

----
1607783297: garbage_collect start 1607783297: gc_sweep start 
1607783297: gc_sweep end (0 s) ----

Right now, I'm leaning towards this being the root cause. 
Something is causing a garbage collect to crash or hang or 
otherwise exit in some unknown way, and automatic garbage 
collection gets disabled until I manually retrigger it.

Garbage collect never runs on other threads/forks, right?  If it 
were hung forever inside garbage_collect(), I would expect the 
whole window to be frozen, but it is not.

I'll add more printfs in garbage_collect() and try to figure out 
where it is exiting.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 13 Dec 2020 03:35:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 22:35:00 2020
Received: from localhost ([127.0.0.1]:47233 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koI9z-0000Pk-Nb
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 22:34:59 -0500
Received: from eggs.gnu.org ([209.51.188.92]:40884)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1koI9y-0000PW-0f
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 22:34:58 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:57378)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1koI9r-0003jl-Pu; Sat, 12 Dec 2020 22:34:51 -0500
Received: from [176.228.60.248] (port=4410 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1koI9p-0005QT-FA; Sat, 12 Dec 2020 22:34:50 -0500
Date: Sun, 13 Dec 2020 05:34:35 +0200
Message-Id: <83eejue5v8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
In-Reply-To: <87zh2i7jqp.fsf@HIDDEN> (message from Michael Heerdegen on Sat,
 12 Dec 2020 23:16:46 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <87zh2i7jqp.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 carlos@HIDDEN, trevor@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Michael Heerdegen <michael_heerdegen@HIDDEN>
> Cc: Trevor Bentley <trevor@HIDDEN>,  monnier@HIDDEN,
>   carlos@HIDDEN,  fweimer@HIDDEN,  43389 <at> debbugs.gnu.org,
>   bugs@HIDDEN,  dj@HIDDEN
> Date: Sat, 12 Dec 2020 23:16:46 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Could it be that some of your packages plays with the value of GC
> > threshold?
> 
> Dunno if it matters, but `gnus-registry-save' binds it temporarily to a
> high value

I'd prefer very much that our core code never did that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 22:17:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 17:17:36 2020
Received: from localhost ([127.0.0.1]:47020 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koDCp-0000QL-Mt
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 17:17:35 -0500
Received: from mout.web.de ([212.227.15.3]:39005)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1koDCo-0000Q5-6m
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 17:17:34 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1607811409;
 bh=LPqjoXBJGHFHLw9e0sW1LB0FVUm6z+TGUAOu0PIlXNA=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=F5ZVTvVg11OnrgHvpeGibqcjrSV9e7J1onbAQI8xZp/5PKlpb/Oe+6P2BgRoJQv54
 GIEssujVo+qIdPlu77FU+dVfI0pIxaosYmCsrlMa44PnUApzQKUvU0n61/RrO5F2xI
 A0ySvlaL2K6TMjr1ZgIkg4XmE5dbXrdbvMf6Lwo4=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([88.67.99.46]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1Mfc4q-1kCyhE3W4u-00gB5J; Sat, 12
 Dec 2020 23:16:48 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
Date: Sat, 12 Dec 2020 23:16:46 +0100
In-Reply-To: <837dpn1ccp.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 12 Dec
 2020 13:40:38 +0200")
Message-ID: <87zh2i7jqp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:W0icIgJvlEnTS6B3g6Wt0vPC8HDdJS8hIYUnyYZWJ6FhpJ1G8h5
 GzSyS6loxIaMQ9LtUgkRC4Hqw8ecTZtRCORbc0atm0iN5RM0sfxbP80tBbn2uCCek++OsTa
 K7yHucaSaijZg6P5jU4t78V06eX9CYI//zaK9HWtBWGtJ1vRKohQhazG6fdPZe3Exi98dSO
 hB/LllA4MItsJczOlksHw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:rVqtrHaKtDU=:wtx77d8Hzwi9ntjZwqFBS4
 0HO6itr1u/0s6bl35Tzrt9n13rQ28eughWyZ2/MMtbkyWA7mK5g691Famv/f2fayacSQlbOiW
 FNO5a6fLy0LvcpfE5cFtM5BDTdwhNNnRz2chxFhzIg9CDKHi4uncPsSUKtWk6ysb/Iv0meatp
 SkF/4+E47rNp2KLi4gBY+vFV/vpUTLIQfUp11ioFee1Oc4w69DCPxJTGlsQC4q0ovkOobmA5y
 5P0hwsWwjVw56c45x+EHKuDhjJckeKqyMUrEL1fxvoYKOmvqeWlFy2qQQsIyuEgkcxP8qYR40
 Kp85MXHysxwb6Xw44XiwSFj7cdE9Y0vDlbAn3/Q7nM8FL6J58c6aWaZXtslT8QQGflk43NJuO
 TmTN+pKOgt3IEZfuJuSLJdAPQO2k0r+gFhxoqdoKYjSRFnILpm9ZYaXMBvcaqyvbH/DYV32aD
 or3teXFdY8BklpAyPMGgDA5jeF3TNmUqXPyOxt573EzoG2AXxt7oFC89YtNMaTe0MkLY2evkC
 UaTTZD6d7twOUz0peIkILV5+6ShgUvp0sqx8k+U24bvuGDT7SK1PnVdS82+UtyqOfrfF7zJvN
 dCFboAv1gq9QFPGJOPKnJeL4kzFx/NEvAZHx2sv2mhUeOKrz06wy9tirgWQEHNEiLBEJ+Y96+
 nZZy5My8gQSbGmA73HZ2AE1ceRIoBwMFqHdGMCHVcFGvHEQEcHWwW1YGSCNITnK97hZO5DOdb
 soMKGULKbj2JEoG8Z8JD5X0MC/uKm40Rani4JDqF4QmiiX3lpZBSWg/vgZWtu05z5rrteFrfH
 /AMjKgwU7irwYI/6yh2uSBpqURSWgY2UzJ0kPVSxTVFqK+ld2X+qcIrXuunatIkpR+O4hXya5
 DWBwQSHOvhta+aF2EnLk10DG3R5xK/v0vL+qRJ95o=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 carlos@HIDDEN, Trevor Bentley <trevor@HIDDEN>,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Could it be that some of your packages plays with the value of GC
> threshold?

Dunno if it matters, but `gnus-registry-save' binds it temporarily to a
high value, and I once had experienced memory grow largely while using
Gnus.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 20:14:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 15:14:14 2020
Received: from localhost ([127.0.0.1]:46750 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koBHS-0001F6-AW
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 15:14:14 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:58681)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1koBHQ-0001Es-91
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 15:14:12 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 65DD5602F4;
 Sat, 12 Dec 2020 21:14:06 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607804046;
 bh=5dE1juXR3cttBBZMdlC+SPlV24kRBrSoodaDfzOTMUw=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=dMHH9mJH1xpe7Z8+I4cpYLUZEa2NDTu7lFBO77B4KNwZBgXvP4YcwGcRrQf1kIqBl
 7+0isfdrAM+pRCFyTT+j3xdBKSzLBwXoNYgfGaFy1BS9ujBcOfZAuBSMO2LseaFYKu
 ZwiM3joKRRRI0EtUeeR1GlLumkukCT/tTwcZBPcY=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83lfe2erbg.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <jwvk0tmon3o.fsf-monnier+emacs@HIDDEN> <83pn3eesq3.fsf@HIDDEN>
 <jwveejuoltx.fsf-monnier+emacs@HIDDEN> <83lfe2erbg.fsf@HIDDEN>
Date: Sat, 12 Dec 2020 21:14:05 +0100
Message-ID: <87wnxmrdde.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Could be, but for tens of minutes? 
> 
> If the system is paging, it could take that long, yes. 
> 
>> AFAIK gc_sweep shouldn't cause too much thrashing either (the 
>> sweep is a mostly sequential scan of memory, so even if the 
>> total heap is larger than your total RAM, it should be ~O(total 
>> heap size / bandwidth from 

In my particular case, I have plenty of free memory.  I assume 
nothing is paging to disk in any of my reports, though I haven't 
thought to explicitly check.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 19:51:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 14:51:39 2020
Received: from localhost ([127.0.0.1]:46691 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koAvb-0006wm-Fe
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 14:51:39 -0500
Received: from eggs.gnu.org ([209.51.188.92]:48230)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1koAvZ-0006wY-Cc
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 14:51:37 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50736)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1koAvT-00024w-H6; Sat, 12 Dec 2020 14:51:31 -0500
Received: from [176.228.60.248] (port=4006 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1koAvS-0000rw-S6; Sat, 12 Dec 2020 14:51:31 -0500
Date: Sat, 12 Dec 2020 21:51:15 +0200
Message-Id: <83lfe2erbg.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <jwveejuoltx.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Sat, 12 Dec 2020 14:46:20 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <jwvk0tmon3o.fsf-monnier+emacs@HIDDEN> <83pn3eesq3.fsf@HIDDEN>
 <jwveejuoltx.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: trevor@HIDDEN,  carlos@HIDDEN,  fweimer@HIDDEN,
>   43389 <at> debbugs.gnu.org,  bugs@HIDDEN,  dj@HIDDEN,
>   michael_heerdegen@HIDDEN
> Date: Sat, 12 Dec 2020 14:46:20 -0500
> 
> > Sure.  But isn't that the same as what I said, just from another POV?
> > "A lot of objects to sweep" means there are many objects that aren't
> > live and need to have their memory freed.
> >
> > Since GC wasn't run for many hours, having a lot of garbage to collect
> > is expected, right?
> 
> Could be, but for tens of minutes?

If the system is paging, it could take that long, yes.

> AFAIK gc_sweep shouldn't cause too much thrashing either (the sweep is
> a mostly sequential scan of memory, so even if the total heap is larger
> than your total RAM, it should be ~O(total heap size / bandwidth from
> swap partition)), so I can't imagine how we could spend tens of minutes
> doing gc_sweep (or maybe the time is spend in gc_sweep but doing
> something else than the sweep itself, e.g. handling weak pointers, or
> removing dead markers from marker lists, ... still seems hard to
> imagine spending tens of minutes, tho).

Does gc_sweep involve touching all the memory we free?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 19:46:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 14:46:30 2020
Received: from localhost ([127.0.0.1]:46650 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koAqc-0006lp-J5
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 14:46:30 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:4869)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1koAqa-0006la-Q5
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 14:46:29 -0500
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 32F581002B8;
 Sat, 12 Dec 2020 14:46:23 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id D6946100236;
 Sat, 12 Dec 2020 14:46:21 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1607802381;
 bh=SUzgFWeEJixFauDpW1Tc+QIxO9gut6Z5Yu/UfiTnM6I=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=YOUQyLbPrZsU+D9ZcUl5bLCBcXmMxMQ0YxUlJruE5AZlmsg1WhzHof6JzM6JOrMn0
 YhEL/meLLkFNujtHHZaKE+voUp50g9VjG6FEoEj3UPT0JzK62EtpiDjg0fi9INkTp/
 EKWcU7AWJGztjzxKZ/sO3j+Qh2nJMt/6Iqo95VFYGoq1fgjY0lsMm3PTYxmKAC1UcA
 HuoPNHVQtseX5sv1g7fvWGSrw9M3meXCXfgCKow7WgDWmnoCe3vR8HAqOWgGvSTN0i
 aH4R4YpARSevGHFvVQiAYbtXEvRM3o7OnQIdVDSvPrMmHJ6ltoR+0MviTnUsXNM7ZX
 1JKWUylN+4FAA==
Received: from alfajor (69-165-136-52.dsl.teksavvy.com [69.165.136.52])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 738E71202FE;
 Sat, 12 Dec 2020 14:46:21 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwveejuoltx.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <jwvk0tmon3o.fsf-monnier+emacs@HIDDEN> <83pn3eesq3.fsf@HIDDEN>
Date: Sat, 12 Dec 2020 14:46:20 -0500
In-Reply-To: <83pn3eesq3.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 12 Dec
 2020 21:20:52 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.078 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Sure.  But isn't that the same as what I said, just from another POV?
> "A lot of objects to sweep" means there are many objects that aren't
> live and need to have their memory freed.
>
> Since GC wasn't run for many hours, having a lot of garbage to collect
> is expected, right?

Could be, but for tens of minutes?

AFAIK gc_sweep shouldn't cause too much thrashing either (the sweep is
a mostly sequential scan of memory, so even if the total heap is larger
than your total RAM, it should be ~O(total heap size / bandwidth from
swap partition)), so I can't imagine how we could spend tens of minutes
doing gc_sweep (or maybe the time is spend in gc_sweep but doing
something else than the sweep itself, e.g. handling weak pointers, or
removing dead markers from marker lists, ... still seems hard to
imagine spending tens of minutes, tho).


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 19:21:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 14:21:17 2020
Received: from localhost ([127.0.0.1]:46577 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koASC-0003zN-QE
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 14:21:17 -0500
Received: from eggs.gnu.org ([209.51.188.92]:38052)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1koASB-0003z8-FY
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 14:21:15 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49939)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1koAS5-0008Pa-I2; Sat, 12 Dec 2020 14:21:09 -0500
Received: from [176.228.60.248] (port=2155 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1koAS4-0001JK-4x; Sat, 12 Dec 2020 14:21:09 -0500
Date: Sat, 12 Dec 2020 21:20:52 +0200
Message-Id: <83pn3eesq3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <jwvk0tmon3o.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Sat, 12 Dec 2020 14:14:39 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
 <jwvk0tmon3o.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: Trevor Bentley <trevor@HIDDEN>,  carlos@HIDDEN,
>   fweimer@HIDDEN,  43389 <at> debbugs.gnu.org,  bugs@HIDDEN,
>   dj@HIDDEN,  michael_heerdegen@HIDDEN
> Date: Sat, 12 Dec 2020 14:14:39 -0500
> 
> >> Not only that, but I added printfs in emacs itself around the 
> >> garbage_collect() and gc_sweep() functions.  Each line prints the 
> >> unix timestamp when it began, and the 'end' lines print the 
> >> duration since the start.  You can see that the entire 50 minutes 
> >> was spent in gc_sweep():
> >
> > I think this is expected if you have a lot of objects to sweep.
> 
> Actually, I'm surprised most of the time is spent in gc_sweep:
> mark_object is usually where most of the time is spent, so this suggests
> that the total heap size is *much* larger than the amount of live objects.

Sure.  But isn't that the same as what I said, just from another POV?
"A lot of objects to sweep" means there are many objects that aren't
live and need to have their memory freed.

Since GC wasn't run for many hours, having a lot of garbage to collect
is expected, right?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 19:14:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 14:14:50 2020
Received: from localhost ([127.0.0.1]:46562 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1koALy-0003oo-6w
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 14:14:50 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:33495)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1koALw-0003ob-T7
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 14:14:49 -0500
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 81696440F18;
 Sat, 12 Dec 2020 14:14:43 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id AD2A24404DE;
 Sat, 12 Dec 2020 14:14:41 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1607800481;
 bh=0ai4Ou4DlWS9MDSkI9Zub7yXwTSdvQwkg0f5lGCe7Rg=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=UlW1sJNoLysIERxklbBCga8Hy3IXeJIOE1N3WhFdG7gKPODlvV/mpaFEuseX245Xk
 rQSDEFx1F7ffCG7jo6PugFLxNyMnfcv5G0NBSX2JMMNLmdDMtvZOKDBTnmJt2Hq5PB
 +xu2WqXZu++P9kaVrCyAEeoPklMC/XmEcS4MVr4F6J2Tl9R2XMJCyONScX0oe4ZBx8
 DhYUp9T0F2YZMTA3PWvaZ55ZfDteBn9EkdQpQqd2iKqXMxcdPWsW7xYdZRuzHpjtQa
 ogTz8Xjk3ctJ2gy0ql1UyDdOoIfE6a3pLWJ3uM4UMS7XtAxnYCXQUP2h1BtXLnqtJ/
 h/VDqbAASIoVQ==
Received: from alfajor (69-165-136-52.dsl.teksavvy.com [69.165.136.52])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 3B6B5120314;
 Sat, 12 Dec 2020 14:14:41 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwvk0tmon3o.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN> <837dpn1ccp.fsf@HIDDEN>
Date: Sat, 12 Dec 2020 14:14:39 -0500
In-Reply-To: <837dpn1ccp.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 12 Dec
 2020 13:40:38 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.068 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, Trevor Bentley <trevor@HIDDEN>,
 michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> Not only that, but I added printfs in emacs itself around the 
>> garbage_collect() and gc_sweep() functions.  Each line prints the 
>> unix timestamp when it began, and the 'end' lines print the 
>> duration since the start.  You can see that the entire 50 minutes 
>> was spent in gc_sweep():
>
> I think this is expected if you have a lot of objects to sweep.

Actually, I'm surprised most of the time is spent in gc_sweep:
mark_object is usually where most of the time is spent, so this suggests
that the total heap size is *much* larger than the amount of live objects.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 18:32:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 13:32:58 2020
Received: from localhost ([127.0.0.1]:46448 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ko9hS-0000UW-Jd
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 13:32:58 -0500
Received: from eggs.gnu.org ([209.51.188.92]:43196)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ko9hO-0000TZ-PB
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 13:32:55 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:48115)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1ko9hI-0006rc-KH; Sat, 12 Dec 2020 13:32:48 -0500
Received: from [176.228.60.248] (port=4577 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ko3Gg-0003Gl-BT; Sat, 12 Dec 2020 06:40:55 -0500
Date: Sat, 12 Dec 2020 13:40:38 +0200
Message-Id: <837dpn1ccp.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87zh2jqnhi.fsf@HIDDEN> (message from Trevor
 Bentley on Sat, 12 Dec 2020 12:20:57 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87zh2jqnhi.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: carlos@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  bugs@HIDDEN, dj@HIDDEN, michael_heerdegen@HIDDEN
> Cc: 
> Date: Sat, 12 Dec 2020 12:20:57 +0100
> 
> Not only that, but I added printfs in emacs itself around the 
> garbage_collect() and gc_sweep() functions.  Each line prints the 
> unix timestamp when it began, and the 'end' lines print the 
> duration since the start.  You can see that the entire 50 minutes 
> was spent in gc_sweep():

I think this is expected if you have a lot of objects to sweep.

> And finally, here's what I find very suspicious: it was nearly 9 
> hours since the last garbage collect ran (1607726912 - 
> 1607695762).  This is an instance that I used all day long, 
> flittering back and forth between it and other work.  It had both 
> tons of interactive use, and tons of idle time.  I don't think 9 
> hours between garbage collects sounds right.

It isn't.  So it is now important to find out why this happens.  Could
it be that some of your packages plays with the value of GC threshold?

> The last garbage collect before the long manual one also never 
> printed an end message, which is confusing.  I see no early 
> returns in garbage_collect()... is there some macro that can 
> trigger a return, or maybe something uses longjmp?

Not that I know of, no.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 11:21:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 06:21:10 2020
Received: from localhost ([127.0.0.1]:44036 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ko2xa-0000Wp-0N
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 06:21:10 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:56163)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1ko2xU-0000Vv-5R
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 06:21:07 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 04E46605E7;
 Sat, 12 Dec 2020 12:20:57 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607772058;
 bh=K1o9jufAV8cxIbI3H+yWZgDR7zgwPjeHsr2TqZkde8o=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=B7SIe7OoUgmgeu44IFT0yuhg1tWxYc5TI1q/QRls0XBTK/C2hFjQLs2bOMjIP56oX
 3F/nOpUrSEnvpQwMJX+tpFvTc7qyJEJ2glVXVnk2gX59XclDPseVTu6mBO8tH9l8ds
 I22GAv9SwUFKWFwwmrbPT4K2GIU9FrO247Bbn6Gw=
From: Trevor Bentley <trevor@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
Date: Sat, 12 Dec 2020 12:20:57 +0100
Message-ID: <87zh2jqnhi.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Stefan Monnier <monnier@HIDDEN> writes:

> Do we have a `profiler-report` available for those 15 minutes? 
> I've taken a quick look at the massive threads in that bug 
> report, but haven't had the time to read in detail.  AFAICT we 
> don't have a profiler output for those 15minutes, so it would be 
> good to try: 
> 
>     M-x profiler-start RET RET M-x garbage-collect RET     ;; 
>     This should presumably take several minutes M-x 
>     profiler-report RET 
> 
> and then shows us this report (using C-u RET on the top-level 
> elements to unfold them). 

I'm back with a new mtrace, a profile of the long garbage-collect, 
and a new discovery.

First of all, the 26GB mtrace of a session that exploded to over 
8GB is available in mtrace12.tar.bz2 here:

https://trevorbentley.com/mtrace/

The summary log is in mtrace12_log.txt in the same directory, 
including output of profiler-report for only the duration of the 
garbage-collect, which took a record 50 minutes to complete.

As you can see in the profiler log, it is, in fact, the C 
garbage_collect() function eating all of the time:

----
;;(profiler-report) - ... 
901307  99% 
   Automatic GC 
   901281  99% 
 + trev/slack--refresh-cache 
 19  0%
----

Not only that, but I added printfs in emacs itself around the 
garbage_collect() and gc_sweep() functions.  Each line prints the 
unix timestamp when it began, and the 'end' lines print the 
duration since the start.  You can see that the entire 50 minutes 
was spent in gc_sweep():

----
1607695679: garbage_collect start 1607695680: gc_sweep start 
1607695680: gc_sweep end (0 s) 1607695680: garbage_collect #1085 
end (1 s) 1607695761: garbage_collect start 1607695762: gc_sweep 
start 1607695762: gc_sweep end (0 s) 1607726912: garbage_collect 
start 1607726913: gc_sweep start 1607729921: gc_sweep end (3008 s) 
1607729922: garbage_collect #1086 end (3010 s)
----

And finally, here's what I find very suspicious: it was nearly 9 
hours since the last garbage collect ran (1607726912 - 
1607695762).  This is an instance that I used all day long, 
flittering back and forth between it and other work.  It had both 
tons of interactive use, and tons of idle time.  I don't think 9 
hours between garbage collects sounds right.

The last garbage collect before the long manual one also never 
printed an end message, which is confusing.  I see no early 
returns in garbage_collect()... is there some macro that can 
trigger a return, or maybe something uses longjmp?

Thanks,

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 08:50:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 12 03:50:04 2020
Received: from localhost ([127.0.0.1]:43885 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ko0bM-0002uk-2l
	for submit <at> debbugs.gnu.org; Sat, 12 Dec 2020 03:50:04 -0500
Received: from mail-out.m-online.net ([212.18.0.10]:37986)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <whitebox@HIDDEN>) id 1ko0bK-0002u6-7v
 for 43389 <at> debbugs.gnu.org; Sat, 12 Dec 2020 03:50:02 -0500
Received: from frontend01.mail.m-online.net (unknown [192.168.8.182])
 by mail-out.m-online.net (Postfix) with ESMTP id 4CtLvC28Q1z1rynZ;
 Sat, 12 Dec 2020 09:49:59 +0100 (CET)
Received: from localhost (dynscan1.mnet-online.de [192.168.6.70])
 by mail.m-online.net (Postfix) with ESMTP id 4CtLvB6HDkz1t82F;
 Sat, 12 Dec 2020 09:49:58 +0100 (CET)
X-Virus-Scanned: amavisd-new at mnet-online.de
Received: from mail.mnet-online.de ([192.168.8.182])
 by localhost (dynscan1.mail.m-online.net [192.168.6.70]) (amavisd-new,
 port 10024)
 with ESMTP id GQbwIY-oo4f3; Sat, 12 Dec 2020 09:49:57 +0100 (CET)
X-Auth-Info: e1ARg9V5V22mO5dciQNA5NQBLcX649acZqdq405YeIGKIBEAxFNVy8jvzgHby1a9
Received: from hase.home (ppp-46-244-182-188.dynamic.mnet-online.de
 [46.244.182.188])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by mail.mnet-online.de (Postfix) with ESMTPSA;
 Sat, 12 Dec 2020 09:49:57 +0100 (CET)
Received: by hase.home (Postfix, from userid 1000)
 id 8FBDB102A56; Sat, 12 Dec 2020 09:49:56 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <X9QcuvkY5voVePhg@HIDDEN>
X-Yow: Oh, FISH sticks, CHEEZ WHIZ, GIN fizz, SHOW BIZ!!
Date: Sat, 12 Dec 2020 09:49:56 +0100
In-Reply-To: <X9QcuvkY5voVePhg@HIDDEN> (Jean Louis's message of
 "Sat, 12 Dec 2020 04:28:26 +0300")
Message-ID: <875z57wgqz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.4 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 Trevor Bentley <trevor@HIDDEN>, michael_heerdegen@HIDDEN,
 Stefan Monnier <monnier@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

On Dez 12 2020, Jean Louis wrote:

> My observation over time is that that running M-x garbage-collect
> created the same effect just as when I observed that Emacs starts
> doing something with hard disk and continues so for unpredicted number
> of minutes.

This is totally expected.  When you are tight on memory, rummaging
through all of it can only make things worse.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 7578 EB47 D4E5 4D69 2510  2552 DF73 E780 A9DA AEC1
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 12 Dec 2020 01:30:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 11 20:30:51 2020
Received: from localhost ([127.0.0.1]:43655 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kntkI-00009V-O0
	for submit <at> debbugs.gnu.org; Fri, 11 Dec 2020 20:30:50 -0500
Received: from stw1.rcdrun.com ([217.170.207.13]:33807)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kntkG-00009C-EW
 for 43389 <at> debbugs.gnu.org; Fri, 11 Dec 2020 20:30:49 -0500
Received: from localhost ([::ffff:41.202.241.42])
 (AUTH: PLAIN securesender, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by stw1.rcdrun.com with ESMTPSA
 id 00000000000442C7.000000005FD41D40.000078DE; Fri, 11 Dec 2020 18:30:40 -0700
Date: Sat, 12 Dec 2020 04:28:26 +0300
From: Jean Louis <bugs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X9QcuvkY5voVePhg@HIDDEN>
References: <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <83zh2l33fv.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, bugs@HIDDEN,
 carlos@HIDDEN, Trevor Bentley <trevor@HIDDEN>,
 michael_heerdegen@HIDDEN, Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Eli Zaretskii <eliz@HIDDEN> [2020-12-10 21:46]:
> Stefan, please help with this complex issue (or maybe several
> issues).  We have collected some evidence in this bug report, but I
> don't yet see where is this going, or how to make any real progress
> here.
> 
> One thing that I cannot explain is this:
> 
> > From: Trevor Bentley <trevor@HIDDEN>
> > Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN,
> >  dj@HIDDEN, michael_heerdegen@HIDDEN
> > Cc: 
> > Date: Tue, 08 Dec 2020 22:50:37 +0100
> > 
> > I've been too busy to modify emacs to print garbage collects, but 
> > these still show really long (garbage-collect) calls, often 
> > exceeding 15 minutes.
> 
> Trevor reported several times that automatic GC is fast as usual, but
> manual invocations of "M-x garbage-collect" take much longer, many
> minutes.  I don't understand how this could happen, because both
> methods of invoking GC do exactly the same job.

My observation over time is that that running M-x garbage-collect
created the same effect just as when I observed that Emacs starts
doing something with hard disk and continues so for unpredicted number
of minutes. Normally so long until I kill it. It could be 10-20
minutes that I have waited. So that could be where the problem lies.

Something happens inside of Emacs, automatic garbage-collect is
invoked which cannot soon finish its job.

About 2 times I invoked garbage-collect manually and caused about
visually same behavior to take place. I hope you understand this
explanation.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 11 Dec 2020 13:56:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 11 08:56:02 2020
Received: from localhost ([127.0.0.1]:40555 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knitt-0000u4-UX
	for submit <at> debbugs.gnu.org; Fri, 11 Dec 2020 08:56:02 -0500
Received: from quimby.gnus.org ([95.216.78.240]:34232)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1knitr-0000ti-PZ
 for 43389 <at> debbugs.gnu.org; Fri, 11 Dec 2020 08:56:00 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=aGebtYq+IHcHn3s8XWHuinjIG/Kbaw/7TzNCpG3Ze7s=; b=rEmqKcKkWStY6CouC1FbjYZPpW
 w9D80zFCfu4ONHNiVcS8KztLCcpKBMyMPyCN6pKtC9sylpBLEQuT6CxSGQ5smkYbF4dI7QENSr4FY
 FhGCc1sKHk/trd2FM5wGWnIeRBZSu3/1QClcOaLSzr1uFIsD2bMTMUF/lDz1a7LH1VXA=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kniti-00037d-Nn; Fri, 11 Dec 2020 14:55:53 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: "Jose A. Ortega Ruiz" <jao@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <87v9edk4eb.fsf@HIDDEN> <87imadcqqk.fsf@HIDDEN>
 <87h7pxjrh5.fsf@HIDDEN> <87eel1cq83.fsf@HIDDEN>
 <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN> <87a6vpcphp.fsf@HIDDEN>
 <83ft5h2pks.fsf@HIDDEN> <87tutxi2cz.fsf@HIDDEN>
 <87y2i9jebl.fsf@HIDDEN> <878sa9f09g.fsf@HIDDEN>
 <20201208123737.GZ6337@maokai> <87r1nywyvj.fsf@HIDDEN>
 <Wfbt5eP6jEx58ad6z_C4kzeT8qg_ELkX_WoEcCCzkDPZiVRG-bKXdI5nHDUy_TTGzfBITWs_ZEI45gXdV8G6ww==@protonmail.internalid>
 <87tusuvi9q.fsf@HIDDEN> <87im9awv0l.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEUnOIxpZGiik0cu
 QkGRcTBfWCuQipn////0LwWVAAAAAWJLR0QHFmGI6wAAAAd0SU1FB+QMCw01M0bJqccAAAGmSURB
 VDjL3ZLbkSMhDEVxBsPYzb+pngCmZAUwXgigjRQAP+Qfwl7xsD1VG8Gq3W24B0kI5Nz/bf7f8meM
 7kz0Lp38hztBT45gftrHyX/+HD7GuA9Ap66fvZcvEegxdaBavqFjUOS49/UGuCjs8EjGWGNAUlan
 GbIIvsP3MRySkyyZIbMB4hTvXd8dj0BetECf27v0HHO8A8i1j4OBMqs4cyG+X18eqtOdhG77tb6D
 Wrv7Xm4JIPjqZQLva/ObGhjej155aDXU1rZcHmmGVdEOWvMA6Y/qNXgLgKqxXQOwzQqaoUTVZRl6
 O/8C4lIKT5DzBGoeCrEGy5GeHgiL7Q6HsCHwKvaSo9O+qxaaRT78u8fMgSktgJt5hrJz/F5dsefi
 pCzdP1mNmVaOLkMlvKFZs7HWYJmPjUwct4M7c/eIerCLUnqH0aFkh0PWV9ZAJg9UyM7GTte6iabZ
 SBcoeHjoN+hsnVbs2E1lthya0F7aO5NHUwMofheB+FVsogPwiLuNvz51I+XSzMpMPhbM6cuc7b6P
 Uv/K+jpe4M3yCKWMxUxFmZaK9y/k9ctSdr/JEgAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAyMC0xMi0x
 MVQxMzo1Mzo1MSswMDowMGCznr4AAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjAtMTItMTFUMTM6NTM6
 NTErMDA6MDAR7iYCAAAAAElFTkSuQmCC
X-Now-Playing: Shopping's _All Or Nothing_: "No Apologies"
Date: Fri, 11 Dec 2020 14:55:49 +0100
In-Reply-To: <87im9awv0l.fsf@HIDDEN> (Jose A. Ortega Ruiz's message of
 "Wed, 09 Dec 2020 21:04:58 +0000")
Message-ID: <87im98bg62.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  As previously briefly discussed, I wondered whether adding
 a command that shows "large" buffers and variables would tell us anything
 interesting in these cases, and I've now implemented that. `M-x memory-report'
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: 43389 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

As previously briefly discussed, I wondered whether adding a command
that shows "large" buffers and variables would tell us anything
interesting in these cases, and I've now implemented that.

`M-x memory-report'

on the current trunk.  It may or may not tell us something
interesting -- please give it a whirl and report back.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 21:46:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 10 16:46:01 2020
Received: from localhost ([127.0.0.1]:39495 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knTlB-0004AR-37
	for submit <at> debbugs.gnu.org; Thu, 10 Dec 2020 16:46:01 -0500
Received: from stw1.rcdrun.com ([217.170.207.13]:44699)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1knTl5-00049m-Hj
 for 43389 <at> debbugs.gnu.org; Thu, 10 Dec 2020 16:45:55 -0500
Received: from localhost ([::ffff:41.202.241.31])
 (AUTH: PLAIN securesender, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by stw1.rcdrun.com with ESMTPSA
 id 000000000001E532.000000005FD2970C.000059E5; Thu, 10 Dec 2020 14:45:48 -0700
Date: Thu, 10 Dec 2020 23:30:05 +0300
From: Jean Louis <bugs@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X9KFTFQd/Hq3KELZ@HIDDEN>
References: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 Trevor Bentley <trevor@HIDDEN>, michael_heerdegen@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Stefan Monnier <monnier@HIDDEN> [2020-12-10 22:21]:
> > Trevor reported several times that automatic GC is fast as usual, but
> > manual invocations of "M-x garbage-collect" take much longer, many
> > minutes.  I don't understand how this could happen, because both
> > methods of invoking GC do exactly the same job.
> 
> Indeed, that makes no sense.  The only thing that comes to mind is that
> when they do `M-x garbage-collect` the 15 minutes aren't actually spent
> in the GC but in some pre/post command hook or something like that
> (e.g. in `execute-extended-command--shorter`)?
> 
> Do we have a `profiler-report` available for those 15 minutes?
> I've taken a quick look at the massive threads in that bug report,
> but haven't had the time to read in detail.  AFAICT we don't have a
> profiler output for those 15minutes, so it would be good to try:
> 
>     M-x profiler-start RET RET
>     M-x garbage-collect RET     ;; This should presumably take several minutes
>     M-x profiler-report RET

Another issue is that since I use LD_PRELOAD with gmalloc trace is
that I have not encountered high swapping and Emacs being totally
unusable. And I have not upgraded Emacs. Changed basically nothing but
using the mtrace.

What I can still observe is that vsize grows high as usual. But I have
not observed swap growing high or that hard disk starts working to
find some swap memory for 40 minutes or longer indefinitely maybe.






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 21:45:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 10 16:45:56 2020
Received: from localhost ([127.0.0.1]:39493 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knTl5-0004A9-SD
	for submit <at> debbugs.gnu.org; Thu, 10 Dec 2020 16:45:56 -0500
Received: from stw1.rcdrun.com ([217.170.207.13]:41431)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1knTl1-00049g-U9
 for 43389 <at> debbugs.gnu.org; Thu, 10 Dec 2020 16:45:52 -0500
Received: from localhost ([::ffff:41.202.241.31])
 (AUTH: PLAIN securesender, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by stw1.rcdrun.com with ESMTPSA
 id 000000000001E52A.000000005FD29709.000059D6; Thu, 10 Dec 2020 14:45:44 -0700
Date: Thu, 10 Dec 2020 23:26:24 +0300
From: Jean Louis <bugs@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X9KEcBiBE34rzCzK@HIDDEN>
References: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 Trevor Bentley <trevor@HIDDEN>, michael_heerdegen@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Stefan Monnier <monnier@HIDDEN> [2020-12-10 22:21]:
>     M-x profiler-start RET RET
>     M-x garbage-collect RET     ;; This should presumably take several minutes
>     M-x profiler-report RET

I will try with function doing all three together.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 21:45:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 10 16:45:51 2020
Received: from localhost ([127.0.0.1]:39489 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knTl1-00049u-JE
	for submit <at> debbugs.gnu.org; Thu, 10 Dec 2020 16:45:51 -0500
Received: from stw1.rcdrun.com ([217.170.207.13]:43599)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1knTky-00049c-Gj
 for 43389 <at> debbugs.gnu.org; Thu, 10 Dec 2020 16:45:50 -0500
Received: from localhost ([::ffff:41.202.241.31])
 (AUTH: PLAIN securesender, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by stw1.rcdrun.com with ESMTPSA
 id 000000000001E527.000000005FD29705.000059BD; Thu, 10 Dec 2020 14:45:41 -0700
Date: Thu, 10 Dec 2020 23:24:04 +0300
From: Jean Louis <bugs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X9KD5NK7WnGuosxp@HIDDEN>
References: <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <83zh2l33fv.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 Trevor Bentley <trevor@HIDDEN>, michael_heerdegen@HIDDEN,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Eli Zaretskii <eliz@HIDDEN> [2020-12-10 21:47]:
> Trevor reported several times that automatic GC is fast as usual, but
> manual invocations of "M-x garbage-collect" take much longer, many
> minutes.  I don't understand how this could happen, because both
> methods of invoking GC do exactly the same job.

Sometimes 30-36 minutes.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 19:48:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 10 14:48:07 2020
Received: from localhost ([127.0.0.1]:39331 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knRv4-0007aF-7w
	for submit <at> debbugs.gnu.org; Thu, 10 Dec 2020 14:48:07 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:21012)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1knRv1-0007Za-T6
 for 43389 <at> debbugs.gnu.org; Thu, 10 Dec 2020 14:48:04 -0500
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 8FDE61000C9;
 Thu, 10 Dec 2020 14:47:58 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id B77E6100225;
 Thu, 10 Dec 2020 14:47:52 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1607629672;
 bh=YvXDDRibJcY1HGc8tBNWSs7sAsBvoSPaWKwu4AnMIdM=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=JV28AtLRhceHTqiCVN7THv6ssdZZzeJ8zDHi2rkTabbz6UHBJYwlers6yTRehC3hE
 dENSVdkKVFGaGCxavIyPKEMa/JjW8UKuRjezAf7tuSJ5uhXazKn+FAQXxk9PfQbQYc
 wMDu/D8KacZ1nEEfP1N3QiNKMxjM0GtoMAYVghXE8UMG/9Kj2QsdSTNZlK4BQSxnDW
 SXO0LWyOYHGkWNSmqx9zc7hDw40C1/pFAt4DtxA0RGDQ9Q1Vx5nFFdNxi4UKKeb68N
 A94lB1k4Snq1p8te6JD0h1RO2oJkWBktUeXk1UjR0Umot56kKTq5vXoFKRbth/6ZhC
 gQTCSpqZu3pmQ==
Received: from alfajor (69-165-136-52.dsl.teksavvy.com [69.165.136.52])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id E266E120124;
 Thu, 10 Dec 2020 14:47:51 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwvzh2lsata.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
 <87a6ulsbgf.fsf@HIDDEN>
Date: Thu, 10 Dec 2020 14:47:51 -0500
In-Reply-To: <87a6ulsbgf.fsf@HIDDEN> (Trevor Bentley's message
 of "Thu, 10 Dec 2020 20:33:20 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.085 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Is there any easy way to check if any of my packages are adding extra hooks
> around garbage-collect?  I can't imagine why they would, but you never know.

I think there can be so many hooks involved that the profiler is the
only good way to figure that out.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 19:33:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 10 14:33:30 2020
Received: from localhost ([127.0.0.1]:39313 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knRgw-0007EQ-2T
	for submit <at> debbugs.gnu.org; Thu, 10 Dec 2020 14:33:30 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:45030)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1knRgt-0007EB-9G
 for 43389 <at> debbugs.gnu.org; Thu, 10 Dec 2020 14:33:28 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id DDDE3612AC;
 Thu, 10 Dec 2020 20:33:20 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607628801;
 bh=ovC3CffbXiBnqmjqQw1HecHZF+6x06foIvwJDWh/pgk=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=jVJyjh6Nb1mty5qYXl8eer/Ta4uIVO2JuqoTUSxHn5kRwIpI/XC2NgmIHQ3Ay1fpz
 d4EKcGltl82iiu+RmErSScczq2cKWKAwUgtjjVrmtZqElPwwk58WuzZGbC5KGaYF24
 bQB0VDIXpcuexMQEt3/99IFW7HeBGjODTgsE9gwA=
From: Trevor Bentley <trevor@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
 <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
Date: Thu, 10 Dec 2020 20:33:20 +0100
Message-ID: <87a6ulsbgf.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Stefan Monnier <monnier@HIDDEN> writes:
 
> Do we have a `profiler-report` available for those 15 minutes? 
> I've taken a quick look at the massive threads in that bug 
> report, but haven't had the time to read in detail.  AFAICT we 
> don't have a profiler output for those 15minutes, so it would be 
> good to try: 
> 
>     M-x profiler-start RET RET M-x garbage-collect RET     ;; 
>     This should presumably take several minutes M-x 
>     profiler-report RET 
> 
> and then shows us this report (using C-u RET on the top-level 
> elements to unfold them). 

I made one a profiler report for a complete 1-2 day session (see 
the e-mail referencing "mtrace3"), but none for just garbage 
collection.  I'll do that for the next one.

Is there any easy way to check if any of my packages are adding 
extra hooks around garbage-collect?  I can't imagine why they 
would, but you never know.

Thanks

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 19:21:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 10 14:21:29 2020
Received: from localhost ([127.0.0.1]:39308 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knRVI-0004qN-Vn
	for submit <at> debbugs.gnu.org; Thu, 10 Dec 2020 14:21:29 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:17610)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1knRVF-0004q6-Qg
 for 43389 <at> debbugs.gnu.org; Thu, 10 Dec 2020 14:21:27 -0500
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 2A88580381;
 Thu, 10 Dec 2020 14:21:20 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 218118033C;
 Thu, 10 Dec 2020 14:21:18 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1607628078;
 bh=wNkJ2rhZDUx4/CJIXQXWPLc2/2ZPWP7TxRon4J7vA1A=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=H7UvQVRved8iViksoIyCPOHnV5eLHyFZMH4BPehjz8r0BHIYCLHBM8DLIrYvqMVpa
 SIhPCsg1nIXW9yLtcxy52ydU2Rn8Rq/Cc9Qk811glcFqgKcmbOpgvm/fsBLRpZP1nt
 Hsw0bxDQ3uUvH9yrnWgTKZVwBq8pwf136Fz1/5M1mDzkhQkpXdTmDZ2XNkkSErAKKL
 dk3LiZZnDdl/Og0v2NPXcMnE5jKnjmP3/WCQP3k3pBEnvGKJumVm/KkHfdb2/abrTe
 Ce2swig99VPpTyupjSlKI+AmGmG2KDw7i8nziclGRYsfdaSw9zI4jp2cvWAA9nyx3O
 hee5pDFYODx3g==
Received: from alfajor (69-165-136-52.dsl.teksavvy.com [69.165.136.52])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id B66EA120340;
 Thu, 10 Dec 2020 14:21:17 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <jwvblf1tr9i.fsf-monnier+emacs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN> <83zh2l33fv.fsf@HIDDEN>
Date: Thu, 10 Dec 2020 14:21:16 -0500
In-Reply-To: <83zh2l33fv.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 10 Dec
 2020 20:45:40 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.060 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, Trevor Bentley <trevor@HIDDEN>,
 michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Trevor reported several times that automatic GC is fast as usual, but
> manual invocations of "M-x garbage-collect" take much longer, many
> minutes.  I don't understand how this could happen, because both
> methods of invoking GC do exactly the same job.

Indeed, that makes no sense.  The only thing that comes to mind is that
when they do `M-x garbage-collect` the 15 minutes aren't actually spent
in the GC but in some pre/post command hook or something like that
(e.g. in `execute-extended-command--shorter`)?

Do we have a `profiler-report` available for those 15 minutes?
I've taken a quick look at the massive threads in that bug report,
but haven't had the time to read in detail.  AFAICT we don't have a
profiler output for those 15minutes, so it would be good to try:

    M-x profiler-start RET RET
    M-x garbage-collect RET     ;; This should presumably take several minutes
    M-x profiler-report RET

and then shows us this report (using C-u RET on the top-level elements
to unfold them).


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 18:46:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 10 13:46:16 2020
Received: from localhost ([127.0.0.1]:39271 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knQxE-0003zr-1d
	for submit <at> debbugs.gnu.org; Thu, 10 Dec 2020 13:46:16 -0500
Received: from eggs.gnu.org ([209.51.188.92]:49694)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1knQx9-0003za-Fq
 for 43389 <at> debbugs.gnu.org; Thu, 10 Dec 2020 13:46:14 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45696)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1knQx3-0005fb-DK; Thu, 10 Dec 2020 13:46:05 -0500
Received: from [176.228.60.248] (port=3566 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1knQx1-0002T4-H4; Thu, 10 Dec 2020 13:46:05 -0500
Date: Thu, 10 Dec 2020 20:45:40 +0200
Message-Id: <83zh2l33fv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>,
 Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <87eek0rmqa.fsf@HIDDEN> (message from Trevor
 Bentley on Tue, 08 Dec 2020 22:50:37 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Stefan, please help with this complex issue (or maybe several
issues).  We have collected some evidence in this bug report, but I
don't yet see where is this going, or how to make any real progress
here.

One thing that I cannot explain is this:

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN,
>  dj@HIDDEN, michael_heerdegen@HIDDEN
> Cc: 
> Date: Tue, 08 Dec 2020 22:50:37 +0100
> 
> I've been too busy to modify emacs to print garbage collects, but 
> these still show really long (garbage-collect) calls, often 
> exceeding 15 minutes.

Trevor reported several times that automatic GC is fast as usual, but
manual invocations of "M-x garbage-collect" take much longer, many
minutes.  I don't understand how this could happen, because both
methods of invoking GC do exactly the same job.

I thought about possible ways of explaining the stark differences in
the time it takes to GC, and came up with these:

 . The depth of the run-time (C-level) stack.  If this is much deeper
   in one of the cases, it could explain the longer time.  But in that
   case, I'd expect the automatic GC to take longer, because typically
   the C stack is relatively shallow when Emacs is idle than when it
   runs some Lisp.  This contradicts Trevor's observations.

 . Some difference in buffers and strings, which causes the manual GC
   to relocate and compact a lot of them.  But again: (a) why the
   automatic GC never hits the same condition, and (b) I can explain
   the reverse easier, i.e. that lots of temporary strings and buffers
   exist while Lisp runs, but not when Emacs is idle.

Any other ideas?  Any data Trevor could provide, e.g. by attaching a
debugger during these prolonged GC, and telling us something
interesting?

TIA




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 08:32:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 10 03:32:37 2020
Received: from localhost ([127.0.0.1]:36949 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knHNN-0002nI-5K
	for submit <at> debbugs.gnu.org; Thu, 10 Dec 2020 03:32:37 -0500
Received: from stw1.rcdrun.com ([217.170.207.13]:54503)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1knHNL-0002n5-0a
 for 43389 <at> debbugs.gnu.org; Thu, 10 Dec 2020 03:32:35 -0500
Received: from localhost ([::ffff:41.202.241.31])
 (AUTH: PLAIN securesender, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by stw1.rcdrun.com with ESMTPSA
 id 000000000001E525.000000005FD1DD1C.000012D4; Thu, 10 Dec 2020 01:32:27 -0700
Date: Thu, 10 Dec 2020 08:43:56 +0300
From: Jean Louis <bugs@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Message-ID: <X9G1nCxbGzLjxrnS@HIDDEN>
References: <87h7pxjrh5.fsf@HIDDEN> <87eel1cq83.fsf@HIDDEN>
 <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN>
 <87a6vpcphp.fsf@HIDDEN> <83ft5h2pks.fsf@HIDDEN>
 <87tutxi2cz.fsf@HIDDEN> <87y2i9jebl.fsf@HIDDEN>
 <X88LYF1fPJjFNP39@HIDDEN> <87lfe8jm67.fsf@HIDDEN>
 <87mtym7acc.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <87mtym7acc.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: 43389 <at> debbugs.gnu.org, RLAdams@HIDDEN, schwab@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Michael Heerdegen <michael_heerdegen@HIDDEN> [2020-12-10 03:51]:
> Michael Heerdegen <michael_heerdegen@HIDDEN> writes:
> 
> > I think we see different symptoms.  I don't see any slow-down at all
> > (unless swapping starts, obviously).  When I do M-x garbage-collect, it
> > finishes immediately without freeing an significant amount of memory.
> 
> I must correct myself.  While this all was definitely the case the last
> time I tried to investigate this issue (one or two months ago) the
> garbage-collect statement is not true anymore.  I did M-x
> garbage-collect today when the memory was getting short and then Emacs
> froze (in the sense of "didn't respond, even to C-g"), without gkrellm
> reporting much progress, so I killed it (after 20 seconds or so - aeons
> for a computer).
> 
> I did not experience a slowdown, however (maybe I've faster RAM?).

One time I waited for 36 minutes and it completed the garbage collection.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 10 Dec 2020 00:51:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 09 19:51:29 2020
Received: from localhost ([127.0.0.1]:36551 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1knAB7-000844-4o
	for submit <at> debbugs.gnu.org; Wed, 09 Dec 2020 19:51:29 -0500
Received: from mout.web.de ([212.227.15.3]:39865)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1knAB4-00083p-D6
 for 43389 <at> debbugs.gnu.org; Wed, 09 Dec 2020 19:51:27 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1607561444;
 bh=VwIFy5emvf70B/csrtfP44yJUHSeVc894J3CcdMDSNU=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=aS4vC6chDFL4aGu0RG8S433EhWKW+VgnQJoVeYJ6LinBqGC/2gW66/aUSiuP8rg4m
 +dvLZTDt3h+4LDZoyz+Ylvpv8ImHTYuePj86MZzcETw+0mpY3oONbZ7tCOquB/YUq4
 +CnsKZl1HlmXslk/PatZc/Gs6ZCI0w3zeiEWvek8=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([88.67.99.46]) by smtp.web.de (mrweb006
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MkVwo-1kQjRS2B2M-00mN2g; Thu, 10
 Dec 2020 01:50:44 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <83pn4l3mts.fsf@HIDDEN> <87v9edk4eb.fsf@HIDDEN>
 <87imadcqqk.fsf@HIDDEN> <87h7pxjrh5.fsf@HIDDEN>
 <87eel1cq83.fsf@HIDDEN> <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN>
 <87a6vpcphp.fsf@HIDDEN> <83ft5h2pks.fsf@HIDDEN>
 <87tutxi2cz.fsf@HIDDEN> <87y2i9jebl.fsf@HIDDEN>
 <X88LYF1fPJjFNP39@HIDDEN> <87lfe8jm67.fsf@HIDDEN>
Date: Thu, 10 Dec 2020 01:50:43 +0100
In-Reply-To: <87lfe8jm67.fsf@HIDDEN> (Michael Heerdegen's message of "Tue, 08
 Dec 2020 17:29:52 +0100")
Message-ID: <87mtym7acc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:SRMHfjUF1wIpJnSQRZlLVoESg/XqVRfO1Wwrg6oj6yAedXVPxs0
 r5q21GE5cnPZBTbjfg3XLMS7y0wVHrg1UjxZ0g3uA8euQxrHQBftPybMi4SaojxVlv9eLCf
 3usUZTONmuif6jUDzkFjxCK/Fcr5TGkiq5SQq3ThWYyx8+goojsTGWwNhvgklc0fa6ONmNB
 WFnUE68E4dz8vWB8Vo2PQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:R4hoYklkoSw=:7Givgt2ZmN8YvEifEQoxZu
 7TWveyak75kWKs/LVmNBrh3pHs6M2QFmQM78BhSY8uEtWhJ6dIjc2NCoXSN/GMXeGGRnWOb1e
 7rhUZxkN97koBkGsGoCVr58oXxCf8KYa1l7jpw/ojOnWBEQGD2cWBNRqxb8pWfy6fk1B7XZi4
 KHzYDDhRukv6IphkUUc26u0wDE0rvc+agPr6jaaVbHyCeRNuYE0KvijNbO8ROAItQxgAe04Bt
 G5c9Nul1MykIiwa9eK++M/G4z2CHxVdc8Al/TNL/M7qfPzRxL2bE6HeI6xbW1trp4calln6+j
 iXvY5FdYgYRcFkZ7f5WW102GXlA8oawskEmxXq2B7mNLkvEWLLFu7FplRnWi/zDZ9jOhmlBFQ
 FbsXRei+rbqfWzM2joSwj7WiCWOHS+aRMzACxm+UUOHjFFfUrjJF0V2vJSG1SsipvqBG5EmiO
 s4TPWrEBBpEUW+sQbEAURW99BD3vsuzvNRxS/CZ3aqe5jA4WQ8pPth9N16IVEArYHsHTPymh9
 qi2NlGts393RhSWRzE9v0em/M5zLqZvixBqEd7c8FP8+Kvney5ixs3WX3NSYiOtMxukPFt+hv
 3Maf/BOGfzl256VCpKiSTc74x66VZvEeqoGdSxnMP9u5j3spVDe1K3z41SOWUHe8uHJNUbMP/
 oQQOmPYrqcWPkpzRPYCvTdl/XhFrwZmFuonQJXAYi0Zvt+WeC4/2asQefg8IOCTzVH+cmW0f6
 Kriwl5GYR/NCBW89CwdflV/ZsBIeQ102gXYNJiZTMcSYoQI2CQ7AEnEAhqbKYqh3I6L8CB6b4
 p0Y9JsR2S0gFEXtofpzGx48tznpAhTx+Q/dw4uQIN0z7AZaAI2b0ZVrhLL9Yuu6ileoyLBTii
 cbnz2s2p63i82au47MzLjlOd+9rdxZm76iWlV7JOM=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43389
Cc: 43389 <at> debbugs.gnu.org, RLAdams@HIDDEN, schwab@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> I think we see different symptoms.  I don't see any slow-down at all
> (unless swapping starts, obviously).  When I do M-x garbage-collect, it
> finishes immediately without freeing an significant amount of memory.

I must correct myself.  While this all was definitely the case the last
time I tried to investigate this issue (one or two months ago) the
garbage-collect statement is not true anymore.  I did M-x
garbage-collect today when the memory was getting short and then Emacs
froze (in the sense of "didn't respond, even to C-g"), without gkrellm
reporting much progress, so I killed it (after 20 seconds or so - aeons
for a computer).

I did not experience a slowdown, however (maybe I've faster RAM?).

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 9 Dec 2020 21:05:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 09 16:05:15 2020
Received: from localhost ([127.0.0.1]:36345 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kn6eA-0002cA-Sz
	for submit <at> debbugs.gnu.org; Wed, 09 Dec 2020 16:05:15 -0500
Received: from eggs.gnu.org ([209.51.188.92]:42218)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <jao@HIDDEN>) id 1kn6e9-0002by-Dh
 for 43389 <at> debbugs.gnu.org; Wed, 09 Dec 2020 16:05:13 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55203)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <jao@HIDDEN>)
 id 1kn6e3-0006RK-2c; Wed, 09 Dec 2020 16:05:08 -0500
Received: from cpc103048-sgyl39-2-0-cust502.18-2.cable.virginm.net
 ([92.233.85.247]:57260 helo=osgiliath.local)
 by fencepost.gnu.org with esmtpsa (TLS1.2:DHE_RSA_AES_256_CBC_SHA256:256)
 (Exim 4.82) (envelope-from <jao@HIDDEN>)
 id 1kn6dw-0006FQ-O4; Wed, 09 Dec 2020 16:05:06 -0500
Received: by osgiliath.local (Postfix, from userid 1000)
 id B4BE1402D1; Wed,  9 Dec 2020 21:04:58 +0000 (GMT)
From: "Jose A. Ortega Ruiz" <jao@HIDDEN>
To: "Lars Ingebrigtsen" <larsi@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
In-Reply-To: <87tusuvi9q.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 09 Dec 2020 21:25:37 +0100")
References: <87v9edk4eb.fsf@HIDDEN> <87imadcqqk.fsf@HIDDEN>
 <87h7pxjrh5.fsf@HIDDEN> <87eel1cq83.fsf@HIDDEN>
 <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN> <87a6vpcphp.fsf@HIDDEN>
 <83ft5h2pks.fsf@HIDDEN> <87tutxi2cz.fsf@HIDDEN>
 <87y2i9jebl.fsf@HIDDEN> <878sa9f09g.fsf@HIDDEN>
 <20201208123737.GZ6337@maokai> <87r1nywyvj.fsf@HIDDEN>
 <Wfbt5eP6jEx58ad6z_C4kzeT8qg_ELkX_WoEcCCzkDPZiVRG-bKXdI5nHDUy_TTGzfBITWs_ZEI45gXdV8G6ww==@protonmail.internalid>
 <87tusuvi9q.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
X-Attribution: jao
X-Clacks-Overhead: GNU Terry Pratchett
X-URL: <http://jao.io/>
Date: Wed, 09 Dec 2020 21:04:58 +0000
Message-ID: <87im9awv0l.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: 43389 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On Wed, Dec 09 2020, Lars Ingebrigtsen wrote:
[...]

> Has anybody tried compiling a list of features people who see the leaks
> are using?  Not that there's really any good way of gathering that data,
> but ...  Like, helm is known for using lots of memory, and eww can, too,
> under some circumstances, and so can image caching...

in my case, it's ivy and emacs-w3m.  the first burst i observe is
usually at the beginning, so not many of the miriad other packages i use
have been active at all.  i use exwm, so that's one that's always there
for sure, and ivy takes control immediately, but little else seems
"needed".

regarding images, i use pdf-tools, and it has a heavy memory footprint
(opening any PDF increases easily emacs ram consumption in 200Mb, no
matter how big the PDF). but those jumps are immediate upon opening the
doc.

in my case, another source of puzzlement is this "bursty" behaviour.
after the firs one, i can be at ~1Gb for a day or two (doing almost
everything inside emacs, so all kinds of packages used), and then,
without any change in my usage patterns i could tell, a new burst will
take my RAM, 10Mbs at a time, up to ~2Gb.  and then stop, again without
me doing, concisouly, anything differently.

jao
-- 
To see ourselves as others see us is a most salutary gift. Hardly less
important is the capacity to see others as they see themselves.
 -Aldous Huxley, novelist (1894-1963)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 9 Dec 2020 20:25:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 09 15:25:49 2020
Received: from localhost ([127.0.0.1]:36256 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kn621-0007xb-20
	for submit <at> debbugs.gnu.org; Wed, 09 Dec 2020 15:25:49 -0500
Received: from quimby.gnus.org ([95.216.78.240]:42190)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kn61z-0007xO-9I
 for 43389 <at> debbugs.gnu.org; Wed, 09 Dec 2020 15:25:47 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=GXeapL4e/GV4Mr3EACbYhk2UktWxoomuZXxAooj2sXM=; b=FTVeB0xayjuP2NFRy6HXS8/Zb/
 MrOss2VQ8nQ3rdoWT1gYHo4v/wGI/OqpvLo1ejziZdjJWmcQGLcl0+9PKzIqbwNiz9lAISKcYzT4c
 wO2EFQwoSyGyYY34bbObb5Gfv8FUpUsy3ytmY8WCpFDNhE+BPaDm+3VQ7wthPBTrfczo=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kn61q-0005Gf-A6; Wed, 09 Dec 2020 21:25:40 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: "Jose A. Ortega Ruiz" <jao@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <87v9edk4eb.fsf@HIDDEN> <87imadcqqk.fsf@HIDDEN>
 <87h7pxjrh5.fsf@HIDDEN> <87eel1cq83.fsf@HIDDEN>
 <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN> <87a6vpcphp.fsf@HIDDEN>
 <83ft5h2pks.fsf@HIDDEN> <87tutxi2cz.fsf@HIDDEN>
 <87y2i9jebl.fsf@HIDDEN> <878sa9f09g.fsf@HIDDEN>
 <20201208123737.GZ6337@maokai> <87r1nywyvj.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwAgMAAAAqbBEUAAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAADFBMVEU4ODuEPmvLzMz/
 //9s1jDoAAAAAWJLR0QDEQxM8gAAAAlwSFlzAAAuIwAALiMBeKU/dgAAAAd0SU1FB+QMCRQVKZfR
 JGsAAAE/SURBVCjPRdGxbsIwEADQOxQjtZOHeCifwFc4FSxMtpSL2s4wNF/Rrp1opTIwUQkQua/s
 nR0HS4n8fOezcwGACiz6hshDHjWA07kJ8iKgANgmGONXvqBKuSPQ2wlIzT2CkapQYFtn7QSwtSnw
 UNfGg8nVYPt0Lz3/5k8wCR4Wm0v0VZMjiyXgHlw+h8/Yn8CQYsZX5jNgp5h/MfMNMCgMJ5iQ97Cm
 ZcymyCXAw04wKNZyUY3wmPaTEHLkkHAS7IK9Jpw17S1msOSYLk+5SgW2/aGUlo89Pk83IMd+kGIZ
 2PEv875cdN5sJnR7pPe2RIJzK/lJPjWEIh7a2XpsonsNuMhpKkM340dAP4Tcbh3LIWgB0rlf8kl/
 vsUU4b/hBRxNowXXUKsLkWKUPWtKc3kEVGAzQlqQ3n48SmsBj3L4P02aiwS5jZmyAAAAJXRFWHRk
 YXRlOmNyZWF0ZQAyMDIwLTEyLTA5VDIwOjIxOjQxKzAwOjAwtMlGhwAAACV0RVh0ZGF0ZTptb2Rp
 ZnkAMjAyMC0xMi0wOVQyMDoyMTo0MSswMDowMMWU/jsAAAAASUVORK5CYII=
X-Now-Playing: =?utf-8?Q?R=C3=B3isin?= Murphy's _Murphy's Law (Crooked
 Remixes)_: "Murphy's Law (Crooked Cowbelly 1)"
Date: Wed, 09 Dec 2020 21:25:37 +0100
In-Reply-To: <87r1nywyvj.fsf@HIDDEN> (Jose A. Ortega Ruiz's message of
 "Wed, 09 Dec 2020 19:41:36 +0000")
Message-ID: <87tusuvi9q.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  "Jose A. Ortega Ruiz" <jao@HIDDEN> writes: > Neither am i
 :) Actually, i just observed the pattern above (RAM going > up by 1Mb/sec
 bringing total memory from 300Mb to 800Mb, then stopping) > before starting
 Gnus. So i guess that, if Gnus play [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: 43389 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

"Jose A. Ortega Ruiz" <jao@HIDDEN> writes:

> Neither am i :) Actually, i just observed the pattern above (RAM going
> up by 1Mb/sec bringing total memory from 300Mb to 800Mb, then stopping)
> before starting Gnus.  So i guess that, if Gnus plays any role, it must
> be indirectly.

I haven't been following this thread closely, but it strikes me as
puzzling that there's a lot of people seeing these leaks -- and there's
also many people (like me) that don't see these leaks at all.  (And I
have Emacsen running for weeks on end, doing all sorts of odd stuff.)

Has anybody tried compiling a list of features people who see the leaks
are using?  Not that there's really any good way of gathering that data,
but ...  Like, helm is known for using lots of memory, and eww can, too,
under some circumstances, and so can image caching...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 9 Dec 2020 20:08:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 09 15:08:15 2020
Received: from localhost ([127.0.0.1]:36232 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kn5l1-0007XM-Gw
	for submit <at> debbugs.gnu.org; Wed, 09 Dec 2020 15:08:15 -0500
Received: from lists.gnu.org ([209.51.188.17]:37494)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1kn5kz-0007XE-Tw
 for submit <at> debbugs.gnu.org; Wed, 09 Dec 2020 15:08:14 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:50198)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1kn5kz-0008TE-OV
 for bug-gnu-emacs@HIDDEN; Wed, 09 Dec 2020 15:08:13 -0500
Received: from static.214.254.202.116.clients.your-server.de
 ([116.202.254.214]:54626 helo=ciao.gmane.io)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1kn5ky-0004mR-8B
 for bug-gnu-emacs@HIDDEN; Wed, 09 Dec 2020 15:08:13 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1kn5ks-000A61-CI
 for bug-gnu-emacs@HIDDEN; Wed, 09 Dec 2020 21:08:06 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: "Jose A. Ortega Ruiz" <jao@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Date: Wed, 09 Dec 2020 19:41:36 +0000
Message-ID: <87r1nywyvj.fsf@HIDDEN>
References: <87v9edk4eb.fsf@HIDDEN> <87imadcqqk.fsf@HIDDEN>
 <87h7pxjrh5.fsf@HIDDEN> <87eel1cq83.fsf@HIDDEN>
 <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN> <87a6vpcphp.fsf@HIDDEN>
 <83ft5h2pks.fsf@HIDDEN> <87tutxi2cz.fsf@HIDDEN>
 <87y2i9jebl.fsf@HIDDEN> <878sa9f09g.fsf@HIDDEN>
 <20201208123737.GZ6337@maokai>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Cancel-Lock: sha1:2vPS7EhgbiKe7LJVOB32GmJFm5Y=
X-Attribution: jao
X-Clacks-Overhead: GNU Terry Pratchett
X-URL: <http://jao.io/>
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: -15
X-Spam_score: -1.6
X-Spam_bar: -
X-Spam_report: (-1.6 / 5.0 requ) BAYES_00=-1.9,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

On Tue, Dec 08 2020, Russell Adams wrote:

> On Tue, Dec 08, 2020 at 03:24:27AM +0000, Jose A. Ortega Ruiz wrote:
>> On Tue, Dec 08 2020, Michael Heerdegen wrote:
>>
>> > shut it down normally).  I'm sure that at least a significant part of
>> > the problem materialized while using (more or less only) Gnus.
>>
>> I also have anecdotal evidence of that.  Quite systematically, i start
>> emacs, things load, i'm around 300Mb or RAM, quite stable.  Then i start
>> Gnus, read some groups, and, ver soon after that, while emacs is
>> basically idle, i can see RAM increasing by ~10Mb every ~10secs until it
>> reaches something like 800-900Mb.
>
> I have consistently encountered this memory leak without a clear path
> to reproducing it other than regular use over time, and I don't use
> Gnus. I read mail in Mutt in another terminal window.
>
> Thus I'm not sure Gnus is the culprit.

Neither am i :) Actually, i just observed the pattern above (RAM going
up by 1Mb/sec bringing total memory from 300Mb to 800Mb, then stopping)
before starting Gnus.  So i guess that, if Gnus plays any role, it must
be indirectly.

jao
-- 
I don't necessarily agree with everything I say.
 -Marshall McLuhan (1911-1980)





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 8 Dec 2020 22:15:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 08 17:15:39 2020
Received: from localhost ([127.0.0.1]:60037 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kmlGl-00052W-Bz
	for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 17:15:39 -0500
Received: from us-smtp-delivery-124.mimecast.com ([216.205.24.124]:39950)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1kmlGi-00052M-Q8
 for 43389 <at> debbugs.gnu.org; Tue, 08 Dec 2020 17:15:38 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1607465736;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=SYQISvuWzpsKbu2O+mIUa7Ul8mL6G37ESQyD4zu8h/w=;
 b=V+AK74X7SbAIF7hjR5HLpalx5vYWVU1prEg3llWMgmFAQDwfwyeulg9YbskMuSq9dOXKKr
 CJy06+hY7Um+1LG+wIQ01YKbQfKwr+CYKV24kEcklZ2P8wG/Wxs3T0ZOtQ/EK4dBTuj0Br
 WR2lqllEPQHcfBKT4Ee+QiridooaKAw=
Received: from mail-qt1-f197.google.com (mail-qt1-f197.google.com
 [209.85.160.197]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-263-EO9wMjjaMFufKtvssuIJ8Q-1; Tue, 08 Dec 2020 17:15:32 -0500
X-MC-Unique: EO9wMjjaMFufKtvssuIJ8Q-1
Received: by mail-qt1-f197.google.com with SMTP id n95so14960338qte.16
 for <43389 <at> debbugs.gnu.org>; Tue, 08 Dec 2020 14:15:32 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=SYQISvuWzpsKbu2O+mIUa7Ul8mL6G37ESQyD4zu8h/w=;
 b=hJUr1SfMtnN1grqns+knU+yI3Z2/dX2rB5RkgdgcaOrkhAKU4pkrJNsLocgS+rz5gV
 2Y4TPDB49Z+vV4Cm51j7h1yrk7UIn7ow6Qxlv9j149ixt5G7gfp5c8+j2ZFj9cGTqsjP
 n7qLj4+rE3kjjd/FM/2AbjrKtLlJsBnloJozFISYHtERTBsfJAQbgK4o7cOp3kANfy4l
 d4RzMXUvE+MobjQ4UhBDU9/RaiDH0ccQQCppO/11nzEPf09iEnXB9IW/qdXcpyt0MBvG
 RA/+8gTJKtrY2ACMxAgBtfBEy1GfRKGtOd6UHUzbZk0c9IXL78k5oUgGKgf3Uy3jOLiA
 FwBQ==
X-Gm-Message-State: AOAM532a70wcWsKB/d+RZPt36rdEhoOALWbSQkkP/dlMibGu6EeQbU4Q
 u0EEpM7XftHlPL4ZeQtcQcLsWk3TYYHam/Up+UI0XdRg0WmkATS3ZZ4zqgRvjY2bYkq7zqRkirZ
 xe62j88wKsE3ZdNg=
X-Received: by 2002:a05:620a:4054:: with SMTP id
 i20mr7660805qko.72.1607465731706; 
 Tue, 08 Dec 2020 14:15:31 -0800 (PST)
X-Google-Smtp-Source: ABdhPJwwuoYv9/vTk3+d5RiVJyydFvNdiQP2qfSKgeR95xgN/FoTzFFfps4td6PiOabssNVrWDwnEA==
X-Received: by 2002:a05:620a:4054:: with SMTP id
 i20mr7660776qko.72.1607465731461; 
 Tue, 08 Dec 2020 14:15:31 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id 76sm5798qkg.134.2020.12.08.14.15.30
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Tue, 08 Dec 2020 14:15:30 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Eli Zaretskii <eliz@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83lfemolvs.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <9d38c8f6-f14a-39b5-5ed7-3da8b718035b@HIDDEN>
Date: Tue, 8 Dec 2020 17:15:29 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <83lfemolvs.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/27/20 10:33 AM, Eli Zaretskii wrote:
>> Cc: trevor@HIDDEN, bugs@HIDDEN, fweimer@HIDDEN,
>>  43389 <at> debbugs.gnu.org, dj@HIDDEN, michael_heerdegen@HIDDEN
>> From: Carlos O'Donell <carlos@HIDDEN>
>> Date: Fri, 27 Nov 2020 00:04:56 -0500
>>
>> lisp_align_malloc (alloc.c:1195)
>>  Fcons (alloc.c:2694)
>>   concat (fns.c:730)
>>    Fcopy_sequence (fns.c:598)
>>     timer_check (keyboard.c:4395)
>>      wait_reading_process_output (process.c:5334)
>>       sit_for (dispnew.c:6056)
>>        read_char (keyboard.c:2742)
>>         read_key_sequence (keyboard.c:9551)
>>          command_loop_1 (keyboard.c:1354)
>>           internal_condition_case (eval.c:1365)
>>            command_loop_2 (keyboard.c:1095)
>>             internal_catch (eval.c:1126)
>>              command_loop (keyboard.c:1074)
>>               recursive_edit_1 (keyboard.c:718)
>>                Frecursive_edit (keyboard.c:790)
>>                 main (emacs.c:2080)
>>  
>> There is a 171MiB's worth of allocations in that path.
> 
> Are there chains of calls that are responsible for more memory
> allocated than 171MB?
 
Yes, you can view them all yourself, just fetch the massif data
and use massif-visualizer to view the data:

http://trevorbentley.com/massif.out.3364630

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 8 Dec 2020 22:12:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 08 17:12:57 2020
Received: from localhost ([127.0.0.1]:60031 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kmlE8-0004xN-S0
	for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 17:12:57 -0500
Received: from us-smtp-delivery-124.mimecast.com ([216.205.24.124]:34900)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1kmlE6-0004xF-7H
 for 43389 <at> debbugs.gnu.org; Tue, 08 Dec 2020 17:12:56 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1607465574;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=8gcuNkyLdtDKOIFnzW1lbwsv0bfS5ZmNa7pMf8DF7ws=;
 b=Sn/RGLWKtJn2arq7tZwKo1yTAZbAOrXjNRN8EyPENLcb1U8EGF3xsYNowEg7eKTAL4L2y8
 grJbq1dHDLAIXfVhS2Hc5F2TK79p6/ltS33mfG7205/397TV9lY59TIQY8tw5ZpOrAAAEc
 s1PpkmS94Tmb5yaWMAMJ9yUTufzH/Bg=
Received: from mail-qk1-f198.google.com (mail-qk1-f198.google.com
 [209.85.222.198]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-359-4vUq2VGQO-WOYxo4nVWSEQ-1; Tue, 08 Dec 2020 17:12:44 -0500
X-MC-Unique: 4vUq2VGQO-WOYxo4nVWSEQ-1
Received: by mail-qk1-f198.google.com with SMTP id x74so6454561qkb.12
 for <43389 <at> debbugs.gnu.org>; Tue, 08 Dec 2020 14:12:44 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=8gcuNkyLdtDKOIFnzW1lbwsv0bfS5ZmNa7pMf8DF7ws=;
 b=uVxgZWIHRcW0qxBs9WuZVtFw79ZfQMCLu+PxIGKa/QDXWeM9LujVzE0sB9iHPkbp4t
 k7o2TFkn0tGU9wKRbpKOfsHuLy7hgz8tRU+hxZz5kVM4zXuxJx8C1GB3slgGSRkWl5uu
 3wjwkO85ec0+fudWZOOMdMtsBSNPcz9HnDqbAc//dJ53LyK2e660msONxV8QAhXV1w4z
 owChYoZXfTLd+40As9PwpRQWkBC1KIlISBG5K1WpkDSUtxIfrnQpHVpSCWkmO45fpJ3f
 zFr1PQWmb9kO6GNTLSfqXPmOW4qAcK7UFIePQSrRa4lwW6k/dQV+zj9HKcwLuWQW43Z3
 k7lQ==
X-Gm-Message-State: AOAM531le1l1xV8mHP2HWERCAhlwZIgOrluwUjuClpIcPJmYxl56HYxV
 ITalvOClyzo84qy/ztHawwTHWPfGzEGCmXxHy2JTxJYIFG2lRcOYC7moPBx4YqWDPQFcB9lcZXI
 gIvdyvJILBbIv4VQ=
X-Received: by 2002:ae9:e007:: with SMTP id m7mr32814302qkk.220.1607465564133; 
 Tue, 08 Dec 2020 14:12:44 -0800 (PST)
X-Google-Smtp-Source: ABdhPJyUoSxLkQ5W755wjCYrb2d4gcrGA5D4Hw6s+C2+zSK+6ZrAtBjeOVPdmXT24vb+2JyLJqKF3A==
X-Received: by 2002:ae9:e007:: with SMTP id m7mr32814275qkk.220.1607465563908; 
 Tue, 08 Dec 2020 14:12:43 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id e7sm5435qkn.117.2020.12.08.14.12.42
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Tue, 08 Dec 2020 14:12:43 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Trevor Bentley <trevor@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
 <87eek0rmqa.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <7e0ce46f-ccb3-ae85-c553-75bd3b487677@HIDDEN>
Date: Tue, 8 Dec 2020 17:12:41 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <87eek0rmqa.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, michael_heerdegen@HIDDEN,
 dj@HIDDEN, bugs@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 12/8/20 4:50 PM, Trevor Bentley wrote:
> Trevor Bentley <trevor@HIDDEN> writes:
> 
> I'm back with 5 mtraces:
> 
> https://trevorbentley.com/mtrace/
> 
> Keep in mind that these things compress well, so the largest one is on the order of 45GB when decompressed.
> 
> These are from various emacs instances, some running the emacs-slack package and others just editing elisp code.  All inflated to several gigabytes of heap over 1-4 days.
> 
> Log files similar to the ones I've been posting in this thread are in the archives.  I don't think there's any point of including them here anymore, as they're all about the same.
> 
> I've been too busy to modify emacs to print garbage collects, but these still show really long (garbage-collect) calls, often exceeding 15 minutes.
> 
> Last thing: I've had one unused (graphical) emacs session running for 16 days now, minimized.  It's still at 57MB RSS.  I can definitively say that the leak doesn't occur unless emacs is actively used, for all the good that does us.

I'm fetching this trace for analysis:
https://trevorbentley.com/mtrace/mtrace9.tar.bz2

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 8 Dec 2020 21:50:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 08 16:50:48 2020
Received: from localhost ([127.0.0.1]:60021 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kmksh-0004Nw-Mu
	for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 16:50:47 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:32792)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kmksf-0004Ni-Di
 for 43389 <at> debbugs.gnu.org; Tue, 08 Dec 2020 16:50:46 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id F0A6C6055C;
 Tue,  8 Dec 2020 22:50:38 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1607464239;
 bh=JCqT/DyRtltRoG+bUrsTyQGoQ50fOG+dY41cFFXqEW4=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=rJkdgc62GnqfpRDbKuvoIKo/D6gaCQRdi13RlxnsCGxZjJukx3ezBhGO6D9U63fKV
 cqRLnzp0RSHi4JbmCensAJ+4H3/LZYUviU+j1aVrzlakJPP6Iqj+CyQDIBD3l2UmDf
 2JvrD9aBeYUwHgL78rFrWxhFt36muTIWrFQeBvR8=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, carlos@HIDDEN
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <87pn3usr13.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
Date: Tue, 08 Dec 2020 22:50:37 +0100
Message-ID: <87eek0rmqa.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Trevor Bentley <trevor@HIDDEN> writes:

I'm back with 5 mtraces:

https://trevorbentley.com/mtrace/

Keep in mind that these things compress well, so the largest one 
is on the order of 45GB when decompressed.

These are from various emacs instances, some running the 
emacs-slack package and others just editing elisp code.  All 
inflated to several gigabytes of heap over 1-4 days.

Log files similar to the ones I've been posting in this thread are 
in the archives.  I don't think there's any point of including 
them here anymore, as they're all about the same.

I've been too busy to modify emacs to print garbage collects, but 
these still show really long (garbage-collect) calls, often 
exceeding 15 minutes.

Last thing: I've had one unused (graphical) emacs session running 
for 16 days now, minimized.  It's still at 57MB RSS.  I can 
definitively say that the leak doesn't occur unless emacs is 
actively used, for all the good that does us.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 8 Dec 2020 16:30:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 08 11:30:40 2020
Received: from localhost ([127.0.0.1]:59360 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kmfsu-0000ae-CX
	for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 11:30:40 -0500
Received: from mout.web.de ([217.72.192.78]:37663)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1kmfsr-0000SQ-Ce
 for 43389 <at> debbugs.gnu.org; Tue, 08 Dec 2020 11:30:39 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1607444994;
 bh=NDbY2F+Rq9T3O+vPFZ+2SoX1ifb49rlNgPdR06I/lpo=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=qsTaJY0YPV66gFm+YY837R04jvNJRDdiXStZ/VW8jsfsJGkBb/DtMNkcI2YR4cqpW
 qGnkFI0x5jk2aOUeRz5QHxikRqsYP94W1pgKRHxRDsgiXTjsniHtORvTVxzPD+z99N
 NNRl0qvTo/7JGle9sjUPAqWV7tJHNgrlerLjVxvM=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([88.67.99.46]) by smtp.web.de (mrweb106
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MxHYA-1jy1CT44am-00xZEp; Tue, 08
 Dec 2020 17:29:54 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <83pn4l3mts.fsf@HIDDEN> <87v9edk4eb.fsf@HIDDEN>
 <87imadcqqk.fsf@HIDDEN> <87h7pxjrh5.fsf@HIDDEN>
 <87eel1cq83.fsf@HIDDEN> <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN>
 <87a6vpcphp.fsf@HIDDEN> <83ft5h2pks.fsf@HIDDEN>
 <87tutxi2cz.fsf@HIDDEN> <87y2i9jebl.fsf@HIDDEN>
 <X88LYF1fPJjFNP39@HIDDEN>
Date: Tue, 08 Dec 2020 17:29:52 +0100
In-Reply-To: <X88LYF1fPJjFNP39@HIDDEN> (Jean Louis's message of
 "Tue, 8 Dec 2020 08:13:04 +0300")
Message-ID: <87lfe8jm67.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:AlQrTkKexgbwF5QlzyELVH13UolUDBBm2trTSJtVOXwD4vri3PA
 RwzWdUKda+LAeOM4yfK/AZQLQxhInVHmmN4DKZiy5E8KdJyFwxt71fwFcgcR51zFPmzixbv
 Xb6AqIF2mJ0MIYMIGY3xj1uFaJ12mtnSdHRn7pXQlMgxtry3u97qQSoz/gOwnjldf/4Qnov
 v7bfi13/xHAaRR4k+eKIw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:Jj3oelGG4Ds=:dsuovmlsk867Auf7GGaJD8
 2gb7eSHpWbzGIvvppje+RnwmA04kszWZSQi2dWl+to6RpNgD5gcOwPC7iwfCBwRCvkrtK6Mcb
 xnl74LLnTZetn/+hFRmdbeZC09n6eJdGQ7EL0bb4ijsQCOt1bKrXhnL7Vwu9AVqv+oUmu92P/
 lE3Z+f57v3bnESwSzBVoiefA1iaUJb4+EjTwy/OHhOns2JUA4PWIB5xzlhzpCm2+svjY3mpRh
 dIoAWHOd+1wSjzKkifOLhuLguv4EVLagY83Z0SC/s5RqbzMuZoFyVVt4gzkNMoyom7mejuGMU
 w3wCP+d6mDxFcjzTJsISt8rZ/cZ7tRZa3dBjAaKdxhCa3r1ZGzAo+uMgqW+NCHXYS8bldlhdu
 Fla7OWTL5FvQlEpqsZh3IJ4IOGBCzHzomv4US+DweEXXmMDZoPtcppJWVqswkWHU7V1TiMYml
 Oe2YP/2WWv0cvBXPRVLJjIqlK1vYvQP0+D5DlgATttOiTqdspkyUvlWlLBQIKrXSigd+vqXpO
 iWHSUWBmITK5fgLij1DCoKLWi2UyvwuPAek0ZR7wIPsli/ExcLgjnYojum+97sinsxp0jvbad
 6GnAhe86+/iimsTURUSRGQe+/i/TfX/yqxFDxLyqirf8lE7JYDJWykCAHL8snl05odtjbg5TX
 tQVrD296Fsbt60XwsMPyrdJNXum4tQaN+WaaDNIJLrR1vUaYb+rew1mLAsYu3KwUFp0pPHbkC
 Ti/FgG7Z4P87XKZ/QtqFR6TDGhuuUmyc2gEGlaL5Fkc5lXh/bXPNh9JPJHuoN868q9H6dGxuo
 n4pEPa7EIN+LCGfys09Iv9lKvV/yv6wuKQaLlgrXfOud+DJImkKJeTs6LriPNS19duVblO+6e
 zCBFWi3qkXxSVsuII+i7H9zb23HYhwn68UDLctUdY=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43389
Cc: 43389 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, schwab@HIDDEN,
 RLAdams@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Jean Louis <bugs@HIDDEN> writes:

> Michael, since I stopped using helm-mode always on, I still use it,
> but not awlays on and I do not query system packages with helm, since
> then I have not get problem of swapping hard with 5 GB and more.

Yesterday it was not swapping yet.  I'm monitoring memory usage with
gkrellm.  When it starts blinking red, which was the case yesterday,
memory starts running out.  It skipped the blinking yellow state, which
means that a lot of memory must have been acquired in a short time
period.

> Now question is, do you use helm with helm mode always on?

I regularly use some Helm commands (e.g. for C-x C-f or M-x) but not
helm-mode.

> I could observe that vsize is increasing as Eli asked me for that. And
> I could observe slow down, like that it slows down being harder to
> type. But hard disk was not working. I could do garbage collect
> without waiting 40-50 minutes for function to finish.

I think we see different symptoms.  I don't see any slow-down at all
(unless swapping starts, obviously).  When I do M-x garbage-collect, it
finishes immediately without freeing an significant amount of memory.

> Of course it need not be related. But it is interesting as since I
> stopped using it at least I did not get swapping problem where Emacs
> tries to get some memory or has troubles with it.
>
> Especially I am thinking of the helm function helm-system-packages
> which always takes longer time as it searches through many
> packages.

I was not using this command.

Maybe our problems have a similar cause, but seems they are a bit
different.


Regards,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 8 Dec 2020 12:38:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 08 07:38:03 2020
Received: from localhost ([127.0.0.1]:56801 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kmcFn-0003Fp-If
	for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 07:38:03 -0500
Received: from lists.gnu.org ([209.51.188.17]:57952)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rladams@HIDDEN>) id 1kmcFj-0003FJ-MG
 for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 07:38:02 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:58246)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rladams@HIDDEN>)
 id 1kmcFj-0003PG-FP
 for bug-gnu-emacs@HIDDEN; Tue, 08 Dec 2020 07:37:59 -0500
Received: from se05.route25.eu ([2a00:f10:121:b00:43f:e2ff:fe00:1cfb]:55777)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rladams@HIDDEN>)
 id 1kmcFf-0002X4-LN
 for bug-gnu-emacs@HIDDEN; Tue, 08 Dec 2020 07:37:59 -0500
Date: Tue, 8 Dec 2020 13:37:37 +0100
From: Russell Adams <RLAdams@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Message-ID: <20201208123737.GZ6337@maokai>
Mail-Followup-To: bug-gnu-emacs@HIDDEN
References: <87v9edk4eb.fsf@HIDDEN> <87imadcqqk.fsf@HIDDEN>
 <87h7pxjrh5.fsf@HIDDEN> <87eel1cq83.fsf@HIDDEN>
 <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN>
 <87a6vpcphp.fsf@HIDDEN> <83ft5h2pks.fsf@HIDDEN>
 <87tutxi2cz.fsf@HIDDEN> <87y2i9jebl.fsf@HIDDEN>
 <878sa9f09g.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <878sa9f09g.fsf@HIDDEN>
X-Originating-IP: 185.87.185.80
X-SpamExperts-Domain: out.pcextreme.nl
X-SpamExperts-Username: 185.87.185.80
Authentication-Results: route25.eu;
 auth=pass smtp.auth=185.87.185.80@HIDDEN
X-SpamExperts-Outgoing-Class: ham
X-SpamExperts-Outgoing-Evidence: Combined (0.15)
X-Recommended-Action: accept
X-Filter-ID: Pt3MvcO5N4iKaDQ5O6lkdGlMVN6RH8bjRMzItlySaT9WLQux0N3HQm8ltz8rnu+BPUtbdvnXkggZ
 3YnVId/Y5jcf0yeVQAvfjHznO7+bT5wlAxozo778b01LESzM9ruWD181ZRkJ75zosNBWoY/fPNcV
 PSoHm0W/3adFfiYl2ntOV5feuIFvRzXh/E+hTSJP/T4GcPvCLvSpAEEGy7kYxsD3QRUnhlexiXT3
 xXuXeIhevFP+kOiMW3ZJfjMJYMEj+gaXrHkgRC7/tI3CjXmVyqkKR3aaaYMFKczxejwYqhbHh0cQ
 L0Ci0sRm4Wh/iZxmPmKsRAie6X5VUup6QaxbpcztdQUSqk/AeLi65+4s/LrywTM2yEHEhvC9Izsy
 /NENTMQ3Kg3hL2oXz5A5E5R/dS4GkJ5hfB+qWugfDEytZYoACfRtBjLzEjgIZNLWhI/Mshn3T8Ox
 KyIrAogwLlirll+u0Sc2bgjgy6NE5WzPnrJ1fJyKyenPq733oZ8bAyJmHQrtppYmxMktfUX7kfB+
 UdezYqxGMqsKjARq8PBC4qgxMmglBiLsgrvXOb7qEGUwgxHIagHkgJmlqPNWnLI1oovhSJcbnX/H
 QqL/X9rNCJCc6iESJvKm1NV8gkr+Wu8ScVDXinOVyuIpITQ9z3M3DO7OWuqF1+w/pTOKTb9S095k
 zceLZ1B7juE/8qhbN5oMeVGYiG9bBjJzOBUnoIYvw5pAsDwSmLLjI7Hj98S4eAnin8trLB1aNUk3
 bKYC3mDyT854kXwv2RX/MHp3a7oN/i32EoSnB0KQ6B3xt8UP9IrQLp/miaSDdXxJiAZb1EzkA9VQ
 u12rxRZzC8qBatCnanu594Bg9F0487570noQlWutNWqkIsYohMMl/dydeuL2ctgzcDoFd+96Xw4Q
 UNtTnT5USTuJ4+3886sgmKmkaUBIi2jULgpXi1xBXhUizdxdDneFtYF4v0IUhnwA7zUt/xXczwGF
 xR7aC6zIFLawTOmNvxgu6jFRoaLzVpT+CP36s6RbLfB6BI3XJUys1lM3IMGhDC7qKEsgLqHNXMxe
 jlB49DjiWowOnKvI8aF4jzAuZNIARVagEMhjyGL5llQ69151eclHOr67cHgLgz4Hvn0=
X-Report-Abuse-To: spam@HIDDEN
Received-SPF: pass client-ip=2a00:f10:121:b00:43f:e2ff:fe00:1cfb;
 envelope-from=rladams@HIDDEN; helo=se05.route25.eu
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

On Tue, Dec 08, 2020 at 03:24:27AM +0000, Jose A. Ortega Ruiz wrote:
> On Tue, Dec 08 2020, Michael Heerdegen wrote:
>
> > shut it down normally).  I'm sure that at least a significant part of
> > the problem materialized while using (more or less only) Gnus.
>
> I also have anecdotal evidence of that.  Quite systematically, i start
> emacs, things load, i'm around 300Mb or RAM, quite stable.  Then i start
> Gnus, read some groups, and, ver soon after that, while emacs is
> basically idle, i can see RAM increasing by ~10Mb every ~10secs until it
> reaches something like 800-900Mb.

I have consistently encountered this memory leak without a clear path
to reproducing it other than regular use over time, and I don't use
Gnus. I read mail in Mutt in another terminal window.

Thus I'm not sure Gnus is the culprit.


------------------------------------------------------------------
Russell Adams                            RLAdams@HIDDEN

PGP Key ID:     0x1160DCB3           http://www.adamsinfoserv.com/

Fingerprint:    1723 D8CA 4280 1EC9 557F  66E8 1154 E018 1160 DCB3




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 8 Dec 2020 12:08:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 08 07:08:21 2020
Received: from localhost ([127.0.0.1]:56770 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kmbn3-0006LQ-Bq
	for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 07:08:21 -0500
Received: from lists.gnu.org ([209.51.188.17]:50288)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1kmbn1-0006LG-1k
 for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 07:08:20 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:51778)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1kmbn0-00042N-Su
 for bug-gnu-emacs@HIDDEN; Tue, 08 Dec 2020 07:08:18 -0500
Received: from static.214.254.202.116.clients.your-server.de
 ([116.202.254.214]:40596 helo=ciao.gmane.io)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1kmbmy-0000Z2-DW
 for bug-gnu-emacs@HIDDEN; Tue, 08 Dec 2020 07:08:18 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1kmbmr-0002cw-Sn
 for bug-gnu-emacs@HIDDEN; Tue, 08 Dec 2020 13:08:09 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: "Jose A. Ortega Ruiz" <jao@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Date: Tue, 08 Dec 2020 03:24:27 +0000
Message-ID: <878sa9f09g.fsf@HIDDEN>
References: <87r1r5428d.fsf@HIDDEN> <875z8fc224.fsf@HIDDEN>
 <20200915175418.GV20869@maokai> <838sda98jm.fsf@HIDDEN>
 <20200915211209.GW20869@maokai> <83pn6l7ozj.fsf@HIDDEN>
 <20200917204704.GA20217@maokai> <83zh5n4hpd.fsf@HIDDEN>
 <878sbagsx8.fsf@HIDDEN> <87imaefck8.fsf@HIDDEN>
 <87wnyudws1.fsf@HIDDEN> <83pn4l3mts.fsf@HIDDEN>
 <87v9edk4eb.fsf@HIDDEN> <87imadcqqk.fsf@HIDDEN>
 <87h7pxjrh5.fsf@HIDDEN> <87eel1cq83.fsf@HIDDEN>
 <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN> <87a6vpcphp.fsf@HIDDEN>
 <83ft5h2pks.fsf@HIDDEN> <87tutxi2cz.fsf@HIDDEN>
 <87y2i9jebl.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Cancel-Lock: sha1:9EDjlRN9lkQj3wB6vYtV0ZNXoXY=
X-Attribution: jao
X-Clacks-Overhead: GNU Terry Pratchett
X-URL: <http://jao.io/>
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 0
X-Spam_score: -0.1
X-Spam_bar: /
X-Spam_report: (-0.1 / 5.0 requ) BAYES_00=-1.9, DATE_IN_PAST_06_12=1.543,
 HEADER_FROM_DIFFERENT_DOMAINS=0.25, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Tue, Dec 08 2020, Michael Heerdegen wrote:

> shut it down normally).  I'm sure that at least a significant part of
> the problem materialized while using (more or less only) Gnus.

I also have anecdotal evidence of that.  Quite systematically, i start
emacs, things load, i'm around 300Mb or RAM, quite stable.  Then i start
Gnus, read some groups, and, ver soon after that, while emacs is
basically idle, i can see RAM increasing by ~10Mb every ~10secs until it
reaches something like 800-900Mb.  

I've checked and i think the only timer with a periodicity of 10secs
always present when that happens is undo-auto--boundary-timer.
(Sometimes there's also slack-ws-ping, which checks that a websocket
connection is open, but i think i've seen this behaviour without that
timer on).

I'm sorry i don't have the time to obtain better benchmark data. Just
mentioning the above in case it rings a bell to someone knowledgeable.

Cheers,
jao





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 8 Dec 2020 05:18:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 08 00:18:20 2020
Received: from localhost ([127.0.0.1]:56283 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kmVOF-0007mn-Vh
	for submit <at> debbugs.gnu.org; Tue, 08 Dec 2020 00:18:20 -0500
Received: from static.rcdrun.com ([95.85.24.50]:42245)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kmVOC-0007mW-Vs
 for 43389 <at> debbugs.gnu.org; Tue, 08 Dec 2020 00:18:19 -0500
Received: from localhost ([::ffff:197.157.0.57])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C1AE2.000000005FCF0C92.00006C04; Tue, 08 Dec 2020 05:18:09 +0000
Date: Tue, 8 Dec 2020 08:13:04 +0300
From: Jean Louis <bugs@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Message-ID: <X88LYF1fPJjFNP39@HIDDEN>
References: <83pn4l3mts.fsf@HIDDEN> <87v9edk4eb.fsf@HIDDEN>
 <87imadcqqk.fsf@HIDDEN> <87h7pxjrh5.fsf@HIDDEN>
 <87eel1cq83.fsf@HIDDEN>
 <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN>
 <87a6vpcphp.fsf@HIDDEN> <83ft5h2pks.fsf@HIDDEN>
 <87tutxi2cz.fsf@HIDDEN> <87y2i9jebl.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <87y2i9jebl.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 3.6 (+++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  * Michael Heerdegen <michael_heerdegen@HIDDEN> [2020-12-08
 04:08]: > Michael Heerdegen <michael_heerdegen@HIDDEN> writes: > > > >
 Compliance!
 > > > > > > (gdb) call (int)malloc_info (0, stdout) > > > [...] 
 Content analysis details:   (3.6 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
 [197.157.0.57 listed in zen.spamhaus.org]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 43389
Cc: 43389 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, schwab@HIDDEN,
 RLAdams@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.6 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * Michael Heerdegen <michael_heerdegen@HIDDEN> [2020-12-08
    04:08]: > Michael Heerdegen <michael_heerdegen@HIDDEN> writes: > > > > Compliance!
    > > > > > > (gdb) call (int)malloc_info (0, stdout) > > > [...] 
 
 Content analysis details:   (2.6 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
                             [197.157.0.57 listed in zen.spamhaus.org]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

* Michael Heerdegen <michael_heerdegen@HIDDEN> [2020-12-08 04:08]:
> Michael Heerdegen <michael_heerdegen@HIDDEN> writes:
> 
> > > Compliance!
> > >
> > >   (gdb) call (int)malloc_info (0, stdout)
> >
> > I'm very sorry, but it's gone.
> 
> Today, "it" happened again (not sure how many problems were are
> discussing here, though).
> 
> I had been cleaning my web.de INBOX with Gnus.  Started Gnus, deleted or
> moved some messages, shut down, and repeated.  Then I suddenly saw that
> our problem was back, Emacs using 6GB or so.  The session is gone now (I
> shut it down normally).  I'm sure that at least a significant part of
> the problem materialized while using (more or less only) Gnus.
> 
> And here is that heap output you wanted:

Michael, since I stopped using helm-mode always on, I still use it,
but not awlays on and I do not query system packages with helm, since
then I have not get problem of swapping hard with 5 GB and more.

I could observe that vsize is increasing as Eli asked me for that. And
I could observe slow down, like that it slows down being harder to
type. But hard disk was not working. I could do garbage collect
without waiting 40-50 minutes for function to finish. And I did not
update or changed Emacs version yet. I have all the mtraces when it
happened and also after when I stopped using helm and waiting for
developers to tell if they need those mtraces.

Now question is, do you use helm with helm mode always on?

Of course it need not be related. But it is interesting as since I
stopped using it at least I did not get swapping problem where Emacs
tries to get some memory or has troubles with it.

Especially I am thinking of the helm function helm-system-packages
which always takes longer time as it searches through many
packages. It need not be related but I do remember that I had problem
with memory hours after using that function or turning helm always
on. Since I do not use, I did not yet observe the same
problem. Usually it would be after one day.






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 8 Dec 2020 01:07:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 07 20:07:26 2020
Received: from localhost ([127.0.0.1]:55971 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kmRTS-0007xL-Gy
	for submit <at> debbugs.gnu.org; Mon, 07 Dec 2020 20:07:26 -0500
Received: from mout.web.de ([212.227.15.14]:57923)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1kmRTQ-0007x6-2V
 for 43389 <at> debbugs.gnu.org; Mon, 07 Dec 2020 20:07:25 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1607389631;
 bh=GnlCWyT1j6XVJ+Gnemw6UwrwFP+ywos2uIg/bmXjJZw=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=VAtWEDvQGhUrX9pbk0Fm1e3cSQMnlRvcjIQqotARJYI1uJpOiIPfXZ5yeb6vuu6bN
 mD3V1tz989kA6CtKwbVIbOrkgIW+sXfRZu5vh1CYVIu54/V+d04VTZg0+GIZnuw4wF
 miFahDuv8UBJ+q8/b+EGNYWpyv6jDKolPKN+YaZM=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([88.67.99.46]) by smtp.web.de (mrweb006
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MD5jp-1kvY8k2jhJ-0099Eg; Tue, 08
 Dec 2020 02:07:11 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <87r1r5428d.fsf@HIDDEN> <87mu1sry72.fsf@HIDDEN>
 <875z8fc224.fsf@HIDDEN> <20200915175418.GV20869@maokai>
 <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <83zh5n4hpd.fsf@HIDDEN> <878sbagsx8.fsf@HIDDEN>
 <87imaefck8.fsf@HIDDEN> <87wnyudws1.fsf@HIDDEN>
 <83pn4l3mts.fsf@HIDDEN> <87v9edk4eb.fsf@HIDDEN>
 <87imadcqqk.fsf@HIDDEN> <87h7pxjrh5.fsf@HIDDEN>
 <87eel1cq83.fsf@HIDDEN> <4788A848-D51C-4A25-B023-BA029874DBE5@HIDDEN>
 <87a6vpcphp.fsf@HIDDEN> <83ft5h2pks.fsf@HIDDEN>
 <87tutxi2cz.fsf@HIDDEN>
Date: Tue, 08 Dec 2020 02:07:10 +0100
In-Reply-To: <87tutxi2cz.fsf@HIDDEN> (Michael Heerdegen's message of "Tue, 10
 Nov 2020 17:49:16 +0100")
Message-ID: <87y2i9jebl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Provags-ID: V03:K1:wUBdIOsCy4IjJKEbwzwemn50Qvt9q4br4e21TxLFowqQmB+8ysD
 gLM5Qy45gAcpr25ol+U9HKtYfEAuAkO+5euCOYYwqV16j9F30uQOUyGyg097BXL7Pt81Lxs
 lIeJy7t66ao0CWQgcVKBTdkro8s+yLp5Or7022cIVs4gexuzsYbNr3UMj5cfCCrfYzn3e8I
 tdXYvr7ZgTc6m5WeKnrYQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:3ExKy3g0Y7Q=:cssZ1Usixtad8kbgR6biEV
 kLhO1FFjcm/ltKaD3OQwBEyrLNSCu/4ZmIsIlh3LOlnDIaQ/QiSkWJQQniVBeMM+iwsYzZ9IE
 9OnJmVFkQVPIGkiwjV6qPeZ0XFY75TN+89zQPbVhkCxfa/+R4QZiXHlLsMofAndTGgLmgnato
 PXGOC4hGh5Uop9VFmMshPzgR+ojUu9z7Zk3D2FrjyaelRHNdQMgbolqnC3la33InaCaPfHzuq
 8w/NGSSfePz44yjtqizyiLl/LWB/w/Nz3rXKA7kvNWJx557mno7RSf34CQVSPWuHOrsKDssRg
 VTYE1t8yKjdidDhMJsHHoFo2+DdQM1gn613tOf/q4AnObNOaryg4Ksz55Ym3zMUOuBoT62wBA
 lkS6ZqumQ5RumgfBVSBIawEM496wmXNJe/pDIOC7rr4BmSIP7dVeLyJTlEaBGIUTafGarciIC
 SHKBfSWhtll0sUld2EQJxgLkldcwdFgH0hgh0FNpKWILXIqiRTvVkMuBGaG92IGZX2DEC+s0B
 f5fuOfwNeU1IWfOMGERbm9NqQKiJmaibREOHLDG9280FVa1RN5zQxAATaHwdUNDRWsQRk3FO8
 jIy/gWPNnbhlG+372HN96k6Gq4nxHbCOTbmOrppbAQj4XIYXeIiTGnznNoM9sKWrC0Puwqd+y
 p+4nCZkG00qbTtvBJwrhflQD20XR9MY6CjXnbS9sa0FxhxFIPvI4rEfgmyHpZVIHGyptPQZEe
 twOh8pQ7pWrYHRAdA2DeeDDNIvBNBhA0zrfb3SG6/HDBS2dNZ0kr/rucwsLACCBdJZhq2IbrG
 kjZQkgkwmAiBihZYaxEZKSA5mTgpesp6IcIrnFkbPb9P4UC43DDordHFfo5D5Lu6tIwLkeKFk
 v6qGdMpMGmTesOP2t4EeOp+eBeMM0pMAC7pmS58Jc=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43389
Cc: 43389 <at> debbugs.gnu.org, RLAdams@HIDDEN, schwab@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> > Compliance!
> >
> >   (gdb) call (int)malloc_info (0, stdout)
>
> I'm very sorry, but it's gone.

Today, "it" happened again (not sure how many problems were are
discussing here, though).

I had been cleaning my web.de INBOX with Gnus.  Started Gnus, deleted or
moved some messages, shut down, and repeated.  Then I suddenly saw that
our problem was back, Emacs using 6GB or so.  The session is gone now (I
shut it down normally).  I'm sure that at least a significant part of
the problem materialized while using (more or less only) Gnus.

And here is that heap output you wanted:


--=-=-=
Content-Type: text/plain
Content-Disposition: inline; filename=heap.txt

<malloc version="1">
<heap nr="0">
<sizes>
  <size from="657" to="657" total="2628" count="4"/>
  <size from="673" to="673" total="2019" count="3"/>
  <size from="689" to="689" total="689" count="1"/>
  <size from="705" to="705" total="705" count="1"/>
  <size from="721" to="721" total="721" count="1"/>
  <size from="737" to="737" total="1474" count="2"/>
  <size from="753" to="753" total="2259" count="3"/>
  <size from="785" to="785" total="1570" count="2"/>
  <size from="801" to="801" total="801" count="1"/>
  <size from="817" to="817" total="817" count="1"/>
  <size from="833" to="833" total="1666" count="2"/>
  <size from="897" to="897" total="1794" count="2"/>
  <size from="961" to="961" total="961" count="1"/>
  <size from="977" to="977" total="1954" count="2"/>
  <size from="993" to="993" total="993" count="1"/>
  <size from="1182753" to="1182753" total="1182753" count="1"/>
  <unsorted from="527265" to="527265" total="527265" count="1"/>
</sizes>
<total type="fast" count="0" size="0"/>
<total type="rest" count="30" size="1832141"/>
<system type="current" size="7946854400"/>
<system type="max" size="7946854400"/>
<aspace type="total" size="7946854400"/>
<aspace type="mprotect" size="7946854400"/>
</heap>
<heap nr="1">
<sizes>
  <size from="17" to="32" total="32" count="1"/>
  <size from="33" to="48" total="96" count="2"/>
  <size from="65" to="80" total="80" count="1"/>
  <unsorted from="481" to="657" total="1138" count="2"/>
</sizes>
<total type="fast" count="4" size="208"/>
<total type="rest" count="3" size="132722"/>
<system type="current" size="135168"/>
<system type="max" size="135168"/>
<aspace type="total" size="135168"/>
<aspace type="mprotect" size="135168"/>
<aspace type="subheaps" size="1"/>
</heap>
<heap nr="2">
<sizes>
  <size from="17" to="32" total="704" count="22"/>
  <size from="33" to="48" total="192" count="4"/>
  <size from="97" to="112" total="112" count="1"/>
</sizes>
<total type="fast" count="27" size="1008"/>
<total type="rest" count="1" size="101424"/>
<system type="current" size="135168"/>
<system type="max" size="135168"/>
<aspace type="total" size="135168"/>
<aspace type="mprotect" size="135168"/>
<aspace type="subheaps" size="1"/>
</heap>
<heap nr="3">
<sizes>
  <size from="17" to="32" total="608" count="19"/>
  <size from="33" to="48" total="96" count="2"/>
  <size from="97" to="112" total="112" count="1"/>
  <unsorted from="513" to="513" total="513" count="1"/>
</sizes>
<total type="fast" count="22" size="816"/>
<total type="rest" count="2" size="48289"/>
<system type="current" size="135168"/>
<system type="max" size="135168"/>
<aspace type="total" size="135168"/>
<aspace type="mprotect" size="135168"/>
<aspace type="subheaps" size="1"/>
</heap>
<heap nr="4">
<sizes>
</sizes>
<total type="fast" count="0" size="0"/>
<total type="rest" count="1" size="132240"/>
<system type="current" size="135168"/>
<system type="max" size="135168"/>
<aspace type="total" size="135168"/>
<aspace type="mprotect" size="135168"/>
<aspace type="subheaps" size="1"/>
</heap>
<total type="fast" count="53" size="2032"/>
<total type="rest" count="37" size="2246816"/>
<total type="mmap" count="11" size="305704960"/>
<system type="current" size="7947395072"/>
<system type="max" size="7947395072"/>
<aspace type="total" size="7947395072"/>
<aspace type="mprotect" size="7947395072"/>
</malloc>

--=-=-=
Content-Type: text/plain



HTH,

Michael.

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 3 Dec 2020 07:21:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 03 02:21:08 2020
Received: from localhost ([127.0.0.1]:38059 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kkivM-0004Cf-DO
	for submit <at> debbugs.gnu.org; Thu, 03 Dec 2020 02:21:08 -0500
Received: from static.rcdrun.com ([95.85.24.50]:50331)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kkivL-0004CF-EI
 for 43389 <at> debbugs.gnu.org; Thu, 03 Dec 2020 02:21:07 -0500
Received: from localhost ([::ffff:197.157.0.57])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C0007.000000005FC891DB.00007CC1; Thu, 03 Dec 2020 07:20:57 +0000
Date: Thu, 3 Dec 2020 09:30:54 +0300
From: Jean Louis <bugs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X8iGHjZ8AmCTMqWw@HIDDEN>
References: <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <83v9dpn9em.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I have finished one Emacs session over 2 days and 11 hours with some
differences in my behavior, and I have not observed no problem with
Emacs swapping hard or having memory problem that impacts my work. I
have not upgraded from git as well.

- while I did use helm mode in the sense to directly invoke it, I did
  not turn it on with helm-mode but some functions used helm
  indirectly. This is because it was said that helm could be
  problem. Now without using helm I did not encounter problem in by
  average longer time than before when I did encounter it.

- I have not used helm to install packages `helm-system-packages' what
  I often do

- my state for input-method before 1.5 days could not be switched back
  any more. C-\ did not work. Anything I would do the input method
  remained. This may or may not be related. To me it looks apparently
  related.

- symon-mode could not be turned off any more. It would say it is
  turned off but it was not. I think it runs with timer and something
  happened. It also looks related to this problem just by feeling. It
  may not be.

Because of not being able to change input method back to normal I have
to restart session.

I have sent one mtrace, there is no report, so I am not sending the
previous 2 mtraces which had the memory problem and swapping, that I
had to kill emacs. Once it becomes needed, I can send it.

I have mtrace for this session and I will send it when somebody tells
me it is needed.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 1 Dec 2020 16:14:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 01 11:14:39 2020
Received: from localhost ([127.0.0.1]:33090 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kk8IZ-0007TG-Cn
	for submit <at> debbugs.gnu.org; Tue, 01 Dec 2020 11:14:39 -0500
Received: from mab.sdf.org ([205.166.94.33]:35248 helo=ma.sdf.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kk8IX-0007T7-2C
 for 43389 <at> debbugs.gnu.org; Tue, 01 Dec 2020 11:14:37 -0500
Received: from akrl by ma.sdf.org with local (Exim 4.92)
 (envelope-from <akrl@HIDDEN>)
 id 1kk8IQ-0004TU-DH; Tue, 01 Dec 2020 16:14:30 +0000
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN> <83blfek8x1.fsf@HIDDEN>
 <87mtyysni5.fsf@HIDDEN> <83wny2is7h.fsf@HIDDEN>
 <X8VFNT+KVhmjYliY@HIDDEN> <83h7p5ikj7.fsf@HIDDEN>
Date: Tue, 01 Dec 2020 16:14:30 +0000
In-Reply-To: <83h7p5ikj7.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 01 Dec
 2020 18:00:12 +0200")
Message-ID: <xjfy2ih33mh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, Jean Louis <bugs@HIDDEN>,
 dj@HIDDEN, carlos@HIDDEN, trevor@HIDDEN,
 michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Date: Mon, 30 Nov 2020 22:17:09 +0300
>> From: Jean Louis <bugs@HIDDEN>
>> Cc: Trevor Bentley <trevor@HIDDEN>, fweimer@HIDDEN,
>>   43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
>>   michael_heerdegen@HIDDEN
>> 
>> This issue on helm is closed but looks very similar to what is
>> happening here and could maybe give related information:
>> 
>> https://github.com/helm/helm/issues/3121
>> 
>> Other issues related to memory leak at helm:
>> https://github.com/helm/helm/issues?q=memory+leak
>
> Are these at all relevant? they are not about Emacs, AFAIU.  There are
> many ways to have a leak and run out of memory, most of them unrelated
> to what happens in our case.

That's another helm "The package manager for Kubernetes", not the Elisp
package.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 1 Dec 2020 16:00:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 01 11:00:27 2020
Received: from localhost ([127.0.0.1]:33066 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kk84o-00078O-KF
	for submit <at> debbugs.gnu.org; Tue, 01 Dec 2020 11:00:27 -0500
Received: from eggs.gnu.org ([209.51.188.92]:52388)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kk84m-00078A-Ag
 for 43389 <at> debbugs.gnu.org; Tue, 01 Dec 2020 11:00:25 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:57264)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kk84g-0000P9-EP; Tue, 01 Dec 2020 11:00:18 -0500
Received: from [176.228.60.248] (port=2419 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kk84f-000165-BL; Tue, 01 Dec 2020 11:00:18 -0500
Date: Tue, 01 Dec 2020 18:00:12 +0200
Message-Id: <83h7p5ikj7.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
In-Reply-To: <X8VFNT+KVhmjYliY@HIDDEN> (message from Jean Louis
 on Mon, 30 Nov 2020 22:17:09 +0300)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN> <83blfek8x1.fsf@HIDDEN>
 <87mtyysni5.fsf@HIDDEN>
 <83wny2is7h.fsf@HIDDEN> <X8VFNT+KVhmjYliY@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Mon, 30 Nov 2020 22:17:09 +0300
> From: Jean Louis <bugs@HIDDEN>
> Cc: Trevor Bentley <trevor@HIDDEN>, fweimer@HIDDEN,
>   43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
>   michael_heerdegen@HIDDEN
> 
> This issue on helm is closed but looks very similar to what is
> happening here and could maybe give related information:
> 
> https://github.com/helm/helm/issues/3121
> 
> Other issues related to memory leak at helm:
> https://github.com/helm/helm/issues?q=memory+leak

Are these at all relevant? they are not about Emacs, AFAIU.  There are
many ways to have a leak and run out of memory, most of them unrelated
to what happens in our case.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 1 Dec 2020 10:35:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 01 05:35:05 2020
Received: from localhost ([127.0.0.1]:57976 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kk2zx-0001wt-2V
	for submit <at> debbugs.gnu.org; Tue, 01 Dec 2020 05:35:05 -0500
Received: from static.rcdrun.com ([95.85.24.50]:41489)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kk2zv-0001wH-Hb
 for 43389 <at> debbugs.gnu.org; Tue, 01 Dec 2020 05:35:04 -0500
Received: from localhost ([::ffff:41.202.241.16])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C0010.000000005FC61C50.000020FA; Tue, 01 Dec 2020 10:34:56 +0000
Date: Tue, 1 Dec 2020 13:33:37 +0300
From: Jean Louis <bugs@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X8YcAfBYSy1EQMj0@HIDDEN>
References: <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN>
 <83v9dpn9em.fsf@HIDDEN> <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN> <83blfek8x1.fsf@HIDDEN>
 <87mtyysni5.fsf@HIDDEN> <83wny2is7h.fsf@HIDDEN>
 <X8VFNT+KVhmjYliY@HIDDEN>
 <87k0u1sui1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: <87k0u1sui1.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Trevor Bentley <trevor@HIDDEN> [2020-12-01 13:15]:
> Jean Louis <bugs@HIDDEN> writes:
> > 
> > This issue on helm is closed but looks very similar to what is happening
> > here and could maybe give related information:
> > 
> > https://github.com/helm/helm/issues/3121
> > 
> > Other issues related to memory leak at helm:
> > https://github.com/helm/helm/issues?q=memory+leak
> 
> This is a different "helm" project, unrelated to emacs as far as I can tell.
> The emacs helm is here: https://github.com/emacs-helm/helm

Ohhh ÷)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 1 Dec 2020 10:14:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 01 05:14:54 2020
Received: from localhost ([127.0.0.1]:57933 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kk2gQ-0007ll-Bv
	for submit <at> debbugs.gnu.org; Tue, 01 Dec 2020 05:14:54 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:40396)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kk2gO-0007lV-TH
 for 43389 <at> debbugs.gnu.org; Tue, 01 Dec 2020 05:14:53 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id EE348605FB;
 Tue,  1 Dec 2020 11:14:46 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606817687;
 bh=GIf40rw2ndipfmRvo4PnP7hjvo8TunyTNAAi82WLNww=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=elah1czW4JyiM2gw8HiRIrDMlbj1oZe4qFKzcRFoP8kxdZUGVCG9jhO6GDTg6ILp6
 03oQHqaxAs1TLfyVXlUBxtSbBkr9jM2BzePK+vwF76ftqQjSpmbP929gmM1nO8toHe
 DzR7PFOfhe5JNn3iwyNi8haJMESCQSSABZjCpens=
From: Trevor Bentley <trevor@HIDDEN>
To: Jean Louis <bugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <X8VFNT+KVhmjYliY@HIDDEN>
References: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN>
 <83v9dpn9em.fsf@HIDDEN> <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN> <83blfek8x1.fsf@HIDDEN>
 <87mtyysni5.fsf@HIDDEN> <83wny2is7h.fsf@HIDDEN>
 <X8VFNT+KVhmjYliY@HIDDEN>
Date: Tue, 01 Dec 2020 11:14:46 +0100
Message-ID: <87k0u1sui1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Jean Louis <bugs@HIDDEN> writes:
> 
> This issue on helm is closed but looks very similar to what is 
> happening here and could maybe give related information: 
> 
> https://github.com/helm/helm/issues/3121 
> 
> Other issues related to memory leak at helm: 
> https://github.com/helm/helm/issues?q=memory+leak 

This is a different "helm" project, unrelated to emacs as far as I 
can tell.  The emacs helm is here: 
https://github.com/emacs-helm/helm

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 1 Dec 2020 09:00:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 01 04:00:13 2020
Received: from localhost ([127.0.0.1]:57743 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kk1W9-0003fC-Ce
	for submit <at> debbugs.gnu.org; Tue, 01 Dec 2020 04:00:13 -0500
Received: from static.rcdrun.com ([95.85.24.50]:41887)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kk1W4-0003cY-HP
 for 43389 <at> debbugs.gnu.org; Tue, 01 Dec 2020 04:00:09 -0500
Received: from localhost ([::ffff:41.202.241.16])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C0006.000000005FC60617.000016E1; Tue, 01 Dec 2020 09:00:07 +0000
Date: Mon, 30 Nov 2020 22:17:09 +0300
From: Jean Louis <bugs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X8VFNT+KVhmjYliY@HIDDEN>
References: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN> <83blfek8x1.fsf@HIDDEN>
 <87mtyysni5.fsf@HIDDEN> <83wny2is7h.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <83wny2is7h.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 Trevor Bentley <trevor@HIDDEN>, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.2 (/)

* Eli Zaretskii <eliz@HIDDEN> [2020-11-30 22:10]:
> > From: Trevor Bentley <trevor@HIDDEN>
> > Cc: carlos@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
> >  bugs@HIDDEN, dj@HIDDEN, michael_heerdegen@HIDDEN
> > Cc: 
> > Date: Mon, 30 Nov 2020 19:33:38 +0100
> > 
> > Eli Zaretskii <eliz@HIDDEN> writes:
> > 
> > >> Also note that the (garbage-collect) call is timed now.  318 
> > >> seconds for this one. 
> > > 
> > > And the automatic GCs were much faster? 
> > > 
> > 
> > Automatic GCs were unnoticeable, as before.  Still not sure what 
> > that means.  I think I'll instrument it in C to try to figure out 
> > what is going on.
> 
> I'm stomped by this discrepancy, and feel that I'm missing something
> very basic here...

This issue on helm is closed but looks very similar to what is
happening here and could maybe give related information:

https://github.com/helm/helm/issues/3121

Other issues related to memory leak at helm:
https://github.com/helm/helm/issues?q=memory+leak




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 30 Nov 2020 19:02:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 30 14:02:29 2020
Received: from localhost ([127.0.0.1]:56669 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kjoRQ-0008KY-T9
	for submit <at> debbugs.gnu.org; Mon, 30 Nov 2020 14:02:29 -0500
Received: from eggs.gnu.org ([209.51.188.92]:52642)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kjoRP-0008KK-R3
 for 43389 <at> debbugs.gnu.org; Mon, 30 Nov 2020 14:02:28 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34718)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kjoRK-0006wh-3w; Mon, 30 Nov 2020 14:02:22 -0500
Received: from [176.228.60.248] (port=4962 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kjoRG-0004p5-44; Mon, 30 Nov 2020 14:02:18 -0500
Date: Mon, 30 Nov 2020 21:02:10 +0200
Message-Id: <83wny2is7h.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87mtyysni5.fsf@HIDDEN> (message from Trevor
 Bentley on Mon, 30 Nov 2020 19:33:38 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN> <83blfek8x1.fsf@HIDDEN>
 <87mtyysni5.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: carlos@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  bugs@HIDDEN, dj@HIDDEN, michael_heerdegen@HIDDEN
> Cc: 
> Date: Mon, 30 Nov 2020 19:33:38 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> >> Also note that the (garbage-collect) call is timed now.  318 
> >> seconds for this one. 
> > 
> > And the automatic GCs were much faster? 
> > 
> 
> Automatic GCs were unnoticeable, as before.  Still not sure what 
> that means.  I think I'll instrument it in C to try to figure out 
> what is going on.

I'm stomped by this discrepancy, and feel that I'm missing something
very basic here...




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 30 Nov 2020 18:33:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 30 13:33:47 2020
Received: from localhost ([127.0.0.1]:56639 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kjnzf-0007X9-LN
	for submit <at> debbugs.gnu.org; Mon, 30 Nov 2020 13:33:47 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:36044)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kjnze-0007Wv-5U
 for 43389 <at> debbugs.gnu.org; Mon, 30 Nov 2020 13:33:46 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 80FDD67480;
 Mon, 30 Nov 2020 19:33:39 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606761219;
 bh=dafJWnYCetUO0jMSzpdGyHhaLLTwQG8MSzu0Jtfmdwc=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=ahuRnZ3IFOGq3jbcEEB02FtacqaUfDiFIOTDZmHmv+QrkajSsK57H2LnkOJpbzyNx
 22ofHWrItl9CGOoGR+jE2yB1IZEmaOp7eHAY1YNCXtn4cQVVzXWdUS+198unsODHuz
 kULRSeU8e3VdtuOSvmElcdWqir3tSw2EWZvBcYqU=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83blfek8x1.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN> <83blfek8x1.fsf@HIDDEN>
Date: Mon, 30 Nov 2020 19:33:38 +0100
Message-ID: <87mtyysni5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Also note that the (garbage-collect) call is timed now.  318 
>> seconds for this one. 
> 
> And the automatic GCs were much faster? 
> 

Automatic GCs were unnoticeable, as before.  Still not sure what 
that means.  I think I'll instrument it in C to try to figure out 
what is going on.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 30 Nov 2020 18:16:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 30 13:16:19 2020
Received: from localhost ([127.0.0.1]:56620 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kjnif-000736-Ex
	for submit <at> debbugs.gnu.org; Mon, 30 Nov 2020 13:16:19 -0500
Received: from eggs.gnu.org ([209.51.188.92]:40912)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kjnid-00072q-4u
 for 43389 <at> debbugs.gnu.org; Mon, 30 Nov 2020 13:16:12 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:33840)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kjniW-0000z1-Qm; Mon, 30 Nov 2020 13:16:04 -0500
Received: from [176.228.60.248] (port=2116 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kjniV-0001pB-72; Mon, 30 Nov 2020 13:16:03 -0500
Date: Mon, 30 Nov 2020 20:15:54 +0200
Message-Id: <83blfek8x1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87pn3usr13.fsf@HIDDEN> (message from Trevor
 Bentley on Mon, 30 Nov 2020 18:17:28 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
 <87pn3usr13.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN,
>  dj@HIDDEN, michael_heerdegen@HIDDEN
> Cc: 
> Date: Mon, 30 Nov 2020 18:17:28 +0100
> 
>  3) I ran the built-in emacs profiler.  The profiler memory 
>  results are in the log

Thanks, but this doesn't really measure memory usage.  It just uses
malloc calls as a poor man's replacement for SIGPROF signal, so the
results show a kind of CPU profile, not memory profile.

>  I don't know how to interpret it, but it looks like maybe a
>  periodic timer started by helm is responsible for 3+GB of RAM?

More like it's responsible for most of the CPU activity.

> Also note that the (garbage-collect) call is timed now.  318 
> seconds for this one.

And the automatic GCs were much faster?

Thanks.  I hope Carlos will be able to give some hints based on your
data.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 30 Nov 2020 17:17:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 30 12:17:38 2020
Received: from localhost ([127.0.0.1]:56526 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kjmnx-0005Pq-Un
	for submit <at> debbugs.gnu.org; Mon, 30 Nov 2020 12:17:38 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:35651)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kjmnx-0005L8-2y
 for 43389 <at> debbugs.gnu.org; Mon, 30 Nov 2020 12:17:37 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 937E7602C8;
 Mon, 30 Nov 2020 18:17:29 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606756649;
 bh=AQ9D0+k22Us+dPUGA/3wK2zYbzr76otqUNZ2nz5/oWM=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=PMo///+h9f6KeQMUpxFx5qYq8TBwLjtoTY/4AHOoLgz9r69PuxfrJLy6Kgzlhd4Jw
 kmh8oaLFJ/rXVGxU2RoAGC3RiyXuPn5+GxzjJfuDMCaho+SQOV1cOxQZ6gjX/NhhkT
 aqaRxDHCjz6lwZq90JKoLZRQIUwV8e9Q6VU6eRxs=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, carlos@HIDDEN
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <87sg8ts766.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
 <87sg8ts766.fsf@HIDDEN>
Date: Mon, 30 Nov 2020 18:17:28 +0100
Message-ID: <87pn3usr13.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> I'll have an mtrace for you from the current experiment (X11 
> focus  leak) tomorrow or Monday.  I hope it's the same issue. 

Ok, here is my latest memory log and a matching libmtrace:

https://trevorbentley.com/mtrace3/

This capture is unique in three ways:
 1) Compared to my other tests, this one did not run emacs-slack 
 and did about half of its leaking from X11 focus events, and the 
 other half drifting upwards during idle.  This session has barely 
 done anything.

 2) I added a custom (malloc-trim) command, and called it after 
 making my standard memory log.  At the end of the log, you can 
 see that after the trim memory usage fell from 4GB to 50MB. 
 Unfortunately, this malloc_trim() might make the libmtrace trace 
 harder to make sense of.  But, at least in this case, it meant 
 99% of the memory could be given back to the OS?

 3) I ran the built-in emacs profiler.  The profiler memory 
 results are in the log, both in normal and reversed format, with 
 the largest element expanded.  I don't know how to interpret it, 
 but it looks like maybe a periodic timer started by helm is 
 responsible for 3+GB of RAM?

Also note that the (garbage-collect) call is timed now.  318 
seconds for this one.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 29 Nov 2020 03:30:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 28 22:30:08 2020
Received: from localhost ([127.0.0.1]:49471 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kjDPb-00011S-Uh
	for submit <at> debbugs.gnu.org; Sat, 28 Nov 2020 22:30:08 -0500
Received: from eggs.gnu.org ([209.51.188.92]:39510)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kjDPY-0000zT-Gj
 for 43389 <at> debbugs.gnu.org; Sat, 28 Nov 2020 22:30:06 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55168)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kjDPR-0002ky-CV; Sat, 28 Nov 2020 22:29:57 -0500
Received: from [176.228.60.248] (port=2690 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kjDPQ-00084Z-Ma; Sat, 28 Nov 2020 22:29:57 -0500
Date: Sun, 29 Nov 2020 05:29:43 +0200
Message-Id: <83a6v0n8m0.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: "Basil L. Contovounesios" <contovob@HIDDEN>
In-Reply-To: <87im9pywr9.fsf@HIDDEN> (contovob@HIDDEN)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai> <837dq8qdpk.fsf@HIDDEN>
 <20201126165436.GB16802@maokai> <831rgfrkl1.fsf@HIDDEN>
 <20201127104520.GE16802@maokai> <83360votzk.fsf@HIDDEN>
 <20201128195631.GK16802@maokai> <83eekdme7v.fsf@HIDDEN>
 <87im9pywr9.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 RLAdams@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: "Basil L. Contovounesios" <contovob@HIDDEN>
> Cc: Russell Adams <RLAdams@HIDDEN>,  fweimer@HIDDEN,
>   43389 <at> debbugs.gnu.org,  dj@HIDDEN,  michael_heerdegen@HIDDEN,
>   trevor@HIDDEN,  carlos@HIDDEN
> Date: Sat, 28 Nov 2020 21:52:42 +0000
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Is there any way to get a trace/record of X events that are delivered
> > to Emacs during this kind of idleness?  Those events and the timers
> > are, I think, the only things that are going inside such an idle
> > session.
> 
> What about asynchronous processes, such as url.el retrievals?

Those should not depend on whether the session is GUI or TTY, nor on
whether an Emacs frame has focus.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 28 Nov 2020 21:52:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 28 16:52:56 2020
Received: from localhost ([127.0.0.1]:49248 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kj89H-0004zl-RL
	for submit <at> debbugs.gnu.org; Sat, 28 Nov 2020 16:52:56 -0500
Received: from mail-wm1-f50.google.com ([209.85.128.50]:40934)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1kj89D-0004zT-Ej
 for 43389 <at> debbugs.gnu.org; Sat, 28 Nov 2020 16:52:54 -0500
Received: by mail-wm1-f50.google.com with SMTP id a3so11498427wmb.5
 for <43389 <at> debbugs.gnu.org>; Sat, 28 Nov 2020 13:52:51 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=tcd-ie.20150623.gappssmtp.com; s=20150623;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=FK1kbwERKp0sgwhlQk3Hopt7dOtakM7HrEW2LkHEtWQ=;
 b=uD7ezE/aUXAN5SYfqX/hj8c3d/aECJvnQjRgKxdcIeVvPLGdIOhvRYoPVMyP6uDYyt
 VMvZRemWwi0D68J0kx3uhmVNXATuwwnvDMsxcT15FUNBS68pdiaDpwygjsNDtSmnp2f5
 RKYGyksncnPHCzuCGlvoLpwe4ZJfWPvo4mKwxwO7QMKeTtct7Vw/D/ePQ2XqH3Tvt2Uo
 RV+GIDHvHJTLIaAP5v5JRl67fie3mNWAVvwx05DDrkZM/ebFsEQNotB3JYm5ka08qT5x
 pkBJdH/XfQUJGqKCKe8uyiIDxGE5iZg8BP4ebYdSW+3+5QqK8TQVIN98EWZQIro5QkXl
 euBA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=FK1kbwERKp0sgwhlQk3Hopt7dOtakM7HrEW2LkHEtWQ=;
 b=iCGgXEqRn9+06yF0lZOjkn+4E2ilma+P4auIm6Fx43Goz6CEYGUxZrBGqJtqdKHAuf
 9IYlHBJ1su4/YhAy8uhjxo7+xl0qWTmF3XqXPzsLpK4W9hNsCZk8MPlHbRjuWnpPmpuv
 1K7UaAE9i1Ctpup2N227Fjin9X5wac8XDzrDs6Eur+fVqLdnvJrE3cJcjPbbuQQAJ9vL
 OJn8yWs/tz/NwMlBAucwk8Xq8mvirEcI5LaEN/341BHFF3WVro37c0/mKwNKh7ZDPhcM
 z80Ta2oDiRgt2D0GfA3nXQ+kJIZRiZ8V1Lq8dkT0jKiz+w6UN5rU08B57MDmWKqUKY+N
 q4Gg==
X-Gm-Message-State: AOAM533nTGi0qXP7zpJsEDgUI5adMY30RvwQ2bqPzvsIAv3YLkbDP2/3
 xpJGMl3Q4sTt4D0KIV+DjqyPeQ==
X-Google-Smtp-Source: ABdhPJxjQpxJAUk/5Lff/89coIMaVR1ybTer0EeKzIPo4VM9Kni/sSw+wmAABmEOjxNzg5KgHCJXIw==
X-Received: by 2002:a1c:ed13:: with SMTP id l19mr4089026wmh.141.1606600365603; 
 Sat, 28 Nov 2020 13:52:45 -0800 (PST)
Received: from localhost ([2a02:8084:20e2:c380:92bd:1bfd:38fc:fae2])
 by smtp.gmail.com with ESMTPSA id w21sm18552851wmi.29.2020.11.28.13.52.43
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 28 Nov 2020 13:52:44 -0800 (PST)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai> <837dq8qdpk.fsf@HIDDEN>
 <20201126165436.GB16802@maokai> <831rgfrkl1.fsf@HIDDEN>
 <20201127104520.GE16802@maokai> <83360votzk.fsf@HIDDEN>
 <20201128195631.GK16802@maokai> <83eekdme7v.fsf@HIDDEN>
Date: Sat, 28 Nov 2020 21:52:42 +0000
In-Reply-To: <83eekdme7v.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 28 Nov
 2020 22:13:56 +0200")
Message-ID: <87im9pywr9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Russell Adams <RLAdams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Is there any way to get a trace/record of X events that are delivered
> to Emacs during this kind of idleness?  Those events and the timers
> are, I think, the only things that are going inside such an idle
> session.

What about asynchronous processes, such as url.el retrievals?
(Though I guess those would be accounted for in buffer/GC lists.)

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 28 Nov 2020 20:14:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 28 15:14:23 2020
Received: from localhost ([127.0.0.1]:49167 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kj6bu-0002af-RA
	for submit <at> debbugs.gnu.org; Sat, 28 Nov 2020 15:14:23 -0500
Received: from eggs.gnu.org ([209.51.188.92]:51462)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kj6bq-0002aP-8k
 for 43389 <at> debbugs.gnu.org; Sat, 28 Nov 2020 15:14:21 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49891)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kj6bj-0000ju-8y; Sat, 28 Nov 2020 15:14:11 -0500
Received: from [176.228.60.248] (port=3946 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kj6bi-000852-6D; Sat, 28 Nov 2020 15:14:10 -0500
Date: Sat, 28 Nov 2020 22:13:56 +0200
Message-Id: <83eekdme7v.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Russell Adams <RLAdams@HIDDEN>
In-Reply-To: <20201128195631.GK16802@maokai> (message from Russell Adams on
 Sat, 28 Nov 2020 20:56:31 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai> <837dq8qdpk.fsf@HIDDEN>
 <20201126165436.GB16802@maokai> <831rgfrkl1.fsf@HIDDEN>
 <20201127104520.GE16802@maokai>
 <83360votzk.fsf@HIDDEN> <20201128195631.GK16802@maokai>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Sat, 28 Nov 2020 20:56:31 +0100
> From: Russell Adams <RLAdams@HIDDEN>
> Cc: dj@HIDDEN, fweimer@HIDDEN, trevor@HIDDEN,
> 	michael_heerdegen@HIDDEN, carlos@HIDDEN, 43389 <at> debbugs.gnu.org
> 
> I find particularly of interest the growth of Emacs processes while
> idle.
> 
> Yesterday I restarted Emacs and over the next 18 hours I left my
> laptop idle with Emacs as the focused application. My Emacs has grown
> to 3GB and every time I select my Emacs window it will grow by a few
> MB while I watch in htop.

Is there any way to get a trace/record of X events that are delivered
to Emacs during this kind of idleness?  Those events and the timers
are, I think, the only things that are going inside such an idle
session.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 28 Nov 2020 19:56:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 28 14:56:40 2020
Received: from localhost ([127.0.0.1]:49145 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kj6Km-0002A5-Ea
	for submit <at> debbugs.gnu.org; Sat, 28 Nov 2020 14:56:40 -0500
Received: from se05.route25.eu ([185.87.186.222]:54419)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rladams@HIDDEN>) id 1kj6Ki-00029t-Vw
 for 43389 <at> debbugs.gnu.org; Sat, 28 Nov 2020 14:56:38 -0500
Date: Sat, 28 Nov 2020 20:56:31 +0100
From: Russell Adams <RLAdams@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Message-ID: <20201128195631.GK16802@maokai>
References: <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai> <837dq8qdpk.fsf@HIDDEN>
 <20201126165436.GB16802@maokai> <831rgfrkl1.fsf@HIDDEN>
 <20201127104520.GE16802@maokai> <83360votzk.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <83360votzk.fsf@HIDDEN>
X-Originating-IP: 185.87.185.80
X-SpamExperts-Domain: out.pcextreme.nl
X-SpamExperts-Username: 185.87.185.80
Authentication-Results: route25.eu;
 auth=pass smtp.auth=185.87.185.80@HIDDEN
X-SpamExperts-Outgoing-Class: ham
X-SpamExperts-Outgoing-Evidence: Combined (0.11)
X-Recommended-Action: accept
X-Filter-ID: Mvzo4OR0dZXEDF/gcnlw0ecN11dQIc3aKzz9DU5dqGmpSDasLI4SayDByyq9LIhVAq3DKs/sLL8N
 5F3RMk1wo0TNWdUk1Ol2OGx3IfrIJKyP9eGNFz9TW9u+Jt8z2T3KeftVfXhxMQ04j8ndL5E8bbUS
 i56EfQ0rdWR4P39S1IpCG43jNckTsnu0Vma2B9rT/7TBeJCtE/3PtdoOyjKfDx66OOYZs3a1h0KV
 b1jwoZlGVm5pZgqyMrcMDB2tS/rO3rA0PMtQ+y0aX4NDRLp2xIUgUBeIBK51+WfVeHZIBkajcXRJ
 xrYzcB206EtR3hhq2s1Xp8nFtzJT3aBfCBDkL9lnibl3vcBqVmvQB4A18ac7dywIp6IjpzPfGPLH
 sDKzAVXirbLuJjy3NtnGWLbnBPSflyeJj6AFoLCUmqyOCtOWTg2esdlueWtJ8prBt64Mg8CBO1Sn
 vm6qXHQp7O9kdYkcpBMgcR761AjiNShpFdRwYZEtAFUQ4Jd7177NiPzHS8KWaecotq4zBypQ19eU
 2GxrlyZPzyn5edZSesYokAKItBMasm7pZA/O6yBhF8ofxGP8GhEQ1f+yBicGv+yRcznV71gErS0C
 0wftxHOa3oGCYOsnTY2OA0dQlbWm0xSdEE6z2imBWb46X5I8GpyRFRKz7c/NnxVl92HbT0+343Te
 OQNHQEdjU4M5JFrls8Or8R3kmST+8AM1EOydCf8J/ZhEHfx/kJUlKY/jXVFcuqwgr/U0flMcy2Vi
 /IcBgY4acnKqPguWcFDuAX4XQPeF/4m2NAvgI4s8HRo3pEptO2+mTg8kj7EIi2j7xoIQhElAhhOD
 hDC2adW/ZikdubSTH0s+a/uhLBizaAsv0ppgp9JpAhe2btBmnyOR1Y+v19Bz0cFf0X+kd3Id+MUV
 d2OtJMr1tQU4Bleak0vC9IQ+CwyYpK8IqcfK7NfbwoNdne0oONHVJe5tplc8MDizMP2r2AWKGxfc
 zPFlnAJy0NZewzLYbunlpmFqidK9KA1zyv4cavkKD23TTnPwZtcwY/Q7zIxpXoIlKaBTyl+1suTE
 KExQFRpAmOPl+Mk2TpNRDPKg+Hdjnzqffuq7pd8q/9stqfyQ+LqrEipHw6fVWMsEaTdo7Pcjf6jh
 xqhOSQCTP5Wo51+QgqgIDHe1cfNBRH3ApgKrPSDQBm06n9mf2cbKcEkLuGFeW6folbmEgVPaWk/v
 95Cn7Wx5X69MUx9Ikn8IaPtsiz0lw03t5oEI9kJnnqcc2eOmWKBjs81R88cYLO8A
X-Report-Abuse-To: spam@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Fri, Nov 27, 2020 at 02:38:07PM +0200, Eli Zaretskii wrote:
> > Unfortunately the Emacs that was 8GB has since been stopped, I killed
> > it before working with the trace files. My laptop was rebooted later
> > when the trace statistics utils ate all the RAM (my error, wrong input
> > file).
> >
> > This list of timers is from a new instance, but the configuration
> > hasn't changed.
> >
> > Are the 50+GB of trace files I have of any value?
>
> I don't think Carlos and others saw your reports, because they were
> not CC'ed.  I'm CC'ing them now; please make sure to reply to all of
> them next time.
>
> Carlos, please read
>
>   https://debbugs.gnu.org/cgi/bugreport.cgi?bug=43389#554
>
> for the details posted by Russel about his data points.  If you can
> instruct him how to produce some analysis from the mtrace files, or
> how to make them available for your analysis, please do.

I find particularly of interest the growth of Emacs processes while
idle.

Yesterday I restarted Emacs and over the next 18 hours I left my
laptop idle with Emacs as the focused application. My Emacs has grown
to 3GB and every time I select my Emacs window it will grow by a few
MB while I watch in htop.

I will restart it again tonight and leave it focused, and see if I can
reproduce the growth. It also appears that the growth is not linear,
slower at first and hard to see, but in the multiple MB at a time
later when the total is in GB.

Again I use emacs in daemon mode with one or more emacsclient
processes connected (x11 and terminal). I use StumpWM in full screen
mode with my emacsclient, and if it's focused it seems the growth
continues despite xscreensaver coming on and dimming the screen.

------------------------------------------------------------------
Russell Adams                            RLAdams@HIDDEN

PGP Key ID:     0x1160DCB3           http://www.adamsinfoserv.com/

Fingerprint:    1723 D8CA 4280 1EC9 557F  66E8 1154 E018 1160 DCB3




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 28 Nov 2020 17:49:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 28 12:49:46 2020
Received: from localhost ([127.0.0.1]:48989 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kj4Lx-0005Of-ND
	for submit <at> debbugs.gnu.org; Sat, 28 Nov 2020 12:49:45 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:50503)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kj4Lv-0005OS-V4
 for 43389 <at> debbugs.gnu.org; Sat, 28 Nov 2020 12:49:44 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 14A3D602C8;
 Sat, 28 Nov 2020 18:49:38 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606585778;
 bh=tILzxGkSVM2qfK+BoQ7xnGYcaqaFDdHy0l0IRBmeSzA=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=gsVb3bqgTSPi+zoT1chz0s4F7haFMe6wjYZox1hYRVFxVcDu436vZNQ9ct1IG4krw
 4ijF7GRn/RRRap0KWqSMkN7afwUEMElANZJw/J9gS3RSwtuHH6i+HHap+88I3nt4AB
 Lq42PtENggcBecCnxjJtUQMgBaPoiFZlMedvDOvc=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, carlos@HIDDEN
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83v9dpn9em.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
Date: Sat, 28 Nov 2020 18:49:37 +0100
Message-ID: <87sg8ts766.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Just to see if we have some problem there, I left an otherwise 
> idle Emacs with 20 timer functions firing every second run 
> overnight.  It gained less than 1MB of memory footprint after 10 
> hours.  So timers alone cannot explain the dramatic increase in 
> memory footprints described in this bug report, although they 
> might be a contributing factor when the Emacs process already 
> has lots of memory allocated to it. 

Something else worth noting is that I have dozens and dozens of 
emacs processes running at all times, and only graphical X11 
clients have had memory explosion.  Plenty of my `emacs -nw` 
instances have been open for 30+ days with heavy use, and all have 
stayed under 100MB RSS.

The most recent instance I ran is a graphical instance that I 
haven't done anything in except scroll around in a single small 
elisp file.  This one has an interesting difference in memory 
usage: the usage is large (2GB heap), but it isn't growing on its 
own.  It seems to grow by 10-20MB every time it gets X11 window 
focus, and other than that it's stable.  If I alt-tab to it 
continuously, I can force its usage up.  It appears to be 
permanent.  This differs from my emacs-slack instances, which 
constantly grow even when backgrounded.

I have yet another graphical instance that I just opened and 
minimized, and never focus.  It's still only using 70MB after over 
a week.  So at least it's not simply leaking all the time... some 
active use has to trigger it.

I'll have an mtrace for you from the current experiment (X11 focus 
leak) tomorrow or Monday.  I hope it's the same issue.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 28 Nov 2020 17:31:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 28 12:31:57 2020
Received: from localhost ([127.0.0.1]:48971 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kj44j-0004zI-9v
	for submit <at> debbugs.gnu.org; Sat, 28 Nov 2020 12:31:57 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:50398)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kj44g-0004z0-OU
 for 43389 <at> debbugs.gnu.org; Sat, 28 Nov 2020 12:31:56 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 97A0165105;
 Sat, 28 Nov 2020 18:31:48 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606584708;
 bh=W25lk1Db8xo8/xY+6cutMnPwS/AuxWzhAMSveOZ1dhc=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=cSfU8iMX4ZHb84HgFf8+A2debiI2+sCxlR7l3nZD6SBXVIj2gd2bSeFIvtTra+4Mc
 MBTU+BUqXapwO3WZU36VwJyIwLqITensjPRBXvv5n0IOBmjgFpGhCWqfrKcP85UjVP
 S4mUStO5c5oaglGCPocUXOZV85MlNv0JxrqpZw00=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83lfenp78f.fsf@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN>
Date: Sat, 28 Nov 2020 18:31:47 +0100
Message-ID: <87v9dps7zw.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:
>>  Thanks.  If they are like the one above, the allocations are 
>> due to some timer.  Could be jabber, I'll take a look at it. 
>> Or maybe helm-ff--cache-mode-refresh, whatever that is; need to 
>> look at Helm as well. 
> 
> Oops, I got this mixed up: the timer list is from Jean, but the 
> massif files are from Trevor. 
> 
> Trevor, can you show the list of timers running on your system? 

I use helm as well, emacs-slack sets a bunch of timers, and I have 
a custom treemacs-based UI for emacs-slack that also refreshes on 
a timer.  A typical timer list looks like this:

(list-timers) 
               0.2s            - thread-list--timer-func 5.0s 
               - undo-auto--boundary-timer 5.1s            - 
               slack-ws-ping 5.1s            - slack-ws-ping 5.1s 
               - slack-ws-ping 5.2s            - slack-ws-ping 
               5.2s            - slack-ws-ping 
              35.6s      1m 0.0s trev/slack--refresh-cache 
   *           0.5s            - #f(compiled-function () 
   #<bytecode 0x1b49fd33ce7c2899> [eldoc-mode global-eldoc-mode 
   eldoc--supported-p (debug error) 
   eldoc-print-current-symbol-info message "eldoc error: %s" nil]) 
   *           0.5s            t #f(compiled-function () 
   #<bytecode 0xbaac23f6e8899> [jit-lock--antiblink-grace-timer 
   jit-lock-context-fontify]) *           0.5s      :repeat 
   blink-cursor-start *           1.0s            - 
   helm-ff--cache-mode-refresh 

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 28 Nov 2020 10:46:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 28 05:46:13 2020
Received: from localhost ([127.0.0.1]:47006 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kixk4-0007R1-Sa
	for submit <at> debbugs.gnu.org; Sat, 28 Nov 2020 05:46:13 -0500
Received: from static.rcdrun.com ([95.85.24.50]:46369)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kixk0-0007Qf-8I
 for 43389 <at> debbugs.gnu.org; Sat, 28 Nov 2020 05:46:12 -0500
Received: from localhost ([::ffff:197.157.0.29])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C0010.000000005FC22A69.0000379E; Sat, 28 Nov 2020 10:46:01 +0000
Date: Sat, 28 Nov 2020 13:45:38 +0300
From: Jean Louis <bugs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X8IqUlRUl90fvg8a@HIDDEN>
References: <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
 <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
 <83mtz3p7qy.fsf@HIDDEN> <83lfenp78f.fsf@HIDDEN>
 <83h7pbp5wh.fsf@HIDDEN> <83v9dpn9em.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <83v9dpn9em.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hello, My good-by function took this time abut 7 minutes with
 swap being about 650 MB. Swap was constantly less than 200 MB. Then without
 me doing something special, maybe I was idling, swap grew to 650 MB. [...]
 Content analysis details:   (1.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.5 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
 [197.157.0.29 listed in dnsbl.sorbs.net]
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.5 (/)

Hello,

My good-by function took this time abut 7 minutes with swap being
about 650 MB. Swap was constantly less than 200 MB. Then without me
doing something special, maybe I was idling, swap grew to 650
MB. That is where I invoked the function:

((uptime "8 hours, 56 minutes, 27 seconds") (pid 14637) (garbage ((conses 16 2191203 1613364) (symbols 48 52843 237) (strings 32 301705 122437) (string-bytes 1 9982401) (vectors 16 99828) (vector-slots 8 1856426 1471952) (floats 8 738 5008) (intervals 56 180891 252942) (buffers 984 343))) (buffers-size 38553249) (vsize (vsize 3268444)))

One can see larger vsize of 3.12 G

Largest buffer is PDF of 5394959, the 4322895, 3706662, and so on.

I have tried deleting some buffers with M-x list-buffers:

- few largest buffers I have deleted without problem

- I have tried deleting my Org file with size 966405 and when I
  pressed D nothing was shown on screen, rather hard disk started
  working and it looks by behavior related to memory or swapping

- screen came back and I could press x to delete those buffers.

- even those some deleted buffers were deleted with x, at next click
  on Size in list-buffers I could again find the deleted buffers in
  the list. This is probably unrelated bug. I pressed x again and they
  disappeared. But what if they were not realy delete first time?

I will work little more in this session and will then provide mtrace
for pid 14637.

If anything else to be provided let me know.

Jean





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 28 Nov 2020 09:00:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 28 04:00:47 2020
Received: from localhost ([127.0.0.1]:46932 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiw63-0004nQ-B5
	for submit <at> debbugs.gnu.org; Sat, 28 Nov 2020 04:00:47 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33046)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiw60-0004nC-Nh
 for 43389 <at> debbugs.gnu.org; Sat, 28 Nov 2020 04:00:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42134)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiw5u-0000jS-R3; Sat, 28 Nov 2020 04:00:38 -0500
Received: from [176.228.60.248] (port=2186 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiw5p-00054N-DA; Sat, 28 Nov 2020 04:00:38 -0500
Date: Sat, 28 Nov 2020 11:00:17 +0200
Message-Id: <83v9dpn9em.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: carlos@HIDDEN
In-Reply-To: <83h7pbp5wh.fsf@HIDDEN> (message from Eli Zaretskii on Fri, 27
 Nov 2020 10:20:46 +0200)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN> <83h7pbp5wh.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 27 Nov 2020 10:20:46 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
>  michael_heerdegen@HIDDEN, trevor@HIDDEN
> 
> > > > lisp_align_malloc (alloc.c:1195)
> > > >  Fcons (alloc.c:2694)
> > > >   concat (fns.c:730)
> > > >    Fcopy_sequence (fns.c:598)
> > > >     timer_check (keyboard.c:4395)
> > > >      wait_reading_process_output (process.c:5334)
> > > >       sit_for (dispnew.c:6056)
> > > >        read_char (keyboard.c:2742)
> > > >         read_key_sequence (keyboard.c:9551)
> > > >          command_loop_1 (keyboard.c:1354)
> > > >           internal_condition_case (eval.c:1365)
> > > >            command_loop_2 (keyboard.c:1095)
> > > >             internal_catch (eval.c:1126)
> > > >              command_loop (keyboard.c:1074)
> > > >               recursive_edit_1 (keyboard.c:718)
> > > >                Frecursive_edit (keyboard.c:790)
> > > >                 main (emacs.c:2080)
> > > >  
> > > > There is a 171MiB's worth of allocations in that path.
> > > > 
> > > > There are a lot of traces ending in wait_reading_process_output that
> > > > are consuming 50MiB.
> > > 
> > > Thanks.  If they are like the one above, the allocations are due to
> > > some timer.  Could be jabber, I'll take a look at it.  Or maybe
> > > helm-ff--cache-mode-refresh, whatever that is; need to look at Helm as
> > > well.
> > 
> > Oops, I got this mixed up: the timer list is from Jean, but the massif
> > files are from Trevor.
> 
> Double oops: the above just shows that each time we process timers, we
> copy the list of the timers first.  Not sure what to do about that.
> Hmm...  Maybe we should try GC at the end of each timer_check call?

This doesn't seem to be necessary: timer functions are called via
'funcall', whose implementation already includes a call to maybe_gc.

Just to see if we have some problem there, I left an otherwise idle
Emacs with 20 timer functions firing every second run overnight.  It
gained less than 1MB of memory footprint after 10 hours.  So timers
alone cannot explain the dramatic increase in memory footprints
described in this bug report, although they might be a contributing
factor when the Emacs process already has lots of memory allocated to
it.

> Each call to lisp_align_malloc above requests a 1008-byte chunk of
> memory for a new block of Lisp conses.

More accurately, malloc is asked to provide a block of memory whose
size is 1024 bytes minus sizeof (void *).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 15:33:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 10:33:38 2020
Received: from localhost ([127.0.0.1]:45996 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kifkg-0004lL-FV
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 10:33:38 -0500
Received: from eggs.gnu.org ([209.51.188.92]:57808)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kifkc-0004l6-Ad
 for 43389 <at> debbugs.gnu.org; Fri, 27 Nov 2020 10:33:37 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52397)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kifkW-0002or-P9; Fri, 27 Nov 2020 10:33:28 -0500
Received: from [176.228.60.248] (port=1667 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kifkV-0000H6-Md; Fri, 27 Nov 2020 10:33:28 -0500
Date: Fri, 27 Nov 2020 17:33:11 +0200
Message-Id: <83lfemolvs.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>
In-Reply-To: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> (message from
 Carlos O'Donell on Fri, 27 Nov 2020 00:04:56 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: trevor@HIDDEN, bugs@HIDDEN, fweimer@HIDDEN,
>  43389 <at> debbugs.gnu.org, dj@HIDDEN, michael_heerdegen@HIDDEN
> From: Carlos O'Donell <carlos@HIDDEN>
> Date: Fri, 27 Nov 2020 00:04:56 -0500
> 
> lisp_align_malloc (alloc.c:1195)
>  Fcons (alloc.c:2694)
>   concat (fns.c:730)
>    Fcopy_sequence (fns.c:598)
>     timer_check (keyboard.c:4395)
>      wait_reading_process_output (process.c:5334)
>       sit_for (dispnew.c:6056)
>        read_char (keyboard.c:2742)
>         read_key_sequence (keyboard.c:9551)
>          command_loop_1 (keyboard.c:1354)
>           internal_condition_case (eval.c:1365)
>            command_loop_2 (keyboard.c:1095)
>             internal_catch (eval.c:1126)
>              command_loop (keyboard.c:1074)
>               recursive_edit_1 (keyboard.c:718)
>                Frecursive_edit (keyboard.c:790)
>                 main (emacs.c:2080)
>  
> There is a 171MiB's worth of allocations in that path.

Are there chains of calls that are responsible for more memory
allocated than 171MB?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 12:38:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 07:38:40 2020
Received: from localhost ([127.0.0.1]:44244 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kid1M-000052-6l
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 07:38:40 -0500
Received: from eggs.gnu.org ([209.51.188.92]:41552)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kid1K-0008WR-Nk
 for 43389 <at> debbugs.gnu.org; Fri, 27 Nov 2020 07:38:39 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46412)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kid18-0007wl-KN; Fri, 27 Nov 2020 07:38:28 -0500
Received: from [176.228.60.248] (port=2422 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kid16-00008l-NH; Fri, 27 Nov 2020 07:38:26 -0500
Date: Fri, 27 Nov 2020 14:38:07 +0200
Message-Id: <83360votzk.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Russell Adams <RLAdams@HIDDEN>
In-Reply-To: <20201127104520.GE16802@maokai> (message from Russell Adams on
 Fri, 27 Nov 2020 11:45:20 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <875z8fc224.fsf@HIDDEN> <20200915175418.GV20869@maokai>
 <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai> <837dq8qdpk.fsf@HIDDEN>
 <20201126165436.GB16802@maokai> <831rgfrkl1.fsf@HIDDEN>
 <20201127104520.GE16802@maokai>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 27 Nov 2020 11:45:20 +0100
> From: Russell Adams <RLAdams@HIDDEN>
> 
> > > Yes I have a few timers, but those trip at midnight. I call org-agenda
> > > and org-caldev-sync. I don't have any other timers that I know of.
> >
> > Just so we have the hard evidence: could you please show the values of
> > timer-list and timer-idle-list on that system?
> >
> > Thanks.
> >
> 
>            3.15     1.00 appt-check
>            8.38        - undo-auto--boundary-timer
>          117.38     5.00 savehist-autosave
>         1143.17    60.00 url-cookie-write-file
>        44223.15  1440.00 org-save-all-org-buffers
>        44283.15  1440.00 org-agenda-list
>        44343.15  1440.00 org-caldav-sync
>    *       0.00        t show-paren-function
>    *       0.50        t #f(compiled-function () #<bytecode 0x1ffd99dba7bf> [jit-lock--antiblink-grace-timer jit-lock-context-fontify])
>    *       1.00        - helm-ff--cache-mode-refresh

Thanks.

> Unfortunately the Emacs that was 8GB has since been stopped, I killed
> it before working with the trace files. My laptop was rebooted later
> when the trace statistics utils ate all the RAM (my error, wrong input
> file).
> 
> This list of timers is from a new instance, but the configuration
> hasn't changed.
> 
> Are the 50+GB of trace files I have of any value?

I don't think Carlos and others saw your reports, because they were
not CC'ed.  I'm CC'ing them now; please make sure to reply to all of
them next time.

Carlos, please read

  https://debbugs.gnu.org/cgi/bugreport.cgi?bug=43389#554

for the details posted by Russel about his data points.  If you can
instruct him how to produce some analysis from the mtrace files, or
how to make them available for your analysis, please do.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Nov 2020 10:45:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 05:45:39 2020
Received: from localhost ([127.0.0.1]:44094 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kibFy-0001Ob-Jt
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 05:45:39 -0500
Received: from lists.gnu.org ([209.51.188.17]:47016)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rladams@HIDDEN>) id 1kibFw-0001OS-P8
 for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 05:45:37 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:33302)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rladams@HIDDEN>)
 id 1kibFw-00042l-GQ
 for bug-gnu-emacs@HIDDEN; Fri, 27 Nov 2020 05:45:36 -0500
Received: from se18.route25.eu ([2a00:f10:400:4:1c00:18ff:fe00:1617]:44292)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rladams@HIDDEN>)
 id 1kibFo-0008PH-RM
 for bug-gnu-emacs@HIDDEN; Fri, 27 Nov 2020 05:45:35 -0500
Date: Fri, 27 Nov 2020 11:45:20 +0100
From: Russell Adams <RLAdams@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Message-ID: <20201127104520.GE16802@maokai>
Mail-Followup-To: bug-gnu-emacs@HIDDEN
References: <875z8fc224.fsf@HIDDEN> <20200915175418.GV20869@maokai>
 <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai> <837dq8qdpk.fsf@HIDDEN>
 <20201126165436.GB16802@maokai> <831rgfrkl1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <831rgfrkl1.fsf@HIDDEN>
X-Originating-IP: 185.87.184.57
X-SpamExperts-Domain: out.pcextreme.nl
X-SpamExperts-Username: 185.87.184.57
Authentication-Results: route25.eu;
 auth=pass smtp.auth=185.87.184.57@HIDDEN
X-SpamExperts-Outgoing-Class: ham
X-SpamExperts-Outgoing-Evidence: Combined (0.14)
X-Recommended-Action: accept
X-Filter-ID: Mvzo4OR0dZXEDF/gcnlw0ecN11dQIc3aKzz9DU5dqGmpSDasLI4SayDByyq9LIhVXL2pm6jngj6P
 fUXcDYIHsUTNWdUk1Ol2OGx3IfrIJKywOmJyM1qr8uRnWBrbSAGD0VsY0HzEkBzUTjuObUvkgtQ5
 3pMmTXeVbblO3cSIiVC6xN67yBfQb4yNgJkfG5otJODXbtOodkPED+RkHjVGH9gpfPe2lDQBFQc5
 pWKjU8U1TnR+f0U9cu064nZcMieLAqdkk6hppCDsqsBwLjHur1XxB26GtR7aQdGQ3RxVouttwXp1
 RdEU8VHZI5KGZSviaHwJ2eESrUp0Iw/gSJ3HqMuR600P9eQ3vodupN36MrkzGQZS068e3EYTgNAB
 jZkD8TzPF4eG61o+cxFZrUIXowfXJosMX5ZQSlYSVlCDu2na8Lc2iK0mXNgodhRh0E6+UMVFei1G
 2PrSIU9EwioS70yFBF2moUWeHNDS4qZDIDBdjx85xQq9VD42UbTRudBo31/E3ahF5MMcDI7KdpjQ
 KULbtCr8aoTjHIUEuG3LCVsCW2UOyugPPaOGK1ZclZhyJ1oAKHx1qHjvOGXm6QB+mk6ZTzCPKsFf
 twxbkg5OTEJBSZDxFdMdjhWKQRs1y634NtkDir044XKUvwzb23wQ7pgpf21taAxkVvyytXnHYuRC
 sfsWpWpZETi3iGJnui/pB5hQ6nsDvccjqgmDvD9Wh3hTQMCZFfPbwKEtSeDoMAHujwN5vAr2fQEN
 gxhN/KmvEyoAEK4rsNWk4mvtBc9RUVZYb+q6sUBKbKRJ7t2JzkiGuP0YIX8qMA5MLNz4roJ5XkZx
 xjtVUSKP0SAjfC/Jzazwe+LlFCfFvyKRS5/5739m4zuNRcgRKiGg7nXFaZTxgU2GYuFGsyYan9g/
 rMdRGcvAcA8+rx4YwgeE+t2FESF6coSh1XA3fOLJ37wDhYziv06NVNr5OEQYW/2Y/CoVJPIjQKAZ
 fI/jcX6o1g9K5ZwJhmYqJ0PIxX89f7dLTMqse5FhVBQaO03dzx9rAMZnZXrgXdZHl2vqCbCSy9Ix
 3eltOv8yJ5cKtwxhveW3ZWTI
X-Report-Abuse-To: spam@HIDDEN
Received-SPF: pass client-ip=2a00:f10:400:4:1c00:18ff:fe00:1617;
 envelope-from=rladams@HIDDEN; helo=se18.route25.eu
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

On Thu, Nov 26, 2020 at 09:20:42PM +0200, Eli Zaretskii wrote:
> > Date: Thu, 26 Nov 2020 17:54:36 +0100
> > From: Russell Adams <RLAdams@HIDDEN>
> >
> > At one point I was watching htop and every time I switched to the
> > Emacs window and returned to htop, I'd see it grow by several more MB
> > over 3-5 seconds and then stop. So I left Emacs as the focused window
> > overnight, and it grew from 4GB to 8GB.
> >
> > In this instance, I had my cursor at the bottom of a saved Org file. I
> > wasn't even actively typing or interacting with Emacs. I just grew
> > each time it got window focus.
>
> OK, so an idling Emacs with one focused frame gains about 0.5GB every
> hour, would that be more or less accurate?
>
> > Yes I have a few timers, but those trip at midnight. I call org-agenda
> > and org-caldev-sync. I don't have any other timers that I know of.
>
> Just so we have the hard evidence: could you please show the values of
> timer-list and timer-idle-list on that system?
>
> Thanks.
>

           3.15     1.00 appt-check
           8.38        - undo-auto--boundary-timer
         117.38     5.00 savehist-autosave
        1143.17    60.00 url-cookie-write-file
       44223.15  1440.00 org-save-all-org-buffers
       44283.15  1440.00 org-agenda-list
       44343.15  1440.00 org-caldav-sync
   *       0.00        t show-paren-function
   *       0.50        t #f(compiled-function () #<bytecode 0x1ffd99dba7bf> [jit-lock--antiblink-grace-timer jit-lock-context-fontify])
   *       1.00        - helm-ff--cache-mode-refresh

Unfortunately the Emacs that was 8GB has since been stopped, I killed
it before working with the trace files. My laptop was rebooted later
when the trace statistics utils ate all the RAM (my error, wrong input
file).

This list of timers is from a new instance, but the configuration
hasn't changed.

Are the 50+GB of trace files I have of any value?

------------------------------------------------------------------
Russell Adams                            RLAdams@HIDDEN

PGP Key ID:     0x1160DCB3           http://www.adamsinfoserv.com/

Fingerprint:    1723 D8CA 4280 1EC9 557F  66E8 1154 E018 1160 DCB3




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 09:50:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 04:50:23 2020
Received: from localhost ([127.0.0.1]:44005 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiaOU-0006JE-Ob
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 04:50:22 -0500
Received: from static.rcdrun.com ([95.85.24.50]:49999)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kiaOQ-0006Iq-Ko
 for 43389 <at> debbugs.gnu.org; Fri, 27 Nov 2020 04:50:21 -0500
Received: from localhost ([::ffff:197.157.0.29])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C000B.000000005FC0CBD4.000075A1; Fri, 27 Nov 2020 09:50:11 +0000
Date: Fri, 27 Nov 2020 11:44:33 +0300
From: Jean Louis <bugs@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X8C8cfCbjfO2EY4C@HIDDEN>
References: <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <87a6v4thst.fsf@HIDDEN> <83eekgqjgp.fsf@HIDDEN>
 <877dq8taau.fsf@HIDDEN>
 <6fe9ab5a-3995-acb2-eaea-9c269f86a604@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <6fe9ab5a-3995-acb2-eaea-9c269f86a604@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  * Carlos O'Donell <carlos@HIDDEN> [2020-11-27 07:54]:
 > Each process generates a trace, and that trace contains the data for > all
 threads in the process. > > I've just pushed MTRACE_CTL_CHILDREN, [...] 
 Content analysis details:   (1.5 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.5 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
 [197.157.0.29 listed in dnsbl.sorbs.net]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, Trevor Bentley <trevor@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.5 (/)

* Carlos O'Donell <carlos@HIDDEN> [2020-11-27 07:54]:
> Each process generates a trace, and that trace contains the data for
> all threads in the process.
> 
> I've just pushed MTRACE_CTL_CHILDREN, set that to 0 and the children
> will not trace. Thanks for the feedback and enhancement.

Thank you, that is nice feature, I will use it for the next session.

I have finished one trace and now packing it to see if it can be packed and uploaded.

I will upload it and share the hyperlink to Carlos and Eli as private email.

Sadly I could not invoke my function M-x good-bye and I also did not
see this time problem with swapping. Problem came that I have invoked
M-x eww and was browsing and it blocked. I had to interrupt. But
nothing worked in the end and user interface became not responsive. I
could not type a key, use mouse or do anything. Hard disk was working,
not much, and not that the LED was turned on as usual continually.

I have been doing usual work, nothing special. Just using eww. Mouse
and menu did not work. M-x did not work. Interrupting with ESC man
times or C-g did not work. It worked once to get error in process
filter but after everything was blocked.

My vsize function have been showing me over 4 GB vsize value in
minibuffer. Swap size was under 200 MB this time. 

When the condition occurs that we are trying to capture my swap size
was always 2-3 GB minimum, and I have 4 GB RAM.

I had to invoke xkill to kill Emacs. Hyperlink with mtrace is coming
as soon as it hopefully gets packed better. 

Thank you,
Jean




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 08:21:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 03:21:12 2020
Received: from localhost ([127.0.0.1]:43835 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiZ0C-0001vC-5A
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 03:21:12 -0500
Received: from eggs.gnu.org ([209.51.188.92]:56140)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiZ0A-0001ux-BZ
 for 43389 <at> debbugs.gnu.org; Fri, 27 Nov 2020 03:21:11 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:33100)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiZ04-0005bj-O7; Fri, 27 Nov 2020 03:21:04 -0500
Received: from [176.228.60.248] (port=2550 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiZ03-0002lQ-UH; Fri, 27 Nov 2020 03:21:04 -0500
Date: Fri, 27 Nov 2020 10:20:46 +0200
Message-Id: <83h7pbp5wh.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: carlos@HIDDEN
In-Reply-To: <83lfenp78f.fsf@HIDDEN> (message from Eli Zaretskii on Fri, 27
 Nov 2020 09:52:00 +0200)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
 <83lfenp78f.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 27 Nov 2020 09:52:00 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
>  carlos@HIDDEN, michael_heerdegen@HIDDEN
> 
> > Date: Fri, 27 Nov 2020 09:40:53 +0200
> > From: Eli Zaretskii <eliz@HIDDEN>
> > Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
> >  michael_heerdegen@HIDDEN, trevor@HIDDEN
> > 
> > > lisp_align_malloc (alloc.c:1195)
> > >  Fcons (alloc.c:2694)
> > >   concat (fns.c:730)
> > >    Fcopy_sequence (fns.c:598)
> > >     timer_check (keyboard.c:4395)
> > >      wait_reading_process_output (process.c:5334)
> > >       sit_for (dispnew.c:6056)
> > >        read_char (keyboard.c:2742)
> > >         read_key_sequence (keyboard.c:9551)
> > >          command_loop_1 (keyboard.c:1354)
> > >           internal_condition_case (eval.c:1365)
> > >            command_loop_2 (keyboard.c:1095)
> > >             internal_catch (eval.c:1126)
> > >              command_loop (keyboard.c:1074)
> > >               recursive_edit_1 (keyboard.c:718)
> > >                Frecursive_edit (keyboard.c:790)
> > >                 main (emacs.c:2080)
> > >  
> > > There is a 171MiB's worth of allocations in that path.
> > > 
> > > There are a lot of traces ending in wait_reading_process_output that
> > > are consuming 50MiB.
> > 
> > Thanks.  If they are like the one above, the allocations are due to
> > some timer.  Could be jabber, I'll take a look at it.  Or maybe
> > helm-ff--cache-mode-refresh, whatever that is; need to look at Helm as
> > well.
> 
> Oops, I got this mixed up: the timer list is from Jean, but the massif
> files are from Trevor.

Double oops: the above just shows that each time we process timers, we
copy the list of the timers first.  Not sure what to do about that.
Hmm...  Maybe we should try GC at the end of each timer_check call?

Is it possible to tell how much time did it take to allocate those
171MB via the above chain of calls?  I'm trying to assess the rate of
allocations we request this way.

Each call to lisp_align_malloc above requests a 1008-byte chunk of
memory for a new block of Lisp conses.  Would it benefit us to tune
this value to a larger or smaller size, as far as glibc's malloc is
concerned?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 07:52:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 02:52:28 2020
Received: from localhost ([127.0.0.1]:43723 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiYYO-00017x-BL
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 02:52:28 -0500
Received: from eggs.gnu.org ([209.51.188.92]:48732)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiYYM-00017l-MU
 for 43389 <at> debbugs.gnu.org; Fri, 27 Nov 2020 02:52:27 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60885)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiYYF-0003Ov-Lh; Fri, 27 Nov 2020 02:52:20 -0500
Received: from [176.228.60.248] (port=4768 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiYYD-0004qN-J2; Fri, 27 Nov 2020 02:52:18 -0500
Date: Fri, 27 Nov 2020 09:52:00 +0200
Message-Id: <83lfenp78f.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: trevor@HIDDEN
In-Reply-To: <83mtz3p7qy.fsf@HIDDEN> (message from Eli Zaretskii on Fri, 27
 Nov 2020 09:40:53 +0200)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> <83mtz3p7qy.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 27 Nov 2020 09:40:53 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
>  michael_heerdegen@HIDDEN, trevor@HIDDEN
> 
> > Cc: trevor@HIDDEN, bugs@HIDDEN, fweimer@HIDDEN,
> >  43389 <at> debbugs.gnu.org, dj@HIDDEN, michael_heerdegen@HIDDEN
> > From: Carlos O'Donell <carlos@HIDDEN>
> > Date: Fri, 27 Nov 2020 00:04:56 -0500
> > 
> > >> 448.2 MiB: Fmake_list
> > >> 270.3 MiB: in 262 places all over the place (below massif's threshold)
> > >> 704.0 MiB: list4 -> exec_byte_code
> > >> 109.7 MiB: F*_json_read_string_0 -> funcall_subr ...
> > >> 102.2 MiB: Flist -> exec_byte_code ...
> > >>  68.5 MiB: Fcopy_alist -> Fframe_parameters ...
> > > 
> > > Thanks.  Those are the low-level primitives, they tell nothing about
> > > the Lisp code which caused this much memory allocation.  We need
> > > higher levels of callstack, and preferably in Lisp terms.  GDB
> > > backtraces would show them, due to tailoring in src/.gdbinit.
> > 
> > Sure, let me pick one for you:
> > 
> > lisp_align_malloc (alloc.c:1195)
> >  Fcons (alloc.c:2694)
> >   concat (fns.c:730)
> >    Fcopy_sequence (fns.c:598)
> >     timer_check (keyboard.c:4395)
> >      wait_reading_process_output (process.c:5334)
> >       sit_for (dispnew.c:6056)
> >        read_char (keyboard.c:2742)
> >         read_key_sequence (keyboard.c:9551)
> >          command_loop_1 (keyboard.c:1354)
> >           internal_condition_case (eval.c:1365)
> >            command_loop_2 (keyboard.c:1095)
> >             internal_catch (eval.c:1126)
> >              command_loop (keyboard.c:1074)
> >               recursive_edit_1 (keyboard.c:718)
> >                Frecursive_edit (keyboard.c:790)
> >                 main (emacs.c:2080)
> >  
> > There is a 171MiB's worth of allocations in that path.
> > 
> > There are a lot of traces ending in wait_reading_process_output that
> > are consuming 50MiB.
> 
> Thanks.  If they are like the one above, the allocations are due to
> some timer.  Could be jabber, I'll take a look at it.  Or maybe
> helm-ff--cache-mode-refresh, whatever that is; need to look at Helm as
> well.

Oops, I got this mixed up: the timer list is from Jean, but the massif
files are from Trevor.

Trevor, can you show the list of timers running on your system?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 07:41:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 02:41:21 2020
Received: from localhost ([127.0.0.1]:43693 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiYNc-0000pV-UO
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 02:41:21 -0500
Received: from eggs.gnu.org ([209.51.188.92]:44192)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiYNZ-0000pI-Nm
 for 43389 <at> debbugs.gnu.org; Fri, 27 Nov 2020 02:41:20 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60756)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiYNT-0007QS-Lt; Fri, 27 Nov 2020 02:41:11 -0500
Received: from [176.228.60.248] (port=4081 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiYNT-0003kS-0W; Fri, 27 Nov 2020 02:41:11 -0500
Date: Fri, 27 Nov 2020 09:40:53 +0200
Message-Id: <83mtz3p7qy.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>
In-Reply-To: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN> (message from
 Carlos O'Donell on Fri, 27 Nov 2020 00:04:56 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
 <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: trevor@HIDDEN, bugs@HIDDEN, fweimer@HIDDEN,
>  43389 <at> debbugs.gnu.org, dj@HIDDEN, michael_heerdegen@HIDDEN
> From: Carlos O'Donell <carlos@HIDDEN>
> Date: Fri, 27 Nov 2020 00:04:56 -0500
> 
> >> 448.2 MiB: Fmake_list
> >> 270.3 MiB: in 262 places all over the place (below massif's threshold)
> >> 704.0 MiB: list4 -> exec_byte_code
> >> 109.7 MiB: F*_json_read_string_0 -> funcall_subr ...
> >> 102.2 MiB: Flist -> exec_byte_code ...
> >>  68.5 MiB: Fcopy_alist -> Fframe_parameters ...
> > 
> > Thanks.  Those are the low-level primitives, they tell nothing about
> > the Lisp code which caused this much memory allocation.  We need
> > higher levels of callstack, and preferably in Lisp terms.  GDB
> > backtraces would show them, due to tailoring in src/.gdbinit.
> 
> Sure, let me pick one for you:
> 
> lisp_align_malloc (alloc.c:1195)
>  Fcons (alloc.c:2694)
>   concat (fns.c:730)
>    Fcopy_sequence (fns.c:598)
>     timer_check (keyboard.c:4395)
>      wait_reading_process_output (process.c:5334)
>       sit_for (dispnew.c:6056)
>        read_char (keyboard.c:2742)
>         read_key_sequence (keyboard.c:9551)
>          command_loop_1 (keyboard.c:1354)
>           internal_condition_case (eval.c:1365)
>            command_loop_2 (keyboard.c:1095)
>             internal_catch (eval.c:1126)
>              command_loop (keyboard.c:1074)
>               recursive_edit_1 (keyboard.c:718)
>                Frecursive_edit (keyboard.c:790)
>                 main (emacs.c:2080)
>  
> There is a 171MiB's worth of allocations in that path.
> 
> There are a lot of traces ending in wait_reading_process_output that
> are consuming 50MiB.

Thanks.  If they are like the one above, the allocations are due to
some timer.  Could be jabber, I'll take a look at it.  Or maybe
helm-ff--cache-mode-refresh, whatever that is; need to look at Helm as
well.

However, GDB's backtraces are even more informative, as they show Lisp
functions invoked in-between (via exec_byte_code, funcall_subr, etc.).
These pinpoint the offending Lisp code much more accurately.  The
downside is that running with GDB stopping Emacs and emitting the
backtrace is no fun...




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 05:08:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 00:08:29 2020
Received: from localhost ([127.0.0.1]:43474 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiVzh-0003Cy-2N
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 00:08:29 -0500
Received: from us-smtp-delivery-124.mimecast.com ([216.205.24.124]:33282)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1kiVzf-0003Cp-0o
 for 43389 <at> debbugs.gnu.org; Fri, 27 Nov 2020 00:08:28 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606453706;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=DppodePAuHn+8xQIF3oArxc7ocVeAG0F0nz2DuKsVxs=;
 b=EfSdJOlKrsINDT76RX2m4thKJMt2bP+UMK3odBWsSudS2poj3kJEZy4jB3O/2vMTZSnPom
 ARlXPDRw/W+WKA9LaBfH9QPtqOnaMTSjjge96y66OLo5rDjUYBxeeax1zmoUVSr8FLpb88
 kGIMytamW6t3z4qZKlvAaZIvL60Nvks=
Received: from mail-il1-f198.google.com (mail-il1-f198.google.com
 [209.85.166.198]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-189-S0quTgfSOSOplqO7qxee7Q-1; Fri, 27 Nov 2020 00:08:24 -0500
X-MC-Unique: S0quTgfSOSOplqO7qxee7Q-1
Received: by mail-il1-f198.google.com with SMTP id u17so2874509ilb.4
 for <43389 <at> debbugs.gnu.org>; Thu, 26 Nov 2020 21:08:24 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=DppodePAuHn+8xQIF3oArxc7ocVeAG0F0nz2DuKsVxs=;
 b=jZsflQ1EeSePK/Qjef6j8BlIkZ/loonEVWh0GBmPnpXUdKEUTd5osBlRyP1htRjx2O
 uor/I2YMWQPuR5x0C8LpHXIAUL4oerEtkjUNZEzRc7+7vVa8wO2L9o4Vr7mOrTi00sv+
 mmm/maErZQaYVlLxCJi4QmxmZH9G+eTD5NNlVQ7vF5rzyiS9R1bYjRXpCrBAGKgyjVyv
 CTZDrR+N4wj3ZAj9/LyQyHqccPj+wN7Kg6CnSnov0k0vI+iFYJTI6HY2A+Ruvul+RoXm
 hgZxxPXM09scaAwB8k88DmVdGSAl5s+E/W8dpdzfaabTQDtfFDPFQjw++CManfLAjJnv
 njjA==
X-Gm-Message-State: AOAM532iC+NAoxaoCcnqBZ+hfOEKevMrF2NMZqCwew6P0NTvWjc0DOgh
 qc+th27xwVydPNE5epyn2pOFEL2SS56QFO5ZEU48z8ti0cGDgmapvrsLhlGUeVJcWfnNXVjKBpf
 dw6tOihyyAg9GawQ=
X-Received: by 2002:a02:272e:: with SMTP id g46mr98072jaa.37.1606453703607;
 Thu, 26 Nov 2020 21:08:23 -0800 (PST)
X-Google-Smtp-Source: ABdhPJxq7H5pEatPhKyyROl8L0ePuJRCdCHoaPzA9YwHYGp1o6vWKRi2MyPWhpFI5jlLVaFjduHS/Q==
X-Received: by 2002:a02:272e:: with SMTP id g46mr98059jaa.37.1606453703433;
 Thu, 26 Nov 2020 21:08:23 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id u24sm308666ili.47.2020.11.26.21.08.22
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Thu, 26 Nov 2020 21:08:22 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Jean Louis <bugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN> <83blfls494.fsf@HIDDEN>
 <X79wzM1DT3ZZQfp7@HIDDEN> <83lfeoqk7t.fsf@HIDDEN>
 <X7/2BBtDxXmq5wXB@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <328ace07-17d8-bac4-e042-789dc50c033c@HIDDEN>
Date: Fri, 27 Nov 2020 00:08:21 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <X7/2BBtDxXmq5wXB@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, trevor@HIDDEN,
 dj@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/26/20 1:37 PM, Jean Louis wrote:
> For this session I can see the corresponding PID on the disk. I am now
> at 8 hours session. Once finishes I hope that mtrace file will not be
> deleted even if I kill Emacs.

Nothing should be deleting the on-disk traces.

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 05:05:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 27 00:05:03 2020
Received: from localhost ([127.0.0.1]:43468 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiVwN-00037m-Em
	for submit <at> debbugs.gnu.org; Fri, 27 Nov 2020 00:05:03 -0500
Received: from us-smtp-delivery-124.mimecast.com ([63.128.21.124]:42978)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1kiVwL-00037U-K2
 for 43389 <at> debbugs.gnu.org; Fri, 27 Nov 2020 00:05:02 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606453501;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=gBJjMMu9yJ0IC2VGHxopM/G1pYKJp9Nvy+4VoWort5o=;
 b=ELneldNMuGh6WO8vXeJob1UssX2NjdhdyvVR3sm4Qhpj2ez6K8pH8CiDpcF5U66EceNyuJ
 TIW77NQWDQL5RD/mYD/1InZJ1X6nKTqYAH+Oa61AWz9/aqezOOlHMtlQFO7ZLBe4csuBSW
 pt2XVyXO7ibp3C7p8Y7Nvki39hsTh9I=
Received: from mail-qk1-f197.google.com (mail-qk1-f197.google.com
 [209.85.222.197]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-424-CZEnYcX4NZa9SgykXRWL7w-1; Fri, 27 Nov 2020 00:04:59 -0500
X-MC-Unique: CZEnYcX4NZa9SgykXRWL7w-1
Received: by mail-qk1-f197.google.com with SMTP id 141so2829058qkh.18
 for <43389 <at> debbugs.gnu.org>; Thu, 26 Nov 2020 21:04:59 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=gBJjMMu9yJ0IC2VGHxopM/G1pYKJp9Nvy+4VoWort5o=;
 b=c/eEdhTaUx6PZ4cRjdaof47w2Ynu79w3C8CGgSeZ0gqxywap48d/xTHkPptmWcFPru
 03Uf6slJNjpvyxNpgYHZI57FB/gMDl4k6EDDkvSUw05O5QLlcEFb7wtJdzgd0/bheh/h
 dhF8w7oOoSI6diS3MxJZMfEUyhKbpEIImgLbC6SY1EPX9iz3yOs1C9Bzvn7OHZ+SEtXX
 UEjGPRF9tA5TXI6dv/LLYWqWebLwJnJIAPMnkSIVzxGb4yJcBz8beNrjnVRQwmKvuS2g
 QyIps+5FZPZTgXpHAwS/onv4d+H1pv/iDb89VLhdoV2rkEDFxnkSpPoUB++D/MP1czYm
 Pj+g==
X-Gm-Message-State: AOAM533Jh3PVFyelFc/WnbmISfPME/iY24tvYVGQe/RMAnu+1OLBHarP
 Qqe8+iUYOMa8GHN6jlX5qN+KtYZedUuSeMZ6WigbpFfYnMB/qA4SMVQmGQBcT5ZimLU5ZtwCuvm
 sNJmGkhCWhxpGDgI=
X-Received: by 2002:a37:9b01:: with SMTP id d1mr6349181qke.89.1606453498819;
 Thu, 26 Nov 2020 21:04:58 -0800 (PST)
X-Google-Smtp-Source: ABdhPJwNjJO7Uy3jJ96sooITKh+e+es9hAw2wIWBWleCPXr8Sk2Zw6WgcBUvaZV3cEActIxyQ7j5EQ==
X-Received: by 2002:a37:9b01:: with SMTP id d1mr6349160qke.89.1606453498569;
 Thu, 26 Nov 2020 21:04:58 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id f189sm4794537qkb.84.2020.11.26.21.04.56
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Thu, 26 Nov 2020 21:04:57 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Eli Zaretskii <eliz@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
 <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> <83y2inq2sp.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <60253612-49f0-a1aa-b9e6-39cfef8d62b5@HIDDEN>
Date: Fri, 27 Nov 2020 00:04:56 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <83y2inq2sp.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/26/20 3:30 PM, Eli Zaretskii wrote:
>> Cc: trevor@HIDDEN, bugs@HIDDEN, fweimer@HIDDEN,
>>  43389 <at> debbugs.gnu.org, dj@HIDDEN, michael_heerdegen@HIDDEN
>> From: Carlos O'Donell <carlos@HIDDEN>
>> Date: Thu, 26 Nov 2020 15:21:04 -0500
>>
>> On 11/26/20 8:58 AM, Eli Zaretskii wrote:
>>> Apart of that, I think we really need to see the most significant
>>> customers of these functions when the memory footprint starts growing
>>> fast.
>>  
>> It's in the mastiff captured data.
>>
>> Of the 1.7GiB it's all in Fcons:
>>
>> 448.2 MiB: Fmake_list
>> 270.3 MiB: in 262 places all over the place (below massif's threshold)
>> 704.0 MiB: list4 -> exec_byte_code
>> 109.7 MiB: F*_json_read_string_0 -> funcall_subr ...
>> 102.2 MiB: Flist -> exec_byte_code ...
>>  68.5 MiB: Fcopy_alist -> Fframe_parameters ...
> 
> Thanks.  Those are the low-level primitives, they tell nothing about
> the Lisp code which caused this much memory allocation.  We need
> higher levels of callstack, and preferably in Lisp terms.  GDB
> backtraces would show them, due to tailoring in src/.gdbinit.

Sure, let me pick one for you:

lisp_align_malloc (alloc.c:1195)
 Fcons (alloc.c:2694)
  concat (fns.c:730)
   Fcopy_sequence (fns.c:598)
    timer_check (keyboard.c:4395)
     wait_reading_process_output (process.c:5334)
      sit_for (dispnew.c:6056)
       read_char (keyboard.c:2742)
        read_key_sequence (keyboard.c:9551)
         command_loop_1 (keyboard.c:1354)
          internal_condition_case (eval.c:1365)
           command_loop_2 (keyboard.c:1095)
            internal_catch (eval.c:1126)
             command_loop (keyboard.c:1074)
              recursive_edit_1 (keyboard.c:718)
               Frecursive_edit (keyboard.c:790)
                main (emacs.c:2080)
 
There is a 171MiB's worth of allocations in that path.

There are a lot of traces ending in wait_reading_process_output that
are consuming 50MiB.

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 04:55:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 23:55:52 2020
Received: from localhost ([127.0.0.1]:43464 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiVnU-0002sH-Dz
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 23:55:52 -0500
Received: from us-smtp-delivery-124.mimecast.com ([63.128.21.124]:48804)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1kiVnR-0002s8-Tl
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 23:55:50 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606452949;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=XjJW84BjOOOR4xTq8CZt1h/RdXbqCsqzY9QrC5WnxT4=;
 b=BmCS2p7A0JbTAmxPTlwrVW4l8UBWlpyWnpPBuj2BLRcWkZOCbEL1rZpp8qt+Uza/42jqLr
 oOq7reM/3+IqvtVAw4195/X1PWhd5AkKCUjBzthA67E2jW+2gjZEgjNnwPRGsCGpbx4lDD
 wPJKtgcTyukcNUnTAONzoeZ/ypmQjXY=
Received: from mail-qk1-f199.google.com (mail-qk1-f199.google.com
 [209.85.222.199]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-376-WMeaRF-KM3S2dQiz8Q5NIw-1; Thu, 26 Nov 2020 23:55:47 -0500
X-MC-Unique: WMeaRF-KM3S2dQiz8Q5NIw-1
Received: by mail-qk1-f199.google.com with SMTP id q21so2811823qkq.11
 for <43389 <at> debbugs.gnu.org>; Thu, 26 Nov 2020 20:55:47 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=XjJW84BjOOOR4xTq8CZt1h/RdXbqCsqzY9QrC5WnxT4=;
 b=Nomin02kuJpbSol7J3eN7nSieMtkR35hDQ8uQaOzl6UxL4HFuj5DZhibhU7CKjUdxO
 9MFTP18ROQ+OPbuCzcNuJojmk//kg2Ih+xfDMfRAh0DTPe/LRXsvecYdEdStnlzfvFsT
 rHz/VRcgQiTtok4c/kBmlXj0Wsshf01E0NDC4rLX4DmqK7cG9/yc2klNhrw5KQjpmarF
 ARrthWQKOFYMhtfjmB4VYvpoia8/4gK9baI9KJOYgAy3rBq7lx46294Zm+UBtunJbR8+
 3wJFHZqQ8BPdm2vc7z6llegH+a5C5H5Ino52qGSf/5thYiewuSUJQRxIvEjLjHp5N9Uo
 nqlw==
X-Gm-Message-State: AOAM533XP023ZA8YudHhyJb1DOJLr3HEK0EogH5C9IOillyp6GxSNpy3
 ND7xez5T72iedAAx0jeoJh2MEjVxlbpc1Z485pUaQ4iotffNaVLGeepCChJWLk+H/DME3r308KK
 1cB4AJ7YOUSYF5lU=
X-Received: by 2002:ad4:4908:: with SMTP id bh8mr6462101qvb.58.1606452947132; 
 Thu, 26 Nov 2020 20:55:47 -0800 (PST)
X-Google-Smtp-Source: ABdhPJyTLoDWIbTUCRsfa6HruDgssRt+Xygil+rGE0pfFp2oVS6/hKjZ7Ekttal86acz/J/gaQ09dg==
X-Received: by 2002:ad4:4908:: with SMTP id bh8mr6462092qvb.58.1606452947000; 
 Thu, 26 Nov 2020 20:55:47 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id 97sm4927860qte.34.2020.11.26.20.55.45
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Thu, 26 Nov 2020 20:55:46 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Jean Louis <bugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <87a6v4thst.fsf@HIDDEN> <83eekgqjgp.fsf@HIDDEN>
 <X7/zH2dUPx5bCUon@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <d3db625e-3794-0bcd-db48-faff93f9a3f1@HIDDEN>
Date: Thu, 26 Nov 2020 23:55:45 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <X7/zH2dUPx5bCUon@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
 Trevor Bentley <trevor@HIDDEN>, dj@HIDDEN,
 michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/26/20 1:25 PM, Jean Louis wrote:
> My mtrace files do not have the PID from Emacs. It got lost maybe
> because I killed Emacs. There are many other PID files. Or maybe
> initial PID file was based by the script that run it.
> 
> Should I provide mtrace files which do not have emacs PID?
 
Each PID is from a spawned subprocess.

I've just pushed new code to the tracer to allow you to do:
MTRACE_CTL_CHILDREN=0 to avoid tracing the spawned child
processes.

We would only want the mtrace file for the emacs PID (all
contained threads store to that file).

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 04:54:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 23:54:30 2020
Received: from localhost ([127.0.0.1]:43460 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiVmA-0002pj-0u
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 23:54:30 -0500
Received: from us-smtp-delivery-124.mimecast.com ([63.128.21.124]:30993)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1kiVm6-0002pZ-60
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 23:54:28 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606452866;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=3ik/T3V3VjYkPiMim+DrOvi39YsNvFDKcTf4oz0icg8=;
 b=fWVOqTCI5vmvRdzIP7RkSAjbV6ecOA86lXm/gZ8cPunXprZCEeRgch3n0oc9GOduTFINB8
 h20qFLvN1xExIYkbt2zUrONY4cFeV/t76MODaLs9rfcNgs2xBkuSTO/kp1zhSmGNvoM7lN
 eMiUmfcw/svFhDuO0JiQakzJZwzD438=
Received: from mail-qt1-f197.google.com (mail-qt1-f197.google.com
 [209.85.160.197]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-20-UarM3hKhN_iPW2Ito6yXCA-1; Thu, 26 Nov 2020 23:54:24 -0500
X-MC-Unique: UarM3hKhN_iPW2Ito6yXCA-1
Received: by mail-qt1-f197.google.com with SMTP id f19so2476793qtx.6
 for <43389 <at> debbugs.gnu.org>; Thu, 26 Nov 2020 20:54:24 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=3ik/T3V3VjYkPiMim+DrOvi39YsNvFDKcTf4oz0icg8=;
 b=K1MniYl1W9vN8HcS4ewlHqH7aRb1gQjfT1+hjwfB2TGb2a+dw/UoHtpaVAqAbDLdp1
 oi1y78VHoYYZqRauLbgwPyEug4vZjNGz7kDO0AVWd4JocWb1TZPzsiD0JfrEI2/HmNWo
 R2AXH7yQDaRaMqBKqtFWPXFkJiizNKRXD4hGmKmWITpuY8mK0V8yd59mqnQVhUqqYmId
 JdjWp5COKBp9QFnJoGtFW88qqryqshERGJdCazCUKlss9Xpz5PkOSfe6MU8qzwbwppbT
 4jl8pOKz/Sm0A0p2gjycmG6JBsup79FXvQZK33TYPpNP7rDsYZuPfTKpTxtGhclEoCwr
 5Gtg==
X-Gm-Message-State: AOAM532dMz9iSRvK/evSUCZlcX1HIFigB2ehuriZQLGks9pJrBH9llWA
 NT1PpcfdggME05l+1cI5YtOXYhZTcXC2QuOEcIqkYXd+oBeTAE1wE1BxToZhmvYqjUC8Z8UoQCg
 uxhaQ5qvGe5aWUKk=
X-Received: by 2002:aed:2823:: with SMTP id r32mr6479297qtd.199.1606452863889; 
 Thu, 26 Nov 2020 20:54:23 -0800 (PST)
X-Google-Smtp-Source: ABdhPJzwmRtbH7wmj25FxuOWXrvs/ZL6Uz7DvkQhogsXu8KCg1jkZ+cfINhW0TVl82lEZWyuVxVwTA==
X-Received: by 2002:aed:2823:: with SMTP id r32mr6479281qtd.199.1606452863712; 
 Thu, 26 Nov 2020 20:54:23 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id c128sm4626977qkg.66.2020.11.26.20.54.21
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Thu, 26 Nov 2020 20:54:22 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Trevor Bentley <trevor@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <87a6v4thst.fsf@HIDDEN> <83eekgqjgp.fsf@HIDDEN>
 <877dq8taau.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <6fe9ab5a-3995-acb2-eaea-9c269f86a604@HIDDEN>
Date: Thu, 26 Nov 2020 23:54:21 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <877dq8taau.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, michael_heerdegen@HIDDEN,
 dj@HIDDEN, bugs@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/26/20 10:19 AM, Trevor Bentley wrote:
>>> If it's one trace per thread, though, then we at least know that
>>> my emacs process in question is blazing through threads.
>> 
>> I don't see how this could be true, unless some library you use
>> (ImageMagick?) starts a lot of threads.  Emacs itself is
>> single-threaded, and the only other threads are those from GTK,
>> which should be very few (like, 4 or 5).  This assumes you didn't
>> use Lisp threads, of course.
> 
> Oh, it may be subprocesses instead of threads.  emacs-slack is doing
> all sorts of things, involving both ImageMagick and launching curl
> subprocesses.  Is there a way to prevent libmtrace from following
> children?

Each process generates a trace, and that trace contains the data for
all threads in the process.

I've just pushed MTRACE_CTL_CHILDREN, set that to 0 and the children
will not trace. Thanks for the feedback and enhancement.

commit 8a88a4840b5a573c50264f04f68f71d0496913d3
Author: Carlos O'Donell <carlos@HIDDEN>
Date:   Thu Nov 26 23:50:57 2020 -0500

    mtrace: Add support for MTRACE_CTL_CHILDREN.
    
    Allow the tracer to only trace the parent process and disable
    tracing in all child processes unless those processes choose
    to programmatically re-eanble tracing via the exposed API.

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 01:01:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 20:01:31 2020
Received: from localhost ([127.0.0.1]:43279 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiS8g-0005dT-IT
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 20:01:30 -0500
Received: from static.rcdrun.com ([95.85.24.50]:54303)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kiS8c-0005cv-FB
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 20:01:26 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C0010.000000005FC04FE0.00001E76; Fri, 27 Nov 2020 01:01:19 +0000
Date: Thu, 26 Nov 2020 21:37:56 +0300
From: Jean Louis <bugs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X7/2BBtDxXmq5wXB@HIDDEN>
References: <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <83blfls494.fsf@HIDDEN> <X79wzM1DT3ZZQfp7@HIDDEN>
 <83lfeoqk7t.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <83lfeoqk7t.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * Eli Zaretskii <eliz@HIDDEN> [2020-11-26 17:14]: > > Date:
 Thu, 26 Nov 2020 12:09:32 +0300 > > From: Jean Louis <bugs@HIDDEN> >
 > Cc: Carlos O'Donell <carlos@HIDDEN>, trevor@HIDDEN [...] 
 Content analysis details:   (1.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.1 DATE_IN_PAST_06_12     Date: is 6 to 12 hours before Received: date
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

* Eli Zaretskii <eliz@HIDDEN> [2020-11-26 17:14]:
> > Date: Thu, 26 Nov 2020 12:09:32 +0300
> > From: Jean Louis <bugs@HIDDEN>
> > Cc: Carlos O'Donell <carlos@HIDDEN>, trevor@HIDDEN,
> >   fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
> >   michael_heerdegen@HIDDEN
> > 
> > ((uptime "2 days, 18 hours, 35 minutes, 19 seconds") (pid 13339) (garbage ((conses 16 4511014 617524) (symbols 48 86926 23) (strings 32 576134 114546) (string-bytes 1 25198549) (vectors 16 245670) (vector-slots 8 4636183 1560354) (floats 8 1859 18842) (intervals 56 655325 24178) (buffers 992 900))) (buffers-size 200898858) (vsize (vsize 5144252)))
> > 
> > But what happened after 36 minutes of waiting is that Emacs became
> > responsive. So I am still running this session and I hope to get
> > mtrace after the session has finished.
> > 
> > Before I was not patient longer than maybe 3-5 minutes and I have
> > aborted Emacs. But now I can see it stabilized after hard work with
> > memory or whatever it was doing. Swap is 1809 MB and vsize just same
> > as above.
> 
> It's still 5GB, which is a fairly large footprint, certainly for a
> 2-day session.

And this time I could observe it was quick to reach, like from some
200 MB swap reported it grew to few gigabytes in few minutes.

> > Observation on "what I was doing when vsize started growing" is
> > simple, I was just editing email, nothing drastic. I did not do
> > anything special.
> 
> Can you describe in more detail how you edit email?  Which email
> package(s) do you do, and what would composing email generally
> involve?

I was using XTerm invoked from outside with mutt. Mutt invokes
emacsclient and it uses normally same frame, but sometimes other
frame. Default setting is to use new frame, but I sometimes change to
invoke it without creating new frame.

There are 2 modules vterm that I load and emacs-libpq for database.

> Also, are there any background activities that routinely run in your
> Emacs sessions?

Jabber doing XMPP without problem before, persistent scratch,
symon-mode, helm, sql-postgres mode, there is eshell always invoked
and shell.

Timers now:
               5.0s            - undo-auto--boundary-timer
              10.1s        30.0s jabber-whitespace-ping-do
              18.8s      1m 0.0s display-time-event-handler
           4m 49.4s      5m 0.0s persistent-scratch-save
          31m 10.9s   1h 0m 0.0s url-cookie-write-file
   *           0.1s            t show-paren-function
   *           0.5s      :repeat blink-cursor-start
   *           0.5s            t #f(compiled-function () #<bytecode 0x23a02dfeda0a1d> [jit-lock--antiblink-grace-timer jit-lock-context-fontify])
   *           1.0s            - helm-ff--cache-mode-refresh
   *           2.0s            t jabber-activity-clean

> > If you say I should finish session now and send the mtrace, I can do
> > it.
> 
> That's for Carlos to say.
> 
> Thanks for the info.

That session after some time invoked much harder hard disk swapping
and I have killed Emacs. But I could not find mtrace with
corresponding PID for that Emacs session

For this session I can see the corresponding PID on the disk. I am now
at 8 hours session. Once finishes I hope that mtrace file will not be
deleted even if I kill Emacs.

((uptime "8 hours, 8 minutes, 11 seconds") (pid 7385) (garbage ((conses 16 1032190 170175) (symbols 48 49048 11) (strings 32 252789 45307) (string-bytes 1 8153413) (vectors 16 84232) (vector-slots 8 1713735 81778) (floats 8 690 1822) (intervals 56 68015 4240) (buffers 984 105))) (buffers-size 3632683) (vsize (vsize 1217088)))




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 27 Nov 2020 01:01:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 20:01:25 2020
Received: from localhost ([127.0.0.1]:43274 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiS8a-0005d4-PG
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 20:01:25 -0500
Received: from static.rcdrun.com ([95.85.24.50]:43215)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kiS8Y-0005cq-TL
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 20:01:23 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C0007.000000005FC04FDC.00001E5E; Fri, 27 Nov 2020 01:01:16 +0000
Date: Thu, 26 Nov 2020 21:25:35 +0300
From: Jean Louis <bugs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X7/zH2dUPx5bCUon@HIDDEN>
References: <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <87a6v4thst.fsf@HIDDEN> <83eekgqjgp.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <83eekgqjgp.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: My mtrace files do not have the PID from Emacs. It got lost
 maybe because I killed Emacs. There are many other PID files. Or maybe initial
 PID file was based by the script that run it. Should I provide mtrace files
 which do not have emacs PID? 
 Content analysis details:   (1.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.1 DATE_IN_PAST_06_12     Date: is 6 to 12 hours before Received: date
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 Trevor Bentley <trevor@HIDDEN>, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

My mtrace files do not have the PID from Emacs. It got lost maybe
because I killed Emacs. There are many other PID files. Or maybe
initial PID file was based by the script that run it.

Should I provide mtrace files which do not have emacs PID?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 20:30:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 15:30:43 2020
Received: from localhost ([127.0.0.1]:43017 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiNud-0005MH-Fh
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 15:30:43 -0500
Received: from eggs.gnu.org ([209.51.188.92]:58186)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiNub-0005M4-JQ
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 15:30:42 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50264)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiNuW-0002Tr-3f; Thu, 26 Nov 2020 15:30:36 -0500
Received: from [176.228.60.248] (port=2986 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiNuT-0003hh-Re; Thu, 26 Nov 2020 15:30:35 -0500
Date: Thu, 26 Nov 2020 22:30:14 +0200
Message-Id: <83y2inq2sp.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>
In-Reply-To: <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN> (message from
 Carlos O'Donell on Thu, 26 Nov 2020 15:21:04 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
 <83pn40qkyb.fsf@HIDDEN> <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: trevor@HIDDEN, bugs@HIDDEN, fweimer@HIDDEN,
>  43389 <at> debbugs.gnu.org, dj@HIDDEN, michael_heerdegen@HIDDEN
> From: Carlos O'Donell <carlos@HIDDEN>
> Date: Thu, 26 Nov 2020 15:21:04 -0500
> 
> On 11/26/20 8:58 AM, Eli Zaretskii wrote:
> > Apart of that, I think we really need to see the most significant
> > customers of these functions when the memory footprint starts growing
> > fast.
>  
> It's in the mastiff captured data.
> 
> Of the 1.7GiB it's all in Fcons:
> 
> 448.2 MiB: Fmake_list
> 270.3 MiB: in 262 places all over the place (below massif's threshold)
> 704.0 MiB: list4 -> exec_byte_code
> 109.7 MiB: F*_json_read_string_0 -> funcall_subr ...
> 102.2 MiB: Flist -> exec_byte_code ...
>  68.5 MiB: Fcopy_alist -> Fframe_parameters ...

Thanks.  Those are the low-level primitives, they tell nothing about
the Lisp code which caused this much memory allocation.  We need
higher levels of callstack, and preferably in Lisp terms.  GDB
backtraces would show them, due to tailoring in src/.gdbinit.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 20:21:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 15:21:13 2020
Received: from localhost ([127.0.0.1]:42999 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiNlR-00056i-Bl
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 15:21:13 -0500
Received: from us-smtp-delivery-124.mimecast.com ([216.205.24.124]:56967)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1kiNlN-00056W-Ix
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 15:21:12 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606422069;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=vb+k8+9/Nia5HQdcT+5z3+EG6P0Adem4Ehsh4DRcUaQ=;
 b=L4x1B3VIRnbje7VGi4nc5LQDffrigOezhHeCqtznmLFxMLcXW8cBqjX1X5RnO6Kh0dOtyX
 GATFitAjIv/EhzbvE7Upda4DnE1NctLDNfttgp9zdp2BHpkc7a5I0lbGk6zFg9j0+8720J
 mdoHNy2584iHkLAEsxaXNxx4hAEojbg=
Received: from mail-qk1-f200.google.com (mail-qk1-f200.google.com
 [209.85.222.200]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-197-UUm1zYXTPhyjb8Pdy1-rwg-1; Thu, 26 Nov 2020 15:21:07 -0500
X-MC-Unique: UUm1zYXTPhyjb8Pdy1-rwg-1
Received: by mail-qk1-f200.google.com with SMTP id o190so2120129qkf.15
 for <43389 <at> debbugs.gnu.org>; Thu, 26 Nov 2020 12:21:07 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=vb+k8+9/Nia5HQdcT+5z3+EG6P0Adem4Ehsh4DRcUaQ=;
 b=UHs2GbyjFM1V04VFEkK3ZTTy0NVLvRXCRLBHlrrNfjxU5uhZjFkBxwGj3MN6BFtxc4
 P5kUPjFchAPtlRZN6PRDVxJZ1kPDX2gH15pNY1tGv7bh1/oiEYAnWRA6h9lL0jUAl2tR
 Md8PX7mmQHVjIpT0hNRx855ze5jlYhFImzrekCWijHDOoOiCtVUTaWVl0O3JRqQ2ykgX
 xQFgwwWmnxSbGYtJJjH5ul6kDZHeLVFI1WBj5D3VCfHSV5SGzed1gvoblnp4/86U9clc
 gzYWCMYn6JNLZgCU5+Qly7jlQ2HbmUvPmWX871AG6Zb12auI9XlQJWJTsPmboWsZ6wq8
 rO0w==
X-Gm-Message-State: AOAM530Z1iHKfc31oWK4KEr2mynjBw2ngi2bEdkpO/gJeEBBEBtprvaO
 Fu+B1biUeLhj3O4Q5xb/19RrogwLUtpg65pOFTUAWADQsN3gb98olAumQhMuS7VMP+bgS46NuJF
 rxEOr7HlE47DsMZs=
X-Received: by 2002:ad4:524d:: with SMTP id s13mr4859426qvq.19.1606422066776; 
 Thu, 26 Nov 2020 12:21:06 -0800 (PST)
X-Google-Smtp-Source: ABdhPJxIMqPoMcYtQQE5sha8wZamcCXBBmi+iN1Q7X332DEDuzmph7/QZFkMizwNqQNnIAnlCN1rLA==
X-Received: by 2002:ad4:524d:: with SMTP id s13mr4859413qvq.19.1606422066574; 
 Thu, 26 Nov 2020 12:21:06 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id h26sm3619746qkh.127.2020.11.26.12.21.05
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Thu, 26 Nov 2020 12:21:05 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Eli Zaretskii <eliz@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> <83pn40qkyb.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <418751f6-41be-a5e2-908a-ea4196d5fb9b@HIDDEN>
Date: Thu, 26 Nov 2020 15:21:04 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <83pn40qkyb.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/26/20 8:58 AM, Eli Zaretskii wrote:
> Apart of that, I think we really need to see the most significant
> customers of these functions when the memory footprint starts growing
> fast.
 
It's in the mastiff captured data.

Of the 1.7GiB it's all in Fcons:

448.2 MiB: Fmake_list
270.3 MiB: in 262 places all over the place (below massif's threshold)
704.0 MiB: list4 -> exec_byte_code
109.7 MiB: F*_json_read_string_0 -> funcall_subr ...
102.2 MiB: Flist -> exec_byte_code ...
 68.5 MiB: Fcopy_alist -> Fframe_parameters ...

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 26 Nov 2020 19:21:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 14:21:06 2020
Received: from localhost ([127.0.0.1]:42916 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiMpF-0003bn-Sb
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 14:21:06 -0500
Received: from lists.gnu.org ([209.51.188.17]:58310)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiMpE-0003bg-Eu
 for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 14:21:04 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:34504)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>) id 1kiMpD-0001zo-HJ
 for bug-gnu-emacs@HIDDEN; Thu, 26 Nov 2020 14:21:03 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49204)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiMpC-00030t-KH; Thu, 26 Nov 2020 14:21:02 -0500
Received: from [176.228.60.248] (port=2671 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiMp9-00036t-Qk; Thu, 26 Nov 2020 14:21:00 -0500
Date: Thu, 26 Nov 2020 21:20:42 +0200
Message-Id: <831rgfrkl1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Russell Adams <RLAdams@HIDDEN>
In-Reply-To: <20201126165436.GB16802@maokai> (message from Russell Adams on
 Thu, 26 Nov 2020 17:54:36 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <87r1r5428d.fsf@HIDDEN> <87mu1sry72.fsf@HIDDEN>
 <875z8fc224.fsf@HIDDEN> <20200915175418.GV20869@maokai>
 <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai> <837dq8qdpk.fsf@HIDDEN>
 <20201126165436.GB16802@maokai>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
Cc: bug-gnu-emacs@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Thu, 26 Nov 2020 17:54:36 +0100
> From: Russell Adams <RLAdams@HIDDEN>
> 
> At one point I was watching htop and every time I switched to the
> Emacs window and returned to htop, I'd see it grow by several more MB
> over 3-5 seconds and then stop. So I left Emacs as the focused window
> overnight, and it grew from 4GB to 8GB.
> 
> In this instance, I had my cursor at the bottom of a saved Org file. I
> wasn't even actively typing or interacting with Emacs. I just grew
> each time it got window focus.

OK, so an idling Emacs with one focused frame gains about 0.5GB every
hour, would that be more or less accurate?

> Yes I have a few timers, but those trip at midnight. I call org-agenda
> and org-caldev-sync. I don't have any other timers that I know of.

Just so we have the hard evidence: could you please show the values of
timer-list and timer-idle-list on that system?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 26 Nov 2020 16:54:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 11:54:52 2020
Received: from localhost ([127.0.0.1]:42677 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiKXj-0006Ip-S7
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 11:54:52 -0500
Received: from lists.gnu.org ([209.51.188.17]:53088)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rladams@HIDDEN>) id 1kiKXh-0006Ih-MT
 for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 11:54:50 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:55312)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rladams@HIDDEN>)
 id 1kiKXh-0001xi-1I
 for bug-gnu-emacs@HIDDEN; Thu, 26 Nov 2020 11:54:49 -0500
Received: from se18.route25.eu ([2a00:f10:400:4:1c00:18ff:fe00:1617]:59366)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rladams@HIDDEN>)
 id 1kiKXc-0007l7-Un
 for bug-gnu-emacs@HIDDEN; Thu, 26 Nov 2020 11:54:47 -0500
Date: Thu, 26 Nov 2020 17:54:36 +0100
From: Russell Adams <RLAdams@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Message-ID: <20201126165436.GB16802@maokai>
Mail-Followup-To: bug-gnu-emacs@HIDDEN
References: <87r1r5428d.fsf@HIDDEN> <87mu1sry72.fsf@HIDDEN>
 <875z8fc224.fsf@HIDDEN> <20200915175418.GV20869@maokai>
 <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai> <837dq8qdpk.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <837dq8qdpk.fsf@HIDDEN>
X-Originating-IP: 2a00:f10:400:2:446:66ff:fe00:2ce
X-SpamExperts-Domain: out.pcextreme.nl
X-SpamExperts-Username: 2a00:f10:400:2:446:66ff:fe00:2ce
Authentication-Results: route25.eu; auth=pass
 smtp.auth=2a00:f10:400:2:446:66ff:fe00:2ce@HIDDEN
X-SpamExperts-Outgoing-Class: ham
X-SpamExperts-Outgoing-Evidence: Combined (0.15)
X-Recommended-Action: accept
X-Filter-ID: Mvzo4OR0dZXEDF/gcnlw0fJVsTFCFA1YlcTpjJcy6PSpSDasLI4SayDByyq9LIhVUZbR67CQ7/vm
 /hHDJU4RXkTNWdUk1Ol2OGx3IfrIJKywOmJyM1qr8uRnWBrbSAGD0VsY0HzEkBzUTjuObUvkgtQ5
 3pMmTXeVbblO3cSIiVA6EIOyzl67b30anJ1fltctJODXbtOodkPED+RkHjVGH9gpfPe2lDQBFQc5
 pWKjU8U1TnR+f0U9cu064nZcMieLAqdkk6hppCDsqsBwLjHur1XxB26GtR7aQdGQ3RxVouttwXp1
 RdEU8VHZI5KGZSviaHwJ2eESrUp0Iw/gSJ3HqMuR600P9eQ3vodupN36MrkzGQZS068e3EYTgNAB
 jZkD8TzPF4eG61o+cxFZrUIXowfXJosMX5ZQSlYSVlCDu2na8Lc2iK0mXNgodhRh0E6+UMVFei1G
 2PrSIU9EwioS70yFBF2moUWeHNDS4qZDIDBdjx85xQq9VD42UbTRudBo31/E3ahF5MMcDI7KdpjQ
 KULbtCr8aoTjHIUEuG3LCVsCW2UOyugPPaOGK1ZclZhyJ1oAKHx1qHjvOGXm6QB+mk6ZTzCPKsFf
 twxbkg5OTEJBSZDxFdMdjhWKQRs1y634ncQ5WKeQ/7rEsJxU50tHcvbkO2/k3PClL+ADRrPkiQom
 eMjKHBjP6ZaffNwqYvUmL8nkwDR3V5eCWS3kuF8Eiy5vj0UGBndj/UwlV/6+vV94bLBiueHg91Bu
 vRZIPRdQl0I4rlRXPFv7CSYqmR2tS5YJVR60EgsQK4e4QdU0u3iBotFRctWNM2uhdjS2uzKcacI7
 P7qjc8/EwgU8p/GRq2js9yN/qOHGqE5JAJM/lajD24VGIrQmPeYn4G4ieUhaM+ZHOJ4Od3JKamn9
 /TD1X5yuUvaV4bwXiAmP35nCbbvfbrsIY86Dt5ybhCB2OzCv8H1dg/u+LGrQdWzpT1PL3S19dl7e
 TocCLA1rf4z2Env1H/aAwarQpYDOYx/6JtUOY6chk/Ym1VOWJ2Egq1PYUKq7p+Aut70NqBHSYY2j
 WnNlOQUSpl/WbCVnblTlIEy6WbHtJTWsABJGLVa9GkLvBMbxrrIm5OCohHtOR2YQX2ieYvMB8Pl7
 zcMiwDZ5DSJtWGRabluw1cZvDvo1nQSJJA==
X-Report-Abuse-To: spam@HIDDEN
Received-SPF: pass client-ip=2a00:f10:400:4:1c00:18ff:fe00:1617;
 envelope-from=rladams@HIDDEN; helo=se18.route25.eu
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

On Thu, Nov 26, 2020 at 06:34:31PM +0200, Eli Zaretskii wrote:
> > Date: Thu, 26 Nov 2020 16:42:19 +0100
> > From: Russell Adams <RLAdams@HIDDEN>
> >
> > So my emacs grew to 8GB in RAM, and what was curious is if it was a
> > background task (not window focused on an emacsclient), then the
> > memory stayed the same. When I had the window focused, I could watch
> > the memory constantly increasing in htop a few megs at a time.
>
> Was the memory increasing even when you did nothing in the session?
> If so, do you have some background functions running, e.g. timers?  If
> Emacs was not idle, can you describe what you were doing at that time?

At one point I was watching htop and every time I switched to the
Emacs window and returned to htop, I'd see it grow by several more MB
over 3-5 seconds and then stop. So I left Emacs as the focused window
overnight, and it grew from 4GB to 8GB.

In this instance, I had my cursor at the bottom of a saved Org file. I
wasn't even actively typing or interacting with Emacs. I just grew
each time it got window focus.

Yes I have a few timers, but those trip at midnight. I call org-agenda
and org-caldev-sync. I don't have any other timers that I know of.

Mind you I'm running daemon mode and I'm looking at an emacsclient
frame.

Thanks.

------------------------------------------------------------------
Russell Adams                            RLAdams@HIDDEN

PGP Key ID:     0x1160DCB3           http://www.adamsinfoserv.com/

Fingerprint:    1723 D8CA 4280 1EC9 557F  66E8 1154 E018 1160 DCB3




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 26 Nov 2020 16:34:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 11:34:54 2020
Received: from localhost ([127.0.0.1]:42614 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiKEQ-0005mn-2D
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 11:34:54 -0500
Received: from lists.gnu.org ([209.51.188.17]:39470)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiKEO-0005md-7m
 for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 11:34:52 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:48184)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>) id 1kiKEO-0003fC-14
 for bug-gnu-emacs@HIDDEN; Thu, 26 Nov 2020 11:34:52 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46317)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiKEM-0004MC-Ld; Thu, 26 Nov 2020 11:34:50 -0500
Received: from [176.228.60.248] (port=4462 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiKEM-0003N1-4v; Thu, 26 Nov 2020 11:34:50 -0500
Date: Thu, 26 Nov 2020 18:34:31 +0200
Message-Id: <837dq8qdpk.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Russell Adams <RLAdams@HIDDEN>
In-Reply-To: <20201126154219.GA16802@maokai> (message from Russell Adams on
 Thu, 26 Nov 2020 16:42:19 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
References: <87r1r5428d.fsf@HIDDEN> <87mu1sry72.fsf@HIDDEN>
 <875z8fc224.fsf@HIDDEN> <20200915175418.GV20869@maokai>
 <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
 <20201126154219.GA16802@maokai>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
Cc: bug-gnu-emacs@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Thu, 26 Nov 2020 16:42:19 +0100
> From: Russell Adams <RLAdams@HIDDEN>
> 
> So my emacs grew to 8GB in RAM, and what was curious is if it was a
> background task (not window focused on an emacsclient), then the
> memory stayed the same. When I had the window focused, I could watch
> the memory constantly increasing in htop a few megs at a time.

Was the memory increasing even when you did nothing in the session?
If so, do you have some background functions running, e.g. timers?  If
Emacs was not idle, can you describe what you were doing at that time?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 26 Nov 2020 15:44:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 10:44:21 2020
Received: from localhost ([127.0.0.1]:42529 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiJRL-0004UN-Ob
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 10:44:21 -0500
Received: from lists.gnu.org ([209.51.188.17]:33420)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rladams@HIDDEN>) id 1kiJRI-0004UD-Ef
 for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 10:44:11 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:55786)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rladams@HIDDEN>)
 id 1kiJRG-00028X-Pf
 for bug-gnu-emacs@HIDDEN; Thu, 26 Nov 2020 10:44:07 -0500
Received: from se15.route25.eu ([2a00:f10:402:781:1c00:45ff:fe00:24f8]:50160)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rladams@HIDDEN>)
 id 1kiJR9-0008Cl-VG
 for bug-gnu-emacs@HIDDEN; Thu, 26 Nov 2020 10:44:05 -0500
Date: Thu, 26 Nov 2020 16:42:19 +0100
From: Russell Adams <RLAdams@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks
Message-ID: <20201126154219.GA16802@maokai>
Mail-Followup-To: bug-gnu-emacs@HIDDEN
References: <87r1r5428d.fsf@HIDDEN> <87mu1sry72.fsf@HIDDEN>
 <875z8fc224.fsf@HIDDEN> <20200915175418.GV20869@maokai>
 <838sda98jm.fsf@HIDDEN> <20200915211209.GW20869@maokai>
 <83pn6l7ozj.fsf@HIDDEN> <20200917204704.GA20217@maokai>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20200917204704.GA20217@maokai>
X-Originating-IP: 185.87.184.57
X-SpamExperts-Domain: out.pcextreme.nl
X-SpamExperts-Username: 185.87.184.57
Authentication-Results: route25.eu;
 auth=pass smtp.auth=185.87.184.57@HIDDEN
X-SpamExperts-Outgoing-Class: ham
X-SpamExperts-Outgoing-Evidence: SB/global_tokens (0.00791682965805)
X-Recommended-Action: accept
X-Filter-ID: Mvzo4OR0dZXEDF/gcnlw0fJVsTFCFA1YlcTpjJcy6PSpSDasLI4SayDByyq9LIhVtcWfpvqLS60e
 BNTMwtOw90TNWdUk1Ol2OGx3IfrIJKywOmJyM1qr8uRnWBrbSAGD0VsY0HzEkBzUTjuObUvkgtQ5
 3pMmTXeVbblO3cSIiVD+lPsJl3NQibG9+awNzLmjJODXbtOodkPED+RkHjVGH9gpfPe2lDQBFQc5
 pWKjU8U1TnR+f0U9cu064nZcMieLAqdkk6hppCDsqsBwLjHur1XxB26GtR7aQdGQ3RxVousDFpkW
 mgyT/YeLVvI3HPYSaHwJ2eESrUp0Iw/gSJ3HqMuR600P9eQ3vodupN36MrkzGQZS068e3EYTgNAB
 jZkD8TzPF4eG61o+cxFZrUIXowfXJosMX5ZQSlYSVlCDu2na8Lc2iK0mXNgodhRh0E6+UMVFei1G
 2PrSIU9EwioS70yFBF2moUWeHNDS4qZDIDB7XoQijaYHvr9sPSt0aWxBU8NAmhVjxOcflCqTdpCd
 nz3dKxLhoxcmaInYbR5vlqF9UZSlUPITrUlXo0KweE5K01CkZQcRJUiIO9z1A2bbodvpo2UgV9PP
 0GtOSQCD3Wp6EipRzMVZ5LqwTx7Vvn9SWQRihqWRcCaa7yMGNcHiKiC9NjNYY5WoFXFyoMFsG38I
 aa05P3P4eYW86qsHunbFcho0P7VyKpXK1A14c1ki+AeYUOp7A73HI6oJg7w/Vod4U0DAmRXz28Ch
 LUng6DAB7o8DebwK9n0BDYMYTfyprxMqABCuK7DVpOJr7QXPUVFWWG/qurFASmykSe7dic5Ihrj9
 GCF/KjAOTCzc+K6CedMMKG5rbgpB8auCio8qMm9fnNrs9kXoCnLlxvUdano2ZuM7jUXIESohoO51
 xWmU8YFNhmLhRrMmGp/YP6zHURnLwHAPPq8eGMIHhPrdhREhenKEodVwN3ziyd+8A4WM4r9OjVTa
 +ThEGFv9mPwqFSTyI0CgGXyP43F+qNYPSuWcCYZmKidDyMV/PX+3S0zKrHuRYVQUGjtN3c8fawDG
 Z2V64F3WR5dr6gmwksvSMd3pbTr/MieXCrcMYb3lt2VkyA==
X-Report-Abuse-To: spam@HIDDEN
Received-SPF: pass client-ip=2a00:f10:402:781:1c00:45ff:fe00:24f8;
 envelope-from=rladams@HIDDEN; helo=se15.route25.eu
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

On Thu, Sep 17, 2020 at 10:47:04PM +0200, Russell Adams wrote:
> From Emacs memory-usage package:
>
> Garbage collection stats:
> ((conses 16 1912248 251798) (symbols 48 54872 19) (strings 32 327552 81803) (string-bytes 1 12344346) (vectors 16 158994) (vector-slots 8 2973919 339416) (floats 8 992 4604) (intervals 56 182607 7492) (buffers 1000 195))
>
>  =>	29.2MB (+ 3.84MB dead) in conses
> 	2.51MB (+ 0.89kB dead) in symbols
> 	10.00MB (+ 2.50MB dead) in strings
> 	11.8MB in string-bytes
> 	2.43MB in vectors
> 	22.7MB (+ 2.59MB dead) in vector-slots
> 	7.75kB (+ 36.0kB dead) in floats
> 	9.75MB (+  410kB dead) in intervals
> 	 190kB in buffers
>
> Total in lisp objects: 97.9MB (live 88.5MB, dead 9.36MB)

I had the memory leak occur again and this time I had the
glibc-malloc-trace-utils loaded and running from the start.

So my emacs grew to 8GB in RAM, and what was curious is if it was a
background task (not window focused on an emacsclient), then the
memory stayed the same. When I had the window focused, I could watch
the memory constantly increasing in htop a few megs at a time.

Garbage collection stats:
((conses 16 1749077 1176908)
 (symbols 48 47530 38)
 (strings 32 307123 144020)
 (string-bytes 1 10062511)
 (vectors 16 113172)
 (vector-slots 8 2105205 486800)
 (floats 8 709 1719)
 (intervals 56 174593 44804)
 (buffers 1000 71))

 =>	26.7MB (+ 18.0MB dead) in conses
	2.18MB (+ 1.78kB dead) in symbols
	9.37MB (+ 4.40MB dead) in strings
	9.60MB in string-bytes
	1.73MB in vectors
	16.1MB (+ 3.71MB dead) in vector-slots
	5.54kB (+ 13.4kB dead) in floats
	9.32MB (+ 2.39MB dead) in intervals
	69.3kB in buffers

Total in lisp objects:  103MB (live 75.0MB, dead 28.5MB)

Buffer ralloc memory usage:
47 buffers
3.36MB total ( 232kB in gaps)
      Size	Gap	Name

    926626	1504	AIS.org
    690050	1933	Personal.org
    553850	2000	Abuffer.org
    490398	3851	*Packages*
    215653	2000	KB.org
     76686	1708	X230.org
     59841	2123	Agenda.org
     51375	51076	*sly-events for sbcl*
     51060	1902	ASC.org
     44596	2000	Contacts.org
     36825	1792	*Messages*
     23882	2309	*org-caldav-debug*
     22867	2000	rgb.lisp
     14678	746	*sly-mrepl for sbcl*
      6640	1173	VirtualFCMap.lisp
      4096	2000	 *code-converting-work*
      3409	16717	 *http orgmode.org:443*
      1946	104	*Org Agenda*
      1528	2028	 *http gaming.demosthenes.org*-491231
      1524	2028	 *http gaming.demosthenes.org*-15349
      1518	2028	 *http gaming.demosthenes.org*
      1276	1368	*sly-inferior-lisp for sbcl*
      1231	2026	 *http gaming.demosthenes.org*-464306
      1208	825	*Help*
       679	1574	*Buffer Details*
       641	1975	 *Agenda Commands*
       531	1494	*Calendar*
       324	2008	 *http melpa.org:443*
       278	3775	*helm M-x*
       185	1838	*org caldav sync result*
       144	2000	*scratch*
        57	21434	*helm find files*
        44	5610	 *icalendar-work*
        30	2000	 *sly-fontify*
        21	2000	*log-edit-files*
        20	0	 *pdf-info-query--escape*
        18	4077	*helm mini*
        12	8630	 *code-conversion-work*
         5	4065	 *Echo Area 1*
         0	2033	 *Minibuf-1*
         0	20	 *Minibuf-0*
         0	20	 *server*
         0	4060	 *Echo Area 0*
         0	61547	 *sly-1*
         0	20	 *sly-dds-1-1*
         0	20	*changes to ~/ASC/Software/Snaps/*
         0	20	*vc*

I started emacs with:

MTRACE_CTL_FILE=mtraceEMACS.mtr LD_PRELOAD=~/software/glibc-malloc-trace-utils/libmtrace.so ~/.local/bin/emacs --daemon >> ~/.config/emacs/emacs.log 2>&1

This created some huge files. By the time I reached 8GB in RAM, the
mtr file for the main process (I think) was 53 GB. I also have little mtrace
files littered everywhere in different project directories.

-rw-r--r--   1 adamsrl adamsrl  53G Nov 26 13:23 mtraceEMACS.mtr.15236
-rw-r--r--   1 adamsrl adamsrl 4.2G Nov 26 13:36 my.wl
-rw-r--r--   1 adamsrl adamsrl 1.3G Nov 26 13:50 mtraceEMACS.mtr.15236.allocs
-rw-r--r--   1 adamsrl adamsrl  32K Nov 26 13:55 mtraceEMACS.mtr.15236.binnedallocs.log
-rw-r--r--   1 adamsrl adamsrl 6.0G Nov 26 15:12 vmrssout
-rw-r--r--   1 adamsrl adamsrl 6.0G Nov 26 15:12 vmout
-rw-r--r--   1 adamsrl adamsrl 8.6G Nov 26 15:12 idealrssout

I converted the mtraceEMACS.mtr.15236 to my.wl using trace2wl.

The trace_run command did this output:

% ~/software/glibc-malloc-trace-utils/trace_run ./my.wl vmout vmrssout idealrssout
11,757,635,230,744 cycles
4,532,472,554 usec wall time
5,966,752,470 usec across 3 threads
8,461,721,600 bytes Max RSS (218,308,608 -> 8,680,030,208)
Starting VmRSS 218308608 (bytes)
Starting VmSize 219549696 (bytes)
Starting MaxRSS 218308608 (bytes)
Ending VmRSS 8680030208 (bytes)
Ending VmSize 8903626752 (bytes)
Ending MaxRSS 8680030208 (bytes)
8,131,008 Kb Max Ideal RSS

sizeof ticks_t is 8
Avg malloc time:    145 in 422,186,832 calls
Avg calloc time: 12,538 in  1,164,584 calls
Avg realloc time:   566 in  3,294,165 calls
Avg free time:      110 in 449,397,629 calls
Total call time: 127,318,389,383 cycles

These files are impossible to share around, is there anything I can
run to extract anything else useful from them?

% ~/software/glibc-malloc-trace-utils/trace_statistics mtraceEMACS.mtr.15236
Min allocation size: 0
Max allocation size: 1603869
Mean allocation size: 128

I did follow the instructions for downsampling, but I haven't a clue
what to do in Octave. Is it worth posting those files?

I have the impression this is more about how often more RAM was
requested, and not the source of the call?

I should mention I'm present in #emacs and happy to discuss there.

------------------------------------------------------------------
Russell Adams                            RLAdams@HIDDEN

PGP Key ID:     0x1160DCB3           http://www.adamsinfoserv.com/

Fingerprint:    1723 D8CA 4280 1EC9 557F  66E8 1154 E018 1160 DCB3




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 15:32:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 10:32:09 2020
Received: from localhost ([127.0.0.1]:42510 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiJFh-0003lP-KK
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 10:32:09 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33618)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiJFe-0003eR-JG
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 10:32:08 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44659)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiJFY-0004PD-Db; Thu, 26 Nov 2020 10:32:00 -0500
Received: from [176.228.60.248] (port=4524 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiJFX-0007DO-20; Thu, 26 Nov 2020 10:31:59 -0500
Date: Thu, 26 Nov 2020 17:31:37 +0200
Message-Id: <83a6v4qgme.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <877dq8taau.fsf@HIDDEN> (message from Trevor
 Bentley on Thu, 26 Nov 2020 16:19:53 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <87a6v4thst.fsf@HIDDEN> <83eekgqjgp.fsf@HIDDEN>
 <877dq8taau.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: carlos@HIDDEN, bugs@HIDDEN, fweimer@HIDDEN,
>  43389 <at> debbugs.gnu.org, dj@HIDDEN, michael_heerdegen@HIDDEN
> Cc: 
> Date: Thu, 26 Nov 2020 16:19:53 +0100
> 
> I've just hooked make-process and make-thread, and see both being 
> called back-to-back very often for spawning curl subprocesses.

What Lisp commands cause make-thread to be called?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 15:20:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 10:20:03 2020
Received: from localhost ([127.0.0.1]:42481 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiJ3z-0001ls-3h
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 10:20:03 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:36253)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kiJ3w-0001lJ-Dk
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 10:20:01 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 5BB8B6022A;
 Thu, 26 Nov 2020 16:19:54 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606403994;
 bh=8ULAdeamrKicVJGyra7OtJ6pqQRISSKWomIGeu1DZ3M=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=i5gLLlULhjstMLZ2o4su9x2q95mD7zbwTU+bt84PngEGgjRakmH2zgaABCJQIuh4Z
 8PvNmK3bUeUoWYbaiS7dx2dYau15RJPLeqp6+fnQhmubx+XWweBks89MnQlJn0VggE
 mp498PUI/MVMt33iTIWFkdfyWGksFcSPGX6YbXGo=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83eekgqjgp.fsf@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <87a6v4thst.fsf@HIDDEN> <83eekgqjgp.fsf@HIDDEN>
Date: Thu, 26 Nov 2020 16:19:53 +0100
Message-ID: <877dq8taau.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> If it's one trace per thread, though, then we at least know 
>> that  my emacs process in question is blazing through threads. 
> 
> I don't see how this could be true, unless some library you use 
> (ImageMagick?) starts a lot of threads.  Emacs itself is 
> single-threaded, and the only other threads are those from GTK, 
> which should be very few (like, 4 or 5).  This assumes you 
> didn't use Lisp threads, of course. 

Oh, it may be subprocesses instead of threads.  emacs-slack is 
doing all sorts of things, involving both ImageMagick and 
launching curl subprocesses.  Is there a way to prevent libmtrace 
from following children?

I've just hooked make-process and make-thread, and see both being 
called back-to-back very often for spawning curl subprocesses.
 
>> This printed a start and stop message each time I evaluated 
>> garbage-collect manually.  It did not print any messages in 11 
>> hours of running unattended. 
> 
> That's expected, because the automatic GC doesn't call 
> garbage-collect.  garbage-collect is just a thin wrapper around 
> a C function, called garbage_collect, and the automatic GC calls 
> that function directly from C.  And you cannot advise C 
> functions not exposed to Lisp. 
> 
> If you want to have record of the times it took each GC to run, 
> you will have to modify the C sources. 

Gotcha.  No surprise, then.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 14:30:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 09:30:52 2020
Received: from localhost ([127.0.0.1]:40419 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiIIN-0008SC-Ed
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 09:30:52 -0500
Received: from eggs.gnu.org ([209.51.188.92]:43562)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiIIC-0008RV-Rf
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 09:30:41 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43182)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiII6-0000GH-Uj; Thu, 26 Nov 2020 09:30:34 -0500
Received: from [176.228.60.248] (port=4181 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiII6-0001U6-AH; Thu, 26 Nov 2020 09:30:34 -0500
Date: Thu, 26 Nov 2020 16:30:14 +0200
Message-Id: <83eekgqjgp.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87a6v4thst.fsf@HIDDEN> (message from Trevor
 Bentley on Thu, 26 Nov 2020 13:37:54 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <87a6v4thst.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: bugs@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  dj@HIDDEN, michael_heerdegen@HIDDEN
> Cc: 
> Date: Thu, 26 Nov 2020 13:37:54 +0100
> 
> If it's one trace per thread, though, then we at least know that 
> my emacs process in question is blazing through threads.

I don't see how this could be true, unless some library you use
(ImageMagick?) starts a lot of threads.  Emacs itself is
single-threaded, and the only other threads are those from GTK, which
should be very few (like, 4 or 5).  This assumes you didn't use Lisp
threads, of course.

> Other thing to note (for Eli): I wrapped garbage-collect like so:
> 
> ---
> (defun trev/garbage-collect (orig-fun &rest args) 
>   (message "%s -- Starting garbage-collect." 
>   (current-time-string)) (let ((time (current-time)) 
>         (result (apply orig-fun args))) 
>     (message "%s -- Finished garbage-collect in %.06f" 
>     (current-time-string) (float-time (time-since time))) result)) 
> (add-function :around (symbol-function 'garbage-collect) 
> #'trev/garbage-collect)
> ---
> 
> This printed a start and stop message each time I evaluated 
> garbage-collect manually.  It did not print any messages in 11 
> hours of running unattended.

That's expected, because the automatic GC doesn't call
garbage-collect.  garbage-collect is just a thin wrapper around a C
function, called garbage_collect, and the automatic GC calls that
function directly from C.  And you cannot advise C functions not
exposed to Lisp.

If you want to have record of the times it took each GC to run, you
will have to modify the C sources.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 14:14:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 09:14:26 2020
Received: from localhost ([127.0.0.1]:40386 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiI2U-0005wc-AW
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 09:14:26 -0500
Received: from eggs.gnu.org ([209.51.188.92]:38738)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiI2S-0005wQ-HH
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 09:14:24 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42755)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiI2M-00031Q-ML; Thu, 26 Nov 2020 09:14:18 -0500
Received: from [176.228.60.248] (port=3185 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiI2M-0007Em-1p; Thu, 26 Nov 2020 09:14:18 -0500
Date: Thu, 26 Nov 2020 16:13:58 +0200
Message-Id: <83lfeoqk7t.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
In-Reply-To: <X79wzM1DT3ZZQfp7@HIDDEN> (message from Jean Louis
 on Thu, 26 Nov 2020 12:09:32 +0300)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <83blfls494.fsf@HIDDEN> <X79wzM1DT3ZZQfp7@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Thu, 26 Nov 2020 12:09:32 +0300
> From: Jean Louis <bugs@HIDDEN>
> Cc: Carlos O'Donell <carlos@HIDDEN>, trevor@HIDDEN,
>   fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
>   michael_heerdegen@HIDDEN
> 
> ((uptime "2 days, 18 hours, 35 minutes, 19 seconds") (pid 13339) (garbage ((conses 16 4511014 617524) (symbols 48 86926 23) (strings 32 576134 114546) (string-bytes 1 25198549) (vectors 16 245670) (vector-slots 8 4636183 1560354) (floats 8 1859 18842) (intervals 56 655325 24178) (buffers 992 900))) (buffers-size 200898858) (vsize (vsize 5144252)))
> 
> But what happened after 36 minutes of waiting is that Emacs became
> responsive. So I am still running this session and I hope to get
> mtrace after the session has finished.
> 
> Before I was not patient longer than maybe 3-5 minutes and I have
> aborted Emacs. But now I can see it stabilized after hard work with
> memory or whatever it was doing. Swap is 1809 MB and vsize just same
> as above.

It's still 5GB, which is a fairly large footprint, certainly for a
2-day session.

> Observation on "what I was doing when vsize started growing" is
> simple, I was just editing email, nothing drastic. I did not do
> anything special.

Can you describe in more detail how you edit email?  Which email
package(s) do you do, and what would composing email generally
involve?

Also, are there any background activities that routinely run in your
Emacs sessions?

> If you say I should finish session now and send the mtrace, I can do
> it.

That's for Carlos to say.

Thanks for the info.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 13:58:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 08:58:35 2020
Received: from localhost ([127.0.0.1]:40330 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiHn9-0005Ut-LK
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 08:58:35 -0500
Received: from eggs.gnu.org ([209.51.188.92]:34686)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kiHn4-0005Uc-Ug
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 08:58:34 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42342)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kiHmz-0006K3-6d; Thu, 26 Nov 2020 08:58:25 -0500
Received: from [176.228.60.248] (port=2210 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kiHmx-0004gw-RQ; Thu, 26 Nov 2020 08:58:24 -0500
Date: Thu, 26 Nov 2020 15:58:04 +0200
Message-Id: <83pn40qkyb.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>
In-Reply-To: <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN> (message from
 Carlos O'Donell on Wed, 25 Nov 2020 15:51:16 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
 <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: Eli Zaretskii <eliz@HIDDEN>, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  dj@HIDDEN, michael_heerdegen@HIDDEN
> From: Carlos O'Donell <carlos@HIDDEN>
> Date: Wed, 25 Nov 2020 15:51:16 -0500
> 
> >  The raw massif output:
> >  http://trevorbentley.com/massif.out.3364630
> >  The *full* tree output:
> >  http://trevorbentley.com/ms_print.3364630.txt
> >  The tree output showing only entries above 10% usage:
> >  http://trevorbentley.com/ms_print.thresh10.3364630.txt
> 
> This data is pretty clear:
> 
>  1.40GiB - lisp_align_malloc (alloc.c:1195)
>  1.40GiB - lmalloc (alloc.c:1359)
>  0.65GiB - lrealloc (alloc.c:1374)
>  0.24GiB - AcquireAlignedMemory (/usr/lib/libMagickCore-7.Q16HDRI.so.7.0.0)
> --------
>  3.60Gib - In use as of the snapshot.
> 
> That's a fairly high fraction of the ~4.2GiB that is eventually in use.
> 
> With lisp_align_malloc, lmalloc, and lrealloc shooting up exponentially at the end of the run look like they are making lists and processing numbers and other objects.
> 
> This is a direct expression of something increasing demand for memory.

So, at least in Trevor's case, it sounds like we sometimes request a
lot of memory during short periods of time.  But what kind of memory
is that?

lmalloc is called by xmalloc, xrealloc, xzalloc, and xpalloc --
functions Emacs calls to get memory unrelated to Lisp data.  But it is
also called by lisp_malloc, which is used to allocate memory for some
Lisp objects.  lisp_align_malloc, OTOH, is used exclusively for
allocating Lisp data (conses, strings, etc.).

It is somewhat strange that lisp_align_malloc and lmalloc were called
to allocate similar amounts of memory: these two functions are
orthogonal, AFAICS, used for disparate groups of Lisp object types,
and it sounds strange that we somehow allocate very similar amounts of
memory for those data types.

Another observation is that since GC succeeds to release a large
portion of this memory, it would probably mean some significant
proportion of the calls are for Lisp data, maybe strings (because GC
compacts strings, which can allow Emacs to release more memory to
glibc's heap allocation machinery).

Apart of that, I think we really need to see the most significant
customers of these functions when the memory footprint starts growing
fast.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 12:38:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 07:38:05 2020
Received: from localhost ([127.0.0.1]:40004 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiGXF-0001KI-Ae
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 07:38:05 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:35451)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1kiGXA-0001JY-VK
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 07:38:02 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id C2A0A60DA4;
 Thu, 26 Nov 2020 13:37:54 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606394274;
 bh=mGf1Bzdq1CN9mGCzRuOrbQ+0XC/sZ9PQj+DMkY22BZg=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=At74EIb0sWDhlaSoKr+5haezWAQm/NTY/X6vJhlwkgK80gfnVF9f2cJDMT+F61IMV
 BTbHpcZ/v9FI/0MMCGfNb3wE/mCRzII5LgHhSTgxiuzlm+y6bYQ1TDwuqUYGQTJ9X+
 guvpgM6jVPBrHBAi95KRoWtVdzjLR4FooY86F8XM=
From: Trevor Bentley <trevor@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
Date: Thu, 26 Nov 2020 13:37:54 +0100
Message-ID: <87a6v4thst.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> You want visibility into what is USING that memory. 
> 
> With glibc-malloc-trace-utils you can try to do that with: 
> 
> LD_PRELOAD=libmtrace.so \ MTRACE_CTL_FILE=/home/user/app.mtr \ 
> MTRACE_CTL_BACKTRACE=1 \ ./app 
> 
> This will use libgcc's unwinder to get a copy of the malloc 
> caller address and then we'll have to decode that based on a 
> /proc/self/maps. 
> 
> Next steps: - Get a glibc-malloc-trace-utils trace of the 
> application ratcheting.  - Get a copy of /proc/$PID/maps for the 
> application (shorter version of smaps). 
> 

Oh, this is going to be a problem.  I guess it is producing one 
trace file per thread?

I ran it with libmtrace overnight.  Memory usage was very high, 
but it doesn't look like the same problem.  I hit 1550MB of RSS, 
but smaps reported only ~350MB of that was in the heap, which 
seemed reasonable for the ~150MB that emacs reported it was using. 
Does libmtrace add a lot of memory overhead?

However, libmtrace has made 4968 files totalling 26GB in that 
time.  Ouch.

It's going to be hard to tell when I hit the bug under libmtrace, 
questionable whether the report will even fit on my disk, and 
tricky to share however many tens of gigabytes of trace files it 
results in.

If it's one trace per thread, though, then we at least know that 
my emacs process in question is blazing through threads.  That 
could be relevant.

Other thing to note (for Eli): I wrapped garbage-collect like so:

---
(defun trev/garbage-collect (orig-fun &rest args) 
  (message "%s -- Starting garbage-collect." 
  (current-time-string)) (let ((time (current-time)) 
        (result (apply orig-fun args))) 
    (message "%s -- Finished garbage-collect in %.06f" 
    (current-time-string) (float-time (time-since time))) result)) 
(add-function :around (symbol-function 'garbage-collect) 
#'trev/garbage-collect)
---

This printed a start and stop message each time I evaluated 
garbage-collect manually.  It did not print any messages in 11 
hours of running unattended.  This is with an active network 
connection receiving messages fairly frequently, so there was 
plenty of consing going on.  Hard for me to judge if it should run 
any garbage collection in that time, but I would have expected so.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 26 Nov 2020 09:09:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 26 04:09:47 2020
Received: from localhost ([127.0.0.1]:38357 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kiDHf-0005mX-EG
	for submit <at> debbugs.gnu.org; Thu, 26 Nov 2020 04:09:47 -0500
Received: from static.rcdrun.com ([95.85.24.50]:48291)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1kiDHd-0005mI-Pu
 for 43389 <at> debbugs.gnu.org; Thu, 26 Nov 2020 04:09:46 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C0007.000000005FBF70D2.00002B76; Thu, 26 Nov 2020 09:09:38 +0000
Date: Thu, 26 Nov 2020 12:09:32 +0300
From: Jean Louis <bugs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X79wzM1DT3ZZQfp7@HIDDEN>
References: <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <83blfls494.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <83blfls494.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 Carlos O'Donell <carlos@HIDDEN>, trevor@HIDDEN,
 michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello Eli,

Here is short report on the behavior:

Emacs uptime: 2 days, 19 hours, 46 minutes, 49 seconds

I think it was 11:12 o'clock my time zone. I was not doing nothing
special just writing emails and invoking emacsclient. All the time
before the swap shown by symon-mode was just about 200 MB suddenly it
grew to large number maybe few gigabytes, hard disk started working
heavily. It became all very slow but I could write letters.

I have tried to invoke M-x good-bye around 11:12, that is where it
became all very slow and started working with hard disk. Almost
everything blocked on screen. Emacs was kind of empty, no menus,
nothing, just blank black background, no mode line. So I moved it to
other workspace and continued working with zile.

About 36 minutes later it finally wrote this information into file:

((uptime "2 days, 18 hours, 32 minutes, 32 seconds") (pid 13339) (garbage ((conses 16 4438358 789442) (symbols 48 86924 25) (strings 32 571988 149785) (string-bytes 1 25104928) (vectors 16 245282) (vector-slots 8 4652918 1622184) (floats 8 1860 19097) (intervals 56 645336 37479) (buffers 992 900))) (buffers-size 200839861) (vsize (vsize 5144252)))

There after few minutes I have invoked the good-bye again:

((uptime "2 days, 18 hours, 35 minutes, 19 seconds") (pid 13339) (garbage ((conses 16 4511014 617524) (symbols 48 86926 23) (strings 32 576134 114546) (string-bytes 1 25198549) (vectors 16 245670) (vector-slots 8 4636183 1560354) (floats 8 1859 18842) (intervals 56 655325 24178) (buffers 992 900))) (buffers-size 200898858) (vsize (vsize 5144252)))

But what happened after 36 minutes of waiting is that Emacs became
responsive. So I am still running this session and I hope to get
mtrace after the session has finished.

Before I was not patient longer than maybe 3-5 minutes and I have
aborted Emacs. But now I can see it stabilized after hard work with
memory or whatever it was doing. Swap is 1809 MB and vsize just same
as above.

Observation on "what I was doing when vsize started growing" is
simple, I was just editing email, nothing drastic. I did not do
anything special.

If you say I should finish session now and send the mtrace, I can do
it.

Jean


(defun good-bye ()
  (interactive)
  (let* ((garbage (garbage-collect))
	 (size 0)
	 (buffers-size (dolist (buffer (buffer-list) size)
			(setq size (+ size (buffer-size buffer)))))
	 (uptime (emacs-uptime))
	 (pid (emacs-pid))
	 (vsize (vsize-value))
	 (file (format "~/tmp/emacs-session-%s.el" pid))
	 (list (list (list 'uptime uptime) (list 'pid pid)
		     (list 'garbage garbage) (list 'buffers-size buffers-size)
		     (list 'vsize vsize))))
    (with-temp-file file
      (insert (prin1-to-string list)))
    (message file)))






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 20:51:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 15:51:24 2020
Received: from localhost ([127.0.0.1]:37265 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki1l6-0000Zs-JM
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 15:51:24 -0500
Received: from us-smtp-delivery-124.mimecast.com ([216.205.24.124]:52388)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1ki1l5-0000Zl-Aa
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 15:51:24 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606337482;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=4QwnxLlSfIwFH/l0+zsGIgeRlr33GEAyRbItBNYRkWo=;
 b=ixH1VfQrlqa9VUTwlyzKyj6zYR6Uu8XsbzJuETFEWuaUG4zTq6uy7ovSYaqmQF65R2hN/K
 +ZXvMvf552R33Sj278EgcEK7xVC+KqSWfo3d2SgTv2T4n+gW7pM8HX34KLekFA5VNpyuac
 cCwEMwf21hThn1RTPXVKWUfJsJgvueQ=
Received: from mail-qv1-f71.google.com (mail-qv1-f71.google.com
 [209.85.219.71]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-155-GMtKIcxdO-ObMNO5H6p2oQ-1; Wed, 25 Nov 2020 15:51:19 -0500
X-MC-Unique: GMtKIcxdO-ObMNO5H6p2oQ-1
Received: by mail-qv1-f71.google.com with SMTP id t14so3259786qvc.13
 for <43389 <at> debbugs.gnu.org>; Wed, 25 Nov 2020 12:51:19 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=4QwnxLlSfIwFH/l0+zsGIgeRlr33GEAyRbItBNYRkWo=;
 b=uEKbgZruxR7iFTmOMcWTIHlTql7mKhpxgz3AC/nMMhqZihBgnrBcOCbNP1vIg1I7N4
 8nCgNOw/RuuKwMy2Dp8pVHyFhk1GvEZlU2IZUHLrIKcL5/ytSOAt9vVS+uOjHlroQKwP
 TpZpEju9jiB5XpVMS50WZF6xzQ3Er1p2PpB4suI/alU6uvQAclhXTpFXXTWKEee4tOyP
 en3l2i3bZfpse6ZfmDt3KwkITwWb/+c+eLiLg+21JaDFmUJ/FMjc3GvrvB41VbJbK8YT
 z2GDQgrjsJPNqgs6Fl6uPemNDxWyKdKGAbAZ3U08/97iDfcXLFcMGWthZmsR2+VkzMTv
 uWcw==
X-Gm-Message-State: AOAM532NWJ3xSY/OqbH0b62DnQ1GaR2FTqxhHA0sbblX6Bo4kJvzlRS6
 8GRYFymzXA19g8ORdx0R3dkjgWlCtbOvNkHSZRSWdy6ZNTv10NvoapNJtoxx6Ce2fOgzBYdp1/N
 CWaGrUdpV+HJH1jM=
X-Received: by 2002:aed:2662:: with SMTP id z89mr803960qtc.70.1606337478785;
 Wed, 25 Nov 2020 12:51:18 -0800 (PST)
X-Google-Smtp-Source: ABdhPJzNy5YezZPu7g6R0+rhDNQ095uNuo54OTel8zWQCgrrUaZMqg8KnzCKdBdusTXtfHmFbyNCEg==
X-Received: by 2002:aed:2662:: with SMTP id z89mr803935qtc.70.1606337478586;
 Wed, 25 Nov 2020 12:51:18 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id j19sm409010qkk.119.2020.11.25.12.51.17
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Wed, 25 Nov 2020 12:51:17 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Trevor Bentley <trevor@HIDDEN>, Jean Louis <bugs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
 <87im9ttfeg.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <399d4681-940a-c782-b91e-750e62840cb6@HIDDEN>
Date: Wed, 25 Nov 2020 15:51:16 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <87im9ttfeg.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 michael_heerdegen@HIDDEN, dj@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/25/20 2:17 PM, Trevor Bentley wrote:
> Carlos O'Donell <carlos@HIDDEN> writes:
> 
>> On 11/25/20 1:51 PM, Trevor Bentley wrote:
>>> I also still hit it while running under Valgrind; the whole emacs session was slow as hell, but still managed to blow out its heap in a few days.  Of course, libmtrace could be different, but at least it doesn't seem to be a heisenbug. 
>>
>> Do you have a valgrind report to share? 
> 
> Yes, they were earlier in this bug report, perhaps before you joined.  It was the 'massif' heap tracing tool from the valgrind suite, not the regular valgrind leak detector.
> 
> Here are the links again:
> 
>  The raw massif output:
>  http://trevorbentley.com/massif.out.3364630
>  The *full* tree output:
>  http://trevorbentley.com/ms_print.3364630.txt
>  The tree output showing only entries above 10% usage:
>  http://trevorbentley.com/ms_print.thresh10.3364630.txt

This data is pretty clear:

 1.40GiB - lisp_align_malloc (alloc.c:1195)
 1.40GiB - lmalloc (alloc.c:1359)
 0.65GiB - lrealloc (alloc.c:1374)
 0.24GiB - AcquireAlignedMemory (/usr/lib/libMagickCore-7.Q16HDRI.so.7.0.0)
--------
 3.60Gib - In use as of the snapshot.

That's a fairly high fraction of the ~4.2GiB that is eventually in use.

With lisp_align_malloc, lmalloc, and lrealloc shooting up exponentially at the end of the run look like they are making lists and processing numbers and other objects.

This is a direct expression of something increasing demand for memory.
	
-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 20:43:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 15:43:15 2020
Received: from localhost ([127.0.0.1]:37261 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki1dC-0000OI-OF
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 15:43:14 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:58593)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1ki1dB-0000O5-9H
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 15:43:13 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 05EAB60131;
 Wed, 25 Nov 2020 21:43:06 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606336987;
 bh=2h0giJNmm7pkNNl5LoL9H2x1AVhyHfxYVAdlOoJ3oJg=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=bhoQqWNaMuCw0dL0fhmBsmWOTWdZ9al2drM2nlrQ6TYzxmfmesEmrnKFQI47rZUvh
 iYI0JXO8gBbcJH3nXx5Xu3YgfQGTvxfDUzJ1i7g4FU8HMyf1qH+huE4ZA9tAhFfwH2
 tpYADvNahfj7IK4ouDWavb45oykx1CHlyFoD6OvM=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83y2ipqk68.fsf@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN> <83d002tuoo.fsf@HIDDEN>
 <87d001u46f.fsf@HIDDEN> <83d001s50b.fsf@HIDDEN>
 <87lfeptfwy.fsf@HIDDEN> <83360xs0md.fsf@HIDDEN>
 <87ft4xtef5.fsf@HIDDEN> <83y2ipqk68.fsf@HIDDEN>
Date: Wed, 25 Nov 2020 21:43:06 +0100
Message-ID: <87d001tbfp.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Oh!  Well, yes, it is there then.  I didn't realize you can 
>> echo  without going to *Messages*.  It's extremely 
>> fleeting... is there  some way to persist these messages? 
> 
> But if GC is taking minutes, you should be seeing the first of 
> these 2 messages sitting in the echo area for the full duration 
> of those minutes.  So how can they be so ephemeral in your case? 

Yes, for the long ones I expect to see the message hang in the 
echo area.  I was just hoping to also see when it is GC'ing in 
general (if it is GCi'ng in general, since it's behaving so 
weirdly).  A timestamped log of every time garbage-collect runs 
would be great.  Maybe I can do that with "(add-function :around 
...)".

The long garbage-collect doesn't happen until I'm in exploding 
memory mode.  I recently restarted emacs, so right now a GC is 
instantaneous.  I'll let you know how it goes next time the memory 
runs away.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 20:02:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 15:02:47 2020
Received: from localhost ([127.0.0.1]:37155 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki102-0007pJ-SQ
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 15:02:47 -0500
Received: from eggs.gnu.org ([209.51.188.92]:41526)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ki100-0007p6-UG
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 15:02:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51752)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1ki0zu-0008LN-Jl; Wed, 25 Nov 2020 15:02:38 -0500
Received: from [176.228.60.248] (port=4066 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ki0zt-0006U6-8q; Wed, 25 Nov 2020 15:02:38 -0500
Date: Wed, 25 Nov 2020 22:02:39 +0200
Message-Id: <83y2ipqk68.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87ft4xtef5.fsf@HIDDEN> (message from Trevor
 Bentley on Wed, 25 Nov 2020 20:38:38 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN> <83d002tuoo.fsf@HIDDEN>
 <87d001u46f.fsf@HIDDEN> <83d001s50b.fsf@HIDDEN>
 <87lfeptfwy.fsf@HIDDEN> <83360xs0md.fsf@HIDDEN>
 <87ft4xtef5.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: bugs@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  dj@HIDDEN, michael_heerdegen@HIDDEN, carlos@HIDDEN
> Cc: 
> Date: Wed, 25 Nov 2020 20:38:38 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> >> you are suggesting that it should print something to 
> >> *Messages*, right? 
> > 
> > No, in the echo area.  these messages don't go to *Messages*. 
> 
> Oh!  Well, yes, it is there then.  I didn't realize you can echo 
> without going to *Messages*.  It's extremely fleeting... is there 
> some way to persist these messages?

But if GC is taking minutes, you should be seeing the first of these 2
messages sitting in the echo area for the full duration of those
minutes.  So how can they be so ephemeral in your case?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 19:38:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 14:38:46 2020
Received: from localhost ([127.0.0.1]:37110 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki0co-0007Ee-HQ
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:38:46 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:58267)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1ki0cn-0007ER-GW
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:38:45 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 4738E67483;
 Wed, 25 Nov 2020 20:38:39 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606333119;
 bh=wmsnf89mG5FohSQ7FG9hWAGu+Rgj3m3XfsieJ37RDwM=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=A1F8O+mazP9eALuHf5n0AVg51+yaPR8I/F2lHRNRf+0aUq6uckxDcCLdV92yaaKSX
 FlJZsqybE+7lyPle2QfAr1T+tfR3R/STKnOAr/v8G4u2ztNuXTsMJnTzm1bXwjQA/Z
 7V54kSIF9pMPX+dVD+vri96/sEjodBTwttjT0gc4=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83360xs0md.fsf@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN> <83d002tuoo.fsf@HIDDEN>
 <87d001u46f.fsf@HIDDEN> <83d001s50b.fsf@HIDDEN>
 <87lfeptfwy.fsf@HIDDEN> <83360xs0md.fsf@HIDDEN>
Date: Wed, 25 Nov 2020 20:38:38 +0100
Message-ID: <87ft4xtef5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> you are suggesting that it should print something to 
>> *Messages*, right? 
> 
> No, in the echo area.  these messages don't go to *Messages*. 

Oh!  Well, yes, it is there then.  I didn't realize you can echo 
without going to *Messages*.  It's extremely fleeting... is there 
some way to persist these messages?
 
>> I've never tried emacs's profiler.  I'll try that next time I 
>> do a  big garbage-collect and see what it shows. 
> 
> That won't help in this case: GC is in C, and the profiler 
> doesn't profile C code that is not exposed to Lisp. 

Ah, ok.  Well, I'll try it anyway, and expect nothing.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 19:22:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 14:22:11 2020
Received: from localhost ([127.0.0.1]:37084 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki0Mk-0006q8-TS
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:22:11 -0500
Received: from eggs.gnu.org ([209.51.188.92]:59178)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ki0Mj-0006pv-EJ
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:22:09 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51086)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1ki0Md-00025l-BJ; Wed, 25 Nov 2020 14:22:03 -0500
Received: from [176.228.60.248] (port=1597 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ki0Mc-0001IQ-J2; Wed, 25 Nov 2020 14:22:03 -0500
Date: Wed, 25 Nov 2020 21:22:02 +0200
Message-Id: <83360xs0md.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87lfeptfwy.fsf@HIDDEN> (message from Trevor
 Bentley on Wed, 25 Nov 2020 20:06:21 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN> <83d002tuoo.fsf@HIDDEN>
 <87d001u46f.fsf@HIDDEN> <83d001s50b.fsf@HIDDEN>
 <87lfeptfwy.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: bugs@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  dj@HIDDEN, michael_heerdegen@HIDDEN, carlos@HIDDEN
> Cc: 
> Date: Wed, 25 Nov 2020 20:06:21 +0100
> 
> > "Freed" in what sense? returned to glibc? 
> 
> I was referring to glibc malloc/free, but emacs internal 
> allocations would also be interesting.  It's a moot point, as I 
> don't think emacs supports it.  In short, the question is "what 
> has garbage-collect done?"  It prints the state of memory after it 
> is finished, but I have no idea if it has actually "collected" 
> anything.

GC always frees something, don't worry about that.  Your chances of
finding Emacs in a state that it has no garbage to free are nil.

> I just set garbage-collection-messages to non-nil and evaluated 
> (garbage-collect), and nothing was printed...

??? really?  That can only happen if memory-full is non-nil.  Is it?

> you are suggesting that it should print something to *Messages*,
> right?

No, in the echo area.  these messages don't go to *Messages*.

> I've never tried emacs's profiler.  I'll try that next time I do a 
> big garbage-collect and see what it shows.

That won't help in this case: GC is in C, and the profiler doesn't
profile C code that is not exposed to Lisp.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 19:17:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 14:17:35 2020
Received: from localhost ([127.0.0.1]:37080 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki0IJ-0006j2-CB
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:17:35 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:58143)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1ki0II-0006io-0Z
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:17:34 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id DFD5D602C7;
 Wed, 25 Nov 2020 20:17:27 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606331848;
 bh=KFVaCCe8ZSOdLyRMS3xlkO4SPSD1PF+tJXz9afOb/lU=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=WfwxqIOI59RDn30Ia9pXkp+11H14/jW+UFhk6pO1/5mxXYLjWzC4HXyrpoF18LZYV
 O/2Ia6Y9aCoa+c2xjg9UQmQqSTcLmS4n9NPA3wVYe0aGzSY0/ekXoExF04Fjyoj/Wu
 JTD9aNY3nBkcPo2Qey1SbCfhuQSXQOhdA5hdzdLY=
From: Trevor Bentley <trevor@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>, Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
 <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
Date: Wed, 25 Nov 2020 20:17:27 +0100
Message-ID: <87im9ttfeg.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, Eli Zaretskii <eliz@HIDDEN>, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Carlos O'Donell <carlos@HIDDEN> writes:

> On 11/25/20 1:51 PM, Trevor Bentley wrote: 
>> I also still hit it while running under Valgrind; the whole 
>> emacs session was slow as hell, but still managed to blow out 
>> its heap in a few days.  Of course, libmtrace could be 
>> different, but at least it doesn't seem to be a heisenbug. 
> 
> Do you have a valgrind report to share? 

Yes, they were earlier in this bug report, perhaps before you 
joined.  It was the 'massif' heap tracing tool from the valgrind 
suite, not the regular valgrind leak detector.

Here are the links again:

  The raw massif output: 
 
  http://trevorbentley.com/massif.out.3364630 
 
  The *full* tree output: 
 
  http://trevorbentley.com/ms_print.3364630.txt 
 
  The tree output showing only entries above 10% usage: 
 
  http://trevorbentley.com/ms_print.thresh10.3364630.txt

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 19:14:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 14:14:05 2020
Received: from localhost ([127.0.0.1]:37072 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki0Ev-0006dH-IV
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:14:05 -0500
Received: from eggs.gnu.org ([209.51.188.92]:56966)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ki0Eu-0006cZ-Bz
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:14:04 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50998)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1ki0Eo-0007zR-V0; Wed, 25 Nov 2020 14:13:58 -0500
Received: from [176.228.60.248] (port=1098 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ki0Eo-0000fs-8S; Wed, 25 Nov 2020 14:13:58 -0500
Date: Wed, 25 Nov 2020 21:13:59 +0200
Message-Id: <835z5ts0zs.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>
In-Reply-To: <53fa9720-e709-81cc-dece-369f6136d048@HIDDEN> (message from
 Carlos O'Donell on Wed, 25 Nov 2020 13:57:34 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN> <83blfls494.fsf@HIDDEN>
 <53fa9720-e709-81cc-dece-369f6136d048@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: trevor@HIDDEN, bugs@HIDDEN, fweimer@HIDDEN,
>  43389 <at> debbugs.gnu.org, dj@HIDDEN, michael_heerdegen@HIDDEN
> From: Carlos O'Donell <carlos@HIDDEN>
> Date: Wed, 25 Nov 2020 13:57:34 -0500
> 
> There are 3 malloc_info traces in the log.
> 
> 1. Lines 47-219. Day 1: 1100MiB of RSS.
> 2. Lines 386-556. Day 4: 2.3GiB of RSS.
> 3. Lines 744-792. Day 5: 4.2GiB of RSS.
> 
> Lines are numbered for the log starting at 1.
>  
> > To make sure there are no misunderstandings, I'm talking about this
> > part of the log:
> 
> Your analysis is for trace #2, lines 386-556.
> 
> My analysis was for trace #3, lines 744-792.

OK, thanks for clarifying my confusion.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 19:06:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 14:06:30 2020
Received: from localhost ([127.0.0.1]:37015 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki07a-0006QR-D1
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:06:30 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:58073)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1ki07Y-0006QD-5K
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:06:28 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 54A5B60C47;
 Wed, 25 Nov 2020 20:06:22 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606331182;
 bh=2ZRLeF1eP/nnbgfS+yrBEXneWHKnoN0jcASYf9tmRPQ=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=Bka7SpRat6SsETWTrSnAYD5N7YaAxXjvTjk19cRadWGOZGTFToo7uTmVc+R5Rxv+m
 Ira0gFlp2Gsqh7B5yELU3jcpy43teBR9DVnOBn6MQcH8lbJbdQuxFeNhlxMLMrpwf/
 sNIEavDErk/BPytfhyygwx3MX2t+01EoRVcVoE64=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83d001s50b.fsf@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN> <83d002tuoo.fsf@HIDDEN>
 <87d001u46f.fsf@HIDDEN> <83d001s50b.fsf@HIDDEN>
Date: Wed, 25 Nov 2020 20:06:21 +0100
Message-ID: <87lfeptfwy.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Then I don't think we will be able to understand what consumes 
> memory at such high rate without some debugging.  Have you 
> considered using breakpoints and collecting backtraces, as I 
> suggested earlier? 

Next up will be libmtrace, and then I can look into gdb.  It's 
going to be really noisy... we'll see how it goes.
 
> 
> So the result of GC shows only tells you how much of the memory 
> was freed but NOT returned to glibc, it doesn't show how much 
> was actually free'd. 
> 
>> I'm wondering how to figure out how much memory a call to 
>> (garbage-collect) has actually freed.  Possibly a sort of "dry 
>> run" where it performs the GC algorithm, but doesn't release 
>> any memory. 
> 
> "Freed" in what sense? returned to glibc? 

I was referring to glibc malloc/free, but emacs internal 
allocations would also be interesting.  It's a moot point, as I 
don't think emacs supports it.  In short, the question is "what 
has garbage-collect done?"  It prints the state of memory after it 
is finished, but I have no idea if it has actually "collected" 
anything.
 
>> As far as I understand, garbage collection is supposed to 
>> happen  automatically during idle.  I would certainly notice if 
>> it locked  up the whole instance for 10 minutes from an idle 
>> GC.  I think  this means the automatic garbage collection is 
>> either not  happening, or running on a different thread, or 
>> being interrupted,  or simply works differently.  I have no 
>> idea, hence asking you :) 
> 
> That is very strange.  There's only one function to perform GC, 
> and it is called both from garbage-collect and from an internal 
> function called when Emacs is idle or when it calls interpreter 
> functions like 'eval' or 'funcall'.  The only thing 
> garbage-collect does that the internal function doesn't is 
> generate the list that is the return value of garbage-collect, 
> but that cannot possibly take minutes. 
> 
> I suggest to set garbage-collection-messages non-nil, then you 
> should see when each GC, whether the one you invoke 
> interactively or the automatic one, starts and ends.  maybe the 
> minutes you wait are not directly related to GC, but to 
> something else that is triggered by GC? 

I just set garbage-collection-messages to non-nil and evaluated 
(garbage-collect), and nothing was printed... you are suggesting 
that it should print something to *Messages*, right?

I've never tried emacs's profiler.  I'll try that next time I do a 
big garbage-collect and see what it shows.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 19:02:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 14:02:40 2020
Received: from localhost ([127.0.0.1]:37003 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki03s-0006KE-Ji
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:02:40 -0500
Received: from us-smtp-delivery-124.mimecast.com ([63.128.21.124]:54651)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1ki03r-0006K6-10
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:02:39 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606330958;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=yLxuPKV3HFHDxFlrafMPiqwS4R5X4dQZim5eq9xfWB8=;
 b=OjKzbIlbaSbKKF5Y8X1YsszEkgCCiFQfwLLGzziVJMrzqD17NAMXC3DLE3JsSj35vBhkr+
 1O3eDaTXWeFvCJejgbcBGulPQU/4AGlOYFEC1FLLbT/VZY/7JqE+idQwpjO6C3WRDNmxEZ
 e6p5ucbLpnKIOQCqUry2baM0WG010dg=
Received: from mail-qt1-f199.google.com (mail-qt1-f199.google.com
 [209.85.160.199]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-126-F-YFWFwyP92ztG99NIvINQ-1; Wed, 25 Nov 2020 14:02:37 -0500
X-MC-Unique: F-YFWFwyP92ztG99NIvINQ-1
Received: by mail-qt1-f199.google.com with SMTP id f19so3148908qtx.6
 for <43389 <at> debbugs.gnu.org>; Wed, 25 Nov 2020 11:02:36 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=yLxuPKV3HFHDxFlrafMPiqwS4R5X4dQZim5eq9xfWB8=;
 b=q1akrH0aeBen4hPVpZ/jc9l4cpKTdDMkq6V+FvZnU8LDtWODq7RiO9ld6WKZnCNeLQ
 32O9O5GaQRFx/Z309GSkCB1YSStrHtNfVbkSAyz23l2iUvvVN/Zj/PHjlpYAx6RYt8yU
 waK2FLU5qLKC0mncwTv7SAoIzZTZiIqOsS8DRGNT7WmyK2Xm1aAXKzZVWoOmilBIb87V
 kz48ULgVbbsbuLjAt2exAby4MMdUt8Iu2WfzN5ly2kK5Ue4dK72tfreBosurorpeu0aW
 NQfZq0IMytxwIRSabzEYJNN5pAaC91LdH7L5ntLX3lpY4OUyMSBV4Go8O4WvV8wRcpc0
 jBSQ==
X-Gm-Message-State: AOAM530Y66L9O5ybZUmZWdyE391aeTMuVm3UxzOC7qHSFruWlu5LKXFY
 NQJsbz9htzjTyrj7+2c3MIixAEH5PJJRvkA68aIuzitc7iHZMaIqppDZJ8nfGuofRh+f2ll76oQ
 zwSbdT2Dh5jix5uM=
X-Received: by 2002:a37:e09:: with SMTP id 9mr313289qko.39.1606330955885;
 Wed, 25 Nov 2020 11:02:35 -0800 (PST)
X-Google-Smtp-Source: ABdhPJyzV1Y9PJtbIYqdQdEpHkZKZJzKp19tBcg5oCc3MtxvZ7CRWFgygYrBA16IWuqE7SBO4puI9A==
X-Received: by 2002:a37:e09:: with SMTP id 9mr313274qko.39.1606330955730;
 Wed, 25 Nov 2020 11:02:35 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id o9sm214478qko.53.2020.11.25.11.02.34
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Wed, 25 Nov 2020 11:02:34 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Trevor Bentley <trevor@HIDDEN>, Jean Louis <bugs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
 <87o8jltglg.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <43b8f55b-d201-76e0-2d19-d97dec8798aa@HIDDEN>
Date: Wed, 25 Nov 2020 14:02:33 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <87o8jltglg.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 michael_heerdegen@HIDDEN, dj@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/25/20 1:51 PM, Trevor Bentley wrote:
> I also still hit it while running under Valgrind; the whole emacs
> session was slow as hell, but still managed to blow out its heap in a
> few days.  Of course, libmtrace could be different, but at least it
> doesn't seem to be a heisenbug.

Do you have a valgrind report to share?

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 19:01:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 14:01:47 2020
Received: from localhost ([127.0.0.1]:36998 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ki031-0006Ig-7g
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:01:47 -0500
Received: from us-smtp-delivery-124.mimecast.com ([63.128.21.124]:60295)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1ki02z-0006IZ-BZ
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 14:01:45 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606330905;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=N1jK98DhEACsiMG51D1xJwGcIgu2uh2Rx/JWgxCooNg=;
 b=UWm6y66GsRzhQsrImnxDjKFKvi9i/3PwKWB3y69d0sR70hdGHHlnkHjtZBRz2Q65G7osHd
 fQe+/hXIgpWniTIkVCCDHpsqR56/KQHyRd2jC61o2cwNElB7oSxui4A7k2qye2xLpSNuhC
 t6iSt1sJP1rTkBZRdE/Rj5e55DW4Z10=
Received: from mail-qt1-f199.google.com (mail-qt1-f199.google.com
 [209.85.160.199]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-502-EtDci-XpNO-zjQqzIy2KAA-1; Wed, 25 Nov 2020 14:01:40 -0500
X-MC-Unique: EtDci-XpNO-zjQqzIy2KAA-1
Received: by mail-qt1-f199.google.com with SMTP id g12so3137315qtc.15
 for <43389 <at> debbugs.gnu.org>; Wed, 25 Nov 2020 11:01:40 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=N1jK98DhEACsiMG51D1xJwGcIgu2uh2Rx/JWgxCooNg=;
 b=plWpGjZRXCBcz574cUbv8o+KiAlMb1g5Coud6igc3n0G6e1M28V8e8Yg3egkBMvz1B
 53v9N3GQV4L0SPtqMz/TKAQykbXNJCuiL8IxMPc9OULWN1rPiI9dvVDZ5CM5ZUPpjXrD
 Z+FgMa654vd657x/viZtyohS7DboBmKA5foKK3o30Em7af7FEUW90SBk7nT46VbqsZqx
 d0KCHETqMbOv9iQvp+P4z9WL47zcWEueqkWadiqBd/A8yKH1P/W/ojjuispq2XRP9N8M
 57rIVDXISAP6s9wni9Pth9owMnl/5tCb79fuOpGf0P/g3cLolBVgEWhMyVUSFAHjXnzL
 Dqeg==
X-Gm-Message-State: AOAM530cAVK4PtBLuZtFqVPCg7ZQsR6vdab8I3yhEmek+I45a4bULP2t
 AwbH3DbhVuPzN5s6KnKG5JyUsr0WamjvvcduJBh+jAxL9yuqWdnK6dnP98jgckvmXe42g36plkI
 hrdGZPsP1qFk5CQA=
X-Received: by 2002:a05:620a:1196:: with SMTP id
 b22mr303349qkk.31.1606330900431; 
 Wed, 25 Nov 2020 11:01:40 -0800 (PST)
X-Google-Smtp-Source: ABdhPJzHLOF71VoBGkV+LBmZ6z8MMLD8ePZhMcd+qXIX9ouFnmGd0KmjVMeU/PJiXogxNaCw1szteA==
X-Received: by 2002:a05:620a:1196:: with SMTP id
 b22mr303326qkk.31.1606330900243; 
 Wed, 25 Nov 2020 11:01:40 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id a42sm195933qtk.64.2020.11.25.11.01.38
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Wed, 25 Nov 2020 11:01:39 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Jean Louis <bugs@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <930a2c1c-b44d-eb25-29f2-63f6d2def7df@HIDDEN>
Date: Wed, 25 Nov 2020 14:01:32 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <X76do2iCm1t1OFVt@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, Trevor Bentley <trevor@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/25/20 1:08 PM, Jean Louis wrote:
> * Carlos O'Donell <carlos@HIDDEN> [2020-11-25 20:45]:
>> With glibc-malloc-trace-utils you can try to do that with:
>>
>> LD_PRELOAD=libmtrace.so \
>> MTRACE_CTL_FILE=/home/user/app.mtr \
>> MTRACE_CTL_BACKTRACE=1 \
>> ./app
>>
>> This will use libgcc's unwinder to get a copy of the malloc caller
>> address and then we'll have to decode that based on a
>> /proc/self/maps.
> 
> I will also try that in the next session.
> 
> One problem I have here is that since I run this session I have not
> get any problem. My uptime is over 2 days, I have not changed my
> habbits of work within Emacs and my swap remains under 200 MB and only
> 10% memory used by Emacs, normally 80-90%
> 
> Almost by the rule I could not run longer than 1 day until I would get
> swap of about 3 GB - 4 GB and not responsive Emacs.
> 
> Can it be that libmtrace.so could prevent something happening what is
> normally happening?

It could. If there are timing sensitivities to this issue then it might
be sufficiently perturbed that it doesn't reproduce. The above backtracing
is expensive and increases the performance impact. However, given that
we want to know who the caller was and determine the source of the 4.2GiB
allocations... we need to try capture that information.

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 18:57:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 13:57:44 2020
Received: from localhost ([127.0.0.1]:36986 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khzz5-0006An-KN
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:57:44 -0500
Received: from us-smtp-delivery-124.mimecast.com ([216.205.24.124]:45025)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1khzz3-0006Af-Ei
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:57:42 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606330661;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=Yiwqv0Wq3VOPx65/MwCXAOWYgMoiJD5S3QuXyarLc8E=;
 b=MBZSBl/f4KUXODpqOMLBY6/qfIRYjasEY5gXDEWRkzBSbAvaTWEB7HZAuVQcjvNt3z+GOw
 jfDTGa7JIv+eaIR1CefUL3X3+fnY5b/VZTs2n0ZYa74qYCdN1OU/ZGao42shu+l7tnD0MO
 Snn+ZbLeXwW7qS+iMtJ81no9qWGuP1U=
Received: from mail-qk1-f199.google.com (mail-qk1-f199.google.com
 [209.85.222.199]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-529-RWbtKlkNPPeAY3b9-L7X7g-1; Wed, 25 Nov 2020 13:57:37 -0500
X-MC-Unique: RWbtKlkNPPeAY3b9-L7X7g-1
Received: by mail-qk1-f199.google.com with SMTP id 198so3179310qkj.7
 for <43389 <at> debbugs.gnu.org>; Wed, 25 Nov 2020 10:57:37 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=Yiwqv0Wq3VOPx65/MwCXAOWYgMoiJD5S3QuXyarLc8E=;
 b=mEJLwKOPt6HFayRmaqU7WGhQ4pgyaVR2N4XmLKDVL6pCOGXkI3B7LP0/wBjWQi2Fz1
 rvYGVX4cr3bTR3w+C2QgJKMbr5rBXyMlQSrAWMtoVRBI9URqJTD5Z5C8XlvYHqrsxAhs
 8DzIq4ToCggnmYtwESdyYna9/H+2GO1e8hLA9yuV9knrZr+OMNmwYIM2daPfwpLxxsOk
 u4grk0VDkgn+3RJXj+mL/6qZKx2+HrCItakL+fuQ1qtX76wsdAtAjzRONYqGS0koLTGP
 gzC5tTDhMoKRplPfQObBzbdrIxANg5sdg+2Vrl0n9fa2ECaVhd1PY2tI3wCZmlnBqaee
 Zgyw==
X-Gm-Message-State: AOAM530F38SSHKeuAYmi8MzFqrDVqsbdFiDOU7gcOPxLL8B6ZlwL/oM9
 Ms+vjRCONBLG0JuCocgZ19U2v0wvc7BCcBM5T1X95N9MqwYWYlOfp+2ONXww+EaZRXCHdUpfJS9
 AgiJA7fjEHNf27GY=
X-Received: by 2002:ac8:4e87:: with SMTP id 7mr278510qtp.310.1606330656639;
 Wed, 25 Nov 2020 10:57:36 -0800 (PST)
X-Google-Smtp-Source: ABdhPJzgJPwqjAJF3vWyhouo7nNxGU8lfvFLi0lQXuA/cHNky67mP02q7t0aD7FHBI1i+CdtswqXFQ==
X-Received: by 2002:ac8:4e87:: with SMTP id 7mr278493qtp.310.1606330656373;
 Wed, 25 Nov 2020 10:57:36 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id c6sm175704qkg.54.2020.11.25.10.57.34
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Wed, 25 Nov 2020 10:57:35 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Eli Zaretskii <eliz@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN> <83blfls494.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <53fa9720-e709-81cc-dece-369f6136d048@HIDDEN>
Date: Wed, 25 Nov 2020 13:57:34 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <83blfls494.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/25/20 1:03 PM, Eli Zaretskii wrote:
>> Cc: bugs@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>>  dj@HIDDEN, michael_heerdegen@HIDDEN
>> From: Carlos O'Donell <carlos@HIDDEN>
>> Date: Wed, 25 Nov 2020 12:45:04 -0500
>>
>> On 11/24/20 11:07 AM, Eli Zaretskii wrote:
>>> Look at the large chunks in the tail of this.  Together, they do
>>> account for ~2GB.
>>>
>>> Carlos, are these chunks in use (i.e. allocated and not freed), or are
>>> they the free chunks that are available for allocation, but not
>>> released to the OS?  If the former, then it sounds like this session
>>> does have around 2GB of allocated heap data, so either there's some
>>> allocated memory we don't account for, or there is indeed a memory
>>> leak in Emacs.  If these are the free chunks, then the way glibc
>>> manages free'd memory is indeed an issue.
>>
>> These chunks are all free and mapped for use by the algorithm to satisfy
>> a request by the application.
> 
> So we have more than 1.5GB free memory available for allocation, is
> that right?

There are 3 malloc_info traces in the log.

1. Lines 47-219. Day 1: 1100MiB of RSS.
2. Lines 386-556. Day 4: 2.3GiB of RSS.
3. Lines 744-792. Day 5: 4.2GiB of RSS.

Lines are numbered for the log starting at 1.
 
> To make sure there are no misunderstandings, I'm talking about this
> part of the log:

Your analysis is for trace #2, lines 386-556.

My analysis was for trace #3, lines 744-792.

>   <heap nr="0">
>   <sizes>
>     [...]
>     <size from="10753" to="12273" total="11387550" count="990"/>
>     <size from="12289" to="16369" total="32661229" count="2317"/>
>     <size from="16385" to="20465" total="36652437" count="2037"/>
>     <size from="20481" to="24561" total="21272131" count="947"/>
>     <size from="24577" to="28657" total="25462302" count="958"/>
>     <size from="28673" to="32753" total="28087234" count="914"/>
>     <size from="32769" to="36849" total="39080113" count="1121"/>
>     <size from="36865" to="40945" total="30141527" count="775"/>
>     <size from="40961" to="65521" total="166092799" count="3119"/>
>     <size from="65537" to="98289" total="218425380" count="2692"/>
>     <size from="98321" to="131057" total="178383171" count="1555"/>
>     <size from="131089" to="163825" total="167800886" count="1142"/>
>     <size from="163841" to="262065" total="367649915" count="1819"/>
>     <size from="262161" to="522673" total="185347984" count="560"/>
>     <size from="525729" to="30878897" total="113322865" count="97"/>
>     <unsorted from="33" to="33" total="33" count="1"/>
>   </sizes>
> 
> If I sum up the "total=" parts of these large numbers, I get 1.6GB.
> Is this free memory, given back to glibc for future allocations from
> this arena, and if so, are those 1.6GB part of the 4.2GB total?

In trace #2 we have these final statistics:

549 <total type="fast" count="39" size="2656"/>
550 <total type="rest" count="44013" size="1755953515"/>
551 <total type="mmap" count="6" size="121565184"/>
552 <system type="current" size="2246778880"/>
553 <system type="max" size="2246778880"/>
554 <aspace type="total" size="2246778880"/>
555 <aspace type="mprotect" size="2246778880"/>
556 </malloc>

This shows ~1.7GiB of unused free chunks. Keep in mind glibc malloc is a
heap-based allocator so if you have FIFO usage pattern you won't see the kernel
heap decrease until you free the most recently allocated chunk. In trace #3 we 
*do* see that application demand consumes all these free chunks again, so
something is using them in the application. There are none left reported in
the malloc_info statistics (could also be chunk corruption).

During trace #2 the only way to free some of the ~1.7GiB in-use by the algorithm
is to call malloc_trim() to free back unused pages (requires free/unsorted chunk
walk and mmumap() calls to the kernel to reduce RSS accounting). Calling malloc_trim
is expensive, particularly if you're just going to use the chunks again, as
appears to be happening the next day.

In trace #3, for which we are at 4.2GiB of RSS usage, we see the following:

742 ;; malloc-info
743 (malloc-info)
744 <malloc version="1">
745 <heap nr="0">
746 <sizes>
747 </sizes>
748 <total type="fast" count="0" size="0"/>
749 <total type="rest" count="1" size="112688"/>

a. Arena 0 (kernel heap) shows 0KiB of unused fast bins, 112KiB of other
   in 1 bin (probably top-chunk).

750 <system type="current" size="4243079168"/>
751 <system type="max" size="4243079168"/>
752 <aspace type="total" size="4243079168"/>
753 <aspace type="mprotect" size="4243079168"/>

b. Arena 0 (kernel heap) shows 4.2GiB "current" which means that the
   sbrk-extended kernel heap is in use up to 4.2GiB.
   WARNING: We count "foreign" uses of sbrk as brk space, so looking for
   sbrk or brk by a foreign source is useful.

754 </heap>
755 <heap nr="1">
756 <sizes>
757   <size from="17" to="32" total="32" count="1"/>
758   <size from="33" to="48" total="240" count="5"/>
759   <size from="49" to="64" total="256" count="4"/>
760   <size from="65" to="80" total="160" count="2"/>
761   <size from="97" to="112" total="224" count="2"/>
762   <size from="33" to="33" total="231" count="7"/>
763   <size from="49" to="49" total="294" count="6"/>
764   <size from="65" to="65" total="390" count="6"/>
765   <size from="81" to="81" total="162" count="2"/>
766   <size from="97" to="97" total="97" count="1"/>
767   <size from="129" to="129" total="516" count="4"/>
768   <size from="161" to="161" total="644" count="4"/>
769   <size from="209" to="209" total="1254" count="6"/>
770   <size from="241" to="241" total="241" count="1"/>
771   <size from="257" to="257" total="257" count="1"/>
772   <size from="305" to="305" total="610" count="2"/>
773   <size from="32209" to="32209" total="32209" count="1"/>
774   <size from="3982129" to="8059889" total="28065174" count="6"/>
775   <unsorted from="209" to="4020593" total="4047069" count="13"/>
776 </sizes>
777 <total type="fast" count="14" size="912"/>
778 <total type="rest" count="61" size="42357420"/>
779 <system type="current" size="42426368"/>
780 <system type="max" size="42426368"/>
781 <aspace type="total" size="42426368"/>
782 <aspace type="mprotect" size="42426368"/>
783 <aspace type="subheaps" size="1"/>

c. Arena 1 has 42MiB of free'd chunks for use.

784 </heap>
785 <total type="fast" count="14" size="912"/>
786 <total type="rest" count="62" size="42470108"/>
787 <total type="mmap" count="9" size="208683008"/>

d. We have:
   - 912KiB of fast bins.
   - 42MiB of regular bins.
   - 200MiB of mmap'd large chunks.

788 <system type="current" size="4285505536"/>
789 <system type="max" size="4285505536"/>
790 <aspace type="total" size="4285505536"/>

e. Total allocated space is 4.2GiB.

791 <aspace type="mprotect" size="4285505536"/>
792 </malloc>

Something is using the kernel heap chunks, or calling sbrk/brk
directly (since foreign brks are counted by our statistics).

>> This shows the application is USING memory on the main system heap.
>>
>> It might not be "leaked" memory since the application might be using it.
>>
>> You want visibility into what is USING that memory.
>>
>> With glibc-malloc-trace-utils you can try to do that with:
>>
>> LD_PRELOAD=libmtrace.so \
>> MTRACE_CTL_FILE=/home/user/app.mtr \
>> MTRACE_CTL_BACKTRACE=1 \
>> ./app
>>
>> This will use libgcc's unwinder to get a copy of the malloc caller
>> address and then we'll have to decode that based on a /proc/self/maps.
>>
>> Next steps:
>> - Get a glibc-malloc-trace-utils trace of the application ratcheting.
>> - Get a copy of /proc/$PID/maps for the application (shorter version of smaps).
>>
>> Then we might be able to correlate where all the kernel heap data went?
> 
> Thanks for the instructions.  Would people please try that and report
> the results?
> 


-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 18:51:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 13:51:47 2020
Received: from localhost ([127.0.0.1]:36977 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khztL-00062U-M4
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:51:47 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:57973)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1khztK-00062I-EH
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:51:46 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 7B0E8603B5;
 Wed, 25 Nov 2020 19:51:40 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606330300;
 bh=qMGI9uABB0eNByaZdFw+CeM4v45pJLTLPzIYF4CUxDQ=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=Fz6rU1UOxa0BwaR+IKeoVCf+mQmSSMzIwSTi/8uhjbvJEWPh8HHxJIvfpFHw9gcNw
 ogZD1VyK3v/sfUZ4xKzl5Hz0E4lXZzherE2QGh1ERhNduGr9JEWXgt9ZR1U4XSN89D
 QqvJmY0wuEa065c007ib6enrDwKC3dRTM3CG8cPw=
From: Trevor Bentley <trevor@HIDDEN>
To: Jean Louis <bugs@HIDDEN>, Carlos O'Donell <carlos@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <X76do2iCm1t1OFVt@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN> <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
 <X76do2iCm1t1OFVt@HIDDEN>
Date: Wed, 25 Nov 2020 19:51:39 +0100
Message-ID: <87o8jltglg.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 michael_heerdegen@HIDDEN, dj@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Jean Louis <bugs@HIDDEN> writes:

>> This will use libgcc's unwinder to get a copy of the malloc 
>> caller address and then we'll have to decode that based on a 
>> /proc/self/maps. 
> 
> I will also try that in the next session. 

As will I, but probably won't set it up until this weekend.
 
> One problem I have here is that since I run this session I have 
> not get any problem. My uptime is over 2 days, I have not 
> changed my habbits of work within Emacs and my swap remains 
> under 200 MB and only 10% memory used by Emacs, normally 80-90% 
> 
> Almost by the rule I could not run longer than 1 day until I 
> would get swap of about 3 GB - 4 GB and not responsive Emacs. 
> 
> Can it be that libmtrace.so could prevent something happening 
> what is normally happening? 

I see high variation in how long it takes to hit it on my machine. 
The shortest was after ~4 hours, average is 1.5 days, and the 
longest was 5 days.  Perhaps you're seeing the same.

I also still hit it while running under Valgrind; the whole emacs 
session was slow as hell, but still managed to blow out its heap 
in a few days.  Of course, libmtrace could be different, but at 
least it doesn't seem to be a heisenbug.

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 18:35:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 13:35:56 2020
Received: from localhost ([127.0.0.1]:36963 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khze0-0005gF-04
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:35:56 -0500
Received: from static.rcdrun.com ([95.85.24.50]:44471)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1khzdy-0005f8-31
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:35:54 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C000B.000000005FBEA408.000038E8; Wed, 25 Nov 2020 18:35:52 +0000
Date: Wed, 25 Nov 2020 21:08:35 +0300
From: Jean Louis <bugs@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X76do2iCm1t1OFVt@HIDDEN>
References: <83y2j0qb2v.fsf@HIDDEN> <X7YX4MxbbM2WsFuk@HIDDEN>
 <831rgppg3w.fsf@HIDDEN> <X7c1CuK9bCP2sw5Z@HIDDEN>
 <83zh3czbvz.fsf@HIDDEN> <X7uWIyMsyIarDbji@HIDDEN>
 <83blfovzxz.fsf@HIDDEN> <87o8jnu5f2.fsf@HIDDEN>
 <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, Trevor Bentley <trevor@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Carlos O'Donell <carlos@HIDDEN> [2020-11-25 20:45]:
> With glibc-malloc-trace-utils you can try to do that with:
> 
> LD_PRELOAD=libmtrace.so \
> MTRACE_CTL_FILE=/home/user/app.mtr \
> MTRACE_CTL_BACKTRACE=1 \
> ./app
> 
> This will use libgcc's unwinder to get a copy of the malloc caller
> address and then we'll have to decode that based on a
> /proc/self/maps.

I will also try that in the next session.

One problem I have here is that since I run this session I have not
get any problem. My uptime is over 2 days, I have not changed my
habbits of work within Emacs and my swap remains under 200 MB and only
10% memory used by Emacs, normally 80-90%

Almost by the rule I could not run longer than 1 day until I would get
swap of about 3 GB - 4 GB and not responsive Emacs.

Can it be that libmtrace.so could prevent something happening what is
normally happening?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 18:35:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 13:35:32 2020
Received: from localhost ([127.0.0.1]:36954 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khzdc-0005fT-Bl
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:35:32 -0500
Received: from static.rcdrun.com ([95.85.24.50]:44471)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1khzda-0005f8-Dd
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:35:31 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C1AE2.000000005FBEA3EC.0000388C; Wed, 25 Nov 2020 18:35:23 +0000
Date: Wed, 25 Nov 2020 18:09:25 +0300
From: Jean Louis <bugs@HIDDEN>
To: Arthur Miller <arthur.miller@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X75zpXAtGvYWmmrg@HIDDEN>
References: <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <X7wcMpkuuE01Ciwb@HIDDEN>
 <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
 <X7yaS5sPWR60tpHD@HIDDEN>
 <AM0PR06MB6577D6DAA08B505246A5360596FB0@HIDDEN>
 <X7zM+wOib15X3tsj@HIDDEN>
 <AM0PR06MB6577E3883B73F33C016A68F296FB0@HIDDEN>
 <X71AWQBI5rwPA/+j@HIDDEN>
 <AM0PR06MB65776B9CDA3D0C49B9B46F0396FA0@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <AM0PR06MB65776B9CDA3D0C49B9B46F0396FA0@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * Arthur Miller <arthur.miller@HIDDEN> [2020-11-25 17:59]:
 > > Hyperbola is independent project that receives little support, it > >
 should receive so much more. They will also create new HyperbolaB [...] 
 Content analysis details:   (1.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.1 DATE_IN_PAST_03_06     Date: is 3 to 6 hours before Received: date
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: hyperbola.info]
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

* Arthur Miller <arthur.miller@HIDDEN> [2020-11-25 17:59]:
> > Hyperbola is independent project that receives little support, it
> > should receive so much more. They will also create new HyperbolaBSD
> > system that will move an OpenBSD kernel into GNU GPL direction.
> >
> > Jean
> Oki; thansk. I never heard of the Hypberbola before.

https://www.hyperbola.info

And there are other fully free operating systems endorsed by the FSF
such as:

Trisquel GNU/Linux-libre
https://trisquel.info

and others on https://www.gnu.org

Those are only that I am using due to agreement among people to
provide fully free software without access to anything non-free.

Jean




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 18:03:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 13:03:48 2020
Received: from localhost ([127.0.0.1]:36895 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khz8u-0004uw-FU
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:03:48 -0500
Received: from eggs.gnu.org ([209.51.188.92]:38718)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1khz8q-0004uh-1S
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 13:03:47 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49468)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1khz8k-0006es-9P; Wed, 25 Nov 2020 13:03:38 -0500
Received: from [176.228.60.248] (port=4760 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1khz8h-0002QY-OV; Wed, 25 Nov 2020 13:03:36 -0500
Date: Wed, 25 Nov 2020 20:03:35 +0200
Message-Id: <83blfls494.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Carlos O'Donell <carlos@HIDDEN>
In-Reply-To: <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN> (message from
 Carlos O'Donell on Wed, 25 Nov 2020 12:45:04 -0500)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: bugs@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  dj@HIDDEN, michael_heerdegen@HIDDEN
> From: Carlos O'Donell <carlos@HIDDEN>
> Date: Wed, 25 Nov 2020 12:45:04 -0500
> 
> On 11/24/20 11:07 AM, Eli Zaretskii wrote:
> > Look at the large chunks in the tail of this.  Together, they do
> > account for ~2GB.
> > 
> > Carlos, are these chunks in use (i.e. allocated and not freed), or are
> > they the free chunks that are available for allocation, but not
> > released to the OS?  If the former, then it sounds like this session
> > does have around 2GB of allocated heap data, so either there's some
> > allocated memory we don't account for, or there is indeed a memory
> > leak in Emacs.  If these are the free chunks, then the way glibc
> > manages free'd memory is indeed an issue.
> 
> These chunks are all free and mapped for use by the algorithm to satisfy
> a request by the application.

So we have more than 1.5GB free memory available for allocation, is
that right?

But then how to reconcile this with what you say next:

> <system type="current" size="4243079168"/>
> 
> => Currently at 4.2GiB in arena 0 (kernel assigned heap).
> => The application is using that sbrk'd memory.
> 
> <system type="max" size="4243079168"/>
> <aspace type="total" size="4243079168"/>
> <aspace type="mprotect" size="4243079168"/>
> 
> => This indicates *real* API usage of 4.2GiB.

Here you seem to say that these 4.2GB are _used_ by the application?
While I thought the large chunks I asked about, which total more than
1.5GB, are a significant part of those 4.2GB?

To make sure there are no misunderstandings, I'm talking about this
part of the log:

  <heap nr="0">
  <sizes>
    [...]
    <size from="10753" to="12273" total="11387550" count="990"/>
    <size from="12289" to="16369" total="32661229" count="2317"/>
    <size from="16385" to="20465" total="36652437" count="2037"/>
    <size from="20481" to="24561" total="21272131" count="947"/>
    <size from="24577" to="28657" total="25462302" count="958"/>
    <size from="28673" to="32753" total="28087234" count="914"/>
    <size from="32769" to="36849" total="39080113" count="1121"/>
    <size from="36865" to="40945" total="30141527" count="775"/>
    <size from="40961" to="65521" total="166092799" count="3119"/>
    <size from="65537" to="98289" total="218425380" count="2692"/>
    <size from="98321" to="131057" total="178383171" count="1555"/>
    <size from="131089" to="163825" total="167800886" count="1142"/>
    <size from="163841" to="262065" total="367649915" count="1819"/>
    <size from="262161" to="522673" total="185347984" count="560"/>
    <size from="525729" to="30878897" total="113322865" count="97"/>
    <unsorted from="33" to="33" total="33" count="1"/>
  </sizes>

If I sum up the "total=" parts of these large numbers, I get 1.6GB.
Is this free memory, given back to glibc for future allocations from
this arena, and if so, are those 1.6GB part of the 4.2GB total?

> This shows the application is USING memory on the main system heap.
> 
> It might not be "leaked" memory since the application might be using it.
> 
> You want visibility into what is USING that memory.
> 
> With glibc-malloc-trace-utils you can try to do that with:
> 
> LD_PRELOAD=libmtrace.so \
> MTRACE_CTL_FILE=/home/user/app.mtr \
> MTRACE_CTL_BACKTRACE=1 \
> ./app
> 
> This will use libgcc's unwinder to get a copy of the malloc caller
> address and then we'll have to decode that based on a /proc/self/maps.
> 
> Next steps:
> - Get a glibc-malloc-trace-utils trace of the application ratcheting.
> - Get a copy of /proc/$PID/maps for the application (shorter version of smaps).
> 
> Then we might be able to correlate where all the kernel heap data went?

Thanks for the instructions.  Would people please try that and report
the results?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 17:48:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 12:48:27 2020
Received: from localhost ([127.0.0.1]:36869 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khyu2-0004Y7-Mb
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 12:48:26 -0500
Received: from us-smtp-delivery-124.mimecast.com ([216.205.24.124]:42004)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1khyu1-0004Y0-60
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 12:48:25 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606326505;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=fm5bTKPTcIyDmafbpcPLNuBNj48TEbTOnOH0JuIdyjo=;
 b=Ql/TvvWQL69p9lATTmkeBHbHLNqp+iuIe0wNgFkbjR0P6zK8+/OFvBHHlZHsOqw+y0M50/
 QK5bHshQDIVqS7oml9B7D0pVffmj603DnycYkf9c4KXkQYxTHyo4PjWFTlqIxXIa7fIvUI
 w8+rYKSPE0N4OiE8jLw89IhFxlFREng=
Received: from mail-qt1-f199.google.com (mail-qt1-f199.google.com
 [209.85.160.199]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-425-lMrWVH6uPMmrUiGrruRi0w-1; Wed, 25 Nov 2020 12:48:22 -0500
X-MC-Unique: lMrWVH6uPMmrUiGrruRi0w-1
Received: by mail-qt1-f199.google.com with SMTP id i14so3002019qtq.18
 for <43389 <at> debbugs.gnu.org>; Wed, 25 Nov 2020 09:48:22 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=fm5bTKPTcIyDmafbpcPLNuBNj48TEbTOnOH0JuIdyjo=;
 b=K+oIZHc1VfZ18E0D7WgjE64jOKGyihcayJJv/IEX+6S9TqOfxo94dAvP+GwMdal0t+
 slpGuurk2bPZ172VHD4Qa7YLZXajk37WafS887qM0E+RYBG16eI7BMRuIkey6DRiCrw8
 gMespY90cM618EtgAK6pSrSejXrzTFVsK1Mapl/hJ1EQCNIqXtw8yd21qqpz/Fj8UIT1
 ph2PrbxqgPmO7b2LKUJ27HlUmcLxaO8YWunpTIg8jubosgRxD91wIO0c9fvEqt4IzD1Z
 OOsrKXteUMvU1yhNwJ1nDJjZERNnF91+mH3oEr7VxFS92k0nIode4A0FFD+fhooJOb8F
 CElg==
X-Gm-Message-State: AOAM532EHeMqZSQUcD6VsTsU3rmIVEzhFq2LF9Zw8IrrsoHEOrhNSJyE
 NdcS8o8f2V0o8nTENpVPuBvLuYk1B/q5YgCkaKMr9atQUIOjkFDEPkXFFkdTgwWdjfvUSevWlqC
 uKJApe0bcTKXhCc4=
X-Received: by 2002:ac8:724d:: with SMTP id l13mr4110823qtp.373.1606326502539; 
 Wed, 25 Nov 2020 09:48:22 -0800 (PST)
X-Google-Smtp-Source: ABdhPJy6i4ywXx8GohY/RkSvjg6Pk0KTxz5k5Gwl9XuhbJpphsRCKpJNwXLDXQexx+RM+rp4qHFVdw==
X-Received: by 2002:ac8:724d:: with SMTP id l13mr4110806qtp.373.1606326502357; 
 Wed, 25 Nov 2020 09:48:22 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id v15sm2803738qto.74.2020.11.25.09.48.20
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Wed, 25 Nov 2020 09:48:21 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Eli Zaretskii <eliz@HIDDEN>, Trevor Bentley <trevor@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN> <83d002tuoo.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <ce7e6b72-bef9-c464-19a1-ca8218434690@HIDDEN>
Date: Wed, 25 Nov 2020 12:48:20 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <83d002tuoo.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, michael_heerdegen@HIDDEN,
 dj@HIDDEN, bugs@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/24/20 2:35 PM, Eli Zaretskii wrote:
>> From: Trevor Bentley <trevor@HIDDEN>
>> Cc: bugs@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>>  dj@HIDDEN, michael_heerdegen@HIDDEN, carlos@HIDDEN
>> Cc: 
>> Date: Tue, 24 Nov 2020 20:05:15 +0100
>>
>> I just updated the log on my website.  Same instance a day later, 
>> after yet another memory spike up to 4.3GB.  Concatenated to the 
>> end:
>>
>> https://trevorbentley.com/emacs_malloc_info.log
> 
> I don't think I can interpret that.  In particular, how come "total"
> is 4GB, but I see no comparable sizes in any of the other fields?
> where do those 4GB hide?  Carlos, can you help interpreting this
> report?

The 4GiB are in use by the application and it is up to us to increase
the observability of that usage with our tooling.

>> Question 3: I've never used the malloc_trim() function.  Could 
>> that be something worth experimenting with, to see if it releases 
>> any of the massive heap back to the OS?
> 
> That's for glibc guys to answer.

If malloc_info() shows memory that is free'd and unused then malloc_trim()
can free back any unused pages to the OS.

However, in your last day malloc_info() output you only show ~50MiB of
unused memory out of ~4GiB, so calling malloc_trim() would only free
~50MiB. There is heavy usage of the kernel heap by something. Finding
out what is using that memory is our next step.

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 17:47:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 12:47:27 2020
Received: from localhost ([127.0.0.1]:36864 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khyt5-0004WR-15
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 12:47:27 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33882)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1khyt3-0004WF-W9
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 12:47:26 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49075)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1khysw-0004Ix-MV; Wed, 25 Nov 2020 12:47:19 -0500
Received: from [176.228.60.248] (port=3766 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1khysu-0002fS-7R; Wed, 25 Nov 2020 12:47:16 -0500
Date: Wed, 25 Nov 2020 19:47:16 +0200
Message-Id: <83d001s50b.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87d001u46f.fsf@HIDDEN> (message from Trevor
 Bentley on Wed, 25 Nov 2020 11:22:16 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN> <83d002tuoo.fsf@HIDDEN>
 <87d001u46f.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: bugs@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  dj@HIDDEN, michael_heerdegen@HIDDEN, carlos@HIDDEN
> Date: Wed, 25 Nov 2020 11:22:16 +0100
> 
> >>  - The leaking stops for a while after (garbage-collect).  It 
> >>  was  leaking 1MB per second for this last log, and stopped 
> >>  growing  after the garbage collection. 
> > 
> > Now, what happens in that session once per second (in an 
> > otherwise idle Emacs, I presume?) to cause such memory 
> > consumption?  Some timers?  If you run with a breakpoint in 
> > malloc that just shows the backtrace and continues, do you see 
> > what could consume 1MB every second? 
> 
> Not an idle emacs at all, in this case.  I have seen the memory 
> growth in an idle emacs, but the only one I can reproduce it on is 
> the emacs-slack one, which is connected to a corporate Slack 
> account.  Tons of short messages streaming in over the network and 
> being displayed in rotating buffers, with images mixed in.  It's a 
> big 'ol "web 2.0" API... it can easily pass 1MB/s of bloated JSON 
> messages through.  This is one _very active_ emacs.

Then I don't think we will be able to understand what consumes memory
at such high rate without some debugging.  Have you considered using
breakpoints and collecting backtraces, as I suggested earlier?

The hard problem is to understand which memory is allocated and not
freed "soon enough", but for such a high rate of memory consumption
perhaps just knowing which code request so much memory would be an
important clue.

> The original strace logs and valgrind output I posted before 
> showed a random assortment of calls from gnutls, imagemagick, and 
> lisp strings, with lisp strings dominating the malloc calls 
> (enlarge_buffer_text, mostly).

Enlarging buffer text generally causes malloc to call mmap (as opposed
to brk/sbrk), so this cannot cause the situation where a lot of unused
memory that is not returned to the OS.  And we already saw that just
by summing up the buffer text memory we never get even close to the VM
size of the process.

> > What do you mean by "reaping dead references" here? 
> > 
> >> It could be that there really were 4.3GB of dead references. 
> > 
> > Not sure I understand what are you trying to establish here. 
> 
> GC is running through a list of active allocations and freeing the 
> ones with no remaining references, right?  Presumably, if a lot of 
> active malloc() allocations are no longer refernced, and 
> (garbage-collect) calls free() on a bunch of blocks.

We only call free on "unfragmented" Lisp data, e.g. if some block of
Lisp strings was freed in its entirety.  If some Lisp objects in a
block are still alive, we don't free the block, we just mark the freed
Lisp objects as being free and available for reuse.

So the result of GC shows only tells you how much of the memory was
freed but NOT returned to glibc, it doesn't show how much was actually
free'd.

> I'm wondering how to figure out how much memory a call to
> (garbage-collect) has actually freed.  Possibly a sort of "dry run"
> where it performs the GC algorithm, but doesn't release any memory.

"Freed" in what sense? returned to glibc?

> > There's only one garbage-collect, it is called for _any_ GC. 
> > 
> > What do you mean by "during normal use" in this sentence: 
> > 
> >   I certainly don't notice 5-10 minute long pauses during normal 
> >   use, though "gcs-done" is incrementing. 
> > 
> > How is what you did here, where GC took several minutes, 
> > different from "normal usage"?
> 
> In this log, I am explicitly executing "(garbage-collect)", and it 
> takes 10 minutes, during which the UI is unresponsive and 
> sometimes even turns grey when the window stops redrawing.
> 
> By "normal use", I mean that I use this emacs instance on-and-off 
> all day long.  I would notice if it were freezing for minutes at a 
> time, and it definitely is not.
> 
> As far as I understand, garbage collection is supposed to happen 
> automatically during idle.  I would certainly notice if it locked 
> up the whole instance for 10 minutes from an idle GC.  I think 
> this means the automatic garbage collection is either not 
> happening, or running on a different thread, or being interrupted, 
> or simply works differently.  I have no idea, hence asking you :)

That is very strange.  There's only one function to perform GC, and it
is called both from garbage-collect and from an internal function
called when Emacs is idle or when it calls interpreter functions like
'eval' or 'funcall'.  The only thing garbage-collect does that the
internal function doesn't is generate the list that is the return
value of garbage-collect, but that cannot possibly take minutes.

I suggest to set garbage-collection-messages non-nil, then you should
see when each GC, whether the one you invoke interactively or the
automatic one, starts and ends.  maybe the minutes you wait are not
directly related to GC, but to something else that is triggered by GC?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 17:45:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 12:45:14 2020
Received: from localhost ([127.0.0.1]:36860 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khyqw-0004T7-FW
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 12:45:14 -0500
Received: from us-smtp-delivery-124.mimecast.com ([216.205.24.124]:52448)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <carlos@HIDDEN>) id 1khyqt-0004Sy-Rx
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 12:45:12 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=redhat.com;
 s=mimecast20190719; t=1606326311;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=2h4Rj/qP+2HOPw4ugkTWm5Do9UVpuWTGL+C+BRxiyp8=;
 b=NsJ3nY1t3gwMVwo3CiDFuXq3vHUzY1YrcEmCK36wHVtxr2o0fGhj8EYPdinVWbN+Tm1aQP
 fGAWpaMq9hWGv/zOMZ+m9as7+UT92lMIY7gb90tZGwzBPTHus0GbNmKXjP17wgyPOcfsIt
 UVWpeISapfwL2yo3rPx1RywcaKts4yc=
Received: from mail-qt1-f198.google.com (mail-qt1-f198.google.com
 [209.85.160.198]) (Using TLS) by relay.mimecast.com with ESMTP id
 us-mta-189-bQvFgBUfMjeL4YZ7gf_8sg-1; Wed, 25 Nov 2020 12:45:08 -0500
X-MC-Unique: bQvFgBUfMjeL4YZ7gf_8sg-1
Received: by mail-qt1-f198.google.com with SMTP id r29so2995691qtu.21
 for <43389 <at> debbugs.gnu.org>; Wed, 25 Nov 2020 09:45:08 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:subject:to:cc:references:from:organization
 :message-id:date:user-agent:mime-version:in-reply-to
 :content-language:content-transfer-encoding;
 bh=2h4Rj/qP+2HOPw4ugkTWm5Do9UVpuWTGL+C+BRxiyp8=;
 b=JehC5ifdyCEc8+tu1yL+nFzZbBhg89q81a9EYOe2AutR8EYQ0vdtorMzUm/bdHJ+u+
 M0yYS8c7OJWJ1UHcos0GVaf7rD3i/QEcP8nnK00LGD0sCKDVVLE++KKPzifVLBdaZSFV
 2Bv8SOva8Rzr25dcUIFkCe3G4H9htkDO5m7S9eqPPeri2Ok6fzGEt+69p/WduhX1XQ/s
 K5IMfltMGZhcXJgp4MJCamaOWY+FcA9Z4RLabhEOir6xEwyN5sa1PYTBHkqyiIPzlTsL
 rTjGhoT7nBgGAnSb1kPxEfwhklHzr1bvlCuf/082EqkrGnm9ZP0hikiyasxxkCvLnm+5
 Tf+g==
X-Gm-Message-State: AOAM532ywQbXBy5pR8Jent5mXll7LFI9SzfDaiuHwCmUJkLfRVbBB/vN
 aM4u/WzEicpDH8Lkx3QvOYmpJO3K8yOx61ZJfDyH3eOadJ4VR4gZJ2zYyWjO+BFmdMGiBdpqy25
 kK5HcOFTF9mrbfho=
X-Received: by 2002:ad4:4721:: with SMTP id l1mr4666231qvz.30.1606326307877;
 Wed, 25 Nov 2020 09:45:07 -0800 (PST)
X-Google-Smtp-Source: ABdhPJxrmLNaFgXompfA8yf4j9JCh7H26mNprKE1tP3doB84wyVy4SppMajVxh/jnt7lFaMXThPyvQ==
X-Received: by 2002:ad4:4721:: with SMTP id l1mr4666200qvz.30.1606326307636;
 Wed, 25 Nov 2020 09:45:07 -0800 (PST)
Received: from [192.168.1.16] (198-84-214-74.cpe.teksavvy.com. [198.84.214.74])
 by smtp.gmail.com with ESMTPSA id q32sm3130610qtb.71.2020.11.25.09.45.05
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Wed, 25 Nov 2020 09:45:06 -0800 (PST)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
To: Eli Zaretskii <eliz@HIDDEN>, Trevor Bentley <trevor@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
From: Carlos O'Donell <carlos@HIDDEN>
Organization: Red Hat
Message-ID: <522e3cc0-c563-3308-7264-1b09cd5e264b@HIDDEN>
Date: Wed, 25 Nov 2020 12:45:04 -0500
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.4.0
MIME-Version: 1.0
In-Reply-To: <83o8jmu49z.fsf@HIDDEN>
Authentication-Results: relay.mimecast.com;
 auth=pass smtp.auth=CUSA124A263 smtp.mailfrom=carlos@HIDDEN
X-Mimecast-Spam-Score: 0
X-Mimecast-Originator: redhat.com
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, michael_heerdegen@HIDDEN,
 dj@HIDDEN, bugs@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 11/24/20 11:07 AM, Eli Zaretskii wrote:
> Look at the large chunks in the tail of this.  Together, they do
> account for ~2GB.
> 
> Carlos, are these chunks in use (i.e. allocated and not freed), or are
> they the free chunks that are available for allocation, but not
> released to the OS?  If the former, then it sounds like this session
> does have around 2GB of allocated heap data, so either there's some
> allocated memory we don't account for, or there is indeed a memory
> leak in Emacs.  If these are the free chunks, then the way glibc
> manages free'd memory is indeed an issue.

These chunks are all free and mapped for use by the algorithm to satisfy
a request by the application.

Looking at the last malloc_info (annotated):
https://trevorbentley.com/emacs_malloc_info.log
===============================================
;; malloc-info
(malloc-info)
<malloc version="1">
<heap nr="0">
<sizes>
</sizes>
<total type="fast" count="0" size="0"/>

=> No fast bins.

<total type="rest" count="1" size="112688"/>

=> 1 unused bin.

=> In total we have only 112KiB in 1 unused chunk free'd on the stack.
=> The rest of the stack is in use by the application.
=> It looks like the application usage goes down to zero and then up again?

<system type="current" size="4243079168"/>

=> Currently at 4.2GiB in arena 0 (kernel assigned heap).
=> The application is using that sbrk'd memory.

<system type="max" size="4243079168"/>
<aspace type="total" size="4243079168"/>
<aspace type="mprotect" size="4243079168"/>

=> This indicates *real* API usage of 4.2GiB.

</heap>
<heap nr="1">

=> This is arena 1, which is a thread heap, and uses mmap to create heaps.

<sizes>
  <size from="17" to="32" total="32" count="1"/>
  <size from="33" to="48" total="240" count="5"/>
  <size from="49" to="64" total="256" count="4"/>
  <size from="65" to="80" total="160" count="2"/>
  <size from="97" to="112" total="224" count="2"/>
  <size from="33" to="33" total="231" count="7"/>
  <size from="49" to="49" total="294" count="6"/>
  <size from="65" to="65" total="390" count="6"/>
  <size from="81" to="81" total="162" count="2"/>
  <size from="97" to="97" total="97" count="1"/>
  <size from="129" to="129" total="516" count="4"/>
  <size from="161" to="161" total="644" count="4"/>
  <size from="209" to="209" total="1254" count="6"/>
  <size from="241" to="241" total="241" count="1"/>
  <size from="257" to="257" total="257" count="1"/>
  <size from="305" to="305" total="610" count="2"/>
  <size from="32209" to="32209" total="32209" count="1"/>
  <size from="3982129" to="8059889" total="28065174" count="6"/>
  <unsorted from="209" to="4020593" total="4047069" count="13"/>
</sizes>
<total type="fast" count="14" size="912"/>
<total type="rest" count="61" size="42357420"/>

=> Pretty small, 912 bytes in fastbins, and 42MiB in cached chunks.

<system type="current" size="42426368"/>
<system type="max" size="42426368"/>
<aspace type="total" size="42426368"/>
<aspace type="mprotect" size="42426368"/>
<aspace type="subheaps" size="1"/>
</heap>
<total type="fast" count="14" size="912"/>
<total type="rest" count="62" size="42470108"/>
<total type="mmap" count="9" size="208683008"/>
<system type="current" size="4285505536"/>
<system type="max" size="4285505536"/>
<aspace type="total" size="4285505536"/>
<aspace type="mprotect" size="4285505536"/>
</malloc>
===============================================

This shows the application is USING memory on the main system heap.

It might not be "leaked" memory since the application might be using it.

You want visibility into what is USING that memory.

With glibc-malloc-trace-utils you can try to do that with:

LD_PRELOAD=libmtrace.so \
MTRACE_CTL_FILE=/home/user/app.mtr \
MTRACE_CTL_BACKTRACE=1 \
./app

This will use libgcc's unwinder to get a copy of the malloc caller
address and then we'll have to decode that based on a /proc/self/maps.

Next steps:
- Get a glibc-malloc-trace-utils trace of the application ratcheting.
- Get a copy of /proc/$PID/maps for the application (shorter version of smaps).

Then we might be able to correlate where all the kernel heap data went?

-- 
Cheers,
Carlos.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 14:59:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 09:59:34 2020
Received: from localhost ([127.0.0.1]:36668 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khwGc-0006ij-8H
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 09:59:34 -0500
Received: from mail-am6eur05olkn2011.outbound.protection.outlook.com
 ([40.92.91.11]:29437 helo=EUR05-AM6-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arthur.miller@HIDDEN>) id 1khwGa-0006iV-MY
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 09:59:33 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=RzC8LuN7x2z62ltG9Yxo5ubAYljf3WAOcq5P98+o2nLuCf9gHPmYkR6RTYVtKokislr+sghdKfgTwApJ4S2j6cthT1EPHU8V8rsJliJfL8g76O4GEPbUcWJQ840BsSA820WUlox1ghlekR8710LBiygOFyPhEThGDWba4WouHtrIU/gKGrhnnYZmLb9RmEKlbuu9k/feUJYN7fFCF+jlnPTPnNdtKDbegOgY3yNgfoaPJzgTSkLBYNx2Yr7Qy2mudG9+EYH7c+iNNgk8OpYwUJuRvdPk4UCRFlLsXoxwDbEyILcAG6sovQFlMr2Q49l0T7vj4a1XU+2iTsdE+6Cv4A==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=3w47K7sRf9NkS52fMLDhOVoKcQzoKebTxP4cVnFVWt4=;
 b=ZF7oDrFBKPD7j6qFpHBYhMN/e/o3SEh5J8qzi1Z0CtKG6tbt4F01OR4D9UIgUw9Zj/Fnpv7vkPdpc1GL1KolEH7sft7Yq2Bq3d1ilOzZ2WA/x3NM14lrPKtuuu//lToxOE8jiz+X5Et7ds0T2nRq6dx/sWj2pt14t6ArH0ShngMMuuSlqj74eOYuZNs2YXBOAByLGI9ozhWDnuSLW2WGO4SyQQ/2b0dqYb3M1IY65xiJnHbDg69DEZ5iJoVK97k4yIuGZJxe0qIQt5k4bcpsdwcYrsv+h9xEsPzmILwSnVvXx8SVc1CfW+wWeG2yLs+bgighXPXPlz+uzCKJmteeww==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=live.com; s=selector1; 
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=3w47K7sRf9NkS52fMLDhOVoKcQzoKebTxP4cVnFVWt4=;
 b=b/8llJNDJhlPF0JR99WdwIRPjRQffPz/k/8E12idjN/BLfD2DZrzHqxggBggVWIt6UKPw4PAx4KHzcRMbFk0qDYFD+8I6NXjvjVqT2YcspnNKgs63UrvNx3P2/9JbVjd1cHoEYeUZ466zMdcG1YcXR0HowhxU/UZGYFMGXke8RsGsA68t/OihLcP1n8/tuXlIR6VmIXAdqnoBxCC/XbIg8F8Hyh3XCYA70fw7zJEQWGoUWUorqytqTUK54Un7hBWo1WGwJ/hwNRc+pGdqMIeuZ4AefvlXXjqVc9QOUJQS8wHYLo2Tf9cjBsHUzy+3FnxY6CRMA1Oy0rgmeAu4nNPDA==
Received: from VI1EUR05FT058.eop-eur05.prod.protection.outlook.com
 (2a01:111:e400:fc12::4e) by
 VI1EUR05HT236.eop-eur05.prod.protection.outlook.com (2a01:111:e400:fc12::405)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20; Wed, 25 Nov
 2020 14:59:25 +0000
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 (2a01:111:e400:fc12::43) by VI1EUR05FT058.mail.protection.outlook.com
 (2a01:111:e400:fc12::344) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20 via Frontend
 Transport; Wed, 25 Nov 2020 14:59:25 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:7B9D3AD7FFAD0FF40C73DB153BDAD0905932A47F59229C56F66485AAE3276E8C;
 UpperCasedChecksum:681AB2DBF5E9317694B34A24E4C49DE3586202ABCD18FC2C3E72D68321DC005F;
 SizeAsReceived:8167; Count:46
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993]) by AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993%7]) with mapi id 15.20.3589.030; Wed, 25 Nov 2020
 14:59:25 +0000
From: Arthur Miller <arthur.miller@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <X7wcMpkuuE01Ciwb@HIDDEN>
 <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
 <X7yaS5sPWR60tpHD@HIDDEN>
 <AM0PR06MB6577D6DAA08B505246A5360596FB0@HIDDEN>
 <X7zM+wOib15X3tsj@HIDDEN>
 <AM0PR06MB6577E3883B73F33C016A68F296FB0@HIDDEN>
 <X71AWQBI5rwPA/+j@HIDDEN>
Date: Wed, 25 Nov 2020 15:59:21 +0100
In-Reply-To: <X71AWQBI5rwPA/+j@HIDDEN> (Jean Louis's message of
 "Tue, 24 Nov 2020 20:18:17 +0300")
Message-ID: <AM0PR06MB65776B9CDA3D0C49B9B46F0396FA0@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Content-Type: text/plain
X-TMN: [4gpxng3ZBw+YwBA7OQu2ezB6b4PrF3hD]
X-ClientProxiedBy: AM5PR0202CA0011.eurprd02.prod.outlook.com
 (2603:10a6:203:69::21) To AM0PR06MB6577.eurprd06.prod.outlook.com
 (2603:10a6:208:19a::23)
X-Microsoft-Original-Message-ID: <87sg8x8oty.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from pascal.homepc (90.230.29.56) by
 AM5PR0202CA0011.eurprd02.prod.outlook.com (2603:10a6:203:69::21) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3611.20 via Frontend
 Transport; Wed, 25 Nov 2020 14:59:24 +0000
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 46
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 13aebbab-21aa-45a4-8a1e-08d89152b33b
X-MS-TrafficTypeDiagnostic: VI1EUR05HT236:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: /phPXQn5XAN1GpVhwMDB0+TMoi4TIJtYNTJ2atQAUMdqI5BI+xaPSmb6FlhM3ftHNtfTRQVG017933IWdgDfIHzEgZ20I5BPyXaVyBY8qqPQAPOQmjsxs/MqH8/L3nPz4iOAWvNCdpO9AbYYE+PU3LFfJAnjKvPXYZyMa2N5/dbp4kLolC650Ac7rtZvAnJctKAoPEP6oI2tMjNV84mB/g==
X-MS-Exchange-AntiSpam-MessageData: jDeZAXhZpKCoQuC2ne/14X3QkkTed5DKKb+GhLRMY6evahnZbRKGk5b8PB+9oRhTWMdGCgV/9OUGlTqfcMtcLD1gvUTELHy+TxRfinoDrS7yinsYqMv1tVfnerVZto0E2D6IvgyodFgrbBYbu6d+Zw==
X-OriginatorOrg: live.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 13aebbab-21aa-45a4-8a1e-08d89152b33b
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 25 Nov 2020 14:59:25.8382 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-AuthSource: VI1EUR05FT058.eop-eur05.prod.protection.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Anonymous
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: VI1EUR05HT236
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Jean Louis <bugs@HIDDEN> writes:

> * Arthur Miller <arthur.miller@HIDDEN> [2020-11-24 12:27]:
>> Yepp; but I am not on lts-kernel, that is probably why.
>
> I think it is the other issue that you hve many packages, I also have
> many for Gnome and KDE but do not get updates, maybe I use mirror that
> is not updated. I will see that.
>
>> > So you have Hyperbola and you get updates every day? How comes?
>> No Hyperbola don't even know what distro it is; Just Arch Linux
>> here.
>
> Well then it is different thing. You are updating from different
> repository than me.
>
>> Harddrive is cheap nowdays. I have entire kde/gnome stack installed; and
>> lots more. When I need to compile a library or application I don't want
>> ot chase dependencies around. I just don't use them as desktops and
>> don't run apps.  For example yesterday I was just able to git clone
>> heaptrack and compile it, no headaches.
>
> That is different OS and Hyperbola is different. Arch Linux has lax policy
> against non-free software, while Hyperbola GNU/Linux-libre has very
> strict policy and does not allow anything non-free, that is reason I
> am using it. It does not use systemd trap and is working stable.
>
> Few times I got problem with building for example webkit, but
> otherwise anything builds pretty well.
>
> Hyperbola is independent project that receives little support, it
> should receive so much more. They will also create new HyperbolaBSD
> system that will move an OpenBSD kernel into GNU GPL direction.
>
> Jean
Oki; thansk. I never heard of the Hypberbola before.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 10:22:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 25 05:22:26 2020
Received: from localhost ([127.0.0.1]:34490 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khrwQ-0005kB-7V
	for submit <at> debbugs.gnu.org; Wed, 25 Nov 2020 05:22:26 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:55476)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1khrwO-0005jv-2x
 for 43389 <at> debbugs.gnu.org; Wed, 25 Nov 2020 05:22:24 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id 7123360808;
 Wed, 25 Nov 2020 11:22:17 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606299737;
 bh=XUiOLQ3BdxJ8iTci8bnH0T9bgVGBHTNdvLIwCC9Uubw=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=O94jvT6gax5yd2L00+fjJo/khRHIW6FV9JhyLwiQWLtrowCusilgysEMgNjFFv3JU
 rFgG8xzfcHZ81iYnSY4zmErf6137Ffk26oeCWiTD8/CqOeSKbx1jogDNXhvoL6gG6N
 Gg1smFJBKC1BTqARceKKz/4lBtSbY55bJp4XQgog=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83d002tuoo.fsf@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN> <83d002tuoo.fsf@HIDDEN>
Date: Wed, 25 Nov 2020 11:22:16 +0100
Message-ID: <87d001u46f.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes: 
>> Some interesting observations: 
>>  - (garbage-collect) takes forever, like on the order of 5-10 
>>  minutes, with one CPU core pegged to 100% and emacs frozen. 
> 
> Is this with the default values of gc-cons-threshold and 
> gc-cons-percentage? 

Yes, and they're both printed in the logs: threshold 800000, 
percentage 0.1.
 
>>  - The leaking stops for a while after (garbage-collect).  It 
>>  was  leaking 1MB per second for this last log, and stopped 
>>  growing  after the garbage collection. 
> 
> Now, what happens in that session once per second (in an 
> otherwise idle Emacs, I presume?) to cause such memory 
> consumption?  Some timers?  If you run with a breakpoint in 
> malloc that just shows the backtrace and continues, do you see 
> what could consume 1MB every second? 

Not an idle emacs at all, in this case.  I have seen the memory 
growth in an idle emacs, but the only one I can reproduce it on is 
the emacs-slack one, which is connected to a corporate Slack 
account.  Tons of short messages streaming in over the network and 
being displayed in rotating buffers, with images mixed in.  It's a 
big 'ol "web 2.0" API... it can easily pass 1MB/s of bloated JSON 
messages through.  This is one _very active_ emacs.

The original strace logs and valgrind output I posted before 
showed a random assortment of calls from gnutls, imagemagick, and 
lisp strings, with lisp strings dominating the malloc calls 
(enlarge_buffer_text, mostly).
 
>> Is there any way to get the same info without actually reaping 
>> dead references? 
> 
> What do you mean by "reaping dead references" here? 
> 
>> It could be that there really were 4.3GB of dead references. 
> 
> Not sure I understand what are you trying to establish here. 
>

GC is running through a list of active allocations and freeing the 
ones with no remaining references, right?  Presumably, if a lot of 
active malloc() allocations are no longer refernced, and 
(garbage-collect) calls free() on a bunch of blocks.  I'm 
wondering how to figure out how much memory a call to 
(garbage-collect) has actually freed.  Possibly a sort of "dry 
run" where it performs the GC algorithm, but doesn't release any 
memory.

(I'm very much assuming how emacs memory management works.  Please 
corect me if I'm wrong.)
 
> There's only one garbage-collect, it is called for _any_ GC. 
> 
> What do you mean by "during normal use" in this sentence: 
> 
>   I certainly don't notice 5-10 minute long pauses during normal 
>   use, though "gcs-done" is incrementing. 
> 
> How is what you did here, where GC took several minutes, 
> different from "normal usage"?

In this log, I am explicitly executing "(garbage-collect)", and it 
takes 10 minutes, during which the UI is unresponsive and 
sometimes even turns grey when the window stops redrawing.

By "normal use", I mean that I use this emacs instance on-and-off 
all day long.  I would notice if it were freezing for minutes at a 
time, and it definitely is not.

As far as I understand, garbage collection is supposed to happen 
automatically during idle.  I would certainly notice if it locked 
up the whole instance for 10 minutes from an idle GC.  I think 
this means the automatic garbage collection is either not 
happening, or running on a different thread, or being interrupted, 
or simply works differently.  I have no idea, hence asking you :)

The confusing part is that "gcs-done" increments a lot between my 
manual (garbage-collect) calls.  It looks like it does about 500 
per day.  There is no way emacs freezes and pegs a CPU core to max 
500 times per day, but it does exactly that every time I manually 
execute garbage-collect. 

Side note: it inflated to 7670MB overnight.  I'm running 
(garbage-collect) as I type this, but it has been churning for 30 
minutes with the UI frozen, and still isn't done.  I'm going to 
give up and kill it if it doesn't finish soon, as I kind of need 
that 8GB back.
 
-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 25 Nov 2020 04:23:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 23:23:53 2020
Received: from localhost ([127.0.0.1]:33829 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khmLR-00032y-JW
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 23:23:53 -0500
Received: from static.rcdrun.com ([95.85.24.50]:42465)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1khmLP-00032k-Ax
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 23:23:52 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C1AE8.000000005FBDDC51.00002A16; Wed, 25 Nov 2020 04:23:44 +0000
Date: Tue, 24 Nov 2020 20:18:17 +0300
From: Jean Louis <bugs@HIDDEN>
To: Arthur Miller <arthur.miller@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X71AWQBI5rwPA/+j@HIDDEN>
References: <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <X7wcMpkuuE01Ciwb@HIDDEN>
 <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
 <X7yaS5sPWR60tpHD@HIDDEN>
 <AM0PR06MB6577D6DAA08B505246A5360596FB0@HIDDEN>
 <X7zM+wOib15X3tsj@HIDDEN>
 <AM0PR06MB6577E3883B73F33C016A68F296FB0@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <AM0PR06MB6577E3883B73F33C016A68F296FB0@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * Arthur Miller <arthur.miller@HIDDEN> [2020-11-24 12:27]:
 > Yepp; but I am not on lts-kernel, that is probably why. I think it is the
 other issue that you hve many packages, I also have many for Gnome and KDE
 but do not get updates, maybe I use mirror that is not updated. I will see
 that. Content analysis details:   (1.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 1.1 DATE_IN_PAST_06_12     Date: is 6 to 12 hours before Received: date
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: live.com]
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

* Arthur Miller <arthur.miller@HIDDEN> [2020-11-24 12:27]:
> Yepp; but I am not on lts-kernel, that is probably why.

I think it is the other issue that you hve many packages, I also have
many for Gnome and KDE but do not get updates, maybe I use mirror that
is not updated. I will see that.

> > So you have Hyperbola and you get updates every day? How comes?
> No Hyperbola don't even know what distro it is; Just Arch Linux
> here.

Well then it is different thing. You are updating from different
repository than me.

> Harddrive is cheap nowdays. I have entire kde/gnome stack installed; and
> lots more. When I need to compile a library or application I don't want
> ot chase dependencies around. I just don't use them as desktops and
> don't run apps.  For example yesterday I was just able to git clone
> heaptrack and compile it, no headaches.

That is different OS and Hyperbola is different. Arch Linux has lax policy
against non-free software, while Hyperbola GNU/Linux-libre has very
strict policy and does not allow anything non-free, that is reason I
am using it. It does not use systemd trap and is working stable.

Few times I got problem with building for example webkit, but
otherwise anything builds pretty well.

Hyperbola is independent project that receives little support, it
should receive so much more. They will also create new HyperbolaBSD
system that will move an OpenBSD kernel into GNU GPL direction.

Jean




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 19:35:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 14:35:15 2020
Received: from localhost ([127.0.0.1]:33056 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khe5r-0000jZ-If
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 14:35:15 -0500
Received: from eggs.gnu.org ([209.51.188.92]:47540)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1khe5p-0000jM-1f
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 14:35:13 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49575)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1khe5j-00041u-BD; Tue, 24 Nov 2020 14:35:07 -0500
Received: from [176.228.60.248] (port=1958 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1khe5h-0006ap-OB; Tue, 24 Nov 2020 14:35:06 -0500
Date: Tue, 24 Nov 2020 21:35:03 +0200
Message-Id: <83d002tuoo.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87ft4ytw2c.fsf@HIDDEN> (message from Trevor
 Bentley on Tue, 24 Nov 2020 20:05:15 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
 <87ft4ytw2c.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: bugs@HIDDEN, fweimer@HIDDEN, 43389 <at> debbugs.gnu.org,
>  dj@HIDDEN, michael_heerdegen@HIDDEN, carlos@HIDDEN
> Cc: 
> Date: Tue, 24 Nov 2020 20:05:15 +0100
> 
> I just updated the log on my website.  Same instance a day later, 
> after yet another memory spike up to 4.3GB.  Concatenated to the 
> end:
> 
> https://trevorbentley.com/emacs_malloc_info.log

I don't think I can interpret that.  In particular, how come "total"
is 4GB, but I see no comparable sizes in any of the other fields?
where do those 4GB hide?  Carlos, can you help interpreting this
report?

> Some interesting observations:
>  - (garbage-collect) takes forever, like on the order of 5-10 
>  minutes, with one CPU core pegged to 100% and emacs frozen.

Is this with the default values of gc-cons-threshold and
gc-cons-percentage?

>  - The leaking stops for a while after (garbage-collect).  It was 
>  leaking 1MB per second for this last log, and stopped growing 
>  after the garbage collection.

Now, what happens in that session once per second (in an otherwise
idle Emacs, I presume?) to cause such memory consumption?  Some
timers?  If you run with a breakpoint in malloc that just shows the
backtrace and continues, do you see what could consume 1MB every
second?

> Question 1: (garbage-collect) shows the memory usage *after* 
> collecting, right?

Yes.

> Is there any way to get the same info without actually reaping dead
> references?

What do you mean by "reaping dead references" here?

> It could be that there really were 4.3GB of dead references.

Not sure I understand what are you trying to establish here.

> Question 2: are the background garbage collections equivalent to 
> the (garbage-collect) function?  I certainly don't notice 5-10 
> minute long pauses during normal use, though "gcs-done" is 
> incrementing.  Does it have a different algorithm for partial 
> collection during idle, perhaps?

There's only one garbage-collect, it is called for _any_ GC.

What do you mean by "during normal use" in this sentence:

  I certainly don't notice 5-10 minute long pauses during normal use,
  though "gcs-done" is incrementing.

How is what you did here, where GC took several minutes, different
from "normal usage"?

> Question 3: I've never used the malloc_trim() function.  Could 
> that be something worth experimenting with, to see if it releases 
> any of the massive heap back to the OS?

That's for glibc guys to answer.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 19:05:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 14:05:24 2020
Received: from localhost ([127.0.0.1]:33017 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khdcy-0008Sl-GU
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 14:05:24 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:51174)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1khdcw-0008SX-U8
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 14:05:23 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id EA406607BA;
 Tue, 24 Nov 2020 20:05:16 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606244717;
 bh=lrZ4UZz4bniK0yXJj4ipYK+kJ+E7qoIIV1KYtbwXl6w=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=oJXBO9GDsFpZ1+DqwZwkA3zV74oitJV43/9Qaj47/e4W4x/Q0RApDf/pXGyQ8U8Za
 uTi2870XAE1qG9u3Ofi+TQe9hkTgvM/Lgqa7qP1Zl/tZrLOuOSxHv4q/JuKn2/rpsl
 sLgWkWIjQPsyUH9oNVjQW0uNIIE7qR0jLID6ok9k=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83o8jmu49z.fsf@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN> <83o8jmu49z.fsf@HIDDEN>
Date: Tue, 24 Nov 2020 20:05:15 +0100
Message-ID: <87ft4ytw2c.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:
> 
> Look at the large chunks in the tail of this.  Together, they do 
> account for ~2GB. 
> 
> Carlos, are these chunks in use (i.e. allocated and not freed), 
> or are they the free chunks that are available for allocation, 
> but not released to the OS?  If the former, then it sounds like 
> this session does have around 2GB of allocated heap data, so 
> either there's some allocated memory we don't account for, or 
> there is indeed a memory leak in Emacs.  If these are the free 
> chunks, then the way glibc manages free'd memory is indeed an 
> issue. 

I just updated the log on my website.  Same instance a day later, 
after yet another memory spike up to 4.3GB.  Concatenated to the 
end:

https://trevorbentley.com/emacs_malloc_info.log

Some interesting observations:
 - (garbage-collect) takes forever, like on the order of 5-10 
 minutes, with one CPU core pegged to 100% and emacs frozen.
 - The leaking stops for a while after (garbage-collect).  It was 
 leaking 1MB per second for this last log, and stopped growing 
 after the garbage collection.

Question 1: (garbage-collect) shows the memory usage *after* 
collecting, right?  Is there any way to get the same info without 
actually reaping dead references?  It could be that there really 
were 4.3GB of dead references.

Question 2: are the background garbage collections equivalent to 
the (garbage-collect) function?  I certainly don't notice 5-10 
minute long pauses during normal use, though "gcs-done" is 
incrementing.  Does it have a different algorithm for partial 
collection during idle, perhaps?

Question 3: I've never used the malloc_trim() function.  Could 
that be something worth experimenting with, to see if it releases 
any of the massive heap back to the OS?

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 16:08:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 11:08:05 2020
Received: from localhost ([127.0.0.1]:60996 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kharM-0006Ed-SB
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 11:08:05 -0500
Received: from eggs.gnu.org ([209.51.188.92]:52326)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kharL-0006E7-J8
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 11:08:03 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46637)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kharE-0007t9-Az; Tue, 24 Nov 2020 11:07:56 -0500
Received: from [176.228.60.248] (port=1112 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kharC-0001Pp-WD; Tue, 24 Nov 2020 11:07:55 -0500
Date: Tue, 24 Nov 2020 18:07:52 +0200
Message-Id: <83o8jmu49z.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Trevor Bentley <trevor@HIDDEN>
In-Reply-To: <87o8jnu5f2.fsf@HIDDEN> (message from Trevor
 Bentley on Mon, 23 Nov 2020 22:30:57 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Trevor Bentley <trevor@HIDDEN>
> Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
>  michael_heerdegen@HIDDEN, carlos@HIDDEN
> Cc: 
> Date: Mon, 23 Nov 2020 22:30:57 +0100
> 
> ;;--------------------------------------
> ;;--------------------------------------
> ;; 3 days later
> ;; RSS was steady at 1150MB
> ;; leaped to 2.3GB very suddenly
> ;;
> ;; RSS 2311M
> ;;--------------------------------------
> ;;--------------------------------------

> ;; ~182MB
> (let ((size 0))
>   (dolist (buffer (buffer-list) size)
>     (setq size (+ size (buffer-size buffer)))))
> 182903045
> 
> ;; sums to ~142MB if I'm reading it right?
> (garbage-collect)
> ((conses 16 2081486 2630206) (symbols 48 61019 79) (strings 32 353371 288980) (string-bytes 1 13294206) (vectors 16 144742) (vector-slots 8 9503757 592939) (floats 8 2373 8320) (intervals 56 46660 10912) (buffers 992 82))

> (reduce '+ (cl-loop for thing in (garbage-collect)
>                     collect (* (nth 1 thing) (nth 2 thing))))
> 142115406
> 
> ;; malloc-info
> (malloc-info)
> <malloc version="1">
> <heap nr="0">
> <sizes>
>   <size from="33" to="48" total="240" count="5"/>
>   <size from="113" to="128" total="128" count="1"/>
> [...]
>   <size from="3137" to="3569" total="2372709" count="709"/>
>   <size from="3585" to="4081" total="1847856" count="480"/>
>   <size from="4097" to="4593" total="5672856" count="1320"/>
>   <size from="4609" to="5105" total="4675836" count="956"/>
>   <size from="5121" to="5617" total="6883318" count="1286"/>
>   <size from="5633" to="6129" total="6011919" count="1023"/>
>   <size from="6145" to="6641" total="6239871" count="975"/>
>   <size from="6657" to="7153" total="6540165" count="949"/>
>   <size from="7169" to="7665" total="5515848" count="744"/>
>   <size from="7681" to="8177" total="5148216" count="648"/>
>   <size from="8193" to="8689" total="8190223" count="975"/>
>   <size from="8705" to="9201" total="5854315" count="651"/>
>   <size from="9217" to="9713" total="5312354" count="562"/>
>   <size from="9729" to="10225" total="5154212" count="516"/>
>   <size from="10241" to="10737" total="4074005" count="389"/>
>   <size from="10753" to="12273" total="11387550" count="990"/>
>   <size from="12289" to="16369" total="32661229" count="2317"/>
>   <size from="16385" to="20465" total="36652437" count="2037"/>
>   <size from="20481" to="24561" total="21272131" count="947"/>
>   <size from="24577" to="28657" total="25462302" count="958"/>
>   <size from="28673" to="32753" total="28087234" count="914"/>
>   <size from="32769" to="36849" total="39080113" count="1121"/>
>   <size from="36865" to="40945" total="30141527" count="775"/>
>   <size from="40961" to="65521" total="166092799" count="3119"/>
>   <size from="65537" to="98289" total="218425380" count="2692"/>
>   <size from="98321" to="131057" total="178383171" count="1555"/>
>   <size from="131089" to="163825" total="167800886" count="1142"/>
>   <size from="163841" to="262065" total="367649915" count="1819"/>
>   <size from="262161" to="522673" total="185347984" count="560"/>
>   <size from="525729" to="30878897" total="113322865" count="97"/>

Look at the large chunks in the tail of this.  Together, they do
account for ~2GB.

Carlos, are these chunks in use (i.e. allocated and not freed), or are
they the free chunks that are available for allocation, but not
released to the OS?  If the former, then it sounds like this session
does have around 2GB of allocated heap data, so either there's some
allocated memory we don't account for, or there is indeed a memory
leak in Emacs.  If these are the free chunks, then the way glibc
manages free'd memory is indeed an issue.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 09:27:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 04:27:37 2020
Received: from localhost ([127.0.0.1]:57675 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khUbg-00089o-Me
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 04:27:37 -0500
Received: from mail-oln040092072086.outbound.protection.outlook.com
 ([40.92.72.86]:52358 helo=EUR03-VE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arthur.miller@HIDDEN>) id 1khUbe-00089X-Dp
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 04:27:26 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=OiF6fuNJQ59YSNT+PQXx4p6MZI5i0d4MGi8zodPAPeENWke8pBDydQFAgz60rl2FFRm5cBQJhK8UDNqbrzsY+cYRoyjWpu+oRP5cdYNgWJ9szIQEVizhUDfYlyd5+EymjH7ccWXe8waKqKCebtOGJaVMKMUATQN3vpKR5UUf/bY2nHLhi326s2bazItEEfrU6VgPFhrm+wBSrX9KL8WzUIV2Uv+Eufe49/53nj2LpewMl6ugQJNjVyKwuaR5LK12z0VEtyCLVr5tL5i8Eud5E80fQ3q4IwR3VwIt0IPkNKKVScz+mKBR5oOKT3xPU+DDjbeL961sLdO2bRv6XFRUBQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=/mvk7RfOvnN6DGB33tdvwdvJP69mUy0RtCCxBrc+brA=;
 b=IUVSEaBIA2pxylk1434G2tuCBryehrATf6RJxK5jWIpXvO68Z+ME0obmIx4oVKwsl1M5mR415kqmhBvnhRIiGFC80eHKvf+a9ETQAPrvyo/RCPxTJaVfgCGX0hBoHKLp2Dp+ldyE1slvtNId6TyVZXaw/NVVfmHDhKkc/ZWmqNO4jq8Kzk/UY+vZCEdvV8FFIKepWa7fdsm9v76cBRlzkIZpqsVPOLJaVma6xRkQlNCKAYNkoIg+yr8oGFVmsmQXrRPupc+ZlQF0Bmdhzpq/8C1DP5zQze0V3Nd56N7ccbQdKcSDfAKcRgb2uT7LWKM8RDVG1xI2qegpsTvtahBtwA==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=live.com; s=selector1; 
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=/mvk7RfOvnN6DGB33tdvwdvJP69mUy0RtCCxBrc+brA=;
 b=HCn6ddoCpVlFyk+OjN3h0ETZUju0k2SkBMv8nbiC5xcimMJusZQqaz7BPkd5IIM9qjPEH9pzcTYD7iCJM34Sy2+GOPw44VUHWIJfRMT+KPPhdH3JbUDjF8T7UEXYEcvMxz9SlLJ3ZfVSmVSkbCX13CQMLreNzVpgjJLOT/dZfCN9zKd5q4Qx6shV5vGcrVQF+Oy9EXR/WfQiuaK7GMmYk86KfMOsrBvAVMP/tRd/y6V41e9OyoA7nOLpu6oehqrhTWzKviSQ67Z+qX+knwXqPN8ccj6LePKM8/Szl7N7jpiL3YfPZPZLi1qk8f7f3U8Z8KBGxhueV4wgni7hq6D10A==
Received: from DB5EUR03FT032.eop-EUR03.prod.protection.outlook.com
 (2a01:111:e400:7e0a::40) by
 DB5EUR03HT155.eop-EUR03.prod.protection.outlook.com (2a01:111:e400:7e0a::211)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20; Tue, 24 Nov
 2020 09:27:19 +0000
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 (2a01:111:e400:7e0a::46) by DB5EUR03FT032.mail.protection.outlook.com
 (2a01:111:e400:7e0a::162) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20 via Frontend
 Transport; Tue, 24 Nov 2020 09:27:19 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:444B315375D170D70388827B878043D0F129EB9C16BDD8AD9574DFD0273CF329;
 UpperCasedChecksum:F90CD1934ACC56D229092DB3C9B76CFD65ADDD8819B6063452EAD12E85A1BC76;
 SizeAsReceived:8164; Count:46
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993]) by AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993%7]) with mapi id 15.20.3589.030; Tue, 24 Nov 2020
 09:27:18 +0000
From: Arthur Miller <arthur.miller@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <BE101E85-568B-4B5C-A8A1-8FBA4726841C@HIDDEN>
 <AM0PR06MB657755833A2EC0DD73BF5BC596FC0@HIDDEN>
 <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <X7wcMpkuuE01Ciwb@HIDDEN>
 <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
 <X7yaS5sPWR60tpHD@HIDDEN>
 <AM0PR06MB6577D6DAA08B505246A5360596FB0@HIDDEN>
 <X7zM+wOib15X3tsj@HIDDEN>
Date: Tue, 24 Nov 2020 10:27:17 +0100
In-Reply-To: <X7zM+wOib15X3tsj@HIDDEN> (Jean Louis's message of
 "Tue, 24 Nov 2020 12:06:03 +0300")
Message-ID: <AM0PR06MB6577E3883B73F33C016A68F296FB0@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Content-Type: text/plain
X-TMN: [C4KsQAaBOIOPNBLNQRAKU4YFi7zOt9lW]
X-ClientProxiedBy: AS8PR04CA0069.eurprd04.prod.outlook.com
 (2603:10a6:20b:313::14) To AM0PR06MB6577.eurprd06.prod.outlook.com
 (2603:10a6:208:19a::23)
X-Microsoft-Original-Message-ID: <877dqb2jgq.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from pascal.homepc (90.230.29.56) by
 AS8PR04CA0069.eurprd04.prod.outlook.com (2603:10a6:20b:313::14) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3611.20 via Frontend
 Transport; Tue, 24 Nov 2020 09:27:18 +0000
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 46
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: b2495917-d0b4-4b24-9ef1-08d8905b2378
X-MS-TrafficTypeDiagnostic: DB5EUR03HT155:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: qe+1Rch/C0aSYqLHVf2MOZKVBZ3VvIsk5getkeqsyII0G/0aLKZs526zZbUMR8MYreoA33fsj6lh4FO7sctm/3ESPYae36AtWh1b6HzozWrDgcF/R00fdx6BsgwQnAFN4t3hTeZ+0jC0orYJqjs35h7ncRILmXbs7j+32bUUaikciscYrpuzJnNddotzoTDdzPU+ypDOPtQGkqaN7ROJbQ==
X-MS-Exchange-AntiSpam-MessageData: 7PbGjpeEZWfxf4Sh0SOq5kfzwJt+sGCgoPXUROSUEKuH89CjIZnJJ8TBUxDGkQL8hGLx+lB2u1PJZUu+knF0E06ZxIhMKzONR+/jco49dbHt5tpEH8gu0OT9IcQwte8FrCqJPnOAot5Pi8mIbDqoZg==
X-OriginatorOrg: live.com
X-MS-Exchange-CrossTenant-Network-Message-Id: b2495917-d0b4-4b24-9ef1-08d8905b2378
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 24 Nov 2020 09:27:18.7503 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-AuthSource: DB5EUR03FT032.eop-EUR03.prod.protection.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Anonymous
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: DB5EUR03HT155
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Jean Louis <bugs@HIDDEN> writes:

> * Arthur Miller <arthur.miller@HIDDEN> [2020-11-24 11:15]:
>> > I am pulling Emacs from git and consider system upgraded that way.
>> same here
>> 
>> > For system packages, pacman says there is nothing to do most of time,
>> > unless there is new kernel or some security issue.
>> 
>> Aha, you are running LTS kernel?
>> 
>> Mine pacman brings in updates every day.
>
> Really?
Yepp; but I am not on lts-kernel, that is probably why.

> /boot:
>
> config-linux-libre-lts
> grub
> initramfs-linux-libre-lts-fallback.img
> initramfs-linux-libre-lts.img
> vmlinuz-linux-libre-lts
>
> So you have Hyperbola and you get updates every day? How comes?
No Hyperbola don't even know what distro it is; Just Arch Linux here.

I guess because I am not on lts-kernel and probably because I have lots
of stuff installed.

Harddrive is cheap nowdays. I have entire kde/gnome stack installed; and
lots more. When I need to compile a library or application I don't want
ot chase dependencies around. I just don't use them as desktops and
don't run apps.  For example yesterday I was just able to git clone
heaptrack and compile it, no headaches.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 09:10:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 04:10:36 2020
Received: from localhost ([127.0.0.1]:57639 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khULL-0007ih-JV
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 04:10:35 -0500
Received: from static.rcdrun.com ([95.85.24.50]:44863)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1khULK-0007iV-RF
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 04:10:35 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C0003.000000005FBCCE04.00006CE8; Tue, 24 Nov 2020 09:10:27 +0000
Date: Tue, 24 Nov 2020 12:06:03 +0300
From: Jean Louis <bugs@HIDDEN>
To: Arthur Miller <arthur.miller@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X7zM+wOib15X3tsj@HIDDEN>
References: <BE101E85-568B-4B5C-A8A1-8FBA4726841C@HIDDEN>
 <AM0PR06MB657755833A2EC0DD73BF5BC596FC0@HIDDEN>
 <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <X7wcMpkuuE01Ciwb@HIDDEN>
 <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
 <X7yaS5sPWR60tpHD@HIDDEN>
 <AM0PR06MB6577D6DAA08B505246A5360596FB0@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <AM0PR06MB6577D6DAA08B505246A5360596FB0@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Arthur Miller <arthur.miller@HIDDEN> [2020-11-24 11:15]:
> > I am pulling Emacs from git and consider system upgraded that way.
> same here
> 
> > For system packages, pacman says there is nothing to do most of time,
> > unless there is new kernel or some security issue.
> 
> Aha, you are running LTS kernel?
> 
> Mine pacman brings in updates every day.

Really?

/boot:

config-linux-libre-lts
grub
initramfs-linux-libre-lts-fallback.img
initramfs-linux-libre-lts.img
vmlinuz-linux-libre-lts

So you have Hyperbola and you get updates every day? How comes?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 08:15:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 03:15:32 2020
Received: from localhost ([127.0.0.1]:57382 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khTU3-0000Al-Kb
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 03:15:31 -0500
Received: from mail-oln040092067072.outbound.protection.outlook.com
 ([40.92.67.72]:60830 helo=EUR02-AM5-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arthur.miller@HIDDEN>) id 1khTU1-0008Ue-O5
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 03:15:30 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=b2maJ8bH+pwT6OgpCbqGNJqsxwwZMJt0m1CEDkTnxcAxunvJJzjO12DLtFipMnVvZ0z9WdqyhP7NGmTdHUOCU/u3o9Yse4MNElj3Cu1xKMY4xa+mBUo6q0UnijMqAYMsfnWwH0h82GbIbPIqDF4FY1whSVgcJp33/gn4fqnJWAS6/LaTN8A71K5lW5OI2redQRTyjrarPsSy5pu/x0u7KlDHaAozslVn9nZuTPN8pe0Ve8Lhb2yxzFn/D2bAZh1E4pS3WlrhJwz8BKgMEzhDrippdvnwR4Wx2SOktCGK/i3sEYJcd+1BHCaOFzM4ZwYbMA0iLDN4kTYgcdxozf1PRQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=2/XHCD+bzJVEiw9Sav+JhZb4Gf1KJNejCCrd996Puzo=;
 b=NTmwkr8Tppw3VWCMjKL/to+Wz9fbZsSa/9c/FMWjv+nw+pkUmPgHVKS3BQkuYJ4TAaVHdrcCUyfMB6KnbQQQZOS3ARU0XXC08m3cVWMC7etEgMks6ewUUr4Kx0mp5gm791He9XIZ1Da2ot54/xYEveO+GhNl0dIs2zo39nPZZEZD1gCnT9tf1DV9QrAC9LDEHJ0AxAky7xfbbpJpNKJXg3dXIm1/LhciFyd1hML7SBAJfSSqIw8vy1XOyVn3ZF1GshNSk9n9tFwOk8RuCwHT4UVe28XViZDu4ucIGp50aiDeajDKLFe+Bglceo05EDLAS/ZHh6WuenZuWc4IP71wCg==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=live.com; s=selector1; 
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=2/XHCD+bzJVEiw9Sav+JhZb4Gf1KJNejCCrd996Puzo=;
 b=YQpW4537vxwpF3fFYw0CD4GBO8+eZfuI/KDWLfOnnwj9Ryfsuxv+EY9V8XRJIk5rxFqDdgUKAdaB5nGrV6hucagv4ufIn80iJKT2ybRtH7jZEtX8qc8gX4BQR+6AYzGVrVnykjqrFsXwzRNMEzptdDz5h/lSJ2egkaVaSENE0IRyYKV0qDwBlQT4T2ItLOsZ5OJTQ79+SyUVBqcjYYnvt4d6JB4hwXkj5+g5+dnHlmNFYx5qDBUyudDqv1EcZ91K3RHtR+VtePOgiIC0iIZn9kQ78SrIChCTiMeO3m453mkujB14Rq9HnCHxYrVm6jn4/HxnTD+2vXJSRs3+KuKkRQ==
Received: from HE1EUR02FT050.eop-EUR02.prod.protection.outlook.com
 (2a01:111:e400:7e1d::50) by
 HE1EUR02HT168.eop-EUR02.prod.protection.outlook.com (2a01:111:e400:7e1d::291)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20; Tue, 24 Nov
 2020 08:15:21 +0000
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 (2a01:111:e400:7e1d::40) by HE1EUR02FT050.mail.protection.outlook.com
 (2a01:111:e400:7e1d::465) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20 via Frontend
 Transport; Tue, 24 Nov 2020 08:15:21 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:AA2D22FD5C066EA5C2728BE7086BF298F97E869B28562D20E9B9B1EE57AA0D32;
 UpperCasedChecksum:ED68B9CEA2C227C1C8F477E5B39CE6A2AB61B00F621A0E0FB838B8BB186EAE1F;
 SizeAsReceived:8109; Count:46
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993]) by AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993%7]) with mapi id 15.20.3589.030; Tue, 24 Nov 2020
 08:15:21 +0000
From: Arthur Miller <arthur.miller@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83k0udw3jb.fsf@HIDDEN> <X7tuqkYiZHYxQpcQ@HIDDEN>
 <BE101E85-568B-4B5C-A8A1-8FBA4726841C@HIDDEN>
 <AM0PR06MB657755833A2EC0DD73BF5BC596FC0@HIDDEN>
 <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <X7wcMpkuuE01Ciwb@HIDDEN>
 <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
 <X7yaS5sPWR60tpHD@HIDDEN>
Date: Tue, 24 Nov 2020 09:15:20 +0100
In-Reply-To: <X7yaS5sPWR60tpHD@HIDDEN> (Jean Louis's message of
 "Tue, 24 Nov 2020 08:29:47 +0300")
Message-ID: <AM0PR06MB6577D6DAA08B505246A5360596FB0@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Content-Type: text/plain
X-TMN: [GLSgXCeY+YlCCibsohH8rc/1HLf06nGJ]
X-ClientProxiedBy: AM6P194CA0067.EURP194.PROD.OUTLOOK.COM
 (2603:10a6:209:84::44) To AM0PR06MB6577.eurprd06.prod.outlook.com
 (2603:10a6:208:19a::23)
X-Microsoft-Original-Message-ID: <87k0ub2msn.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from pascal.homepc (90.230.29.56) by
 AM6P194CA0067.EURP194.PROD.OUTLOOK.COM (2603:10a6:209:84::44) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.3589.20 via Frontend Transport; Tue, 24 Nov 2020 08:15:21 +0000
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 46
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 26f49481-9ac1-4cdd-84ba-08d89051165a
X-MS-TrafficTypeDiagnostic: HE1EUR02HT168:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: aJAYLgrQMgDiX0xy3D7z8TgAqY5HUiT+e6LwYb7fOAodWSkGrzO9BCP801x7p0yqP7DZqg3uJBRskhcohL4izMInEBOSeBva8u9qyzD6QAGWD+y4pjlyaO/yc/WRUqodbf2kao34K1lLXcsuMHQkKFFY+bgYlDFYlRAvP3MQdxpLK1gVkqrvzSZxuuhZMPaeCvXN0e6fwOXaUre+Q1DXbw==
X-MS-Exchange-AntiSpam-MessageData: wJce1WPvgH5jlzESsORtZEVZNGZbHr/QAh0kvkznypDdZkVm8PVf7HoWPH6nF2iLdZlxOBmwZnORuu3mIfN0Ew/XxeNFlBNHnjAJxdHWiJZP+gnWCb77iY3bAHUKBiIkVS2jeEgU8S3cFyJPg2wfTg==
X-OriginatorOrg: live.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 26f49481-9ac1-4cdd-84ba-08d89051165a
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 24 Nov 2020 08:15:21.7624 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-AuthSource: HE1EUR02FT050.eop-EUR02.prod.protection.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Anonymous
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: HE1EUR02HT168
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Jean Louis <bugs@HIDDEN> writes:

> * Arthur Miller <arthur.miller@HIDDEN> [2020-11-24 00:23]:
>> Jean Louis <bugs@HIDDEN> writes:
>> 
>> > * Arthur Miller <arthur.miller@HIDDEN> [2020-11-23 23:22]:
>> >> The only thing that changed regularly was of course system updates: kernel,
>> >> gcc & co etc. So it maybe is as mentioned earlier in this thread by
>> >> either you or somebody else is that glibc changed and that maybe
>> >> triggers something in Emacs based on how Emacs use it. I don't know I am
>> >> not expert in this. Isn't Valgrind good for this kind of problems? Can I
>> >> run emacs as a systemd service in Valgrind?
>> >
>> > I did not change anything like glibc or kernel in Hyperbola
>> > GNU/Linux-libre
>> Didn't you update your system since last summer?
>
> I am pulling Emacs from git and consider system upgraded that way.
same here

> For system packages, pacman says there is nothing to do most of time,
> unless there is new kernel or some security issue.

Aha, you are running LTS kernel?

Mine pacman brings in updates every day.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 05:44:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 00:44:54 2020
Received: from localhost ([127.0.0.1]:52161 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khR8I-0006K1-6l
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 00:44:54 -0500
Received: from static.rcdrun.com ([95.85.24.50]:47021)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1khR8G-0006Jm-AF
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 00:44:52 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C1AE7.000000005FBC9DCD.0000528F; Tue, 24 Nov 2020 05:44:45 +0000
Date: Tue, 24 Nov 2020 08:29:47 +0300
From: Jean Louis <bugs@HIDDEN>
To: Arthur Miller <arthur.miller@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X7yaS5sPWR60tpHD@HIDDEN>
References: <83k0udw3jb.fsf@HIDDEN> <X7tuqkYiZHYxQpcQ@HIDDEN>
 <BE101E85-568B-4B5C-A8A1-8FBA4726841C@HIDDEN>
 <AM0PR06MB657755833A2EC0DD73BF5BC596FC0@HIDDEN>
 <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <X7wcMpkuuE01Ciwb@HIDDEN>
 <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* Arthur Miller <arthur.miller@HIDDEN> [2020-11-24 00:23]:
> Jean Louis <bugs@HIDDEN> writes:
> 
> > * Arthur Miller <arthur.miller@HIDDEN> [2020-11-23 23:22]:
> >> The only thing that changed regularly was of course system updates: kernel,
> >> gcc & co etc. So it maybe is as mentioned earlier in this thread by
> >> either you or somebody else is that glibc changed and that maybe
> >> triggers something in Emacs based on how Emacs use it. I don't know I am
> >> not expert in this. Isn't Valgrind good for this kind of problems? Can I
> >> run emacs as a systemd service in Valgrind?
> >
> > I did not change anything like glibc or kernel in Hyperbola
> > GNU/Linux-libre
> Didn't you update your system since last summer?

I am pulling Emacs from git and consider system upgraded that way.

For system packages, pacman says there is nothing to do most of time,
unless there is new kernel or some security issue.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 05:06:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 24 00:06:47 2020
Received: from localhost ([127.0.0.1]:52093 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khQXP-0003EN-94
	for submit <at> debbugs.gnu.org; Tue, 24 Nov 2020 00:06:47 -0500
Received: from static.rcdrun.com ([95.85.24.50]:46211)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bugs@HIDDEN>) id 1khQXN-0003E4-Bq
 for 43389 <at> debbugs.gnu.org; Tue, 24 Nov 2020 00:06:45 -0500
Received: from localhost ([::ffff:41.202.241.56])
 (AUTH: PLAIN admin, TLS: TLS1.2,256bits,ECDHE_RSA_AES_256_GCM_SHA384)
 by static.rcdrun.com with ESMTPSA
 id 00000000002C000B.000000005FBC94DF.00004C35; Tue, 24 Nov 2020 05:06:38 +0000
Date: Tue, 24 Nov 2020 00:09:03 +0300
From: Jean Louis <bugs@HIDDEN>
To: Andreas Schwab <schwab@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
Message-ID: <X7wk7yN5bSDYCmlR@HIDDEN>
References: <X7u42BnBTDQE4fvs@HIDDEN>
 <5c8da650-6f3d-8a36-6c09-4690b6c59fbe@HIDDEN>
 <X7wGVEBkAfCRH5h6@HIDDEN>
 <4c13d495-c0a1-b783-aacc-572887913212@HIDDEN>
 <X7wTnllN5hcwh0T1@HIDDEN>
 <655ae11b-aa72-d10b-6817-9c2db62fb191@HIDDEN>
 <X7wZBRDS5i+QOCkr@HIDDEN> <838sarvmq5.fsf@HIDDEN>
 <X7weduBiQPvbRJrL@HIDDEN> <87sg8zbxrx.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 7bit
Content-Disposition: inline
In-Reply-To: <87sg8zbxrx.fsf@HIDDEN>
User-Agent: Mutt/2.0 (3d08634) (2020-11-07)
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * Andreas Schwab <schwab@HIDDEN> [2020-11-23 23:53]:
 > On Nov 23 2020, Jean Louis wrote: > > > It happens during eww call, not
 immediately but during. > > That probably just means it is busy i [...] 
 Content analysis details:   (1.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.1 DATE_IN_PAST_06_12     Date: is 6 to 12 hours before Received: date
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN, carlos@HIDDEN,
 trevor@HIDDEN, michael_heerdegen@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)

* Andreas Schwab <schwab@HIDDEN> [2020-11-23 23:53]:
> On Nov 23 2020, Jean Louis wrote:
> 
> > It happens during eww call, not immediately but during.
> 
> That probably just means it is busy in libxml parsing the page.

The instance without LD_PRELOAD is fast. Instance with LD_PRELOAD will
show me page but not allow any keyboard input unless I interrupt it
few times then few times. And there is no CPU activity going on that I
can see it on the indicator.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 03:26:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 23 22:26:14 2020
Received: from localhost ([127.0.0.1]:51925 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khOy6-0000hZ-Ia
	for submit <at> debbugs.gnu.org; Mon, 23 Nov 2020 22:26:14 -0500
Received: from eggs.gnu.org ([209.51.188.92]:58798)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1khOy3-0000hK-Cs
 for 43389 <at> debbugs.gnu.org; Mon, 23 Nov 2020 22:26:13 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:33875)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1khOxw-0007ek-8u; Mon, 23 Nov 2020 22:26:04 -0500
Received: from [176.228.60.248] (port=2351 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1khOxu-0002Ts-Pp; Mon, 23 Nov 2020 22:26:03 -0500
Date: Tue, 24 Nov 2020 05:25:59 +0200
Message-Id: <834klfv3js.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andreas Schwab <schwab@HIDDEN>
In-Reply-To: <87sg8zbxrx.fsf@HIDDEN> (message from Andreas Schwab on Mon,
 23 Nov 2020 21:53:22 +0100)
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <X7rBbqnN4ydxoO0n@HIDDEN> <83k0udw3jb.fsf@HIDDEN>
 <X7u42BnBTDQE4fvs@HIDDEN>
 <5c8da650-6f3d-8a36-6c09-4690b6c59fbe@HIDDEN>
 <X7wGVEBkAfCRH5h6@HIDDEN>
 <4c13d495-c0a1-b783-aacc-572887913212@HIDDEN>
 <X7wTnllN5hcwh0T1@HIDDEN>
 <655ae11b-aa72-d10b-6817-9c2db62fb191@HIDDEN>
 <X7wZBRDS5i+QOCkr@HIDDEN> <838sarvmq5.fsf@HIDDEN>
 <X7weduBiQPvbRJrL@HIDDEN> <87sg8zbxrx.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 carlos@HIDDEN, trevor@HIDDEN, michael_heerdegen@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Andreas Schwab <schwab@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  fweimer@HIDDEN,
>   43389 <at> debbugs.gnu.org,  dj@HIDDEN,  carlos@HIDDEN,
>   trevor@HIDDEN,  michael_heerdegen@HIDDEN
> Date: Mon, 23 Nov 2020 21:53:22 +0100
> 
> On Nov 23 2020, Jean Louis wrote:
> 
> > It happens during eww call, not immediately but during.
> 
> That probably just means it is busy in libxml parsing the page.

That's not what the backtrace is showing, though.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 24 Nov 2020 02:07:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 23 21:07:49 2020
Received: from localhost ([127.0.0.1]:51844 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khNkD-0007JW-Ac
	for submit <at> debbugs.gnu.org; Mon, 23 Nov 2020 21:07:49 -0500
Received: from mail-am7eur06olkn2028.outbound.protection.outlook.com
 ([40.92.16.28]:15297 helo=EUR06-AM7-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arthur.miller@HIDDEN>) id 1khNkB-0007JJ-44
 for 43389 <at> debbugs.gnu.org; Mon, 23 Nov 2020 21:07:47 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=PAN0Ch3OCKvRhvTPaRX3yimFRx0vy5wJUPEL3VFY6+TplvCDDsCilVx9oqlnnDDKl2NzHeknp+a/78rAHqoPzv57Hveq6rxJDnGiYDek3xhCz4rEcAZZ6HDIpF1gVXyyDsEwy1ckJy22at/8QnW3yuupwm+CTjVkoic+RTgJU/9vInLI7o7VtWGiECtTY9djRy85r7YIKdOqCWxKgUfQV2i4YecItRU2RaoZvwR6JPJJoqlKqsJHU3XJAWzwV5uvOmoDt31iEC5CSMsGBaoN2muOZtJY27QR8qRhYD3LNBVE/4Ntp67agK7wjv5mRIF6UxbPzExKNF8Z+w39sKbI7g==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=Ux3bx6Hv4wJoR24dtJGa//jlTdUOTfPhHY3fyOuJ+ak=;
 b=aTqyEOs3So3Kzx18OJ7FX7c+e3FEz7c3N8NTruxr6MOxzuTuToSUNTaauZnfAMxKHbMVHbWqNFXrFQm6Ad14RRT1WzXHrrO15DkL+Wh4x3KrPLmU/afGyyyqOr8JH6M9zM/7Ul4dDXNyhtNo9NsDF70GaWWprD1ED1Deqiz7atTDXTTURxcecSb2JheS7t4YuprerGj7ei6AOUU0NiHHypE/O6+i5eAeCLOVp4E66W/xWX3tM2ZCkS248H/VuTRJlOqXF2OHXEF8hM5cRBUzKiYNLv4FIKtAEzcBOuz6Eif4vDWwF73lMMlk6b53KHvGlS7VziMEgvVKbGd6DPPl9A==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=live.com; s=selector1; 
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=Ux3bx6Hv4wJoR24dtJGa//jlTdUOTfPhHY3fyOuJ+ak=;
 b=XGqlT0wzD1wj2TU/EHYGTtCSJS78D1A7kE7WJjygKjf1AGAaPtVrc9xTBowY1L3hCi5fxEuh2QlysyBgMnk2TB0exbOeJp9UUlOr6epcQBV/VDFdfO27Qx4GbO47npXpEwLt2UbU/fHFhtYD93Dr6Y4+yApc0Sp7jpgbUGpsr+KpKMMYARADu/JWTKFQdvRaVsnRNZhpNeLjCwVahsoRb8Nt7YlypaxwF7DUYHV94nq4U/NFy/pvIXQrdLw476l0TfIkXTC1++fDEenKW6nnpRykPMA9ylbFBzUMyogVr320VtCfkTBj9NNpi4MDXGl119SwnTbAOtZi6fcedHkipA==
Received: from AM7EUR06FT022.eop-eur06.prod.protection.outlook.com
 (2a01:111:e400:fc36::4b) by
 AM7EUR06HT203.eop-eur06.prod.protection.outlook.com (2a01:111:e400:fc36::109)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20; Tue, 24 Nov
 2020 02:07:40 +0000
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 (2a01:111:e400:fc36::4a) by AM7EUR06FT022.mail.protection.outlook.com
 (2a01:111:e400:fc36::388) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20 via Frontend
 Transport; Tue, 24 Nov 2020 02:07:40 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:09CAB705EE7FD68874A62B3FEAC4046E1813E4C141C0CDBE1D9DA885F1C86756;
 UpperCasedChecksum:3BD0200B8190DDD25CDF6EE034D16A7A7D19D566DD6D3279EE6B16E020102A0D;
 SizeAsReceived:8268; Count:46
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993]) by AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993%7]) with mapi id 15.20.3589.030; Tue, 24 Nov 2020
 02:07:40 +0000
From: Arthur Miller <arthur.miller@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7rBbqnN4ydxoO0n@HIDDEN> <83k0udw3jb.fsf@HIDDEN>
 <X7tuqkYiZHYxQpcQ@HIDDEN>
 <BE101E85-568B-4B5C-A8A1-8FBA4726841C@HIDDEN>
 <AM0PR06MB657755833A2EC0DD73BF5BC596FC0@HIDDEN>
 <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <83eekjvnzg.fsf@HIDDEN>
Date: Tue, 24 Nov 2020 03:07:39 +0100
In-Reply-To: <83eekjvnzg.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 23 Nov
 2020 22:04:35 +0200")
Message-ID: <AM0PR06MB6577AC0862DAB1AC4AA1D10996FB0@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Content-Type: text/plain
X-TMN: [foDzW72mAVUqwyKA+nigwVzXyoSA2HiJ]
X-ClientProxiedBy: AM6PR10CA0104.EURPRD10.PROD.OUTLOOK.COM
 (2603:10a6:209:8c::45) To AM0PR06MB6577.eurprd06.prod.outlook.com
 (2603:10a6:208:19a::23)
X-Microsoft-Original-Message-ID: <87h7pfpkwk.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from pascal.homepc (90.230.29.56) by
 AM6PR10CA0104.EURPRD10.PROD.OUTLOOK.COM (2603:10a6:209:8c::45) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.3589.20 via Frontend Transport; Tue, 24 Nov 2020 02:07:40 +0000
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 46
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 543101b5-e04c-4aa5-2b23-08d8901db904
X-MS-TrafficTypeDiagnostic: AM7EUR06HT203:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: kT3wbKejWJDxsM7PThU8AA0lpNDjwhuhNujZr3qqS5iSButbGaOa6LXkYp61Qkhez4eflVYKvqGk5/+xdDaL7f5yNQXmh2KnvbDkTOa6zzWPlRgsODtDOT9RyU7jnTP25dxIYD8D/bE3rY5n6IF2X+W8Mg63is6tPd8K9Nv1vcSHUYiyGkTCcP81wjjK8O2s/VNoUGmyBEcTiUcnlX7cWw==
X-MS-Exchange-AntiSpam-MessageData: trIZkN6COxpJ5TWdDhQItAc2iNCMZtENr7y6vdld65nhxOi4k0lt8tRyEiKPcP2EkBTVx1lzZ6pdIMzKIP6Z9eGCO7XU+b/n12OUu51UKyIUm+3JiT+doyihgkwjXiQV0RgPpKrcrte//Js7hsPfpg==
X-OriginatorOrg: live.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 543101b5-e04c-4aa5-2b23-08d8901db904
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 24 Nov 2020 02:07:40.8760 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-AuthSource: AM7EUR06FT022.eop-eur06.prod.protection.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Anonymous
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: AM7EUR06HT203
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Arthur Miller <arthur.miller@HIDDEN>
>> Cc: bugs@HIDDEN,  fweimer@HIDDEN,  43389 <at> debbugs.gnu.org,
>>   dj@HIDDEN,  michael_heerdegen@HIDDEN,  trevor@HIDDEN,
>>   carlos@HIDDEN
>> Date: Mon, 23 Nov 2020 20:49:48 +0100
>> 
>> Isn't Valgrind good for this kind of problems? Can I run emacs as a
>> systemd service in Valgrind?
>
> You can run Emacs under Valgrind, see etc/DEBUG for the details.  But
> I'm not sure it will work as systemd service.
>
> Valgrind is only the right tool if we think there's a memory leak in
> Emacs itself.
Yeah, you are right;

I was trying to crash my Emacs for like 4 hours now, I tried to simulate
dired and copying/moving around files since I experienced crashes mostly
when in dired and helm; I put a function on a timer where I made 1000 files every
few seconds, red those files back inoto lists, copy them around and deleted
them; and watched allocations and all I got was spent time; Emacs was
rock solid. Typical :D.

I hope that this pmem for the process is correct; I was looking at
attributes and I saw it go up and down, but it seemed to stay in reange
~2.5 tp ~3.5%, 

This looked typical, pmem was different for every run, but stayed below
3.5%

((args . "/home/arthur/repos/emacs/src/emacs --fg-daemon") (pmem . 2.919526565234921) (pcpu . 13.355092518800808) (etime 0 5521 40000 0) (rss . 958748) (vsize . 1125912) (start 24508 19530 683640 125000) (thcount . 2) (nice . 0) (pri . 20) (ctime 0 6 880000 0) (cstime 0 0 420000 0) (cutime 0 6 460000 0) (time 0 737 340000 0) (stime 0 47 950000 0) (utime 0 689 390000 0) (cmajflt . 485) (cminflt . 214598) (majflt . 73) (minflt . 1286399) (tpgid . -1) (ttname . "") (sess . 24105) (pgrp . 24105) (ppid . 595) (state . "R") (comm . "emacs") (group . "users") (egid . 100) (user . "arthur") (euid . 1000))

((args . "/home/arthur/repos/emacs/src/emacs --fg-daemon") (pmem . 2.919526565234921) (pcpu . 13.355092518800808) (etime 0 5521 40000 0) (rss . 958748) (vsize . 1125912) (start 24508 19530 684725 570000) (thcount . 2) (nice . 0) (pri . 20) (ctime 0 6 880000 0) (cstime 0 0 420000 0) (cutime 0 6 460000 0) (time 0 737 340000 0) (stime 0 47 950000 0) (utime 0 689 390000 0) (cmajflt . 485) (cminflt . 214598) (majflt . 73) (minflt . 1286399) (tpgid . -1) (ttname . "") (sess . 24105) (pgrp . 24105) (ppid . 595) (state . "R") (comm . "emacs") (group . "users") (egid . 100) (user . "arthur") (euid . 1000))

((args . "/home/arthur/repos/emacs/src/emacs --fg-daemon") (pmem . 2.919526565234921) (pcpu . 13.355092518800808) (etime 0 5521 40000 0) (rss . 958748) (vsize . 1125912) (start 24508 19530 685810 502000) (thcount . 2) (nice . 0) (pri . 20) (ctime 0 6 880000 0) (cstime 0 0 420000 0) (cutime 0 6 460000 0) (time 0 737 340000 0) (stime 0 47 950000 0) (utime 0 689 390000 0) (cmajflt . 485) (cminflt . 214598) (majflt . 73) (minflt . 1286399) (tpgid . -1) (ttname . "") (sess . 24105) (pgrp . 24105) (ppid . 595) (state . "R") (comm . "emacs") (group . "users") (egid . 100) (user . "arthur") (euid . 1000))

((args . "/home/arthur/repos/emacs/src/emacs --fg-daemon") (pmem . 2.919526565234921) (pcpu . 13.355092518800808) (etime 0 5521 40000 0) (rss . 958748) (vsize . 1125912) (start 24508 19530 686711 538000) (thcount . 2) (nice . 0) (pri . 20) (ctime 0 6 880000 0) (cstime 0 0 420000 0) (cutime 0 6 460000 0) (time 0 737 340000 0) (stime 0 47 950000 0) (utime 0 689 390000 0) (cmajflt . 485) (cminflt . 214598) (majflt . 73) (minflt . 1286399) (tpgid . -1) (ttname . "") (sess . 24105) (pgrp . 24105) (ppid . 595) (state . "R") (comm . "emacs") (group . "users") (egid . 100) (user . "arthur") (euid . 1000))

((args . "/home/arthur/repos/emacs/src/emacs --fg-daemon") (pmem . 2.919526565234921) (pcpu . 13.355092518800808) (etime 0 5521 40000 0) (rss . 958748) (vsize . 1125912) (start 24508 19530 687465 69000) (thcount . 2) (nice . 0) (pri . 20) (ctime 0 6 880000 0) (cstime 0 0 420000 0) (cutime 0 6 460000 0) (time 0 737 340000 0) (stime 0 47 950000 0) (utime 0 689 390000 0) (cmajflt . 485) (cminflt . 214598) (majflt . 73) (minflt . 1286399) (tpgid . -1) (ttname . "") (sess . 24105) (pgrp . 24105) (ppid . 595) (state . "R") (comm . "emacs") (group . "users") (egid . 100) (user . "arthur") (euid . 1000))

I will see it comes back, and see if I can play more with it; I give up for now.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 23 Nov 2020 22:11:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 23 17:11:13 2020
Received: from localhost ([127.0.0.1]:51488 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khK3F-0007t1-6r
	for submit <at> debbugs.gnu.org; Mon, 23 Nov 2020 17:11:13 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:45273)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1khK3B-0007sk-Mp
 for 43389 <at> debbugs.gnu.org; Mon, 23 Nov 2020 17:11:11 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id DA08C600D1;
 Mon, 23 Nov 2020 23:11:03 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606169464;
 bh=AlwW4QImHxqk5xfolAbBhQStPj8fLSRD1qi8XVQPeik=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=JZREy/DREjOCcPJAwcaRf86AAtbogKkxvZsDQbVkNZwIgQH2UgmgsB2+jWvNyvT9/
 KLREvgH4pgKlvBFVc51sqd9VZDsP9SIa3kdMbrY91rHBCPMEt0PEiSKLMxG2uQTYiU
 Foo+3g5YaAH6UZDPWFMMNjLBjBCjr+ooNvkS+y+s=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <87o8jnu5f2.fsf@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <87o8jnu5f2.fsf@HIDDEN>
Date: Mon, 23 Nov 2020 23:11:03 +0100
Message-ID: <87im9vu3k8.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Trevor Bentley <trevor@HIDDEN> writes:
 
> Below is a large memory report from the emacs-slack instance: 

Formatting was butchered.  Try this:

https://trevorbentley.com/emacs_malloc_info.log

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 23 Nov 2020 21:31:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 23 16:31:11 2020
Received: from localhost ([127.0.0.1]:51462 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khJQT-0006xA-Tt
	for submit <at> debbugs.gnu.org; Mon, 23 Nov 2020 16:31:11 -0500
Received: from mail.trevorbentley.com ([37.187.5.80]:45042)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <trevor@HIDDEN>) id 1khJQQ-0006wf-P5
 for 43389 <at> debbugs.gnu.org; Mon, 23 Nov 2020 16:31:08 -0500
Received: from localhost (c188-150-0-48.bredband.comhem.se [188.150.0.48])
 by mail.trevorbentley.com (Postfix) with ESMTPSA id E2B5E60A2C;
 Mon, 23 Nov 2020 22:30:59 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=mail.trevorbentley.com; s=mail; t=1606167060;
 bh=qUsodgiu6PCj9uR7U5c2SyVbu+oHCW0GJ1YxcHJgxoQ=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=HStsXoMQAOAu+PBEahOvH+qU6swAa+lMcagYp/nzEm5Zj9Hs/WQYbsH1G+uKQ0W+6
 xREsQANsp7lh25C9KQjDIUHT6IglL0EVDq45p+ZB7Cs4/rvmuq5oERUsNSaNO3BtUV
 TPiBxAZbim2KE+agL8iUkZV91zLOcbJ1w1HfZhCs=
From: Trevor Bentley <trevor@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
In-Reply-To: <83blfovzxz.fsf@HIDDEN>
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
Date: Mon, 23 Nov 2020 22:30:57 +0100
Message-ID: <87o8jnu5f2.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; format=flowed
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, carlos@HIDDEN, 
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Ah geez, there's a dozen threads now.  I'll just start from here.

I haven't setup the memory trace lib yet, but I've been running an 
instance of emacs and printing as much as I can about its memory 
usage, including (malloc-info).  I reduced MALLOC_ARENA_MAX to 2.

This instance sat around at ~300MB for a day, then spiked to 
1000MB.  I ran a bunch of memory-related functions, and it stopped 
growing.  I believe (garbage-collect) halted the growth.

It ran for another 3 days at ~1100MB until another sudden spike up 
to 2300MB.

As usual, this is a graphical instance running emacs-slack with 
tons of network traffic and images and the such.

In the mean time, while that instance was running, a second 
graphical instance suddenly spiked to 4100MB.  The other instance 
is interesting, as it's not doing anything special at all.  It has 
a few elisp files open, and reports only 700KB of buffers and 
42.2MB in elisp data.

A third graphical instance has been idling during this time.  I've 
never done a single thing with it beyond start it.  That one is 
still at 83MB.

Below is a large memory report from the emacs-slack instance:

----------------
BEGIN LOG
----------------
;;--------------------------------------  ;; one day of runtime
;; growing 1MB every few seconds RSS 1100MB 
;; -------------------------------------- 
;; --------------------------------------  (getenv 
;; "MALLOC_ARENA_MAX") "2"  buffers ~= 60MB (let ((size 0)) 
  (dolist (buffer (buffer-list) size) 
    (setq size (+ size (buffer-size buffer))))) 
60300462  ;; sums to ~100MB if I'm reading it right? 
(garbage-collect) ((conses 16 1143686 1675416) (symbols 48 32466 
160) (strings 32 241966 542675) (string-bytes 1 5872840) (vectors 
16 116994) (vector-slots 8 8396419 357942) (floats 8 1705 7024) 
(intervals 56 27139 10678) (buffers 992 53))  ;; /proc/$PID/smaps 
heap 56395d707000-56399b330000 rw-p 00000000 00:00 0 
[heap] Size:            1011876 kB KernelPageSize:        4 kB 
MMUPageSize:           4 kB Rss:             1010948 kB Pss: 
1010948 kB Shared_Clean:          0 kB Shared_Dirty:          0 kB 
Private_Clean:         0 kB Private_Dirty:   1010948 kB 
Referenced:      1007016 kB Anonymous:       1010948 kB LazyFree: 
0 kB AnonHugePages:         0 kB ShmemPmdMapped:        0 kB 
FilePmdMapped:        0 kB Shared_Hugetlb:        0 kB 
Private_Hugetlb:       0 kB Swap:                  0 kB SwapPss: 
0 kB Locked:                0 kB THPeligible:            0 
ProtectionKey:         0  ;; malloc-info <malloc version="1"> 
<heap nr="0"> <sizes> 
  <size from="17" to="32" total="64" count="2"/> <size from="33" 
  to="48" total="192" count="4"/> <size from="33" to="33" 
  total="56826" count="1722"/> <size from="49" to="49" 
  total="16121" count="329"/> <size from="65" to="65" 
  total="567970" count="8738"/> <size from="81" to="81" 
  total="38070" count="470"/> <size from="97" to="97" 
  total="80122" count="826"/> <size from="113" to="113" 
  total="37629" count="333"/> <size from="129" to="129" 
  total="435117" count="3373"/> <size from="145" to="145" 
  total="44805" count="309"/> <size from="161" to="161" 
  total="111090" count="690"/> <size from="177" to="177" 
  total="35577" count="201"/> <size from="193" to="193" 
  total="293553" count="1521"/> <size from="209" to="209" 
  total="33858" count="162"/> <size from="225" to="225" 
  total="66600" count="296"/> <size from="241" to="241" 
  total="35909" count="149"/> <size from="257" to="257" 
  total="179900" count="700"/> <size from="273" to="273" 
  total="28938" count="106"/> <size from="289" to="289" 
  total="48841" count="169"/> <size from="305" to="305" 
  total="21655" count="71"/> <size from="321" to="321" 
  total="127758" count="398"/> <size from="337" to="337" 
  total="20220" count="60"/> <size from="353" to="353" 
  total="37065" count="105"/> <size from="369" to="369" 
  total="28044" count="76"/> <size from="385" to="385" 
  total="90860" count="236"/> <size from="401" to="401" 
  total="21253" count="53"/> <size from="417" to="417" 
  total="51291" count="123"/> <size from="433" to="433" 
  total="21217" count="49"/> <size from="449" to="449" 
  total="77228" count="172"/> <size from="465" to="465" 
  total="19995" count="43"/> <size from="481" to="481" 
  total="32227" count="67"/> <size from="497" to="497" 
  total="19383" count="39"/> <size from="513" to="513" 
  total="63099" count="123"/> <size from="529" to="529" 
  total="14283" count="27"/> <size from="545" to="545" 
  total="31065" count="57"/> <size from="561" to="561" 
  total="23001" count="41"/> <size from="577" to="577" 
  total="50199" count="87"/> <size from="593" to="593" 
  total="18383" count="31"/> <size from="609" to="609" 
  total="38367" count="63"/> <size from="625" to="625" 
  total="21875" count="35"/> <size from="641" to="641" 
  total="39101" count="61"/> <size from="657" to="657" 
  total="28251" count="43"/> <size from="673" to="673" 
  total="30958" count="46"/> <size from="689" to="689" 
  total="19292" count="28"/> <size from="705" to="705" 
  total="38070" count="54"/> <size from="721" to="721" 
  total="12978" count="18"/> <size from="737" to="737" 
  total="33902" count="46"/> <size from="753" to="753" 
  total="20331" count="27"/> <size from="769" to="769" 
  total="33067" count="43"/> <size from="785" to="785" 
  total="18840" count="24"/> <size from="801" to="801" 
  total="29637" count="37"/> <size from="817" to="817" 
  total="17157" count="21"/> <size from="833" to="833" 
  total="35819" count="43"/> <size from="849" to="849" 
  total="16131" count="19"/> <size from="865" to="865" 
  total="21625" count="25"/> <size from="881" to="881" 
  total="14977" count="17"/> <size from="897" to="897" 
  total="31395" count="35"/> <size from="913" to="913" 
  total="18260" count="20"/> <size from="929" to="929" 
  total="37160" count="40"/> <size from="945" to="945" 
  total="28350" count="30"/> <size from="961" to="961" 
  total="40362" count="42"/> <size from="977" to="977" 
  total="30287" count="31"/> <size from="993" to="993" 
  total="43692" count="44"/> <size from="1009" to="1009" 
  total="1426726" count="1414"/> <size from="1025" to="1073" 
  total="1167589" count="1093"/> <size from="1089" to="1137" 
  total="1370809" count="1209"/> <size from="1153" to="1201" 
  total="723005" count="605"/> <size from="1217" to="1265" 
  total="467988" count="372"/> <size from="1281" to="1329" 
  total="258180" count="196"/> <size from="1345" to="1393" 
  total="128221" count="93"/> <size from="1409" to="1457" 
  total="143844" count="100"/> <size from="1473" to="1521" 
  total="129078" count="86"/> <size from="1537" to="1585" 
  total="93980" count="60"/> <size from="1601" to="1649" 
  total="108995" count="67"/> <size from="1665" to="1713" 
  total="98218" count="58"/> <size from="1729" to="1777" 
  total="121253" count="69"/> <size from="1793" to="1841" 
  total="110877" count="61"/> <size from="1857" to="1905" 
  total="92257" count="49"/> <size from="1921" to="1969" 
  total="83691" count="43"/> <size from="1985" to="2033" 
  total="235973" count="117"/> <size from="2049" to="2097" 
  total="213783" count="103"/> <size from="2113" to="2161" 
  total="653793" count="305"/> <size from="2177" to="2225" 
  total="682581" count="309"/> <size from="2241" to="2289" 
  total="260931" count="115"/> <size from="2305" to="2337" 
  total="109375" count="47"/> <size from="2369" to="2417" 
  total="88789" count="37"/> <size from="2433" to="2481" 
  total="83378" count="34"/> <size from="2497" to="2545" 
  total="98263" count="39"/> <size from="2561" to="2609" 
  total="77438" count="30"/> <size from="2657" to="2673" 
  total="42656" count="16"/> <size from="2689" to="2737" 
  total="48754" count="18"/> <size from="2753" to="2801" 
  total="63879" count="23"/> <size from="2817" to="2865" 
  total="62422" count="22"/> <size from="2881" to="2929" 
  total="57988" count="20"/> <size from="2945" to="2993" 
  total="68247" count="23"/> <size from="3009" to="3057" 
  total="133164" count="44"/> <size from="3073" to="3121" 
  total="397169" count="129"/> <size from="3137" to="3569" 
  total="2008020" count="612"/> <size from="3585" to="4081" 
  total="666716" count="172"/> <size from="4097" to="4593" 
  total="7549855" count="1775"/> <size from="4609" to="5105" 
  total="2643468" count="540"/> <size from="5121" to="5617" 
  total="5882607" count="1103"/> <size from="5633" to="6129" 
  total="2430783" count="415"/> <size from="6145" to="6641" 
  total="3494147" count="547"/> <size from="6657" to="7153" 
  total="2881062" count="422"/> <size from="7169" to="7665" 
  total="5880630" count="790"/> <size from="7681" to="8177" 
  total="2412798" count="302"/> <size from="8193" to="8689" 
  total="11000664" count="1320"/> <size from="8705" to="9201" 
  total="4458714" count="490"/> <size from="9217" to="9713" 
  total="4959696" count="528"/> <size from="9729" to="10225" 
  total="6223631" count="623"/> <size from="10241" to="10737" 
  total="3347537" count="321"/> <size from="10753" to="12273" 
  total="7665386" count="666"/> <size from="12289" to="16369" 
  total="37137026" count="2658"/> <size from="16385" to="20465" 
  total="26637896" count="1496"/> <size from="20481" to="24561" 
  total="17043773" count="765"/> <size from="24593" to="28657" 
  total="15934986" count="602"/> <size from="28673" to="32753" 
  total="21737575" count="711"/> <size from="32769" to="36849" 
  total="17276544" count="496"/> <size from="36865" to="40945" 
  total="14702299" count="379"/> <size from="40961" to="65521" 
  total="53337460" count="1044"/> <size from="65585" to="98289" 
  total="51364750" count="654"/> <size from="98369" to="131057" 
  total="27361507" count="243"/> <size from="131121" to="163665" 
  total="27275915" count="187"/> <size from="163841" to="262129" 
  total="63020958" count="302"/> <size from="262145" to="519809" 
  total="126431823" count="351"/> <size from="525073" to="4639665" 
  total="148733598" count="174"/> <unsorted from="18465" 
  to="18465" total="18465" count="1"/> 
</sizes> <total type="fast" count="6" size="256"/> <total 
type="rest" count="50540" size="735045803"/> <system 
type="current" size="1036161024"/> <system type="max" 
size="1036161024"/> <aspace type="total" size="1036161024"/> 
<aspace type="mprotect" size="1036161024"/> </heap> <heap nr="1"> 
<sizes> 
  <size from="33" to="33" total="231" count="7"/> <size from="49" 
  to="49" total="245" count="5"/> <size from="65" to="65" 
  total="260" count="4"/> <size from="81" to="81" total="243" 
  count="3"/> <size from="97" to="97" total="97" count="1"/> <size 
  from="113" to="113" total="113" count="1"/> <size from="129" 
  to="129" total="516" count="4"/> <size from="161" to="161" 
  total="644" count="4"/> <size from="209" to="209" total="418" 
  count="2"/> <size from="241" to="241" total="241" count="1"/> 
  <size from="257" to="257" total="257" count="1"/> <size 
  from="305" to="305" total="610" count="2"/> <size from="705" 
  to="705" total="705" count="1"/> <size from="1294673" 
  to="3981489" total="7995027" count="3"/> <unsorted from="30561" 
  to="4013649" total="4044210" count="2"/> 
</sizes> <total type="fast" count="0" size="0"/> <total 
type="rest" count="42" size="20184569"/> <system type="current" 
size="20250624"/> <system type="max" size="20250624"/> <aspace 
type="total" size="20250624"/> <aspace type="mprotect" 
size="20250624"/> <aspace type="subheaps" size="1"/> </heap> 
<total type="fast" count="6" size="256"/> <total type="rest" 
count="50582" size="755230372"/> <total type="mmap" count="4" 
size="44789760"/> <system type="current" size="1056411648"/> 
<system type="max" size="1056411648"/> <aspace type="total" 
size="1056411648"/> <aspace type="mprotect" size="1056411648"/> 
</malloc>     ;;-------------------------------------- 
;;-------------------------------------- ;; ~3 hours later.  ;; 
growth slowed after the previous (garbage-collect) ;; RSS 1140MB 
;;-------------------------------------- 
;;--------------------------------------  (memory-limit) ;; 
virtual memory, not RSS 1429620 (message "%f" gc-cons-threshold) 
"800000.000000" (message "%f" gc-cons-percentage) "0.100000" 
(emacs-uptime) "1 day, 4 hours, 50 minutes, 30 seconds" (message 
"%f" gcs-done) "708.000000" (message "%f" gc-elapsed) "201.724018" 
(message "%s" memory-full) "nil"  (memory-use-counts) (224118465 
575286 217714299 65607 946347937 563190 26430775)  (memory-usage) 
((conses 16 1199504 2511807) (symbols 48 32742 159) (strings 32 
246671 575263) (string-bytes 1 5992063) (vectors 16 118364) 
(vector-slots 8 8412872 474129) (floats 8 1771 10028) (intervals 
56 29873 12035) (buffers 992 60)) 
 
 =>	18.3MB (+ 38.3MB dead) in conses 
	1.50MB (+ 7.45kB dead) in symbols 7.53MB (+ 17.6MB dead) in 
	strings 5.71MB in string-bytes 1.81MB in vectors 64.2MB (+ 
	3.62MB dead) in vector-slots 13.8kB (+ 78.3kB dead) in floats 
	1.60MB (+  658kB dead) in intervals 58.1kB in buffers  Total in 
	lisp objects:  161MB (live  101MB, dead 60.2MB)  Buffer ralloc 
	memory usage: 60 buffers 64.4MB total ( 956kB in gaps) 
      Size	Gap	Name 
 
  47795241	745530	 *censored* 
   4681196	29261	   *censored* 4543324	25017	   *censored* 
   4478601	28398	   *censored* 
    862373	622	     *censored* 859981	4898	   *censored* 859617 
    3696	   *censored* 859355	4131	   *censored* 859131	4009 
    *censored* 471538	6609	   *censored* 
     60099	6451	   *censored* 20589	1312	   *censored* 19452 
     2129	   *censored* 17776	1746	   *censored* 16877	217 
     *censored* 16484	1447	   *censored* 13488	56 
     *censored* 13212	1810	   *censored* 12747	2081 
     *censored* 12640	2098	   *censored* 12478	900 
     *censored* 12130	453	     *censored* 10745	10186 
     *censored* 10703	2082	   *censored* 
      9965	474	     *censored* 9828	1075	   *censored* 8000 
      226	     *censored* 5117	1396	   *censored* 4282	1891 
      *censored* 2546	1544	   *censored* 1630	675 
      *censored* 1479	591	     *censored* 1228	918 
      *censored* 
       883	1280	   *censored* 679	1574	   *censored* 678	5483 
       *censored* 513	27194	   *censored* 299	1731	   *censored* 
       232	3839	   *censored* 131	1985	   *censored* 
        97	1935	   *censored* 92	1979	   *censored* 72	1999 
        *censored* 69	1999	   *censored* 69	4009	   *censored* 
        67	1999	   *censored* 64	1985	   *censored* 62	6034 
        *censored* 62	1999	   *censored* 61	1960	   *censored* 
        28	4030	   *censored* 27	1999	   *censored* 
         0	2026	   *censored* 0	20	     *censored* 0	2065 
         *censored* 0	2072	   *censored* 0	20	     *censored* 0 
         20	     *censored* 0	2059	   *censored* 0	2037 
         *censored* 
 
 
 
;;--------------------------------------  ;; 3 days later ;; RSS 
;;--------------------------------------was steady at 1150MB ;; 
;;--------------------------------------leaped to 2.3GB very 
;;--------------------------------------suddenly ;; ;; RSS 2311M 
;;--------------------------------------;; ~182MB (let ((size 0)) 
  (dolist (buffer (buffer-list) size) 
    (setq size (+ size (buffer-size buffer))))) 
182903045   ;; sums to ~142MB if I'm reading it right? 
(garbage-collect) ((conses 16 2081486 2630206) (symbols 48 61019 
79) (strings 32 353371 288980) (string-bytes 1 13294206) (vectors 
16 144742) (vector-slots 8 9503757 592939) (floats 8 2373 8320) 
(intervals 56 46660 10912) (buffers 992 82))  (reduce '+ (cl-loop 
for thing in (garbage-collect) 
                    collect (* (nth 1 thing) (nth 2 thing)))) 
142115406  ;; /proc/$PID/smaps heap 56395d707000-5639e0d43000 rw-p 
00000000 00:00 0                          [heap] Size: 
2152688 kB KernelPageSize:        4 kB MMUPageSize:           4 kB 
Rss:             2152036 kB Pss:             2152036 kB 
Shared_Clean:          0 kB Shared_Dirty:          0 kB 
Private_Clean:         0 kB Private_Dirty:   2152036 kB 
Referenced:      2146588 kB Anonymous:       2152036 kB LazyFree: 
0 kB AnonHugePages:         0 kB ShmemPmdMapped:        0 kB 
FilePmdMapped:        0 kB Shared_Hugetlb:        0 kB 
Private_Hugetlb:       0 kB Swap:                  0 kB SwapPss: 
0 kB Locked:                0 kB THPeligible:            0 
ProtectionKey:         0   ;; malloc-info (malloc-info) <malloc 
version="1"> <heap nr="0"> <sizes> 
  <size from="33" to="48" total="240" count="5"/> <size from="113" 
  to="128" total="128" count="1"/> <size from="129" to="129" 
  total="26961" count="209"/> <size from="145" to="145" 
  total="112230" count="774"/> <size from="161" to="161" 
  total="4830" count="30"/> <size from="177" to="177" 
  total="66375" count="375"/> <size from="193" to="193" 
  total="159804" count="828"/> <size from="209" to="209" 
  total="6897" count="33"/> <size from="225" to="225" 
  total="82800" count="368"/> <size from="241" to="241" 
  total="48923" count="203"/> <size from="257" to="257" 
  total="119505" count="465"/> <size from="273" to="273" 
  total="47775" count="175"/> <size from="289" to="289" 
  total="73984" count="256"/> <size from="305" to="305" 
  total="33855" count="111"/> <size from="321" to="321" 
  total="147660" count="460"/> <size from="337" to="337" 
  total="33700" count="100"/> <size from="353" to="353" 
  total="73424" count="208"/> <size from="369" to="369" 
  total="5166" count="14"/> <size from="385" to="385" 
  total="94325" count="245"/> <size from="401" to="401" 
  total="44511" count="111"/> <size from="417" to="417" 
  total="67971" count="163"/> <size from="433" to="433" 
  total="31176" count="72"/> <size from="449" to="449" 
  total="88004" count="196"/> <size from="465" to="465" 
  total="33480" count="72"/> <size from="481" to="481" 
  total="86580" count="180"/> <size from="497" to="497" 
  total="36778" count="74"/> <size from="513" to="513" 
  total="108243" count="211"/> <size from="529" to="529" 
  total="15341" count="29"/> <size from="545" to="545" 
  total="64310" count="118"/> <size from="561" to="561" 
  total="28050" count="50"/> <size from="577" to="577" 
  total="76741" count="133"/> <size from="593" to="593" 
  total="40917" count="69"/> <size from="609" to="609" 
  total="77343" count="127"/> <size from="625" to="625" 
  total="30000" count="48"/> <size from="641" to="641" 
  total="164737" count="257"/> <size from="657" to="657" 
  total="35478" count="54"/> <size from="673" to="673" 
  total="44418" count="66"/> <size from="689" to="689" 
  total="4134" count="6"/> <size from="705" to="705" total="86010" 
  count="122"/> <size from="721" to="721" total="35329" 
  count="49"/> <size from="737" to="737" total="63382" 
  count="86"/> <size from="753" to="753" total="45933" 
  count="61"/> <size from="769" to="769" total="85359" 
  count="111"/> <size from="785" to="785" total="51810" 
  count="66"/> <size from="801" to="801" total="191439" 
  count="239"/> <size from="817" to="817" total="42484" 
  count="52"/> <size from="833" to="833" total="7497" count="9"/> 
  <size from="849" to="849" total="5094" count="6"/> <size 
  from="865" to="865" total="4325" count="5"/> <size from="881" 
  to="881" total="5286" count="6"/> <size from="897" to="897" 
  total="6279" count="7"/> <size from="913" to="913" total="6391" 
  count="7"/> <size from="929" to="929" total="4645" count="5"/> 
  <size from="945" to="945" total="3780" count="4"/> <size 
  from="961" to="961" total="1922" count="2"/> <size from="977" 
  to="977" total="9770" count="10"/> <size from="1009" to="1009" 
  total="122089" count="121"/> <size from="1025" to="1073" 
  total="156226" count="146"/> <size from="1089" to="1137" 
  total="148084" count="132"/> <size from="1153" to="1201" 
  total="75664" count="64"/> <size from="1217" to="1265" 
  total="83731" count="67"/> <size from="1281" to="1329" 
  total="101437" count="77"/> <size from="1345" to="1393" 
  total="107822" count="78"/> <size from="1409" to="1457" 
  total="91680" count="64"/> <size from="1473" to="1521" 
  total="51074" count="34"/> <size from="1537" to="1585" 
  total="65482" count="42"/> <size from="1601" to="1649" 
  total="32484" count="20"/> <size from="1665" to="1713" 
  total="50638" count="30"/> <size from="1729" to="1777" 
  total="33283" count="19"/> <size from="1793" to="1825" 
  total="18106" count="10"/> <size from="1857" to="1905" 
  total="35683" count="19"/> <size from="1921" to="1969" 
  total="117132" count="60"/> <size from="1985" to="2033" 
  total="46295" count="23"/> <size from="2049" to="2097" 
  total="257804" count="124"/> <size from="2113" to="2161" 
  total="92075" count="43"/> <size from="2177" to="2225" 
  total="39666" count="18"/> <size from="2241" to="2289" 
  total="81972" count="36"/> <size from="2305" to="2353" 
  total="337953" count="145"/> <size from="2369" to="2417" 
  total="399879" count="167"/> <size from="2433" to="2481" 
  total="555635" count="227"/> <size from="2497" to="2545" 
  total="372660" count="148"/> <size from="2561" to="2609" 
  total="431415" count="167"/> <size from="2625" to="2673" 
  total="325771" count="123"/> <size from="2689" to="2737" 
  total="412584" count="152"/> <size from="2753" to="2801" 
  total="335673" count="121"/> <size from="2817" to="2865" 
  total="235587" count="83"/> <size from="2881" to="2929" 
  total="283890" count="98"/> <size from="2945" to="2993" 
  total="335073" count="113"/> <size from="3009" to="3057" 
  total="278876" count="92"/> <size from="3073" to="3121" 
  total="358180" count="116"/> <size from="3137" to="3569" 
  total="2372709" count="709"/> <size from="3585" to="4081" 
  total="1847856" count="480"/> <size from="4097" to="4593" 
  total="5672856" count="1320"/> <size from="4609" to="5105" 
  total="4675836" count="956"/> <size from="5121" to="5617" 
  total="6883318" count="1286"/> <size from="5633" to="6129" 
  total="6011919" count="1023"/> <size from="6145" to="6641" 
  total="6239871" count="975"/> <size from="6657" to="7153" 
  total="6540165" count="949"/> <size from="7169" to="7665" 
  total="5515848" count="744"/> <size from="7681" to="8177" 
  total="5148216" count="648"/> <size from="8193" to="8689" 
  total="8190223" count="975"/> <size from="8705" to="9201" 
  total="5854315" count="651"/> <size from="9217" to="9713" 
  total="5312354" count="562"/> <size from="9729" to="10225" 
  total="5154212" count="516"/> <size from="10241" to="10737" 
  total="4074005" count="389"/> <size from="10753" to="12273" 
  total="11387550" count="990"/> <size from="12289" to="16369" 
  total="32661229" count="2317"/> <size from="16385" to="20465" 
  total="36652437" count="2037"/> <size from="20481" to="24561" 
  total="21272131" count="947"/> <size from="24577" to="28657" 
  total="25462302" count="958"/> <size from="28673" to="32753" 
  total="28087234" count="914"/> <size from="32769" to="36849" 
  total="39080113" count="1121"/> <size from="36865" to="40945" 
  total="30141527" count="775"/> <size from="40961" to="65521" 
  total="166092799" count="3119"/> <size from="65537" to="98289" 
  total="218425380" count="2692"/> <size from="98321" to="131057" 
  total="178383171" count="1555"/> <size from="131089" to="163825" 
  total="167800886" count="1142"/> <size from="163841" to="262065" 
  total="367649915" count="1819"/> <size from="262161" to="522673" 
  total="185347984" count="560"/> <size from="525729" 
  to="30878897" total="113322865" count="97"/> <unsorted from="33" 
  to="33" total="33" count="1"/> 
</sizes> <total type="fast" count="6" size="368"/> <total 
type="rest" count="43944" size="1713595767"/> <system 
type="current" size="2204352512"/> <system type="max" 
size="2204352512"/> <aspace type="total" size="2204352512"/> 
<aspace type="mprotect" size="2204352512"/> </heap> <heap nr="1"> 
<sizes> 
  <size from="17" to="32" total="160" count="5"/> <size from="33" 
  to="48" total="336" count="7"/> <size from="49" to="64" 
  total="448" count="7"/> <size from="65" to="80" total="560" 
  count="7"/> <size from="97" to="112" total="784" count="7"/> 
  <size from="33" to="33" total="231" count="7"/> <size from="49" 
  to="49" total="245" count="5"/> <size from="65" to="65" 
  total="390" count="6"/> <size from="81" to="81" total="162" 
  count="2"/> <size from="97" to="97" total="97" count="1"/> <size 
  from="113" to="113" total="113" count="1"/> <size from="129" 
  to="129" total="516" count="4"/> <size from="161" to="161" 
  total="644" count="4"/> <size from="209" to="209" total="2299" 
  count="11"/> <size from="241" to="241" total="241" count="1"/> 
  <size from="257" to="257" total="257" count="1"/> <size 
  from="305" to="305" total="610" count="2"/> <size from="32209" 
  to="32209" total="64418" count="2"/> <size from="1294673" 
  to="4053073" total="27998472" count="8"/> <unsorted from="209" 
  to="4053073" total="4080781" count="13"/> 
</sizes> <total type="fast" count="33" size="2288"/> <total 
type="rest" count="69" size="42357748"/> <system type="current" 
size="42426368"/> <system type="max" size="42426368"/> <aspace 
type="total" size="42426368"/> <aspace type="mprotect" 
size="42426368"/> <aspace type="subheaps" size="1"/> </heap> 
<total type="fast" count="39" size="2656"/> <total type="rest" 
count="44013" size="1755953515"/> <total type="mmap" count="6" 
size="121565184"/> <system type="current" size="2246778880"/> 
<system type="max" size="2246778880"/> <aspace type="total" 
size="2246778880"/> <aspace type="mprotect" size="2246778880"/> 
</malloc>   (memory-limit) ;; virtual memory, not RSS 2630768 
(message "%f" gc-cons-threshold) "800000.000000"  (message "%f" 
gc-cons-percentage) "0.100000"  (emacs-uptime) "4 days, 4 hours, 5 
minutes, 3 seconds"  (message "%f" gcs-done) "2140.000000" 
(message "%f" gc-elapsed) "760.624580"  (message "%s" memory-full) 
"nil"  ;; I belive this is cumulative, not current? 
(memory-use-counts) (989044259 2763760 754240919 143568 2633617972 
2535567 76512576)  (reduce '+ (memory-use-counts)) 4509544031 
 
  
(memory-usage) ((conses 16 2081326 3094498) (symbols 48 61019 79) 
(strings 32 353291 494869) (string-bytes 1 13286757) (vectors 16 
144725) (vector-slots 8 9503378 623467) (floats 8 2373 8320) 
(intervals 56 46640 11652) (buffers 992 82)) 
 
 =>	31.8MB (+ 47.2MB dead) in conses 
	2.79MB (+ 3.70kB dead) in symbols 10.8MB (+ 15.1MB dead) in 
	strings 12.7MB in string-bytes 2.21MB in vectors 72.5MB (+ 
	4.76MB dead) in vector-slots 18.5kB (+ 65.0kB dead) in floats 
	2.49MB (+  637kB dead) in intervals 79.4kB in buffers  Total in 
	lisp objects:  203MB (live  135MB, dead 67.8MB)  Buffer ralloc 
	memory usage: 82 buffers 
 176MB total (2.04MB in gaps) 
      Size	Gap	Name 
 
  91928037	1241610	*censored* 27233492	123915	*censored* 
  16165441	173855	*censored* 15789683	66347	  *censored* 
  15688792	205051	*censored* 
   3040510	1437	  *censored* 3030476	17503	  *censored* 3027663 
   15314	  *censored* 3027493	16032	  *censored* 3026818	15601 
   *censored* 
    211934	5198	  *censored* 
     87685	23923	  *censored* 57762	2629	  *censored* 52780 
     677	    *censored* 35991	2269	  *censored* 25403	1824 
     *censored* 18008	1514	  *censored* 16930	64	    *censored* 
     16877	217	    *censored* 16484	1447	  *censored* 14232 
     14654	  *censored* 14192	605	    *censored* 13715	1130 
     *censored* 13575	1689	  *censored* 13343	1377	  *censored* 
     13198	1540	  *censored* 13178	1598	  *censored* 12747 
     2081	  *censored* 10883	1902	  *censored* 10271	632 
     *censored* 
      6402	44449	  *censored* 5127	1386	  *censored* 5005	1156 
      *censored* 4282	1891	  *censored* 3840	2313	  *censored* 
      3409	16717	  *censored* 3409	16717	  *censored* 2872	1186 
      *censored* 2541	1511	  *censored* 2067	2011	  *censored* 
      1630	675	    *censored* 1626	444	    *censored* 1490	679 
      *censored* 1413	26294	  *censored* 1159	4937	  *censored* 
       962	1063	  *censored* 678	1574	  *censored* 562	2297 
       *censored* 324	2008	  *censored* 324	2008	  *censored* 
       151	1967	  *censored* 137	1887	  *censored* 133	1983 
       *censored* 
        97	1935	  *censored* 78	3998	  *censored* 72	1999 
        *censored* 71	3985	  *censored* 69	1999	  *censored* 67 
        1999	  *censored* 64	1985	  *censored* 62	1999 
        *censored* 61	6035	  *censored* 49	2008	  *censored* 33 
        2038	  *censored* 31	4040	  *censored* 27	1999 
        *censored* 25	1999	  *censored* 25	1999	  *censored* 25 
        1999	  *censored* 22	1999	  *censored* 20	0 
        *censored* 16	2021	  *censored* 16	4	      *censored* 
         0	2026	  *censored* 0	20	    *censored* 0	5026 
         *censored* 0	2072	  *censored* 0	20	    *censored* 0 
         20	    *censored* 0	2059	  *censored* 0	20 
         *censored* 0	20	    *censored* 

----------------
END LOG
----------------

-Trevor




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 23 Nov 2020 21:22:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 23 16:22:41 2020
Received: from localhost ([127.0.0.1]:51435 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khJIG-0006id-Nk
	for submit <at> debbugs.gnu.org; Mon, 23 Nov 2020 16:22:40 -0500
Received: from mail-oln040092068079.outbound.protection.outlook.com
 ([40.92.68.79]:16295 helo=EUR02-HE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arthur.miller@HIDDEN>) id 1khJIF-0006iQ-CW
 for 43389 <at> debbugs.gnu.org; Mon, 23 Nov 2020 16:22:40 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=MpMdEGlTd0AyYdxcvzNX8I6nuawgS9bVX2I6ZuljiZAUiZ3XLFwwisKRH2Nld/UgPcpK4n3awuPXasW8FqiP5779oit+MUtZnneJ3KoO+7yc+kYFMB8yWgkY5TAENdnaX95IVFWnWqidrBFR9aU1CodQeIrIGYBD14FxNQmAWB1B18qCyQhPTh9vEzFhKG/bj5vOnTv65cd6H05tA99Jeb/upmfM7d2JIzlTjXiRX/h71TI0RMXP573hD5Z9qrp5hkarEPiYJKSkLLkRSNObxq4wMrcz0SIy8ltcA8EBvg0qCU3Wk0XyxOp55wgW/v7R/OdMz1gkbkUtt/TcIqGL/w==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=Y/8D/XkBN653oOcY6tzgErDFEXW5xNDLwNLKhjeEO+k=;
 b=Ps00L8KVG/b81TPs3GAOxzzw3ELNVTsMKLVyAyy5uhVNgmnJn8egOou/6YD867HNhKe05Fwgw2gTHrMo5ymjUVbcxRVudHVUmez4M3s6sRIWUUK7h+ZTa5IKQi6uj5o7VOmgCr0rAzoA/NQoose0OVYEqxj1CRn1Mj5ZIFhtPn87pNZ0AICHRK/MLYhoMQubapwvkSg7GMuhXfihHg1a5JS6fxQJuJ277MlFAWDOeE8QD2UpNADQXvYrTVJn7XF9TQ0z4iedgtt61SVI/7GMXvyTZIFGF4vw2IHWbIuHhU/kheJESNkqV3+7tHHTU5uej1Gd3+woaSdbzI1k6T/u5Q==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=live.com; s=selector1; 
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=Y/8D/XkBN653oOcY6tzgErDFEXW5xNDLwNLKhjeEO+k=;
 b=aFN9rZNV5B+prC1jSwDr8RdWEZ6bRxVH1386kk00Y5e7Kyv2puJhtgXz6KqB31wTXFMPokooNugQLOjFfGZgZn2+M457c909bN95frYoHtaHrXdXw1So6eIfxyvDxjDnxbhoVvDF/lOC6yhhUgX6PwdP5NimF4oRaonXhNQqY9b3wCRmXxr2UOnKkaXuVWXLjswbiuKrrYJZxl19I5h9/AAAGgG60NKPS2Y8XwcFwmbW1QtZDsHV3aIxZX/xC5ecULsfOtLR1uZk0278h6clvbEcrYUsnhvtJk5Tty9+9HO+iCQki9rnDVzK9vtid/yg9w/XGs15gwxB5AQ2IduAMA==
Received: from AM5EUR02FT028.eop-EUR02.prod.protection.outlook.com
 (2a01:111:e400:7e1c::4a) by
 AM5EUR02HT124.eop-EUR02.prod.protection.outlook.com (2a01:111:e400:7e1c::479)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20; Mon, 23 Nov
 2020 21:22:29 +0000
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 (2a01:111:e400:7e1c::4d) by AM5EUR02FT028.mail.protection.outlook.com
 (2a01:111:e400:7e1c::115) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20 via Frontend
 Transport; Mon, 23 Nov 2020 21:22:29 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:A6E0D024D537EB1BC3DAEFA34E9CF000CFD546B467263915C30A2A4FF75FFA66;
 UpperCasedChecksum:58CA8172D413CE92C5AC9CF114C5EA6A807CDF8E4C53BB93A08C8F803D8ED3CC;
 SizeAsReceived:8045; Count:46
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993]) by AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993%7]) with mapi id 15.20.3589.030; Mon, 23 Nov 2020
 21:22:29 +0000
From: Arthur Miller <arthur.miller@HIDDEN>
To: Jean Louis <bugs@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <83zh3czbvz.fsf@HIDDEN> <X7rBbqnN4ydxoO0n@HIDDEN>
 <83k0udw3jb.fsf@HIDDEN> <X7tuqkYiZHYxQpcQ@HIDDEN>
 <BE101E85-568B-4B5C-A8A1-8FBA4726841C@HIDDEN>
 <AM0PR06MB657755833A2EC0DD73BF5BC596FC0@HIDDEN>
 <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <X7wcMpkuuE01Ciwb@HIDDEN>
Date: Mon, 23 Nov 2020 22:22:28 +0100
In-Reply-To: <X7wcMpkuuE01Ciwb@HIDDEN> (Jean Louis's message of
 "Mon, 23 Nov 2020 23:31:46 +0300")
Message-ID: <AM0PR06MB6577E94D0FB628547C7347AF96FC0@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Content-Type: text/plain
X-TMN: [Sv/PL3hsVlHAcDWLjuNaIdPAH2ZGF/sV]
X-ClientProxiedBy: AM6PR08CA0013.eurprd08.prod.outlook.com
 (2603:10a6:20b:b2::25) To AM0PR06MB6577.eurprd06.prod.outlook.com
 (2603:10a6:208:19a::23)
X-Microsoft-Original-Message-ID: <87y2ir4vl7.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from pascal.homepc (90.230.29.56) by
 AM6PR08CA0013.eurprd08.prod.outlook.com (2603:10a6:20b:b2::25) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.3589.20 via Frontend Transport; Mon, 23 Nov 2020 21:22:29 +0000
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 46
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: e940c82a-4f83-42f0-74be-08d88ff5e1da
X-MS-TrafficTypeDiagnostic: AM5EUR02HT124:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: sr+5x2C9bLlewiOuXYeL9Aoqp6i+9FqXYHszPUJ467/mEeblbgvb6su47X3o0mNCwUroP8krk6047qSr8vAM73D8svKgg4FaqBen0BLkDAErjK5g0WCa3fqBQBrzqv84twf3cXzlpogFwJLVKZrH8NBntnQFk8UGT4la2okISHhJe/cbe2qyBn1b67mdnjRiAnpz5hEb5IbsQsQfiyAUEw==
X-MS-Exchange-AntiSpam-MessageData: SUX79TYpRy3GFmwustwwdeEVKF9g+ilAi0uXHw46fJVQAZ9xfrzbzV2WkZt1V4VngQPenRSTkpYwY1pMJQ9SQT8ajWx9ePN9j5N33+CppOJ7zfeAQbVfMD3F/f3vFZQWXsQd1wtooCXwH2B9FXCLtg==
X-OriginatorOrg: live.com
X-MS-Exchange-CrossTenant-Network-Message-Id: e940c82a-4f83-42f0-74be-08d88ff5e1da
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 23 Nov 2020 21:22:29.4702 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-AuthSource: AM5EUR02FT028.eop-EUR02.prod.protection.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Anonymous
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: AM5EUR02HT124
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Jean Louis <bugs@HIDDEN> writes:

> * Arthur Miller <arthur.miller@HIDDEN> [2020-11-23 23:22]:
>> The only thing that changed regularly was of course system updates: kernel,
>> gcc & co etc. So it maybe is as mentioned earlier in this thread by
>> either you or somebody else is that glibc changed and that maybe
>> triggers something in Emacs based on how Emacs use it. I don't know I am
>> not expert in this. Isn't Valgrind good for this kind of problems? Can I
>> run emacs as a systemd service in Valgrind?
>
> I did not change anything like glibc or kernel in Hyperbola
> GNU/Linux-libre
Didn't you update your system since last summer?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 23 Nov 2020 21:15:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 23 16:15:57 2020
Received: from localhost ([127.0.0.1]:51418 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khJBh-0006Y5-AJ
	for submit <at> debbugs.gnu.org; Mon, 23 Nov 2020 16:15:57 -0500
Received: from mail-oln040092069074.outbound.protection.outlook.com
 ([40.92.69.74]:49865 helo=EUR02-VE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arthur.miller@HIDDEN>) id 1khJBb-0006Xn-GT
 for 43389 <at> debbugs.gnu.org; Mon, 23 Nov 2020 16:15:51 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=Sq2Q1ZPjHsvw9QJ9DQjgokBy53kfLxig6MHYbCTuLvz0yTyYdvYnTHjQrjM3tvN1duHuIxbVS0oCjVALxiO2yzMQeIsORoRb48BZ7j/pb33RtEPC1HSJhQwaCSXhQtTsy+ZUUPIt0Pf0aVrxIQoEFTgzuXcYgTrbTdSH6eZbmcKS2ZdFRR5f7tJ+2OzmgVFXvi6E0+8XxQxDLjCWXsEmpxcooJnGBC8Dd2aUnzOS/6YHYNCwyIcshhqJp5bygnOPJyf8GmTYZhod0zgS/NArzHhxV3CItGd4IHmzok0FKAeT66gmQedlL03LnFZvwM7I0AvHzsr4qBCO6EDIzBaGpw==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=MOhw+4jV+dNpC0yTdUiEUzEWxpuAx7gF+hoEKv37RUo=;
 b=HQlq604cOAPtmeNDaNRsKAhtqvCIC4jmu7UaLNZuAZgNX++kD9wfiZpGPY7JRY7p46ckOjRRoRiLeoSBGLkQKAFShxn0H7DFv6Dkf9wANxwnh5tikovT/YsKfTHXjo7/eDQCBSI3Xc0dMT+iHK+4s/SxrnYDkjW6kiU3J9kbU4X8ZxJw8hTBio33U9KEoAk7qPPQycVqr4cSU+wfEa50U66QHJCF5FFbhDPcT8xjSvhSEbR6Bow80RwMCP6nmMqE4kFCKglI+WmAGtgK7fuwd/RKxOx7tMlgpZDc0lH3WuXJs/XJFLTFLywECAojQLExv9HZf2AQCdLH9jMMwE8xZg==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=live.com; s=selector1; 
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=MOhw+4jV+dNpC0yTdUiEUzEWxpuAx7gF+hoEKv37RUo=;
 b=XFthKC4sipLJL6z1o1cuXt3RXXY+w/O2/4BRDWuwUCqLg8ibt/MHi6nBXCgDAzScJftDS3voUAFSFZTWFCbc6QhyWYoFhoqxMb+UO2mDdzcUQIjlVfX0XNnf/C3CyAD6kJSMERk4BFKWMeDMEmVpnUv42iRp8CqMqez131EOOuHqZRd4/bnfC6WkG3xwPSCCODK6yJoa1c07GP3GxILig4UQQReNjdY1ZOCJHcrgqwknVNyQyAAnUZ5SFfCzoCBDucEujr3nEW1c8MqteDyc96IYeoHW/M6SjhjGWerkYS3RB1zGqITUr2HOQsAkDjHKBdpAGCjbBfoALNxQO45/Tg==
Received: from AM5EUR02FT021.eop-EUR02.prod.protection.outlook.com
 (2a01:111:e400:7e1c::47) by
 AM5EUR02HT235.eop-EUR02.prod.protection.outlook.com (2a01:111:e400:7e1c::469)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20; Mon, 23 Nov
 2020 21:15:40 +0000
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 (2a01:111:e400:7e1c::52) by AM5EUR02FT021.mail.protection.outlook.com
 (2a01:111:e400:7e1c::93) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20 via Frontend
 Transport; Mon, 23 Nov 2020 21:15:40 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:F15E6291E8AE1BD2E739E5E267C2FF55736F27459BF9D57490DD7D2606C87877;
 UpperCasedChecksum:43BF52C0A850A200A60C817B0AAAF2AD8E66743174967FF26595E5BC71A67FDE;
 SizeAsReceived:8216; Count:46
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993]) by AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993%7]) with mapi id 15.20.3589.030; Mon, 23 Nov 2020
 21:15:40 +0000
From: Arthur Miller <arthur.miller@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7uWIyMsyIarDbji@HIDDEN> <83blfovzxz.fsf@HIDDEN>
 <AM0PR06MB65775C17E3A9FB119BF3F44596FC0@HIDDEN>
 <83tutgufuf.fsf@HIDDEN>
 <AM0PR06MB6577CD76CD91CBB35A24DEA696FC0@HIDDEN>
 <83lfervpvd.fsf@HIDDEN> <xjfeekj7thk.fsf@HIDDEN>
 <AM0PR06MB6577466DC434794DA38454F596FC0@HIDDEN>
 <83blfnvnho.fsf@HIDDEN>
Date: Mon, 23 Nov 2020 22:15:39 +0100
In-Reply-To: <83blfnvnho.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 23 Nov
 2020 22:15:15 +0200")
Message-ID: <AM0PR06MB6577CE64EBB3093F449FEF9B96FC0@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Content-Type: text/plain
X-TMN: [ccxkwgM8KS9ml1DOzjLZKK7I/Y3RxuML]
X-ClientProxiedBy: AM6PR10CA0021.EURPRD10.PROD.OUTLOOK.COM
 (2603:10a6:209:89::34) To AM0PR06MB6577.eurprd06.prod.outlook.com
 (2603:10a6:208:19a::23)
X-Microsoft-Original-Message-ID: <87360z6ah0.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from pascal.homepc (90.230.29.56) by
 AM6PR10CA0021.EURPRD10.PROD.OUTLOOK.COM (2603:10a6:209:89::34) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.3589.20 via Frontend Transport; Mon, 23 Nov 2020 21:15:39 +0000
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 46
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: cfba0ff7-9d2b-4c1a-8575-08d88ff4ee06
X-MS-TrafficTypeDiagnostic: AM5EUR02HT235:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: G14KTigsg6/UZHQGW2VfRgQGQvtUIzkAHWSzuane+my+eqGrOwFMQDFGHpqVezkZuT6BCD/q5rIKoV4LA0ATjI1OkUe0Pql/paofVIpE6EJiw/haAs0+vFfG1GgQV+YEccFtWVm7jWlVUsDtCOd7VF35aKEt6G73kjOdeq5jzN33pUPKJAGUbAzwcgRgyDRu50pkY0igUPJeLg4tuYkQ4KzJexf+313YoUuX2SfV6tNnoeJjAyxsPCmIbc1+BPTF
X-MS-Exchange-AntiSpam-MessageData: rackv8rqO84dm+8Hs3uNiDQnft25ySFAr/K19wVpLi3HkIYiAoteP9rQ/oyjgrMxZLU845NkIWw7f0IBwEiGHWMKQtqNgRDyfi/S/mpD426BbOPMZ5jBE0+eVVyPL+KnaYVn3Klci2eg3UYq7YaHCA==
X-OriginatorOrg: live.com
X-MS-Exchange-CrossTenant-Network-Message-Id: cfba0ff7-9d2b-4c1a-8575-08d88ff4ee06
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 23 Nov 2020 21:15:40.7534 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-AuthSource: AM5EUR02FT021.eop-EUR02.prod.protection.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Anonymous
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: AM5EUR02HT235
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN,
 akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Arthur Miller <arthur.miller@HIDDEN>
>> Cc: Eli Zaretskii <eliz@HIDDEN>,  fweimer@HIDDEN,
>>   43389 <at> debbugs.gnu.org,  bugs@HIDDEN,  dj@HIDDEN,
>>   michael_heerdegen@HIDDEN,  trevor@HIDDEN,  carlos@HIDDEN
>> Date: Mon, 23 Nov 2020 20:59:21 +0100
>> 
>> How hard/possible is to use this tool in Emacs:
>> 
>> https://gperftools.github.io/gperftools/heapprofile.html
>
> AFAIU, this cannot be used with glibc's malloc, it needs libtcmalloc
> instead.
Oh yes I understand, there is not a chance it would help to run emacs on
tcmalloc instead of standard malloc? If there is by a chance a leak
somewhere in Emacs? ... god forbid of course :-)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#43389; Package emacs. Full text available.

Message received at 43389 <at> debbugs.gnu.org:


Received: (at 43389) by debbugs.gnu.org; 23 Nov 2020 21:12:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 23 16:12:31 2020
Received: from localhost ([127.0.0.1]:51412 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1khJ8Q-0006Sk-Ra
	for submit <at> debbugs.gnu.org; Mon, 23 Nov 2020 16:12:30 -0500
Received: from mail-oln040092067070.outbound.protection.outlook.com
 ([40.92.67.70]:44900 helo=EUR02-AM5-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arthur.miller@HIDDEN>) id 1khJ8N-0006SV-To
 for 43389 <at> debbugs.gnu.org; Mon, 23 Nov 2020 16:12:28 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=fERc/TdWxYrRh9RzuoOU5AyuuzmzVp2sn3ITBFgGitz2vmVvogQHv/jXMt1Q29u6OxEp0qIA/a6f2ntDnRUS2IM7qzU1OEf4nMd7a2ElYfN15wzKKOzu/dab2Mng9O3hiOmgDO4qxhK6V1wPcc3LP6buDWzROzJ+/7OCV9824K3PSEdmER/DyXDohjSSOe3QOgFPAnyqgXa/zBrEdFRdlqjrhx/dmbN9ifWn8niVAsj1xQU6CgNrBEyFUAPGMZQeJrQm/Acm2Ny38WzpY2B1WSOB8W4JsLsXadct9kmsNdOpgDaYlVmjQsBWzkN5+JXKbNC+FBz6bj2D7YcP74VneQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=iQo4aqCF8vSbkrb/ulkAeNULNBklQ1vPiV0pWWvF+d8=;
 b=JuADE2fkhV8jO/0BzLMHQ4gs4eKq6SB/lZium2Lj2DuK/aNacW709wiTYMJ0PjeAX+HwEFA/6z+aPUhnGZRMUQO7dwvRIoGEHzqShRIMRFpdXxLLRSCivVjGeNDIbJiDqEFvB3XFwSj7BGAhSj1GhJ2ZaI8v6rc/Iq5VPtDmieSqrdX+12BtIkLBsA8toIvtpUh0jlBxeUkYQhaGz0fama/yXypRcLcFow3P0AqM8eWiI52Bkp0th6UuAHpjg/3Z+w4ozYVJQU/8v/jfJnqQQOqaTXEmfUwe9hrdf0N/Fl2UMOFTjixRBH2CoLcDtJBlqNuLm5RDHvaQq9NdqnFDtA==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=live.com; s=selector1; 
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=iQo4aqCF8vSbkrb/ulkAeNULNBklQ1vPiV0pWWvF+d8=;
 b=WmOnUB8/ORTeGc+FkUVp4x1tE9DuSnYy8UkGwobCGeC9SG25CsOxSTH7jU/UFnQdapUwiT9gz3gCfPNLQzepioPkUuiG3p8cknlDk/AQjOwgqdWrB25IMR5UzX/MjXbvExrXsyvBrmgx2AEPBmQXYlBWwemtSJJcl+PEdcThcHu1ejU3OreGwPJYU1UCmz5pLqVwMoH+e4QViwDxODLRPy7o6YKnjHli3hgpY8E4IjuAK3ojASH18rnzhhYUYIFMo1wSDMWaLN4oW9kpSofKgN7dN+ege9OMbDC9MXrQZ3gj85bstXsxXrq2PFiPtXdr0ikBMZ40jRTZrP9rxu5MSA==
Received: from AM5EUR02FT021.eop-EUR02.prod.protection.outlook.com
 (2a01:111:e400:7e1c::43) by
 AM5EUR02HT107.eop-EUR02.prod.protection.outlook.com (2a01:111:e400:7e1c::424)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20; Mon, 23 Nov
 2020 21:12:14 +0000
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 (2a01:111:e400:7e1c::52) by AM5EUR02FT021.mail.protection.outlook.com
 (2a01:111:e400:7e1c::93) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3589.20 via Frontend
 Transport; Mon, 23 Nov 2020 21:12:14 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:33CE995DA2A96BA29446750D19B1E6811E311C906CB8C0FE6204241DEB4F6377;
 UpperCasedChecksum:9DBF0A0A51060F788E0553D03ACAC6ED738A11154D596FB126F92116876A7CEE;
 SizeAsReceived:8293; Count:46
Received: from AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993]) by AM0PR06MB6577.eurprd06.prod.outlook.com
 ([fe80::9487:8c7d:da00:4993%7]) with mapi id 15.20.3589.030; Mon, 23 Nov 2020
 21:12:14 +0000
From: Arthur Miller <arthur.miller@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#43389: 28.0.50; Emacs memory leaks using hard disk all time
References: <86y2j2brg2.fsf@HIDDEN> <83blfxth7c.fsf@HIDDEN>
 <X7KmHzy9nQHZlZjb@HIDDEN> <83y2j0qb2v.fsf@HIDDEN>
 <X7YX4MxbbM2WsFuk@HIDDEN> <831rgppg3w.fsf@HIDDEN>
 <X7c1CuK9bCP2sw5Z@HIDDEN> <83zh3czbvz.fsf@HIDDEN>
 <X7rBbqnN4ydxoO0n@HIDDEN> <83k0udw3jb.fsf@HIDDEN>
 <X7tuqkYiZHYxQpcQ@HIDDEN>
 <BE101E85-568B-4B5C-A8A1-8FBA4726841C@HIDDEN>
 <AM0PR06MB657755833A2EC0DD73BF5BC596FC0@HIDDEN>
 <83v9dwufx4.fsf@HIDDEN>
 <AM0PR06MB6577D7B890F347230140276996FC0@HIDDEN>
 <83mtz7vq8j.fsf@HIDDEN>
 <AM0PR06MB6577DFB1B574E70F66E2ABE696FC0@HIDDEN>
 <83eekjvnzg.fsf@HIDDEN>
Date: Mon, 23 Nov 2020 22:12:12 +0100
In-Reply-To: <83eekjvnzg.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 23 Nov
 2020 22:04:35 +0200")
Message-ID: <AM0PR06MB6577BC7620178FAE0C25C78B96FC0@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
Content-Type: multipart/mixed; boundary="=-=-="
X-TMN: [7FMbJDp73lh9xtmZgnTI4YseUdXag715]
X-ClientProxiedBy: AM6P195CA0027.EURP195.PROD.OUTLOOK.COM
 (2603:10a6:209:81::40) To AM0PR06MB6577.eurprd06.prod.outlook.com
 (2603:10a6:208:19a::23)
X-Microsoft-Original-Message-ID: <877dqb6amr.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from pascal.homepc (90.230.29.56) by
 AM6P195CA0027.EURP195.PROD.OUTLOOK.COM (2603:10a6:209:81::40) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.3589.22 via Frontend Transport; Mon, 23 Nov 2020 21:12:13 +0000
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 46
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: d8d122c2-f173-49ef-3e65-08d88ff472b3
X-MS-TrafficTypeDiagnostic: AM5EUR02HT107:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: 3twIh3O4WjRxPshDO4lL6FpxUy1ihXns1nveZww7BCrhR4VrmBrOkUbrh5evxx6c0Polu57N53h+hQckZAQdqHR/jLuRtgBGCH65FdYPckVjUWFJgPDY6cWkxvE7UKZ1SpWqmYxssH70S6pbhrt8hs6ZPJZAZ/MXoXrmeK68s2LuZBA2fz+s0hAbt1jAv9CCDz5ZMAUeTwjdezTX0hhk5Q==
X-MS-Exchange-AntiSpam-MessageData: zcICHKNorT7zMqYhHGtXJ+PezJEgK60YuY4YZyhlcKi9/g+Ybop6eANG3FHOo0V8+srpQ7BphkHxQwUUTydEQk1aNZ7JRrWXA6dTPS+lKYeT4t8vmzCTSNt14lCaky/T/IWoB41AGFH/YAAydMTJpg==
X-OriginatorOrg: live.com
X-MS-Exchange-CrossTenant-Network-Message-Id: d8d122c2-f173-49ef-3e65-08d88ff472b3
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 23 Nov 2020 21:12:14.6981 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-AuthSource: AM5EUR02FT021.eop-EUR02.prod.protection.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Anonymous
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: AM5EUR02HT107
X-Debbugs-Envelope-To: 43389
Cc: fweimer@HIDDEN, 43389 <at> debbugs.gnu.org, bugs@HIDDEN, dj@HIDDEN,
 michael_heerdegen@HIDDEN, trevor@HIDDEN, carlos@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>

--=-=-=
Content-Type: text/plain

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Arthur Miller <arthur.miller@HIDDEN>
>> Cc: bugs@HIDDEN,  fweimer@HIDDEN,  43389 <at> debbugs.gnu.org,
>>   dj@HIDDEN,  michael_heerdegen@HIDDEN,  trevor@HIDDEN,
>>   carlos@HIDDEN
>> Date: Mon, 23 Nov 2020 20:49:48 +0100
>> 
>> Isn't Valgrind good for this kind of problems? Can I run emacs as a
>> systemd service in Valgrind?
>
> You can run Emacs under Valgrind, see etc/DEBUG for the details.  But
> I'm not sure it will work as systemd service.
>
> Valgrind is only the right tool if we think there's a memory leak in
> Emacs itself.
Ok, I'll take a look at debug docs; It's ok, just i get a test I can run
it as normal process; it's ok.

Anyway I have tested heaptrack; It built in like few seconds, nothing
special there.

I am not sure about the tool; I think it missunderstands memory taken by
lisp environement as a leaked memory. It repports like heap loads of
leaks :-), so it must be that it just missunderstands Emacs. I am not
sure, I am attaching few screenshots, but I don't believe it can be that
many leaks as it rapports. It is just emacs what one gets from emacs -Q
there. I will attach the generated data too.

I had some problem with it too. I tried to attach it to a running deamon
process (started by sysd) and it failed untill I run it as sudo
user. As soon as it attached itself seems that both server and
emacsclient got completely unresponsive and stayed that way. I killed
client process, but windowed stayed alive, I had to kill it with
xkill. After I restarded server Emacs didn't read the init file, because
paths got messed up, so I had to sort that out too. Also the tool
produced empty rapport (it didn't work). But runnign on standalone emacs
process as a sudo user worked.

Anyway, despite problems it seems to be very nice graphical tool to see
call stack and how Emacs looks like internally; but I am not sure if it
works at all to find leaks in Emacs.


--=-=-=
Content-Type: image/png
Content-Disposition: attachment; filename=em-heaptrack1.png
Content-Transfer-Encoding: base64
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